#!/bin/sh
# Use this script to patch ncurses 5.4 to 5.4 (20040224)
# Run this script inside the ncurses 5.4 source directory et voila! Updated.

if ( egrep '^NCURSES_MAJOR = 5$' dist.mk >/dev/null 2>&1 \
  && egrep '^NCURSES_MINOR = 4$' dist.mk >/dev/null 2>&1 \
  && egrep '^NCURSES_PATCH = 20040208$' dist.mk >/dev/null 2>&1 )
then
        echo patching...
else
        echo 'This does not look like ncurses 5.4'
        exit 1
fi

patch -p1 -i $0         # shell command = this script = inputfile for patch
exit

# ------------------------------------------------------------------------------
# Ada95/gen/Makefile.in                           |    9 
# Ada95/samples/Makefile.in                       |   19 
# Ada95/src/Makefile.in                           |   11 
# INSTALL                                         |   43 
# MANIFEST                                        |    1 
# NEWS                                            |   92 
# TO-DO                                           |    5 
# aclocal.m4                                      |  183 +
# config.guess                                    |   24 
# config.sub                                      |   18 
# configure                                       | 2546 ++++++++++++----------
# configure.in                                    |   90 
# dist.mk                                         |    4 
# form/fld_pad.c                                  |   16 
# form/form.priv.h                                |   25 
# form/frm_driver.c                               | 1021 ++++----
# form/fty_alnum.c                                |   36 
# form/fty_alpha.c                                |  147 -
# form/fty_int.c                                  |    6 
# form/fty_ipv4.c                                 |    8 
# form/fty_num.c                                  |    8 
# include/curses.h.in                             |   14 
# include/ncurses_defs                            |    3 
# include/tic.h                                   |   15 
# man/curs_add_wchstr.3x                          |    5 
# man/curs_bkgrnd.3x                              |    5 
# man/curs_border_set.3x                          |    5 
# man/curs_insstr.3x                              |   40 
# man/curs_inwstr.3x                              |    5 
# man/terminfo.tail                               |   28 
# menu/m_driver.c                                 |  642 ++---
# menu/m_item_new.c                               |   79 
# menu/m_pad.c                                    |   22 
# menu/m_pattern.c                                |   46 
# menu/m_post.c                                   |  269 +-
# menu/menu.priv.h                                |    6 
# misc/terminfo.src                               |  105 
# mk-0th.awk                                      |    6 
# mk-1st.awk                                      |    3 
# mk-2nd.awk                                      |   23 
# ncurses-5.4-20040424/ncurses/base/lib_insnstr.c |   68 
# ncurses/Makefile.in                             |    4 
# ncurses/base/MKunctrl.awk                       |    9 
# ncurses/base/lib_addch.c                        |   16 
# ncurses/base/lib_freeall.c                      |    7 
# ncurses/base/lib_insch.c                        |   66 
# ncurses/base/lib_newwin.c                       |    7 
# ncurses/base/lib_set_term.c                     |    8 
# ncurses/base/vsscanf.c                          |    6 
# ncurses/curses.priv.h                           |   27 
# ncurses/llib-lncurses                           |   42 
# ncurses/llib-lncursesw                          |   38 
# ncurses/modules                                 |    5 
# ncurses/tinfo/alloc_entry.c                     |   13 
# ncurses/tinfo/comp_error.c                      |    9 
# ncurses/tinfo/comp_parse.c                      |   21 
# ncurses/tinfo/comp_scan.c                       |  363 +--
# ncurses/tinfo/lib_setup.c                       |   42 
# ncurses/tinfo/name_match.c                      |   14 
# ncurses/tinfo/read_termcap.c                    |   16 
# ncurses/trace/lib_tracechr.c                    |    8 
# ncurses/tty/lib_mvcur.c                         |   12 
# ncurses/tty/tty_update.c                        |   10 
# ncurses/widechar/lib_add_wch.c                  |    6 
# ncurses/widechar/lib_get_wch.c                  |    6 
# progs/tic.c                                     |   17 
# test/README                                     |   33 
# test/bs.c                                       |    4 
# test/color_set.c                                |   12 
# test/demo_forms.c                               |    4 
# test/dots.c                                     |   14 
# test/ncurses.c                                  |   51 
# test/test.priv.h                                |   10 
# test/view.c                                     |   39 
# 74 files changed, 3819 insertions(+), 2821 deletions(-)
# ------------------------------------------------------------------------------
Index: Ada95/gen/Makefile.in
--- ncurses-5.4-20040208/Ada95/gen/Makefile.in	2003-10-25 11:39:18.000000000 -0400
+++ ncurses-5.4-20040424/Ada95/gen/Makefile.in	2004-03-06 14:57:16.000000000 -0500
@@ -1,5 +1,5 @@
 ##############################################################################
-# Copyright (c) 1998-2002,2003 Free Software Foundation, Inc.                #
+# Copyright (c) 1998-2003,2004 Free Software Foundation, Inc.                #
 #                                                                            #
 # Permission is hereby granted, free of charge, to any person obtaining a    #
 # copy of this software and associated documentation files (the "Software"), #
@@ -28,8 +28,7 @@
 #
 #  Author:  Juergen Pfeifer, 1996
 #
-#  Version Control
-#  $Revision: 1.44 $
+#  $Id: Makefile.in,v 1.45 2004/03/06 19:57:16 tom Exp $
 #
 .SUFFIXES:
 
@@ -152,7 +151,7 @@
 
 all \
 libs :	$(GEN_TARGETS)
-	@
+	@echo made $@
 
 sources:
 
@@ -431,7 +430,7 @@
 	@rm -rf html
 
 html : adahtml $(HTML_DIR)/table.html
-	@
+	@echo made $@
 
 ###############################################################################
 # The remainder of this file is automatically generated during configuration
Index: Ada95/samples/Makefile.in
--- ncurses-5.4-20040208/Ada95/samples/Makefile.in	2003-10-25 11:39:18.000000000 -0400
+++ ncurses-5.4-20040424/Ada95/samples/Makefile.in	2004-03-06 14:57:16.000000000 -0500
@@ -1,5 +1,5 @@
 ##############################################################################
-# Copyright (c) 1998 Free Software Foundation, Inc.                          #
+# Copyright (c) 1998-2003,2004 Free Software Foundation, Inc.                #
 #                                                                            #
 # Permission is hereby granted, free of charge, to any person obtaining a    #
 # copy of this software and associated documentation files (the "Software"), #
@@ -28,8 +28,7 @@
 #
 #  Author:  Juergen Pfeifer, 1996
 #
-#  Version Control
-#  $Revision: 1.30 $
+#  $Id: Makefile.in,v 1.31 2004/03/06 19:57:16 tom Exp $
 #
 .SUFFIXES:
 
@@ -111,19 +110,19 @@
 
 
 all ::  tour$x rain$x ncurses$x
-	@
+	@echo made $@
 
 sources :
-	@
+	@echo made $@
 
 libs \
 install \
 install.libs ::
-	@
+	@echo made $@
 
 uninstall \
 uninstall.libs ::
-	@
+	@echo made $@
 
 ncurses$x :
 	$(ADAMAKE) $(ADAMAKEFLAGS) ncurses $(CARGS) $(LARGS)
@@ -138,7 +137,7 @@
 	$(ADAMAKE) $(ADAMAKEFLAGS) rain $(CARGS) $(LARGS)
 
 mostlyclean:
-	@
+	@echo made $@
 
 clean :: mostlyclean
 	rm -f *.o *.ali b_t*.* *.s $(PROGS) a.out core b_*_test.c *.xr[bs] \
@@ -148,6 +147,4 @@
 	rm -f Makefile
 
 realclean :: distclean
-	@
-
-
+	@echo made $@
Index: Ada95/src/Makefile.in
--- ncurses-5.4-20040208/Ada95/src/Makefile.in	2003-10-25 11:39:18.000000000 -0400
+++ ncurses-5.4-20040424/Ada95/src/Makefile.in	2004-03-06 14:57:16.000000000 -0500
@@ -1,5 +1,5 @@
 ##############################################################################
-# Copyright (c) 1998 Free Software Foundation, Inc.                          #
+# Copyright (c) 1998-2003,2004 Free Software Foundation, Inc.                #
 #                                                                            #
 # Permission is hereby granted, free of charge, to any person obtaining a    #
 # copy of this software and associated documentation files (the "Software"), #
@@ -28,8 +28,7 @@
 #
 #  Author:  Juergen Pfeifer, 1996
 #
-#  Version Control
-#  $Revision: 1.28 $
+#  $Id: Makefile.in,v 1.29 2004/03/06 19:57:16 tom Exp $
 #
 .SUFFIXES:
 
@@ -175,17 +174,17 @@
 	@sh -c 'for f in $(LIBALIS) $(GENALIS); do test -f $$f || touch $$f; done'
 
 sources :
-	@
+	@echo made $@
 
 libs \
 install \
 install.libs \
 uninstall \
 uninstall.libs ::
-	@
+	@echo made $@
 
 generics: $(GENALIS)
-	@
+	@echo made $@
 
 mostlyclean ::
 	rm -f *.o *.ali b_t*.* *.s $(PROGS) a.out core b_*_test.c *.xr[bs] *.a
Index: INSTALL
Prereq:  1.71 
--- ncurses-5.4-20040208/INSTALL	2004-02-07 16:06:05.000000000 -0500
+++ ncurses-5.4-20040424/INSTALL	2004-02-14 20:26:09.000000000 -0500
@@ -1,4 +1,4 @@
--- $Id: INSTALL,v 1.71 2004/02/07 21:06:05 tom Exp $
+-- $Id: INSTALL,v 1.73 2004/02/15 01:26:09 tom Exp $
 ---------------------------------------------------------------------
              How to install Ncurses/Terminfo on your system
 ---------------------------------------------------------------------
@@ -45,7 +45,7 @@
 REQUIREMENTS:
 ------------
 
-You will need the following in order to build and install ncurses under UNIX:
+You will need the following to build and install ncurses under UNIX:
 
 	* ANSI C compiler  (gcc, for instance)
 	* sh               (bash will do)
@@ -64,9 +64,10 @@
     with it.
 
     The --prefix option to configure changes the root directory for installing
-    ncurses.  The default is in subdirectories of /usr/local.  Use
-    --prefix=/usr to replace your default curses distribution.  This is the
-    default for Linux and BSD/OS users.
+    ncurses.  The default is normally in subdirectories of /usr/local, except
+    for systems where ncurses is normally installed as a system library, e.g.,
+    Linux, the various BSD systems and Cygwin.  Use --prefix=/usr to replace
+    your default curses distribution.
 
     The package gets installed beneath the --prefix directory as follows:
 
@@ -77,9 +78,20 @@
     In $(prefix)/include:      C header files
     Under $(prefix)/man:       the manual pages
 
-    Note however that the configure script attempts to locate previous
-    installation of ncurses, and will set the default prefix according to where
-    it finds the ncurses headers.
+    Note that the configure script attempts to locate previous installation of
+    ncurses, and will set the default prefix according to where it finds the
+    ncurses headers.
+
+    Do not use commands such as
+
+    	make install prefix=XXX
+
+    to change the prefix after configuration, since the prefix value is used
+    for some absolute pathnames such as TERMINFO.  Instead do this
+
+    	make install DESTDIR=XXX
+
+    See also the discussion of --with-install-prefix.
 
 2.  Type `./configure' in the top-level directory of the distribution to
     configure ncurses for your operating system and create the Makefiles.
@@ -551,7 +563,11 @@
     --with-install-prefix=XXX
 	Allows you to specify an alternate location for installing ncurses
 	after building it.  The value you specify is prepended to the "real"
-	install location.  This simplifies making binary packages.
+	install location.  This simplifies making binary packages.  The
+	makefile variable DESTDIR is set by this option.  It is also possible
+	to use
+		make install DESTDIR=XXX
+	since the makefiles pass that variable to subordinate makes.
 
 	NOTE:  a few systems build shared libraries with fixed pathnames; this
 	option probably will not work for those configurations.
@@ -657,12 +673,19 @@
 	Specify a search-list of terminfo directories which will be compiled
 	into the ncurses library (default: DATADIR/terminfo)
 
-    --with-termlib
+    --with-termlib[=XXX]
 	When building the ncurses library, organize this as two parts:  the
 	curses library (libncurses) and the low-level terminfo library
 	(libtinfo).  This is done to accommodate applications that use only
 	the latter.  The terminfo library is about half the size of the total.
 
+	If an option value is given, that overrides the name of the terminfo
+	library.  For instance, if the wide-character version is built, the
+	terminfo library would be named libtinfow.  But the libtinfow interface
+	is upward compatible from libtinfo, so it would be possible to overlay
+	libtinfo.so with a "wide" version of libtinfow.so by renaming it with
+	this option.
+
     --with-termpath=XXX
 	Specify a search-list of termcap files which will be compiled into the
 	ncurses library (default:  /etc/termcap:/usr/share/misc/termcap)
Index: MANIFEST
--- ncurses-5.4-20040208/MANIFEST	2004-01-03 18:04:44.000000000 -0500
+++ ncurses-5.4-20040424/MANIFEST	2004-02-28 20:09:13.000000000 -0500
@@ -738,6 +738,7 @@
 ./ncurses/base/lib_initscr.c
 ./ncurses/base/lib_insch.c
 ./ncurses/base/lib_insdel.c
+./ncurses/base/lib_insnstr.c
 ./ncurses/base/lib_instr.c
 ./ncurses/base/lib_isendwin.c
 ./ncurses/base/lib_leaveok.c
Index: NEWS
Prereq:  1.797 
--- ncurses-5.4-20040208/NEWS	2004-02-08 16:15:26.000000000 -0500
+++ ncurses-5.4-20040424/NEWS	2004-04-24 17:56:22.000000000 -0400
@@ -1,4 +1,4 @@
--- $Id: NEWS,v 1.797 2004/02/08 21:15:26 tom Exp $
+-- $Id: NEWS,v 1.809 2004/04/24 21:56:22 tom Exp $
 
 This is a log of changes that ncurses has gone through since Zeyd started
 working with Pavel Curtis' original work, pcurses, in 1992.
@@ -6,6 +6,96 @@
 Changes through 1.9.9e are recorded by Zeyd M. Ben-Halim.
 Changes since 1.9.9e are recorded by Thomas Dickey.
 
+20040424
+	+ minor compiler-warning and test-program fixes.
+
+20040417
+	+ modify tic's missing-sgr warning to apply to terminfo only.
+	+ free some memory leaks in tic.
+	+ remove check in post_menu() that prevented menus from extending
+	  beyond the screen (request by Max J. Werner).
+	+ remove check in newwin() that prevents allocating windows
+	  that extend beyond the screen.  Solaris curses does this.
+	+ add ifdef in test/color_set.c to allow it to compile with older
+	  curses.
+	+ add napms() calls to test/dots.c to make it not be a CPU hog.
+
+20040403
+	+ modify unctrl() to return null if its parameter does not correspond
+	  to an unsigned char.
+	+ add some limit-checks to guard isprint(), etc., from being used on
+	  values that do not fit into an unsigned char (report by Sami Farin).
+
+20040328
+	+ fix a typo in the _nc_get_locale() change.
+
+20040327
+	+ modify _nc_get_locale() to use setlocale() to query the program's
+	  current locale rather than using getenv().  This fixes a case in tin
+	  which relies on legacy treatment of 8-bit characters when the locale
+	  is not initialized (reported by Urs Jansen).
+	+ add sgr string to screen's and rxvt's terminfo entries -TD.
+	+ add a check in tic for terminfo entries having an sgr0 but no sgr
+	  string.  This confuses Tru64 and HPUX curses when combined with
+	  color, e.g., making them leave line-drawing characters in odd places.
+	+ correct casts used in ABSENT_BOOLEAN, CANCELLED_BOOLEAN, matches the
+	  original definitions used in Debian package to fix PowerPC bug before
+	  20030802 (Debian #237629).
+
+20040320
+	+ modify PutAttrChar() and PUTC() macro to improve use of
+	  A_ALTCHARSET attribute to prevent line-drawing characters from
+	  being lost in situations where the locale would otherwise treat the
+	  raw data as nonprintable (Debian #227879).
+
+20040313
+	+ fix a redefinition of CTRL() macro in test/view.c for AIX 5.2 (report
+	  by Jim Idle).
+	+ remove ".PP" after ".SH NAME" in a few manpages; this confuses
+	  some apropos script (Debian #237831).
+
+20040306
+	+ modify ncurses.c 'r' test so editing commands, like inserted text,
+	  set the field background, and the state of insert/overlay editing
+	  mode is shown in that test.
+	+ change syntax of dummy targets in Ada95 makefiles to work with pmake.
+	+ correct logic in test/ncurses.c 'b' for noncolor terminals which
+	  did not recognize a quit-command (cf: 20030419).
+
+20040228
+	+ modify _nc_insert_ch() to allow for its input to be part of a
+	  multibyte string.
+	+ split out lib_insnstr.c, to prepare to rewrite it.  X/Open states
+	  that this function performs wrapping, unlike all of the other
+	  insert-functions.  Currently it does not wrap.
+	+ check for nl_langinfo(CODESET), use it if available (report by
+	  Stanislav Ievlev).
+	+ split-out CF_BUILD_CC macro, actually did this for lynx first.
+	+ fixes for configure script CF_WITH_DBMALLOC and CF_WITH_DMALLOC,
+	  which happened to work with bash, but not with Bourne shell (report
+	  by Marco d'Itri via tin-dev).
+
+20040221
+	+ some changes to adapt the form library to wide characters, incomplete
+	  (request by Mike Aubury).
+	+ add symbol to curses.h which can be used to suppress include of
+	  stdbool.h, e.g.,
+	  	#define NCURSES_ENABLE_STDBOOL_H 0
+		#include <curses.h>
+	  (discussion on XFree86 mailing list).
+
+20040214
+	+ modify configure --with-termlib option to accept a value which sets
+	  the name of the terminfo library.  This would allow a packager to
+	  build libtinfow.so renamed to coincide with libtinfo.so (discussion
+	  with Stanislav Ievlev).
+	+ improve documentation of --with-install-prefix, --prefix and
+	  $(DESTDIR) in INSTALL (prompted by discussion with Paul Lew).
+	+ add configure check if the compiler can use -c -o options to rename
+	  its output file, use that to omit the 'cd' command which was used to
+	  ensure object files are created in a separate staging directory
+	  (prompted by comments by Johnny Wezel, Martin Mokrejs).
+
 20040208 5.4 release for upload to ftp.gnu.org
 	+ update TO-DO.
 
Index: TO-DO
Prereq:  1.43 
--- ncurses-5.4-20040208/TO-DO	2004-02-08 16:09:00.000000000 -0500
+++ ncurses-5.4-20040424/TO-DO	2004-03-06 21:04:20.000000000 -0500
@@ -1,4 +1,4 @@
--- $Id: TO-DO,v 1.43 2004/02/08 21:09:00 tom Exp $
+-- $Id: TO-DO,v 1.44 2004/03/07 02:04:20 tom Exp $
 
 SHORT-TERM TO-DO ITEMS:
 
@@ -6,9 +6,6 @@
 
 * The form/menu libraries do not use wide-character features.
 
-* Some users would like to build a single version of libtinfo which can be
-  used from either libncursesw or libncurses.
-
 * libtool does not work with GNAT.
 
 * The screen optimization has been tested only in an ad hoc manner.  We should
Index: aclocal.m4
Prereq:  1.333 
--- ncurses-5.4-20040208/aclocal.m4	2004-01-30 15:59:56.000000000 -0500
+++ ncurses-5.4-20040424/aclocal.m4	2004-02-28 14:34:44.000000000 -0500
@@ -26,15 +26,38 @@
 dnl authorization.                                                           *
 dnl***************************************************************************
 dnl
-dnl Author: Thomas E. Dickey 1995-2003
+dnl Author: Thomas E. Dickey 1995-2004
 dnl
-dnl $Id: aclocal.m4,v 1.333 2004/01/30 20:59:56 tom Exp $
+dnl $Id: aclocal.m4,v 1.338 2004/02/28 19:34:44 tom Exp $
 dnl Macros used in NCURSES auto-configuration script.
 dnl
 dnl See http://invisible-island.net/autoconf/ for additional information.
 dnl
 dnl ---------------------------------------------------------------------------
 dnl ---------------------------------------------------------------------------
+dnl AM_LANGINFO_CODESET version: 3 updated: 2002/10/27 23:21:42
+dnl -------------------
+dnl Inserted as requested by gettext 0.10.40
+dnl File from /usr/share/aclocal
+dnl codeset.m4
+dnl ====================
+dnl serial AM1
+dnl
+dnl From Bruno Haible.
+AC_DEFUN([AM_LANGINFO_CODESET],
+[
+  AC_CACHE_CHECK([for nl_langinfo and CODESET], am_cv_langinfo_codeset,
+    [AC_TRY_LINK([#include <langinfo.h>],
+      [char* cs = nl_langinfo(CODESET);],
+      am_cv_langinfo_codeset=yes,
+      am_cv_langinfo_codeset=no)
+    ])
+  if test $am_cv_langinfo_codeset = yes; then
+    AC_DEFINE(HAVE_LANGINFO_CODESET, 1,
+      [Define if you have <langinfo.h> and nl_langinfo(CODESET).])
+  fi
+])dnl
+dnl ---------------------------------------------------------------------------
 dnl CF_ADA_INCLUDE_DIRS version: 4 updated: 2002/12/01 00:12:15
 dnl -------------------
 dnl Construct the list of include-options for the C programs in the Ada95
@@ -282,6 +305,71 @@
 fi
 ])dnl
 dnl ---------------------------------------------------------------------------
+dnl CF_BUILD_CC version: 3 updated: 2004/02/17 20:55:59
+dnl -----------
+dnl If we're cross-compiling, allow the user to override the tools and their
+dnl options.  The configure script is oriented toward identifying the host
+dnl compiler, etc., but we need a build compiler to generate parts of the
+dnl source.
+dnl
+dnl $1 = default for $CPPFLAGS
+dnl $2 = default for $LIBS
+AC_DEFUN([CF_BUILD_CC],[
+AC_REQUIRE([CF_PROG_EXT])
+if test "$cross_compiling" = yes ; then
+	# defaults that we might want to override
+	: ${BUILD_CC:='$(CC)'}
+	: ${BUILD_CPP:='$(CC) -E'}
+	: ${BUILD_CFLAGS:=''}
+	: ${BUILD_CPPFLAGS:='ifelse([$1],,,[$1])'}
+	: ${BUILD_LDFLAGS:=''}
+	: ${BUILD_LIBS:='ifelse([$2],,,[$2])'}
+	: ${BUILD_EXEEXT:='$x'}
+	: ${BUILD_OBJEXT:='o'}
+	AC_ARG_WITH(build-cc,
+		[  --with-build-cc=XXX     the build C compiler ($BUILD_CC)],
+		[BUILD_CC="$withval"],
+		[AC_CHECK_PROGS(BUILD_CC, $CC gcc cc)])
+	AC_ARG_WITH(build-cpp,
+		[  --with-build-cpp=XXX    the build C preprocessor ($BUILD_CPP)],
+		[BUILD_CPP="$withval"],
+		[BUILD_CPP='$(CC) -E'])
+	AC_ARG_WITH(build-cflags,
+		[  --with-build-cflags=XXX the build C compiler-flags],
+		[BUILD_CFLAGS="$withval"])
+	AC_ARG_WITH(build-cppflags,
+		[  --with-build-cppflags=XXX the build C preprocessor-flags],
+		[BUILD_CPPFLAGS="$withval"])
+	AC_ARG_WITH(build-ldflags,
+		[  --with-build-ldflags=XXX the build linker-flags],
+		[BUILD_LDFLAGS="$withval"])
+	AC_ARG_WITH(build-libs,
+		[  --with-build-libs=XXX   the build libraries],
+		[BUILD_LIBS="$withval"])
+	# this assumes we're on Unix.
+	BUILD_EXEEXT=
+	BUILD_OBJEXT=o
+else
+	: ${BUILD_CC:='$(CC)'}
+	: ${BUILD_CPP:='$(CPP)'}
+	: ${BUILD_CFLAGS:='$(CFLAGS)'}
+	: ${BUILD_CPPFLAGS:='$(CPPFLAGS)'}
+	: ${BUILD_LDFLAGS:='$(LDFLAGS)'}
+	: ${BUILD_LIBS:='$(LIBS)'}
+	: ${BUILD_EXEEXT:='$x'}
+	: ${BUILD_OBJEXT:='o'}
+fi
+
+AC_SUBST(BUILD_CC)
+AC_SUBST(BUILD_CPP)
+AC_SUBST(BUILD_CFLAGS)
+AC_SUBST(BUILD_CPPFLAGS)
+AC_SUBST(BUILD_LDFLAGS)
+AC_SUBST(BUILD_LIBS)
+AC_SUBST(BUILD_EXEEXT)
+AC_SUBST(BUILD_OBJEXT)
+])dnl
+dnl ---------------------------------------------------------------------------
 dnl CF_CFG_DEFAULTS version: 6 updated: 2003/07/12 15:15:19
 dnl ---------------
 dnl Determine the default configuration into which we'll install ncurses.  This
@@ -1138,7 +1226,7 @@
 	AC_SUBST(LIB_PREFIX)
 ])dnl
 dnl ---------------------------------------------------------------------------
-dnl CF_LIB_RULES version: 30 updated: 2004/01/10 15:50:50
+dnl CF_LIB_RULES version: 33 updated: 2004/02/14 20:31:27
 dnl ------------
 dnl Append definitions and rules for the given models to the subdirectory
 dnl Makefiles, and the recursion rule for the top-level Makefile.  If the
@@ -1199,7 +1287,7 @@
 			cf_subsets="$LIB_SUBSETS"
 			cf_termlib=`echo "$cf_subsets" |sed -e 's/ .*$//'`
 			if test "$cf_termlib" != "$cf_subsets" ; then
-				cf_item=`echo $LIBS_TO_MAKE |sed -e s%$LIB_NAME%$TINFO_NAME%g`
+				cf_item=`echo $LIBS_TO_MAKE |sed -e s%${LIB_NAME}${LIB_SUFFIX}%${TINFO_LIB_SUFFIX}%g`
 				LIBS_TO_MAKE="$cf_item $LIBS_TO_MAKE"
 			fi
 		else
@@ -1226,6 +1314,22 @@
 			CF_LIB_SUFFIX($cf_item,cf_suffix)
 			CF_OBJ_SUBDIR($cf_item,cf_subdir)
 
+			# Test for case where we build libinfo with a different name.
+			cf_libname=$cf_dir
+			if test $cf_dir = ncurses ; then
+				case $cf_subset in
+				*base*)
+					;;
+				termlib*)
+					cf_libname=$TINFO_LIB_SUFFIX
+					if test -n "${DFT_ARG_SUFFIX}" ; then
+						# undo $LIB_SUFFIX add-on in CF_LIB_SUFFIX
+						cf_suffix=`echo $cf_suffix |sed -e "s%^${LIB_SUFFIX}%%"`
+					fi
+				;;
+				esac
+			fi
+
 			# These dependencies really are for development, not
 			# builds, but they are useful in porting, too.
 			cf_depend="../include/ncurses_cfg.h"
@@ -1242,7 +1346,7 @@
 			fi
 
 			$AWK -f $srcdir/mk-1st.awk \
-				name=$cf_dir \
+				name=$cf_libname \
 				traces=$LIB_TRACING \
 				MODEL=$CF_ITEM \
 				model=$cf_subdir \
@@ -1271,6 +1375,8 @@
 				subset=$cf_subset \
 				srcdir=$srcdir \
 				echo=$WITH_ECHO \
+				crenames=$cf_cv_prog_CC_c_o \
+				cxxrenames=$cf_cv_prog_CXX_c_o \
 				$srcdir/$cf_dir/modules >>$cf_dir/Makefile
 			cf_subdirs="$cf_subdirs $cf_subdir"
 			done
@@ -2462,6 +2568,45 @@
 fi
 ])dnl
 dnl ---------------------------------------------------------------------------
+dnl CF_PROG_CC_C_O version: 1 updated: 2004/02/14 15:00:43
+dnl --------------
+dnl Analogous to AC_PROG_CC_C_O, but more useful: tests only $CC, ensures that
+dnl the output file can be renamed, and allows for a shell variable that can
+dnl be used later.  The parameter is either CC or CXX.  The result is the
+dnl cache variable:
+dnl	$cf_cv_prog_CC_c_o
+dnl	$cf_cv_prog_CXX_c_o
+AC_DEFUN([CF_PROG_CC_C_O],
+[AC_REQUIRE([AC_PROG_CC])dnl
+AC_MSG_CHECKING([whether [$]$1 understands -c and -o together])
+AC_CACHE_VAL(cf_cv_prog_$1_c_o,
+[
+cat > conftest.$ac_ext <<CF_EOF
+#include <stdio.h>
+int main()
+{
+	return 0;
+}
+CF_EOF
+# We do the test twice because some compilers refuse to overwrite an
+# existing .o file with -o, though they will create one.
+ac_try='[$]$1 -c conftest.$ac_ext -o conftest2.$ac_objext >&AC_FD_CC'
+if AC_TRY_EVAL(ac_try) &&
+  test -f conftest2.$ac_objext && AC_TRY_EVAL(ac_try);
+then
+  eval cf_cv_prog_$1_c_o=yes
+else
+  eval cf_cv_prog_$1_c_o=no
+fi
+rm -f conftest*
+])dnl
+if test $cf_cv_prog_$1_c_o = yes; then
+  AC_MSG_RESULT([yes])
+else
+  AC_MSG_RESULT([no])
+fi
+])dnl
+dnl ---------------------------------------------------------------------------
 dnl CF_PROG_EXT version: 10 updated: 2004/01/03 19:28:18
 dnl -----------
 dnl Compute $PROG_EXT, used for non-Unix ports, such as OS/2 EMX.
@@ -2904,7 +3049,7 @@
 fi
 ])dnl
 dnl ---------------------------------------------------------------------------
-dnl CF_SRC_MODULES version: 15 updated: 2004/01/10 16:05:16
+dnl CF_SRC_MODULES version: 16 updated: 2004/02/14 20:18:37
 dnl --------------
 dnl For each parameter, test if the source-directory exists, and if it contains
 dnl a 'modules' file.  If so, add to the list $cf_cv_src_modules which we'll
@@ -2925,7 +3070,7 @@
 fi
 
 # dependencies and linker-arguments for utility-programs
-test "$with_termlib" != yes && PROG_ARGS="$TEST_ARGS"
+test "$with_termlib" = no && PROG_ARGS="$TEST_ARGS"
 
 cf_cv_src_modules=
 for cf_dir in $1
@@ -3356,33 +3501,37 @@
 ])
 ])dnl
 dnl ---------------------------------------------------------------------------
-dnl CF_WITH_DBMALLOC version: 2 updated: 2002/12/29 21:11:45
+dnl CF_WITH_DBMALLOC version: 4 updated: 2004/02/28 05:49:27
 dnl ----------------
-dnl Configure-option for dbmalloc
+dnl Configure-option for dbmalloc.  The optional parameter is used to override
+dnl the updating of $LIBS, e.g., to avoid conflict with subsequent tests.
 AC_DEFUN([CF_WITH_DBMALLOC],[
 AC_MSG_CHECKING(if you want to link with dbmalloc for testing)
 AC_ARG_WITH(dbmalloc,
-	[  --with-dbmalloc         test: use Conor Cahill's dbmalloc library],
+	[  --with-dbmalloc         use Conor Cahill's dbmalloc library],
 	[with_dbmalloc=$withval],
 	[with_dbmalloc=no])
 AC_MSG_RESULT($with_dbmalloc)
-if test $with_dbmalloc = yes ; then
-	AC_CHECK_LIB(dbmalloc,debug_malloc)
+if test "$with_dbmalloc" = yes ; then
+	AC_CHECK_HEADER(dbmalloc.h,
+		[AC_CHECK_LIB(dbmalloc,[debug_malloc]ifelse($1,,[],[,$1]))])
 fi
 ])dnl
 dnl ---------------------------------------------------------------------------
-dnl CF_WITH_DMALLOC version: 2 updated: 2002/12/29 21:11:45
+dnl CF_WITH_DMALLOC version: 4 updated: 2004/02/28 05:49:27
 dnl ---------------
-dnl Configure-option for dmalloc
+dnl Configure-option for dmalloc.  The optional parameter is used to override
+dnl the updating of $LIBS, e.g., to avoid conflict with subsequent tests.
 AC_DEFUN([CF_WITH_DMALLOC],[
 AC_MSG_CHECKING(if you want to link with dmalloc for testing)
 AC_ARG_WITH(dmalloc,
-	[  --with-dmalloc          test: use Gray Watson's dmalloc library],
+	[  --with-dmalloc          use Gray Watson's dmalloc library],
 	[with_dmalloc=$withval],
 	[with_dmalloc=no])
 AC_MSG_RESULT($with_dmalloc)
-if test $with_dmalloc = yes ; then
-	AC_CHECK_LIB(dmalloc,dmalloc_debug)
+if test "$with_dmalloc" = yes ; then
+	AC_CHECK_HEADER(dmalloc.h,
+		[AC_CHECK_LIB(dmalloc,[dmalloc_debug]ifelse($1,,[],[,$1]))])
 fi
 ])dnl
 dnl ---------------------------------------------------------------------------
Index: config.guess
--- ncurses-5.4-20040208/config.guess	2004-01-06 19:58:42.000000000 -0500
+++ ncurses-5.4-20040424/config.guess	2004-02-17 18:47:10.000000000 -0500
@@ -3,7 +3,7 @@
 #   Copyright (C) 1992, 1993, 1994, 1995, 1996, 1997, 1998, 1999,
 #   2000, 2001, 2002, 2003 Free Software Foundation, Inc.
 
-timestamp='2004-01-05'
+timestamp='2004-02-16'
 
 # This file is free software; you can redistribute it and/or modify it
 # under the terms of the GNU General Public License as published by
@@ -197,12 +197,18 @@
 	# CPU_TYPE-MANUFACTURER-OPERATING_SYSTEM is used.
 	echo "${machine}-${os}${release}"
 	exit 0 ;;
+    amd64:OpenBSD:*:*)
+	echo x86_64-unknown-openbsd${UNAME_RELEASE}
+	exit 0 ;;
     amiga:OpenBSD:*:*)
 	echo m68k-unknown-openbsd${UNAME_RELEASE}
 	exit 0 ;;
     arc:OpenBSD:*:*)
 	echo mipsel-unknown-openbsd${UNAME_RELEASE}
 	exit 0 ;;
+    cats:OpenBSD:*:*)
+	echo arm-unknown-openbsd${UNAME_RELEASE}
+	exit 0 ;;
     hp300:OpenBSD:*:*)
 	echo m68k-unknown-openbsd${UNAME_RELEASE}
 	exit 0 ;;
@@ -239,6 +245,15 @@
     *:OpenBSD:*:*)
 	echo ${UNAME_MACHINE}-unknown-openbsd${UNAME_RELEASE}
 	exit 0 ;;
+    *:ekkoBSD:*:*)
+	echo ${UNAME_MACHINE}-unknown-ekkobsd${UNAME_RELEASE}
+	exit 0 ;;
+    macppc:MirBSD:*:*)
+	echo powerppc-unknown-mirbsd${UNAME_RELEASE}
+	exit 0 ;;
+    *:MirBSD:*:*)
+	echo ${UNAME_MACHINE}-unknown-mirbsd${UNAME_RELEASE}
+	exit 0 ;;
     alpha:OSF1:*:*)
 	if test $UNAME_RELEASE = "V4.0"; then
 		UNAME_RELEASE=`/usr/sbin/sizer -v | awk '{print $3}'`
@@ -405,6 +420,9 @@
     *:*MiNT:*:* | *:*mint:*:* | *:*TOS:*:*)
         echo m68k-unknown-mint${UNAME_RELEASE}
         exit 0 ;;
+    m68k:machten:*:*)
+	echo m68k-apple-machten${UNAME_RELEASE}
+	exit 0 ;;
     powerpc:machten:*:*)
 	echo powerpc-apple-machten${UNAME_RELEASE}
 	exit 0 ;;
@@ -1230,8 +1248,8 @@
     SEI:*:*:SEIUX)
 	echo mips-sei-seiux${UNAME_RELEASE}
 	exit 0 ;;
-    *:DRAGONFLY:*:*)
-	echo ${UNAME_MACHINE}-unknown-dragonfly${UNAME_RELEASE}
+    *:DragonFly:*:*)
+	echo ${UNAME_MACHINE}-unknown-dragonfly`echo ${UNAME_RELEASE}|sed -e 's/[-(].*//'`
 	exit 0 ;;
 esac
 
Index: config.sub
--- ncurses-5.4-20040208/config.sub	2004-01-06 20:00:46.000000000 -0500
+++ ncurses-5.4-20040424/config.sub	2004-02-23 15:57:09.000000000 -0500
@@ -3,7 +3,7 @@
 #   Copyright (C) 1992, 1993, 1994, 1995, 1996, 1997, 1998, 1999,
 #   2000, 2001, 2002, 2003 Free Software Foundation, Inc.
 
-timestamp='2004-01-05'
+timestamp='2004-02-23'
 
 # This file is (in principle) common to ALL GNU software.
 # The presence of a machine in this file suggests that SOME GNU software
@@ -363,6 +363,9 @@
 		basic_machine=a29k-amd
 		os=-udi
 		;;
+	abacus)
+		basic_machine=abacus-unknown
+		;;
 	adobe68k)
 		basic_machine=m68010-adobe
 		os=-scout
@@ -442,12 +445,20 @@
 		basic_machine=j90-cray
 		os=-unicos
 		;;
+	cr16c)
+		basic_machine=cr16c-unknown
+		os=-elf
+		;;
 	crds | unos)
 		basic_machine=m68k-crds
 		;;
 	cris | cris-* | etrax*)
 		basic_machine=cris-axis
 		;;
+	crx)
+		basic_machine=crx-unknown
+		os=-elf
+		;;
 	da30 | da30-*)
 		basic_machine=m68k-da30
 		;;
@@ -1143,8 +1154,9 @@
 	      | -aos* \
 	      | -nindy* | -vxsim* | -vxworks* | -ebmon* | -hms* | -mvs* \
 	      | -clix* | -riscos* | -uniplus* | -iris* | -rtu* | -xenix* \
-	      | -hiux* | -386bsd* | -knetbsd* | -netbsd* | -openbsd* | -kfreebsd* | -freebsd* | -riscix* \
-	      | -lynxos* | -bosx* | -nextstep* | -cxux* | -aout* | -elf* | -oabi* \
+	      | -hiux* | -386bsd* | -knetbsd* | -mirbsd* | -netbsd* | -openbsd* \
+	      | -ekkobsd* | -kfreebsd* | -freebsd* | -riscix* | -lynxos* \
+	      | -bosx* | -nextstep* | -cxux* | -aout* | -elf* | -oabi* \
 	      | -ptx* | -coff* | -ecoff* | -winnt* | -domain* | -vsta* \
 	      | -udi* | -eabi* | -lites* | -ieee* | -go32* | -aux* \
 	      | -chorusos* | -chorusrdb* \
Index: configure
--- ncurses-5.4-20040208/configure	2004-01-31 20:03:42.000000000 -0500
+++ ncurses-5.4-20040424/configure	2004-02-28 20:07:21.000000000 -0500
@@ -1,5 +1,5 @@
 #! /bin/sh
-# From configure.in Revision: 1.312 .
+# From configure.in Revision: 1.316 .
 # Guess values for system-dependent variables and create Makefiles.
 # Generated by Autoconf 2.52.20030208.
 #
@@ -666,6 +666,7 @@
   --with-install-prefix   prefixes actual install-location ($DESTDIR)
 Build-Tools Needed to Compile Temporary Applications for Cross-compiling:
   --with-build-cc=XXX     the build C compiler ($BUILD_CC)
+  --with-build-cpp=XXX    the build C preprocessor ($BUILD_CPP)
   --with-build-cflags=XXX the build C compiler-flags
   --with-build-cppflags=XXX the build C preprocessor-flags
   --with-build-ldflags=XXX the build linker-flags
@@ -677,8 +678,8 @@
   --with-debug            generate debug-libraries (default)
   --with-profile          generate profile-libraries
   --with-termlib          generate separate terminfo library
-  --with-dbmalloc         test: use Conor Cahill's dbmalloc library
-  --with-dmalloc          test: use Gray Watson's dmalloc library
+  --with-dbmalloc         use Conor Cahill's dbmalloc library
+  --with-dmalloc          use Gray Watson's dmalloc library
   --with-gpm              use Alessandro Rubini's GPM library
   --with-sysmouse         use sysmouse (FreeBSD console)
   --enable-rpath          use rpath option when generating shared libraries
@@ -936,7 +937,7 @@
 fi
 for ac_site_file in $CONFIG_SITE; do
   if test -r "$ac_site_file"; then
-    { echo "$as_me:939: loading site script $ac_site_file" >&5
+    { echo "$as_me:940: loading site script $ac_site_file" >&5
 echo "$as_me: loading site script $ac_site_file" >&6;}
     cat "$ac_site_file" >&5
     . "$ac_site_file"
@@ -947,7 +948,7 @@
   # Some versions of bash will fail to source /dev/null (special
   # files actually), so we avoid doing that.
   if test -f "$cache_file"; then
-    { echo "$as_me:950: loading cache $cache_file" >&5
+    { echo "$as_me:951: loading cache $cache_file" >&5
 echo "$as_me: loading cache $cache_file" >&6;}
     case $cache_file in
       [\\/]* | ?:[\\/]* ) . $cache_file;;
@@ -955,7 +956,7 @@
     esac
   fi
 else
-  { echo "$as_me:958: creating cache $cache_file" >&5
+  { echo "$as_me:959: creating cache $cache_file" >&5
 echo "$as_me: creating cache $cache_file" >&6;}
   >$cache_file
 fi
@@ -971,21 +972,21 @@
   eval ac_new_val="\$ac_env_${ac_var}_value"
   case $ac_old_set,$ac_new_set in
     set,)
-      { echo "$as_me:974: error: \`$ac_var' was set to \`$ac_old_val' in the previous run" >&5
+      { echo "$as_me:975: error: \`$ac_var' was set to \`$ac_old_val' in the previous run" >&5
 echo "$as_me: error: \`$ac_var' was set to \`$ac_old_val' in the previous run" >&2;}
       ac_cache_corrupted=: ;;
     ,set)
-      { echo "$as_me:978: error: \`$ac_var' was not set in the previous run" >&5
+      { echo "$as_me:979: error: \`$ac_var' was not set in the previous run" >&5
 echo "$as_me: error: \`$ac_var' was not set in the previous run" >&2;}
       ac_cache_corrupted=: ;;
     ,);;
     *)
       if test "x$ac_old_val" != "x$ac_new_val"; then
-        { echo "$as_me:984: error: \`$ac_var' has changed since the previous run:" >&5
+        { echo "$as_me:985: error: \`$ac_var' has changed since the previous run:" >&5
 echo "$as_me: error: \`$ac_var' has changed since the previous run:" >&2;}
-        { echo "$as_me:986:   former value:  $ac_old_val" >&5
+        { echo "$as_me:987:   former value:  $ac_old_val" >&5
 echo "$as_me:   former value:  $ac_old_val" >&2;}
-        { echo "$as_me:988:   current value: $ac_new_val" >&5
+        { echo "$as_me:989:   current value: $ac_new_val" >&5
 echo "$as_me:   current value: $ac_new_val" >&2;}
         ac_cache_corrupted=:
       fi;;
@@ -1004,9 +1005,9 @@
   fi
 done
 if $ac_cache_corrupted; then
-  { echo "$as_me:1007: error: changes in the environment can compromise the build" >&5
+  { echo "$as_me:1008: error: changes in the environment can compromise the build" >&5
 echo "$as_me: error: changes in the environment can compromise the build" >&2;}
-  { { echo "$as_me:1009: error: run \`make distclean' and/or \`rm $cache_file' and start over" >&5
+  { { echo "$as_me:1010: error: run \`make distclean' and/or \`rm $cache_file' and start over" >&5
 echo "$as_me: error: run \`make distclean' and/or \`rm $cache_file' and start over" >&2;}
    { (exit 1); exit 1; }; }
 fi
@@ -1026,10 +1027,10 @@
 echo "#! $SHELL" >conftest.sh
 echo  "exit 0"   >>conftest.sh
 chmod +x conftest.sh
-if { (echo "$as_me:1029: PATH=\".;.\"; conftest.sh") >&5
+if { (echo "$as_me:1030: PATH=\".;.\"; conftest.sh") >&5
   (PATH=".;."; conftest.sh) 2>&5
   ac_status=$?
-  echo "$as_me:1032: \$? = $ac_status" >&5
+  echo "$as_me:1033: \$? = $ac_status" >&5
   (exit $ac_status); }; then
   ac_path_separator=';'
 else
@@ -1046,7 +1047,7 @@
 cf_cv_abi_version=${NCURSES_MAJOR}
 cf_cv_rel_version=${NCURSES_MAJOR}.${NCURSES_MINOR}
 cf_cv_timestamp=`date`
-echo "$as_me:1049: result: Configuring NCURSES $cf_cv_rel_version ABI $cf_cv_abi_version ($cf_cv_timestamp)" >&5
+echo "$as_me:1050: result: Configuring NCURSES $cf_cv_rel_version ABI $cf_cv_abi_version ($cf_cv_timestamp)" >&5
 echo "${ECHO_T}Configuring NCURSES $cf_cv_rel_version ABI $cf_cv_abi_version ($cf_cv_timestamp)" >&6
 
 test -z "$cf_cv_rel_version" && cf_cv_rel_version=0.0
@@ -1054,7 +1055,7 @@
 # Check whether --with-rel-version or --without-rel-version was given.
 if test "${with_rel_version+set}" = set; then
   withval="$with_rel_version"
-  { echo "$as_me:1057: WARNING: overriding release version $cf_cv_rel_version to $withval" >&5
+  { echo "$as_me:1058: WARNING: overriding release version $cf_cv_rel_version to $withval" >&5
 echo "$as_me: WARNING: overriding release version $cf_cv_rel_version to $withval" >&2;}
  cf_cv_rel_version=$withval
 fi;
@@ -1067,13 +1068,13 @@
   [0-9]*) #(vi
  	;;
   *)
-	{ { echo "$as_me:1070: error: Release major-version is not a number: $NCURSES_MAJOR" >&5
+	{ { echo "$as_me:1071: error: Release major-version is not a number: $NCURSES_MAJOR" >&5
 echo "$as_me: error: Release major-version is not a number: $NCURSES_MAJOR" >&2;}
    { (exit 1); exit 1; }; }
  	;;
   esac
 else
-  { { echo "$as_me:1076: error: Release major-version value is empty" >&5
+  { { echo "$as_me:1077: error: Release major-version value is empty" >&5
 echo "$as_me: error: Release major-version value is empty" >&2;}
    { (exit 1); exit 1; }; }
 fi
@@ -1083,13 +1084,13 @@
   [0-9]*) #(vi
  	;;
   *)
-	{ { echo "$as_me:1086: error: Release minor-version is not a number: $NCURSES_MINOR" >&5
+	{ { echo "$as_me:1087: error: Release minor-version is not a number: $NCURSES_MINOR" >&5
 echo "$as_me: error: Release minor-version is not a number: $NCURSES_MINOR" >&2;}
    { (exit 1); exit 1; }; }
  	;;
   esac
 else
-  { { echo "$as_me:1092: error: Release minor-version value is empty" >&5
+  { { echo "$as_me:1093: error: Release minor-version value is empty" >&5
 echo "$as_me: error: Release minor-version value is empty" >&2;}
    { (exit 1); exit 1; }; }
 fi
@@ -1099,7 +1100,7 @@
 # Check whether --with-abi-version or --without-abi-version was given.
 if test "${with_abi_version+set}" = set; then
   withval="$with_abi_version"
-  { echo "$as_me:1102: WARNING: overriding ABI version $cf_cv_abi_version to $withval" >&5
+  { echo "$as_me:1103: WARNING: overriding ABI version $cf_cv_abi_version to $withval" >&5
 echo "$as_me: WARNING: overriding ABI version $cf_cv_abi_version to $withval" >&2;}
  cf_cv_abi_version=$withval
 fi;
@@ -1109,13 +1110,13 @@
   [0-9]*) #(vi
  	;;
   *)
-	{ { echo "$as_me:1112: error: ABI version is not a number: $cf_cv_abi_version" >&5
+	{ { echo "$as_me:1113: error: ABI version is not a number: $cf_cv_abi_version" >&5
 echo "$as_me: error: ABI version is not a number: $cf_cv_abi_version" >&2;}
    { (exit 1); exit 1; }; }
  	;;
   esac
 else
-  { { echo "$as_me:1118: error: ABI version value is empty" >&5
+  { { echo "$as_me:1119: error: ABI version value is empty" >&5
 echo "$as_me: error: ABI version value is empty" >&2;}
    { (exit 1); exit 1; }; }
 fi
@@ -1137,7 +1138,7 @@
   fi
 done
 if test -z "$ac_aux_dir"; then
-  { { echo "$as_me:1140: error: cannot find install-sh or install.sh in $srcdir $srcdir/.. $srcdir/../.." >&5
+  { { echo "$as_me:1141: error: cannot find install-sh or install.sh in $srcdir $srcdir/.. $srcdir/../.." >&5
 echo "$as_me: error: cannot find install-sh or install.sh in $srcdir $srcdir/.. $srcdir/../.." >&2;}
    { (exit 1); exit 1; }; }
 fi
@@ -1147,11 +1148,11 @@
 
 # Make sure we can run config.sub.
 $ac_config_sub sun4 >/dev/null 2>&1 ||
-  { { echo "$as_me:1150: error: cannot run $ac_config_sub" >&5
+  { { echo "$as_me:1151: error: cannot run $ac_config_sub" >&5
 echo "$as_me: error: cannot run $ac_config_sub" >&2;}
    { (exit 1); exit 1; }; }
 
-echo "$as_me:1154: checking build system type" >&5
+echo "$as_me:1155: checking build system type" >&5
 echo $ECHO_N "checking build system type... $ECHO_C" >&6
 if test "${ac_cv_build+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
@@ -1160,23 +1161,23 @@
 test -z "$ac_cv_build_alias" &&
   ac_cv_build_alias=`$ac_config_guess`
 test -z "$ac_cv_build_alias" &&
-  { { echo "$as_me:1163: error: cannot guess build type; you must specify one" >&5
+  { { echo "$as_me:1164: error: cannot guess build type; you must specify one" >&5
 echo "$as_me: error: cannot guess build type; you must specify one" >&2;}
    { (exit 1); exit 1; }; }
 ac_cv_build=`$ac_config_sub $ac_cv_build_alias` ||
-  { { echo "$as_me:1167: error: $ac_config_sub $ac_cv_build_alias failed." >&5
+  { { echo "$as_me:1168: error: $ac_config_sub $ac_cv_build_alias failed." >&5
 echo "$as_me: error: $ac_config_sub $ac_cv_build_alias failed." >&2;}
    { (exit 1); exit 1; }; }
 
 fi
-echo "$as_me:1172: result: $ac_cv_build" >&5
+echo "$as_me:1173: result: $ac_cv_build" >&5
 echo "${ECHO_T}$ac_cv_build" >&6
 build=$ac_cv_build
 build_cpu=`echo $ac_cv_build | sed 's/^\([^-]*\)-\([^-]*\)-\(.*\)$/\1/'`
 build_vendor=`echo $ac_cv_build | sed 's/^\([^-]*\)-\([^-]*\)-\(.*\)$/\2/'`
 build_os=`echo $ac_cv_build | sed 's/^\([^-]*\)-\([^-]*\)-\(.*\)$/\3/'`
 
-echo "$as_me:1179: checking host system type" >&5
+echo "$as_me:1180: checking host system type" >&5
 echo $ECHO_N "checking host system type... $ECHO_C" >&6
 if test "${ac_cv_host+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
@@ -1185,12 +1186,12 @@
 test -z "$ac_cv_host_alias" &&
   ac_cv_host_alias=$ac_cv_build_alias
 ac_cv_host=`$ac_config_sub $ac_cv_host_alias` ||
-  { { echo "$as_me:1188: error: $ac_config_sub $ac_cv_host_alias failed" >&5
+  { { echo "$as_me:1189: error: $ac_config_sub $ac_cv_host_alias failed" >&5
 echo "$as_me: error: $ac_config_sub $ac_cv_host_alias failed" >&2;}
    { (exit 1); exit 1; }; }
 
 fi
-echo "$as_me:1193: result: $ac_cv_host" >&5
+echo "$as_me:1194: result: $ac_cv_host" >&5
 echo "${ECHO_T}$ac_cv_host" >&6
 host=$ac_cv_host
 host_cpu=`echo $ac_cv_host | sed 's/^\([^-]*\)-\([^-]*\)-\(.*\)$/\1/'`
@@ -1198,7 +1199,7 @@
 host_os=`echo $ac_cv_host | sed 's/^\([^-]*\)-\([^-]*\)-\(.*\)$/\3/'`
 
 if test -f $srcdir/config.guess ; then
-	echo "$as_me:1201: checking target system type" >&5
+	echo "$as_me:1202: checking target system type" >&5
 echo $ECHO_N "checking target system type... $ECHO_C" >&6
 if test "${ac_cv_target+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
@@ -1207,12 +1208,12 @@
 test "x$ac_cv_target_alias" = "x" &&
   ac_cv_target_alias=$ac_cv_host_alias
 ac_cv_target=`$ac_config_sub $ac_cv_target_alias` ||
-  { { echo "$as_me:1210: error: $ac_config_sub $ac_cv_target_alias failed" >&5
+  { { echo "$as_me:1211: error: $ac_config_sub $ac_cv_target_alias failed" >&5
 echo "$as_me: error: $ac_config_sub $ac_cv_target_alias failed" >&2;}
    { (exit 1); exit 1; }; }
 
 fi
-echo "$as_me:1215: result: $ac_cv_target" >&5
+echo "$as_me:1216: result: $ac_cv_target" >&5
 echo "${ECHO_T}$ac_cv_target" >&6
 target=$ac_cv_target
 target_cpu=`echo $ac_cv_target | sed 's/^\([^-]*\)-\([^-]*\)-\(.*\)$/\1/'`
@@ -1243,13 +1244,13 @@
 fi
 
 test -z "$system_name" && system_name="$cf_cv_system_name"
-test -n "$cf_cv_system_name" && echo "$as_me:1246: result: Configuring for $cf_cv_system_name" >&5
+test -n "$cf_cv_system_name" && echo "$as_me:1247: result: Configuring for $cf_cv_system_name" >&5
 echo "${ECHO_T}Configuring for $cf_cv_system_name" >&6
 
 if test ".$system_name" != ".$cf_cv_system_name" ; then
-	echo "$as_me:1250: result: Cached system name ($system_name) does not agree with actual ($cf_cv_system_name)" >&5
+	echo "$as_me:1251: result: Cached system name ($system_name) does not agree with actual ($cf_cv_system_name)" >&5
 echo "${ECHO_T}Cached system name ($system_name) does not agree with actual ($cf_cv_system_name)" >&6
-	{ { echo "$as_me:1252: error: \"Please remove config.cache and try again.\"" >&5
+	{ { echo "$as_me:1253: error: \"Please remove config.cache and try again.\"" >&5
 echo "$as_me: error: \"Please remove config.cache and try again.\"" >&2;}
    { (exit 1); exit 1; }; }
 fi
@@ -1257,7 +1258,7 @@
 # Check whether --with-system-type or --without-system-type was given.
 if test "${with_system_type+set}" = set; then
   withval="$with_system_type"
-  { echo "$as_me:1260: WARNING: overriding system type to $withval" >&5
+  { echo "$as_me:1261: WARNING: overriding system type to $withval" >&5
 echo "$as_me: WARNING: overriding system type to $withval" >&2;}
  cf_cv_system_name=$withval
 fi;
@@ -1267,7 +1268,7 @@
 
 ###	Default install-location
 
-echo "$as_me:1270: checking for prefix" >&5
+echo "$as_me:1271: checking for prefix" >&5
 echo $ECHO_N "checking for prefix... $ECHO_C" >&6
 if test "x$prefix" = "xNONE" ; then
 	case "$cf_cv_system_name" in
@@ -1279,11 +1280,11 @@
 		;;
 	esac
 fi
-echo "$as_me:1282: result: $prefix" >&5
+echo "$as_me:1283: result: $prefix" >&5
 echo "${ECHO_T}$prefix" >&6
 
 if test "x$prefix" = "xNONE" ; then
-echo "$as_me:1286: checking for default include-directory" >&5
+echo "$as_me:1287: checking for default include-directory" >&5
 echo $ECHO_N "checking for default include-directory... $ECHO_C" >&6
 test -n "$verbose" && echo 1>&6
 for cf_symbol in \
@@ -1306,7 +1307,7 @@
 	fi
 	test -n "$verbose"  && echo "	tested $cf_dir" 1>&6
 done
-echo "$as_me:1309: result: $includedir" >&5
+echo "$as_me:1310: result: $includedir" >&5
 echo "${ECHO_T}$includedir" >&6
 fi
 
@@ -1319,7 +1320,7 @@
 if test -n "$ac_tool_prefix"; then
   # Extract the first word of "${ac_tool_prefix}gcc", so it can be a program name with args.
 set dummy ${ac_tool_prefix}gcc; ac_word=$2
-echo "$as_me:1322: checking for $ac_word" >&5
+echo "$as_me:1323: checking for $ac_word" >&5
 echo $ECHO_N "checking for $ac_word... $ECHO_C" >&6
 if test "${ac_cv_prog_CC+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
@@ -1334,7 +1335,7 @@
   test -z "$ac_dir" && ac_dir=.
   $as_executable_p "$ac_dir/$ac_word" || continue
 ac_cv_prog_CC="${ac_tool_prefix}gcc"
-echo "$as_me:1337: found $ac_dir/$ac_word" >&5
+echo "$as_me:1338: found $ac_dir/$ac_word" >&5
 break
 done
 
@@ -1342,10 +1343,10 @@
 fi
 CC=$ac_cv_prog_CC
 if test -n "$CC"; then
-  echo "$as_me:1345: result: $CC" >&5
+  echo "$as_me:1346: result: $CC" >&5
 echo "${ECHO_T}$CC" >&6
 else
-  echo "$as_me:1348: result: no" >&5
+  echo "$as_me:1349: result: no" >&5
 echo "${ECHO_T}no" >&6
 fi
 
@@ -1354,7 +1355,7 @@
   ac_ct_CC=$CC
   # Extract the first word of "gcc", so it can be a program name with args.
 set dummy gcc; ac_word=$2
-echo "$as_me:1357: checking for $ac_word" >&5
+echo "$as_me:1358: checking for $ac_word" >&5
 echo $ECHO_N "checking for $ac_word... $ECHO_C" >&6
 if test "${ac_cv_prog_ac_ct_CC+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
@@ -1369,7 +1370,7 @@
   test -z "$ac_dir" && ac_dir=.
   $as_executable_p "$ac_dir/$ac_word" || continue
 ac_cv_prog_ac_ct_CC="gcc"
-echo "$as_me:1372: found $ac_dir/$ac_word" >&5
+echo "$as_me:1373: found $ac_dir/$ac_word" >&5
 break
 done
 
@@ -1377,10 +1378,10 @@
 fi
 ac_ct_CC=$ac_cv_prog_ac_ct_CC
 if test -n "$ac_ct_CC"; then
-  echo "$as_me:1380: result: $ac_ct_CC" >&5
+  echo "$as_me:1381: result: $ac_ct_CC" >&5
 echo "${ECHO_T}$ac_ct_CC" >&6
 else
-  echo "$as_me:1383: result: no" >&5
+  echo "$as_me:1384: result: no" >&5
 echo "${ECHO_T}no" >&6
 fi
 
@@ -1393,7 +1394,7 @@
   if test -n "$ac_tool_prefix"; then
   # Extract the first word of "${ac_tool_prefix}cc", so it can be a program name with args.
 set dummy ${ac_tool_prefix}cc; ac_word=$2
-echo "$as_me:1396: checking for $ac_word" >&5
+echo "$as_me:1397: checking for $ac_word" >&5
 echo $ECHO_N "checking for $ac_word... $ECHO_C" >&6
 if test "${ac_cv_prog_CC+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
@@ -1408,7 +1409,7 @@
   test -z "$ac_dir" && ac_dir=.
   $as_executable_p "$ac_dir/$ac_word" || continue
 ac_cv_prog_CC="${ac_tool_prefix}cc"
-echo "$as_me:1411: found $ac_dir/$ac_word" >&5
+echo "$as_me:1412: found $ac_dir/$ac_word" >&5
 break
 done
 
@@ -1416,10 +1417,10 @@
 fi
 CC=$ac_cv_prog_CC
 if test -n "$CC"; then
-  echo "$as_me:1419: result: $CC" >&5
+  echo "$as_me:1420: result: $CC" >&5
 echo "${ECHO_T}$CC" >&6
 else
-  echo "$as_me:1422: result: no" >&5
+  echo "$as_me:1423: result: no" >&5
 echo "${ECHO_T}no" >&6
 fi
 
@@ -1428,7 +1429,7 @@
   ac_ct_CC=$CC
   # Extract the first word of "cc", so it can be a program name with args.
 set dummy cc; ac_word=$2
-echo "$as_me:1431: checking for $ac_word" >&5
+echo "$as_me:1432: checking for $ac_word" >&5
 echo $ECHO_N "checking for $ac_word... $ECHO_C" >&6
 if test "${ac_cv_prog_ac_ct_CC+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
@@ -1443,7 +1444,7 @@
   test -z "$ac_dir" && ac_dir=.
   $as_executable_p "$ac_dir/$ac_word" || continue
 ac_cv_prog_ac_ct_CC="cc"
-echo "$as_me:1446: found $ac_dir/$ac_word" >&5
+echo "$as_me:1447: found $ac_dir/$ac_word" >&5
 break
 done
 
@@ -1451,10 +1452,10 @@
 fi
 ac_ct_CC=$ac_cv_prog_ac_ct_CC
 if test -n "$ac_ct_CC"; then
-  echo "$as_me:1454: result: $ac_ct_CC" >&5
+  echo "$as_me:1455: result: $ac_ct_CC" >&5
 echo "${ECHO_T}$ac_ct_CC" >&6
 else
-  echo "$as_me:1457: result: no" >&5
+  echo "$as_me:1458: result: no" >&5
 echo "${ECHO_T}no" >&6
 fi
 
@@ -1467,7 +1468,7 @@
 if test -z "$CC"; then
   # Extract the first word of "cc", so it can be a program name with args.
 set dummy cc; ac_word=$2
-echo "$as_me:1470: checking for $ac_word" >&5
+echo "$as_me:1471: checking for $ac_word" >&5
 echo $ECHO_N "checking for $ac_word... $ECHO_C" >&6
 if test "${ac_cv_prog_CC+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
@@ -1487,7 +1488,7 @@
   continue
 fi
 ac_cv_prog_CC="cc"
-echo "$as_me:1490: found $ac_dir/$ac_word" >&5
+echo "$as_me:1491: found $ac_dir/$ac_word" >&5
 break
 done
 
@@ -1509,10 +1510,10 @@
 fi
 CC=$ac_cv_prog_CC
 if test -n "$CC"; then
-  echo "$as_me:1512: result: $CC" >&5
+  echo "$as_me:1513: result: $CC" >&5
 echo "${ECHO_T}$CC" >&6
 else
-  echo "$as_me:1515: result: no" >&5
+  echo "$as_me:1516: result: no" >&5
 echo "${ECHO_T}no" >&6
 fi
 
@@ -1523,7 +1524,7 @@
   do
     # Extract the first word of "$ac_tool_prefix$ac_prog", so it can be a program name with args.
 set dummy $ac_tool_prefix$ac_prog; ac_word=$2
-echo "$as_me:1526: checking for $ac_word" >&5
+echo "$as_me:1527: checking for $ac_word" >&5
 echo $ECHO_N "checking for $ac_word... $ECHO_C" >&6
 if test "${ac_cv_prog_CC+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
@@ -1538,7 +1539,7 @@
   test -z "$ac_dir" && ac_dir=.
   $as_executable_p "$ac_dir/$ac_word" || continue
 ac_cv_prog_CC="$ac_tool_prefix$ac_prog"
-echo "$as_me:1541: found $ac_dir/$ac_word" >&5
+echo "$as_me:1542: found $ac_dir/$ac_word" >&5
 break
 done
 
@@ -1546,10 +1547,10 @@
 fi
 CC=$ac_cv_prog_CC
 if test -n "$CC"; then
-  echo "$as_me:1549: result: $CC" >&5
+  echo "$as_me:1550: result: $CC" >&5
 echo "${ECHO_T}$CC" >&6
 else
-  echo "$as_me:1552: result: no" >&5
+  echo "$as_me:1553: result: no" >&5
 echo "${ECHO_T}no" >&6
 fi
 
@@ -1562,7 +1563,7 @@
 do
   # Extract the first word of "$ac_prog", so it can be a program name with args.
 set dummy $ac_prog; ac_word=$2
-echo "$as_me:1565: checking for $ac_word" >&5
+echo "$as_me:1566: checking for $ac_word" >&5
 echo $ECHO_N "checking for $ac_word... $ECHO_C" >&6
 if test "${ac_cv_prog_ac_ct_CC+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
@@ -1577,7 +1578,7 @@
   test -z "$ac_dir" && ac_dir=.
   $as_executable_p "$ac_dir/$ac_word" || continue
 ac_cv_prog_ac_ct_CC="$ac_prog"
-echo "$as_me:1580: found $ac_dir/$ac_word" >&5
+echo "$as_me:1581: found $ac_dir/$ac_word" >&5
 break
 done
 
@@ -1585,10 +1586,10 @@
 fi
 ac_ct_CC=$ac_cv_prog_ac_ct_CC
 if test -n "$ac_ct_CC"; then
-  echo "$as_me:1588: result: $ac_ct_CC" >&5
+  echo "$as_me:1589: result: $ac_ct_CC" >&5
 echo "${ECHO_T}$ac_ct_CC" >&6
 else
-  echo "$as_me:1591: result: no" >&5
+  echo "$as_me:1592: result: no" >&5
 echo "${ECHO_T}no" >&6
 fi
 
@@ -1600,32 +1601,32 @@
 
 fi
 
-test -z "$CC" && { { echo "$as_me:1603: error: no acceptable cc found in \$PATH" >&5
+test -z "$CC" && { { echo "$as_me:1604: error: no acceptable cc found in \$PATH" >&5
 echo "$as_me: error: no acceptable cc found in \$PATH" >&2;}
    { (exit 1); exit 1; }; }
 
 # Provide some information about the compiler.
-echo "$as_me:1608:" \
+echo "$as_me:1609:" \
      "checking for C compiler version" >&5
 ac_compiler=`set X $ac_compile; echo $2`
-{ (eval echo "$as_me:1611: \"$ac_compiler --version </dev/null >&5\"") >&5
+{ (eval echo "$as_me:1612: \"$ac_compiler --version </dev/null >&5\"") >&5
   (eval $ac_compiler --version </dev/null >&5) 2>&5
   ac_status=$?
-  echo "$as_me:1614: \$? = $ac_status" >&5
+  echo "$as_me:1615: \$? = $ac_status" >&5
   (exit $ac_status); }
-{ (eval echo "$as_me:1616: \"$ac_compiler -v </dev/null >&5\"") >&5
+{ (eval echo "$as_me:1617: \"$ac_compiler -v </dev/null >&5\"") >&5
   (eval $ac_compiler -v </dev/null >&5) 2>&5
   ac_status=$?
-  echo "$as_me:1619: \$? = $ac_status" >&5
+  echo "$as_me:1620: \$? = $ac_status" >&5
   (exit $ac_status); }
-{ (eval echo "$as_me:1621: \"$ac_compiler -V </dev/null >&5\"") >&5
+{ (eval echo "$as_me:1622: \"$ac_compiler -V </dev/null >&5\"") >&5
   (eval $ac_compiler -V </dev/null >&5) 2>&5
   ac_status=$?
-  echo "$as_me:1624: \$? = $ac_status" >&5
+  echo "$as_me:1625: \$? = $ac_status" >&5
   (exit $ac_status); }
 
 cat >conftest.$ac_ext <<_ACEOF
-#line 1628 "configure"
+#line 1629 "configure"
 #include "confdefs.h"
 
 int
@@ -1641,13 +1642,13 @@
 # Try to create an executable without -o first, disregard a.out.
 # It will help us diagnose broken compilers, and finding out an intuition
 # of exeext.
-echo "$as_me:1644: checking for C compiler default output" >&5
+echo "$as_me:1645: checking for C compiler default output" >&5
 echo $ECHO_N "checking for C compiler default output... $ECHO_C" >&6
 ac_link_default=`echo "$ac_link" | sed 's/ -o *conftest[^ ]*//'`
-if { (eval echo "$as_me:1647: \"$ac_link_default\"") >&5
+if { (eval echo "$as_me:1648: \"$ac_link_default\"") >&5
   (eval $ac_link_default) 2>&5
   ac_status=$?
-  echo "$as_me:1650: \$? = $ac_status" >&5
+  echo "$as_me:1651: \$? = $ac_status" >&5
   (exit $ac_status); }; then
   # Find the output, starting from the most likely.  This scheme is
 # not robust to junk in `.', hence go to wildcards (a.*) only as a last
@@ -1670,34 +1671,34 @@
 else
   echo "$as_me: failed program was:" >&5
 cat conftest.$ac_ext >&5
-{ { echo "$as_me:1673: error: C compiler cannot create executables" >&5
+{ { echo "$as_me:1674: error: C compiler cannot create executables" >&5
 echo "$as_me: error: C compiler cannot create executables" >&2;}
    { (exit 77); exit 77; }; }
 fi
 
 ac_exeext=$ac_cv_exeext
-echo "$as_me:1679: result: $ac_file" >&5
+echo "$as_me:1680: result: $ac_file" >&5
 echo "${ECHO_T}$ac_file" >&6
 
 # Check the compiler produces executables we can run.  If not, either
 # the compiler is broken, or we cross compile.
-echo "$as_me:1684: checking whether the C compiler works" >&5
+echo "$as_me:1685: checking whether the C compiler works" >&5
 echo $ECHO_N "checking whether the C compiler works... $ECHO_C" >&6
 # FIXME: These cross compiler hacks should be removed for Autoconf 3.0
 # If not cross compiling, check that we can run a simple program.
 if test "$cross_compiling" != yes; then
   if { ac_try='./$ac_file'
-  { (eval echo "$as_me:1690: \"$ac_try\"") >&5
+  { (eval echo "$as_me:1691: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:1693: \$? = $ac_status" >&5
+  echo "$as_me:1694: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
     cross_compiling=no
   else
     if test "$cross_compiling" = maybe; then
 	cross_compiling=yes
     else
-	{ { echo "$as_me:1700: error: cannot run C compiled programs.
+	{ { echo "$as_me:1701: error: cannot run C compiled programs.
 If you meant to cross compile, use \`--host'." >&5
 echo "$as_me: error: cannot run C compiled programs.
 If you meant to cross compile, use \`--host'." >&2;}
@@ -1705,24 +1706,24 @@
     fi
   fi
 fi
-echo "$as_me:1708: result: yes" >&5
+echo "$as_me:1709: result: yes" >&5
 echo "${ECHO_T}yes" >&6
 
 rm -f a.out a.exe conftest$ac_cv_exeext
 ac_clean_files=$ac_clean_files_save
 # Check the compiler produces executables we can run.  If not, either
 # the compiler is broken, or we cross compile.
-echo "$as_me:1715: checking whether we are cross compiling" >&5
+echo "$as_me:1716: checking whether we are cross compiling" >&5
 echo $ECHO_N "checking whether we are cross compiling... $ECHO_C" >&6
-echo "$as_me:1717: result: $cross_compiling" >&5
+echo "$as_me:1718: result: $cross_compiling" >&5
 echo "${ECHO_T}$cross_compiling" >&6
 
-echo "$as_me:1720: checking for executable suffix" >&5
+echo "$as_me:1721: checking for executable suffix" >&5
 echo $ECHO_N "checking for executable suffix... $ECHO_C" >&6
-if { (eval echo "$as_me:1722: \"$ac_link\"") >&5
+if { (eval echo "$as_me:1723: \"$ac_link\"") >&5
   (eval $ac_link) 2>&5
   ac_status=$?
-  echo "$as_me:1725: \$? = $ac_status" >&5
+  echo "$as_me:1726: \$? = $ac_status" >&5
   (exit $ac_status); }; then
   # If both `conftest.exe' and `conftest' are `present' (well, observable)
 # catch `conftest.exe'.  For instance with Cygwin, `ls conftest' will
@@ -1738,25 +1739,25 @@
   esac
 done
 else
-  { { echo "$as_me:1741: error: cannot compute EXEEXT: cannot compile and link" >&5
+  { { echo "$as_me:1742: error: cannot compute EXEEXT: cannot compile and link" >&5
 echo "$as_me: error: cannot compute EXEEXT: cannot compile and link" >&2;}
    { (exit 1); exit 1; }; }
 fi
 
 rm -f conftest$ac_cv_exeext
-echo "$as_me:1747: result: $ac_cv_exeext" >&5
+echo "$as_me:1748: result: $ac_cv_exeext" >&5
 echo "${ECHO_T}$ac_cv_exeext" >&6
 
 rm -f conftest.$ac_ext
 EXEEXT=$ac_cv_exeext
 ac_exeext=$EXEEXT
-echo "$as_me:1753: checking for object suffix" >&5
+echo "$as_me:1754: checking for object suffix" >&5
 echo $ECHO_N "checking for object suffix... $ECHO_C" >&6
 if test "${ac_cv_objext+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
 else
   cat >conftest.$ac_ext <<_ACEOF
-#line 1759 "configure"
+#line 1760 "configure"
 #include "confdefs.h"
 
 int
@@ -1768,10 +1769,10 @@
 }
 _ACEOF
 rm -f conftest.o conftest.obj
-if { (eval echo "$as_me:1771: \"$ac_compile\"") >&5
+if { (eval echo "$as_me:1772: \"$ac_compile\"") >&5
   (eval $ac_compile) 2>&5
   ac_status=$?
-  echo "$as_me:1774: \$? = $ac_status" >&5
+  echo "$as_me:1775: \$? = $ac_status" >&5
   (exit $ac_status); }; then
   for ac_file in `(ls conftest.o conftest.obj; ls conftest.*) 2>/dev/null`; do
   case $ac_file in
@@ -1783,24 +1784,24 @@
 else
   echo "$as_me: failed program was:" >&5
 cat conftest.$ac_ext >&5
-{ { echo "$as_me:1786: error: cannot compute OBJEXT: cannot compile" >&5
+{ { echo "$as_me:1787: error: cannot compute OBJEXT: cannot compile" >&5
 echo "$as_me: error: cannot compute OBJEXT: cannot compile" >&2;}
    { (exit 1); exit 1; }; }
 fi
 
 rm -f conftest.$ac_cv_objext conftest.$ac_ext
 fi
-echo "$as_me:1793: result: $ac_cv_objext" >&5
+echo "$as_me:1794: result: $ac_cv_objext" >&5
 echo "${ECHO_T}$ac_cv_objext" >&6
 OBJEXT=$ac_cv_objext
 ac_objext=$OBJEXT
-echo "$as_me:1797: checking whether we are using the GNU C compiler" >&5
+echo "$as_me:1798: checking whether we are using the GNU C compiler" >&5
 echo $ECHO_N "checking whether we are using the GNU C compiler... $ECHO_C" >&6
 if test "${ac_cv_c_compiler_gnu+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
 else
   cat >conftest.$ac_ext <<_ACEOF
-#line 1803 "configure"
+#line 1804 "configure"
 #include "confdefs.h"
 
 int
@@ -1815,16 +1816,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext
-if { (eval echo "$as_me:1818: \"$ac_compile\"") >&5
+if { (eval echo "$as_me:1819: \"$ac_compile\"") >&5
   (eval $ac_compile) 2>&5
   ac_status=$?
-  echo "$as_me:1821: \$? = $ac_status" >&5
+  echo "$as_me:1822: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest.$ac_objext'
-  { (eval echo "$as_me:1824: \"$ac_try\"") >&5
+  { (eval echo "$as_me:1825: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:1827: \$? = $ac_status" >&5
+  echo "$as_me:1828: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   ac_compiler_gnu=yes
 else
@@ -1836,19 +1837,19 @@
 ac_cv_c_compiler_gnu=$ac_compiler_gnu
 
 fi
-echo "$as_me:1839: result: $ac_cv_c_compiler_gnu" >&5
+echo "$as_me:1840: result: $ac_cv_c_compiler_gnu" >&5
 echo "${ECHO_T}$ac_cv_c_compiler_gnu" >&6
 GCC=`test $ac_compiler_gnu = yes && echo yes`
 ac_test_CFLAGS=${CFLAGS+set}
 ac_save_CFLAGS=$CFLAGS
 CFLAGS="-g"
-echo "$as_me:1845: checking whether $CC accepts -g" >&5
+echo "$as_me:1846: checking whether $CC accepts -g" >&5
 echo $ECHO_N "checking whether $CC accepts -g... $ECHO_C" >&6
 if test "${ac_cv_prog_cc_g+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
 else
   cat >conftest.$ac_ext <<_ACEOF
-#line 1851 "configure"
+#line 1852 "configure"
 #include "confdefs.h"
 
 int
@@ -1860,16 +1861,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext
-if { (eval echo "$as_me:1863: \"$ac_compile\"") >&5
+if { (eval echo "$as_me:1864: \"$ac_compile\"") >&5
   (eval $ac_compile) 2>&5
   ac_status=$?
-  echo "$as_me:1866: \$? = $ac_status" >&5
+  echo "$as_me:1867: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest.$ac_objext'
-  { (eval echo "$as_me:1869: \"$ac_try\"") >&5
+  { (eval echo "$as_me:1870: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:1872: \$? = $ac_status" >&5
+  echo "$as_me:1873: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   ac_cv_prog_cc_g=yes
 else
@@ -1879,7 +1880,7 @@
 fi
 rm -f conftest.$ac_objext conftest.$ac_ext
 fi
-echo "$as_me:1882: result: $ac_cv_prog_cc_g" >&5
+echo "$as_me:1883: result: $ac_cv_prog_cc_g" >&5
 echo "${ECHO_T}$ac_cv_prog_cc_g" >&6
 if test "$ac_test_CFLAGS" = set; then
   CFLAGS=$ac_save_CFLAGS
@@ -1906,16 +1907,16 @@
 #endif
 _ACEOF
 rm -f conftest.$ac_objext
-if { (eval echo "$as_me:1909: \"$ac_compile\"") >&5
+if { (eval echo "$as_me:1910: \"$ac_compile\"") >&5
   (eval $ac_compile) 2>&5
   ac_status=$?
-  echo "$as_me:1912: \$? = $ac_status" >&5
+  echo "$as_me:1913: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest.$ac_objext'
-  { (eval echo "$as_me:1915: \"$ac_try\"") >&5
+  { (eval echo "$as_me:1916: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:1918: \$? = $ac_status" >&5
+  echo "$as_me:1919: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   for ac_declaration in \
    ''\
@@ -1927,7 +1928,7 @@
    'void exit (int);'
 do
   cat >conftest.$ac_ext <<_ACEOF
-#line 1930 "configure"
+#line 1931 "configure"
 #include "confdefs.h"
 #include <stdlib.h>
 $ac_declaration
@@ -1940,16 +1941,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext
-if { (eval echo "$as_me:1943: \"$ac_compile\"") >&5
+if { (eval echo "$as_me:1944: \"$ac_compile\"") >&5
   (eval $ac_compile) 2>&5
   ac_status=$?
-  echo "$as_me:1946: \$? = $ac_status" >&5
+  echo "$as_me:1947: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest.$ac_objext'
-  { (eval echo "$as_me:1949: \"$ac_try\"") >&5
+  { (eval echo "$as_me:1950: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:1952: \$? = $ac_status" >&5
+  echo "$as_me:1953: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   :
 else
@@ -1959,7 +1960,7 @@
 fi
 rm -f conftest.$ac_objext conftest.$ac_ext
   cat >conftest.$ac_ext <<_ACEOF
-#line 1962 "configure"
+#line 1963 "configure"
 #include "confdefs.h"
 $ac_declaration
 int
@@ -1971,16 +1972,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext
-if { (eval echo "$as_me:1974: \"$ac_compile\"") >&5
+if { (eval echo "$as_me:1975: \"$ac_compile\"") >&5
   (eval $ac_compile) 2>&5
   ac_status=$?
-  echo "$as_me:1977: \$? = $ac_status" >&5
+  echo "$as_me:1978: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest.$ac_objext'
-  { (eval echo "$as_me:1980: \"$ac_try\"") >&5
+  { (eval echo "$as_me:1981: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:1983: \$? = $ac_status" >&5
+  echo "$as_me:1984: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   break
 else
@@ -2009,11 +2010,11 @@
 
 GCC_VERSION=none
 if test "$GCC" = yes ; then
-	echo "$as_me:2012: checking version of $CC" >&5
+	echo "$as_me:2013: checking version of $CC" >&5
 echo $ECHO_N "checking version of $CC... $ECHO_C" >&6
 	GCC_VERSION="`${CC} --version|sed -e '2,$d' -e 's/^[^0-9.]*//' -e 's/[^0-9.].*//'`"
 	test -z "$GCC_VERSION" && GCC_VERSION=unknown
-	echo "$as_me:2016: result: $GCC_VERSION" >&5
+	echo "$as_me:2017: result: $GCC_VERSION" >&5
 echo "${ECHO_T}$GCC_VERSION" >&6
 fi
 
@@ -2022,7 +2023,7 @@
 ac_compile='$CC -c $CFLAGS $CPPFLAGS conftest.$ac_ext >&5'
 ac_link='$CC -o conftest$ac_exeext $CFLAGS $CPPFLAGS $LDFLAGS conftest.$ac_ext $LIBS >&5'
 ac_compiler_gnu=$ac_cv_c_compiler_gnu
-echo "$as_me:2025: checking how to run the C preprocessor" >&5
+echo "$as_me:2026: checking how to run the C preprocessor" >&5
 echo $ECHO_N "checking how to run the C preprocessor... $ECHO_C" >&6
 # On Suns, sometimes $CPP names a directory.
 if test -n "$CPP" && test -d "$CPP"; then
@@ -2043,18 +2044,18 @@
   # On the NeXT, cc -E runs the code through the compiler's parser,
   # not just through cpp. "Syntax error" is here to catch this case.
   cat >conftest.$ac_ext <<_ACEOF
-#line 2046 "configure"
+#line 2047 "configure"
 #include "confdefs.h"
 #include <assert.h>
                      Syntax error
 _ACEOF
-if { (eval echo "$as_me:2051: \"$ac_cpp conftest.$ac_ext\"") >&5
+if { (eval echo "$as_me:2052: \"$ac_cpp conftest.$ac_ext\"") >&5
   (eval $ac_cpp conftest.$ac_ext) 2>conftest.er1
   ac_status=$?
   egrep -v '^ *\+' conftest.er1 >conftest.err
   rm -f conftest.er1
   cat conftest.err >&5
-  echo "$as_me:2057: \$? = $ac_status" >&5
+  echo "$as_me:2058: \$? = $ac_status" >&5
   (exit $ac_status); } >/dev/null; then
   if test -s conftest.err; then
     ac_cpp_err=$ac_c_preproc_warn_flag
@@ -2077,17 +2078,17 @@
   # OK, works on sane cases.  Now check whether non-existent headers
   # can be detected and how.
   cat >conftest.$ac_ext <<_ACEOF
-#line 2080 "configure"
+#line 2081 "configure"
 #include "confdefs.h"
 #include <ac_nonexistent.h>
 _ACEOF
-if { (eval echo "$as_me:2084: \"$ac_cpp conftest.$ac_ext\"") >&5
+if { (eval echo "$as_me:2085: \"$ac_cpp conftest.$ac_ext\"") >&5
   (eval $ac_cpp conftest.$ac_ext) 2>conftest.er1
   ac_status=$?
   egrep -v '^ *\+' conftest.er1 >conftest.err
   rm -f conftest.er1
   cat conftest.err >&5
-  echo "$as_me:2090: \$? = $ac_status" >&5
+  echo "$as_me:2091: \$? = $ac_status" >&5
   (exit $ac_status); } >/dev/null; then
   if test -s conftest.err; then
     ac_cpp_err=$ac_c_preproc_warn_flag
@@ -2124,7 +2125,7 @@
 else
   ac_cv_prog_CPP=$CPP
 fi
-echo "$as_me:2127: result: $CPP" >&5
+echo "$as_me:2128: result: $CPP" >&5
 echo "${ECHO_T}$CPP" >&6
 ac_preproc_ok=false
 for ac_c_preproc_warn_flag in '' yes
@@ -2134,18 +2135,18 @@
   # On the NeXT, cc -E runs the code through the compiler's parser,
   # not just through cpp. "Syntax error" is here to catch this case.
   cat >conftest.$ac_ext <<_ACEOF
-#line 2137 "configure"
+#line 2138 "configure"
 #include "confdefs.h"
 #include <assert.h>
                      Syntax error
 _ACEOF
-if { (eval echo "$as_me:2142: \"$ac_cpp conftest.$ac_ext\"") >&5
+if { (eval echo "$as_me:2143: \"$ac_cpp conftest.$ac_ext\"") >&5
   (eval $ac_cpp conftest.$ac_ext) 2>conftest.er1
   ac_status=$?
   egrep -v '^ *\+' conftest.er1 >conftest.err
   rm -f conftest.er1
   cat conftest.err >&5
-  echo "$as_me:2148: \$? = $ac_status" >&5
+  echo "$as_me:2149: \$? = $ac_status" >&5
   (exit $ac_status); } >/dev/null; then
   if test -s conftest.err; then
     ac_cpp_err=$ac_c_preproc_warn_flag
@@ -2168,17 +2169,17 @@
   # OK, works on sane cases.  Now check whether non-existent headers
   # can be detected and how.
   cat >conftest.$ac_ext <<_ACEOF
-#line 2171 "configure"
+#line 2172 "configure"
 #include "confdefs.h"
 #include <ac_nonexistent.h>
 _ACEOF
-if { (eval echo "$as_me:2175: \"$ac_cpp conftest.$ac_ext\"") >&5
+if { (eval echo "$as_me:2176: \"$ac_cpp conftest.$ac_ext\"") >&5
   (eval $ac_cpp conftest.$ac_ext) 2>conftest.er1
   ac_status=$?
   egrep -v '^ *\+' conftest.er1 >conftest.err
   rm -f conftest.er1
   cat conftest.err >&5
-  echo "$as_me:2181: \$? = $ac_status" >&5
+  echo "$as_me:2182: \$? = $ac_status" >&5
   (exit $ac_status); } >/dev/null; then
   if test -s conftest.err; then
     ac_cpp_err=$ac_c_preproc_warn_flag
@@ -2206,7 +2207,7 @@
 if $ac_preproc_ok; then
   :
 else
-  { { echo "$as_me:2209: error: C preprocessor \"$CPP\" fails sanity check" >&5
+  { { echo "$as_me:2210: error: C preprocessor \"$CPP\" fails sanity check" >&5
 echo "$as_me: error: C preprocessor \"$CPP\" fails sanity check" >&2;}
    { (exit 1); exit 1; }; }
 fi
@@ -2218,14 +2219,14 @@
 ac_compiler_gnu=$ac_cv_c_compiler_gnu
 
 if test $ac_cv_c_compiler_gnu = yes; then
-    echo "$as_me:2221: checking whether $CC needs -traditional" >&5
+    echo "$as_me:2222: checking whether $CC needs -traditional" >&5
 echo $ECHO_N "checking whether $CC needs -traditional... $ECHO_C" >&6
 if test "${ac_cv_prog_gcc_traditional+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
 else
     ac_pattern="Autoconf.*'x'"
   cat >conftest.$ac_ext <<_ACEOF
-#line 2228 "configure"
+#line 2229 "configure"
 #include "confdefs.h"
 #include <sgtty.h>
 int Autoconf = TIOCGETP;
@@ -2240,7 +2241,7 @@
 
   if test $ac_cv_prog_gcc_traditional = no; then
     cat >conftest.$ac_ext <<_ACEOF
-#line 2243 "configure"
+#line 2244 "configure"
 #include "confdefs.h"
 #include <termio.h>
 int Autoconf = TCGETA;
@@ -2253,19 +2254,61 @@
 
   fi
 fi
-echo "$as_me:2256: result: $ac_cv_prog_gcc_traditional" >&5
+echo "$as_me:2257: result: $ac_cv_prog_gcc_traditional" >&5
 echo "${ECHO_T}$ac_cv_prog_gcc_traditional" >&6
   if test $ac_cv_prog_gcc_traditional = yes; then
     CC="$CC -traditional"
   fi
 fi
 
-echo "$as_me:2263: checking for POSIXized ISC" >&5
+echo "$as_me:2264: checking whether $CC understands -c and -o together" >&5
+echo $ECHO_N "checking whether $CC understands -c and -o together... $ECHO_C" >&6
+if test "${cf_cv_prog_CC_c_o+set}" = set; then
+  echo $ECHO_N "(cached) $ECHO_C" >&6
+else
+
+cat > conftest.$ac_ext <<CF_EOF
+#include <stdio.h>
+int main()
+{
+	return 0;
+}
+CF_EOF
+# We do the test twice because some compilers refuse to overwrite an
+# existing .o file with -o, though they will create one.
+ac_try='$CC -c conftest.$ac_ext -o conftest2.$ac_objext >&5'
+if { (eval echo "$as_me:2280: \"$ac_try\"") >&5
+  (eval $ac_try) 2>&5
+  ac_status=$?
+  echo "$as_me:2283: \$? = $ac_status" >&5
+  (exit $ac_status); } &&
+  test -f conftest2.$ac_objext && { (eval echo "$as_me:2285: \"$ac_try\"") >&5
+  (eval $ac_try) 2>&5
+  ac_status=$?
+  echo "$as_me:2288: \$? = $ac_status" >&5
+  (exit $ac_status); };
+then
+  eval cf_cv_prog_CC_c_o=yes
+else
+  eval cf_cv_prog_CC_c_o=no
+fi
+rm -f conftest*
+
+fi
+if test $cf_cv_prog_CC_c_o = yes; then
+  echo "$as_me:2299: result: yes" >&5
+echo "${ECHO_T}yes" >&6
+else
+  echo "$as_me:2302: result: no" >&5
+echo "${ECHO_T}no" >&6
+fi
+
+echo "$as_me:2306: checking for POSIXized ISC" >&5
 echo $ECHO_N "checking for POSIXized ISC... $ECHO_C" >&6
 if test -d /etc/conf/kconfig.d &&
    grep _POSIX_VERSION /usr/include/sys/unistd.h >/dev/null 2>&1
 then
-  echo "$as_me:2268: result: yes" >&5
+  echo "$as_me:2311: result: yes" >&5
 echo "${ECHO_T}yes" >&6
   ISC=yes # If later tests want to check for ISC.
 
@@ -2279,12 +2322,12 @@
     CC="$CC -Xp"
   fi
 else
-  echo "$as_me:2282: result: no" >&5
+  echo "$as_me:2325: result: no" >&5
 echo "${ECHO_T}no" >&6
   ISC=
 fi
 
-echo "$as_me:2287: checking for ${CC-cc} option to accept ANSI C" >&5
+echo "$as_me:2330: checking for ${CC-cc} option to accept ANSI C" >&5
 echo $ECHO_N "checking for ${CC-cc} option to accept ANSI C... $ECHO_C" >&6
 if test "${cf_cv_ansi_cc+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
@@ -2340,7 +2383,7 @@
 fi
 
 	cat >conftest.$ac_ext <<_ACEOF
-#line 2343 "configure"
+#line 2386 "configure"
 #include "confdefs.h"
 
 #ifndef CC_HAS_PROTOS
@@ -2361,16 +2404,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext
-if { (eval echo "$as_me:2364: \"$ac_compile\"") >&5
+if { (eval echo "$as_me:2407: \"$ac_compile\"") >&5
   (eval $ac_compile) 2>&5
   ac_status=$?
-  echo "$as_me:2367: \$? = $ac_status" >&5
+  echo "$as_me:2410: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest.$ac_objext'
-  { (eval echo "$as_me:2370: \"$ac_try\"") >&5
+  { (eval echo "$as_me:2413: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:2373: \$? = $ac_status" >&5
+  echo "$as_me:2416: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   cf_cv_ansi_cc="$cf_arg"; break
 else
@@ -2383,7 +2426,7 @@
 CPPFLAGS="$cf_save_CPPFLAGS"
 
 fi
-echo "$as_me:2386: result: $cf_cv_ansi_cc" >&5
+echo "$as_me:2429: result: $cf_cv_ansi_cc" >&5
 echo "${ECHO_T}$cf_cv_ansi_cc" >&6
 
 if test "$cf_cv_ansi_cc" != "no"; then
@@ -2428,7 +2471,7 @@
 fi
 
 if test "$cf_cv_ansi_cc" = "no"; then
-	{ { echo "$as_me:2431: error: Your compiler does not appear to recognize prototypes.
+	{ { echo "$as_me:2474: error: Your compiler does not appear to recognize prototypes.
 You have the following choices:
 	a. adjust your compiler options
 	b. get an up-to-date compiler
@@ -2468,7 +2511,7 @@
 *) LDPATH=$PATH:/sbin:/usr/sbin
   # Extract the first word of "ldconfig", so it can be a program name with args.
 set dummy ldconfig; ac_word=$2
-echo "$as_me:2471: checking for $ac_word" >&5
+echo "$as_me:2514: checking for $ac_word" >&5
 echo $ECHO_N "checking for $ac_word... $ECHO_C" >&6
 if test "${ac_cv_path_LDCONFIG+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
@@ -2485,7 +2528,7 @@
   test -z "$ac_dir" && ac_dir=.
   if $as_executable_p "$ac_dir/$ac_word"; then
    ac_cv_path_LDCONFIG="$ac_dir/$ac_word"
-   echo "$as_me:2488: found $ac_dir/$ac_word" >&5
+   echo "$as_me:2531: found $ac_dir/$ac_word" >&5
    break
 fi
 done
@@ -2496,10 +2539,10 @@
 LDCONFIG=$ac_cv_path_LDCONFIG
 
 if test -n "$LDCONFIG"; then
-  echo "$as_me:2499: result: $LDCONFIG" >&5
+  echo "$as_me:2542: result: $LDCONFIG" >&5
 echo "${ECHO_T}$LDCONFIG" >&6
 else
-  echo "$as_me:2502: result: no" >&5
+  echo "$as_me:2545: result: no" >&5
 echo "${ECHO_T}no" >&6
 fi
 
@@ -2507,7 +2550,7 @@
 esac
 fi
 
-echo "$as_me:2510: checking if you want to ensure bool is consistent with C++" >&5
+echo "$as_me:2553: checking if you want to ensure bool is consistent with C++" >&5
 echo $ECHO_N "checking if you want to ensure bool is consistent with C++... $ECHO_C" >&6
 
 # Check whether --with-cxx or --without-cxx was given.
@@ -2517,7 +2560,7 @@
 else
   cf_with_cxx=yes
 fi;
-echo "$as_me:2520: result: $cf_with_cxx" >&5
+echo "$as_me:2563: result: $cf_with_cxx" >&5
 echo "${ECHO_T}$cf_with_cxx" >&6
 if test "X$cf_with_cxx" = Xno ; then
 	CXX=""
@@ -2534,7 +2577,7 @@
   do
     # Extract the first word of "$ac_tool_prefix$ac_prog", so it can be a program name with args.
 set dummy $ac_tool_prefix$ac_prog; ac_word=$2
-echo "$as_me:2537: checking for $ac_word" >&5
+echo "$as_me:2580: checking for $ac_word" >&5
 echo $ECHO_N "checking for $ac_word... $ECHO_C" >&6
 if test "${ac_cv_prog_CXX+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
@@ -2549,7 +2592,7 @@
   test -z "$ac_dir" && ac_dir=.
   $as_executable_p "$ac_dir/$ac_word" || continue
 ac_cv_prog_CXX="$ac_tool_prefix$ac_prog"
-echo "$as_me:2552: found $ac_dir/$ac_word" >&5
+echo "$as_me:2595: found $ac_dir/$ac_word" >&5
 break
 done
 
@@ -2557,10 +2600,10 @@
 fi
 CXX=$ac_cv_prog_CXX
 if test -n "$CXX"; then
-  echo "$as_me:2560: result: $CXX" >&5
+  echo "$as_me:2603: result: $CXX" >&5
 echo "${ECHO_T}$CXX" >&6
 else
-  echo "$as_me:2563: result: no" >&5
+  echo "$as_me:2606: result: no" >&5
 echo "${ECHO_T}no" >&6
 fi
 
@@ -2573,7 +2616,7 @@
 do
   # Extract the first word of "$ac_prog", so it can be a program name with args.
 set dummy $ac_prog; ac_word=$2
-echo "$as_me:2576: checking for $ac_word" >&5
+echo "$as_me:2619: checking for $ac_word" >&5
 echo $ECHO_N "checking for $ac_word... $ECHO_C" >&6
 if test "${ac_cv_prog_ac_ct_CXX+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
@@ -2588,7 +2631,7 @@
   test -z "$ac_dir" && ac_dir=.
   $as_executable_p "$ac_dir/$ac_word" || continue
 ac_cv_prog_ac_ct_CXX="$ac_prog"
-echo "$as_me:2591: found $ac_dir/$ac_word" >&5
+echo "$as_me:2634: found $ac_dir/$ac_word" >&5
 break
 done
 
@@ -2596,10 +2639,10 @@
 fi
 ac_ct_CXX=$ac_cv_prog_ac_ct_CXX
 if test -n "$ac_ct_CXX"; then
-  echo "$as_me:2599: result: $ac_ct_CXX" >&5
+  echo "$as_me:2642: result: $ac_ct_CXX" >&5
 echo "${ECHO_T}$ac_ct_CXX" >&6
 else
-  echo "$as_me:2602: result: no" >&5
+  echo "$as_me:2645: result: no" >&5
 echo "${ECHO_T}no" >&6
 fi
 
@@ -2611,32 +2654,32 @@
 fi
 
 # Provide some information about the compiler.
-echo "$as_me:2614:" \
+echo "$as_me:2657:" \
      "checking for C++ compiler version" >&5
 ac_compiler=`set X $ac_compile; echo $2`
-{ (eval echo "$as_me:2617: \"$ac_compiler --version </dev/null >&5\"") >&5
+{ (eval echo "$as_me:2660: \"$ac_compiler --version </dev/null >&5\"") >&5
   (eval $ac_compiler --version </dev/null >&5) 2>&5
   ac_status=$?
-  echo "$as_me:2620: \$? = $ac_status" >&5
+  echo "$as_me:2663: \$? = $ac_status" >&5
   (exit $ac_status); }
-{ (eval echo "$as_me:2622: \"$ac_compiler -v </dev/null >&5\"") >&5
+{ (eval echo "$as_me:2665: \"$ac_compiler -v </dev/null >&5\"") >&5
   (eval $ac_compiler -v </dev/null >&5) 2>&5
   ac_status=$?
-  echo "$as_me:2625: \$? = $ac_status" >&5
+  echo "$as_me:2668: \$? = $ac_status" >&5
   (exit $ac_status); }
-{ (eval echo "$as_me:2627: \"$ac_compiler -V </dev/null >&5\"") >&5
+{ (eval echo "$as_me:2670: \"$ac_compiler -V </dev/null >&5\"") >&5
   (eval $ac_compiler -V </dev/null >&5) 2>&5
   ac_status=$?
-  echo "$as_me:2630: \$? = $ac_status" >&5
+  echo "$as_me:2673: \$? = $ac_status" >&5
   (exit $ac_status); }
 
-echo "$as_me:2633: checking whether we are using the GNU C++ compiler" >&5
+echo "$as_me:2676: checking whether we are using the GNU C++ compiler" >&5
 echo $ECHO_N "checking whether we are using the GNU C++ compiler... $ECHO_C" >&6
 if test "${ac_cv_cxx_compiler_gnu+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
 else
   cat >conftest.$ac_ext <<_ACEOF
-#line 2639 "configure"
+#line 2682 "configure"
 #include "confdefs.h"
 
 int
@@ -2651,16 +2694,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext
-if { (eval echo "$as_me:2654: \"$ac_compile\"") >&5
+if { (eval echo "$as_me:2697: \"$ac_compile\"") >&5
   (eval $ac_compile) 2>&5
   ac_status=$?
-  echo "$as_me:2657: \$? = $ac_status" >&5
+  echo "$as_me:2700: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest.$ac_objext'
-  { (eval echo "$as_me:2660: \"$ac_try\"") >&5
+  { (eval echo "$as_me:2703: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:2663: \$? = $ac_status" >&5
+  echo "$as_me:2706: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   ac_compiler_gnu=yes
 else
@@ -2672,19 +2715,19 @@
 ac_cv_cxx_compiler_gnu=$ac_compiler_gnu
 
 fi
-echo "$as_me:2675: result: $ac_cv_cxx_compiler_gnu" >&5
+echo "$as_me:2718: result: $ac_cv_cxx_compiler_gnu" >&5
 echo "${ECHO_T}$ac_cv_cxx_compiler_gnu" >&6
 GXX=`test $ac_compiler_gnu = yes && echo yes`
 ac_test_CXXFLAGS=${CXXFLAGS+set}
 ac_save_CXXFLAGS=$CXXFLAGS
 CXXFLAGS="-g"
-echo "$as_me:2681: checking whether $CXX accepts -g" >&5
+echo "$as_me:2724: checking whether $CXX accepts -g" >&5
 echo $ECHO_N "checking whether $CXX accepts -g... $ECHO_C" >&6
 if test "${ac_cv_prog_cxx_g+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
 else
   cat >conftest.$ac_ext <<_ACEOF
-#line 2687 "configure"
+#line 2730 "configure"
 #include "confdefs.h"
 
 int
@@ -2696,16 +2739,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext
-if { (eval echo "$as_me:2699: \"$ac_compile\"") >&5
+if { (eval echo "$as_me:2742: \"$ac_compile\"") >&5
   (eval $ac_compile) 2>&5
   ac_status=$?
-  echo "$as_me:2702: \$? = $ac_status" >&5
+  echo "$as_me:2745: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest.$ac_objext'
-  { (eval echo "$as_me:2705: \"$ac_try\"") >&5
+  { (eval echo "$as_me:2748: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:2708: \$? = $ac_status" >&5
+  echo "$as_me:2751: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   ac_cv_prog_cxx_g=yes
 else
@@ -2715,7 +2758,7 @@
 fi
 rm -f conftest.$ac_objext conftest.$ac_ext
 fi
-echo "$as_me:2718: result: $ac_cv_prog_cxx_g" >&5
+echo "$as_me:2761: result: $ac_cv_prog_cxx_g" >&5
 echo "${ECHO_T}$ac_cv_prog_cxx_g" >&6
 if test "$ac_test_CXXFLAGS" = set; then
   CXXFLAGS=$ac_save_CXXFLAGS
@@ -2742,7 +2785,7 @@
    'void exit (int);'
 do
   cat >conftest.$ac_ext <<_ACEOF
-#line 2745 "configure"
+#line 2788 "configure"
 #include "confdefs.h"
 #include <stdlib.h>
 $ac_declaration
@@ -2755,16 +2798,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext
-if { (eval echo "$as_me:2758: \"$ac_compile\"") >&5
+if { (eval echo "$as_me:2801: \"$ac_compile\"") >&5
   (eval $ac_compile) 2>&5
   ac_status=$?
-  echo "$as_me:2761: \$? = $ac_status" >&5
+  echo "$as_me:2804: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest.$ac_objext'
-  { (eval echo "$as_me:2764: \"$ac_try\"") >&5
+  { (eval echo "$as_me:2807: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:2767: \$? = $ac_status" >&5
+  echo "$as_me:2810: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   :
 else
@@ -2774,7 +2817,7 @@
 fi
 rm -f conftest.$ac_objext conftest.$ac_ext
   cat >conftest.$ac_ext <<_ACEOF
-#line 2777 "configure"
+#line 2820 "configure"
 #include "confdefs.h"
 $ac_declaration
 int
@@ -2786,16 +2829,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext
-if { (eval echo "$as_me:2789: \"$ac_compile\"") >&5
+if { (eval echo "$as_me:2832: \"$ac_compile\"") >&5
   (eval $ac_compile) 2>&5
   ac_status=$?
-  echo "$as_me:2792: \$? = $ac_status" >&5
+  echo "$as_me:2835: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest.$ac_objext'
-  { (eval echo "$as_me:2795: \"$ac_try\"") >&5
+  { (eval echo "$as_me:2838: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:2798: \$? = $ac_status" >&5
+  echo "$as_me:2841: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   break
 else
@@ -2821,7 +2864,7 @@
 	if test "$CXX" = "g++" ; then
 		# Extract the first word of "g++", so it can be a program name with args.
 set dummy g++; ac_word=$2
-echo "$as_me:2824: checking for $ac_word" >&5
+echo "$as_me:2867: checking for $ac_word" >&5
 echo $ECHO_N "checking for $ac_word... $ECHO_C" >&6
 if test "${ac_cv_path_CXX+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
@@ -2838,7 +2881,7 @@
   test -z "$ac_dir" && ac_dir=.
   if $as_executable_p "$ac_dir/$ac_word"; then
    ac_cv_path_CXX="$ac_dir/$ac_word"
-   echo "$as_me:2841: found $ac_dir/$ac_word" >&5
+   echo "$as_me:2884: found $ac_dir/$ac_word" >&5
    break
 fi
 done
@@ -2849,16 +2892,16 @@
 CXX=$ac_cv_path_CXX
 
 if test -n "$CXX"; then
-  echo "$as_me:2852: result: $CXX" >&5
+  echo "$as_me:2895: result: $CXX" >&5
 echo "${ECHO_T}$CXX" >&6
 else
-  echo "$as_me:2855: result: no" >&5
+  echo "$as_me:2898: result: no" >&5
 echo "${ECHO_T}no" >&6
 fi
 
 	fi
 	if test "$CXX" = "g++" ; then
-		{ echo "$as_me:2861: WARNING: ignoring hardcoded g++" >&5
+		{ echo "$as_me:2904: WARNING: ignoring hardcoded g++" >&5
 echo "$as_me: WARNING: ignoring hardcoded g++" >&2;}
 		cf_with_cxx=no; CXX=""; GXX="";
 	fi
@@ -2866,10 +2909,10 @@
 
 GXX_VERSION=none
 if test "$GXX" = yes; then
-	echo "$as_me:2869: checking version of g++" >&5
+	echo "$as_me:2912: checking version of g++" >&5
 echo $ECHO_N "checking version of g++... $ECHO_C" >&6
 	GXX_VERSION="`${CXX-g++} --version|sed -e '2,$d'`"
-	echo "$as_me:2872: result: $GXX_VERSION" >&5
+	echo "$as_me:2915: result: $GXX_VERSION" >&5
 echo "${ECHO_T}$GXX_VERSION" >&6
 fi
 
@@ -2877,12 +2920,12 @@
 1*|2.[0-6]*)
 	GXX=""; CXX=""; ac_cv_cxx_compiler_gnu=no
 	cf_cxx_library=no
-	{ echo "$as_me:2880: WARNING: templates do not work" >&5
+	{ echo "$as_me:2923: WARNING: templates do not work" >&5
 echo "$as_me: WARNING: templates do not work" >&2;}
 	;;
 esac
 
-echo "$as_me:2885: checking if you want to build C++ binding and demo" >&5
+echo "$as_me:2928: checking if you want to build C++ binding and demo" >&5
 echo $ECHO_N "checking if you want to build C++ binding and demo... $ECHO_C" >&6
 
 # Check whether --with-cxx-binding or --without-cxx-binding was given.
@@ -2892,10 +2935,10 @@
 else
   cf_with_cxx_binding=$cf_with_cxx
 fi;
-echo "$as_me:2895: result: $cf_with_cxx_binding" >&5
+echo "$as_me:2938: result: $cf_with_cxx_binding" >&5
 echo "${ECHO_T}$cf_with_cxx_binding" >&6
 
-echo "$as_me:2898: checking if you want to build with Ada95" >&5
+echo "$as_me:2941: checking if you want to build with Ada95" >&5
 echo $ECHO_N "checking if you want to build with Ada95... $ECHO_C" >&6
 
 # Check whether --with-ada or --without-ada was given.
@@ -2905,10 +2948,10 @@
 else
   cf_with_ada=yes
 fi;
-echo "$as_me:2908: result: $cf_with_ada" >&5
+echo "$as_me:2951: result: $cf_with_ada" >&5
 echo "${ECHO_T}$cf_with_ada" >&6
 
-echo "$as_me:2911: checking if you want to build programs such as tic" >&5
+echo "$as_me:2954: checking if you want to build programs such as tic" >&5
 echo $ECHO_N "checking if you want to build programs such as tic... $ECHO_C" >&6
 
 # Check whether --with-progs or --without-progs was given.
@@ -2918,10 +2961,10 @@
 else
   cf_with_progs=yes
 fi;
-echo "$as_me:2921: result: $cf_with_progs" >&5
+echo "$as_me:2964: result: $cf_with_progs" >&5
 echo "${ECHO_T}$cf_with_progs" >&6
 
-echo "$as_me:2924: checking if you wish to install curses.h" >&5
+echo "$as_me:2967: checking if you wish to install curses.h" >&5
 echo $ECHO_N "checking if you wish to install curses.h... $ECHO_C" >&6
 
 # Check whether --with-curses-h or --without-curses-h was given.
@@ -2931,7 +2974,7 @@
 else
   with_curses_h=yes
 fi;
-echo "$as_me:2934: result: $with_curses_h" >&5
+echo "$as_me:2977: result: $with_curses_h" >&5
 echo "${ECHO_T}$with_curses_h" >&6
 
 modules_to_build="ncurses"
@@ -2957,7 +3000,7 @@
 do
   # Extract the first word of "$ac_prog", so it can be a program name with args.
 set dummy $ac_prog; ac_word=$2
-echo "$as_me:2960: checking for $ac_word" >&5
+echo "$as_me:3003: checking for $ac_word" >&5
 echo $ECHO_N "checking for $ac_word... $ECHO_C" >&6
 if test "${ac_cv_prog_AWK+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
@@ -2972,7 +3015,7 @@
   test -z "$ac_dir" && ac_dir=.
   $as_executable_p "$ac_dir/$ac_word" || continue
 ac_cv_prog_AWK="$ac_prog"
-echo "$as_me:2975: found $ac_dir/$ac_word" >&5
+echo "$as_me:3018: found $ac_dir/$ac_word" >&5
 break
 done
 
@@ -2980,17 +3023,17 @@
 fi
 AWK=$ac_cv_prog_AWK
 if test -n "$AWK"; then
-  echo "$as_me:2983: result: $AWK" >&5
+  echo "$as_me:3026: result: $AWK" >&5
 echo "${ECHO_T}$AWK" >&6
 else
-  echo "$as_me:2986: result: no" >&5
+  echo "$as_me:3029: result: no" >&5
 echo "${ECHO_T}no" >&6
 fi
 
   test -n "$AWK" && break
 done
 
-echo "$as_me:2993: checking whether ${MAKE-make} sets \${MAKE}" >&5
+echo "$as_me:3036: checking whether ${MAKE-make} sets \${MAKE}" >&5
 echo $ECHO_N "checking whether ${MAKE-make} sets \${MAKE}... $ECHO_C" >&6
 set dummy ${MAKE-make}; ac_make=`echo "$2" | sed 'y,./+-,__p_,'`
 if eval "test \"\${ac_cv_prog_make_${ac_make}_set+set}\" = set"; then
@@ -3010,11 +3053,11 @@
 rm -f conftest.make
 fi
 if eval "test \"`echo '$ac_cv_prog_make_'${ac_make}_set`\" = yes"; then
-  echo "$as_me:3013: result: yes" >&5
+  echo "$as_me:3056: result: yes" >&5
 echo "${ECHO_T}yes" >&6
   SET_MAKE=
 else
-  echo "$as_me:3017: result: no" >&5
+  echo "$as_me:3060: result: no" >&5
 echo "${ECHO_T}no" >&6
   SET_MAKE="MAKE=${MAKE-make}"
 fi
@@ -3031,7 +3074,7 @@
 # AFS /usr/afsws/bin/install, which mishandles nonexistent args
 # SVR4 /usr/ucb/install, which tries to use the nonexistent group "staff"
 # ./install, which can be erroneously created by make from ./install.sh.
-echo "$as_me:3034: checking for a BSD compatible install" >&5
+echo "$as_me:3077: checking for a BSD compatible install" >&5
 echo $ECHO_N "checking for a BSD compatible install... $ECHO_C" >&6
 if test -z "$INSTALL"; then
 if test "${ac_cv_path_install+set}" = set; then
@@ -3080,7 +3123,7 @@
     INSTALL=$ac_install_sh
   fi
 fi
-echo "$as_me:3083: result: $INSTALL" >&5
+echo "$as_me:3126: result: $INSTALL" >&5
 echo "${ECHO_T}$INSTALL" >&6
 
 # Use test -z because SunOS4 sh mishandles braces in ${var-val}.
@@ -3101,7 +3144,7 @@
   ;;
 esac
 
-echo "$as_me:3104: checking for long file names" >&5
+echo "$as_me:3147: checking for long file names" >&5
 echo $ECHO_N "checking for long file names... $ECHO_C" >&6
 if test "${ac_cv_sys_long_file_names+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
@@ -3140,7 +3183,7 @@
   rm -rf $ac_xdir 2>/dev/null
 done
 fi
-echo "$as_me:3143: result: $ac_cv_sys_long_file_names" >&5
+echo "$as_me:3186: result: $ac_cv_sys_long_file_names" >&5
 echo "${ECHO_T}$ac_cv_sys_long_file_names" >&6
 if test $ac_cv_sys_long_file_names = yes; then
 
@@ -3150,7 +3193,7 @@
 
 fi
 
-echo "$as_me:3153: checking if filesystem supports mixed-case filenames" >&5
+echo "$as_me:3196: checking if filesystem supports mixed-case filenames" >&5
 echo $ECHO_N "checking if filesystem supports mixed-case filenames... $ECHO_C" >&6
 if test "${cf_cv_mixedcase+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
@@ -3177,26 +3220,26 @@
 fi
 
 fi
-echo "$as_me:3180: result: $cf_cv_mixedcase" >&5
+echo "$as_me:3223: result: $cf_cv_mixedcase" >&5
 echo "${ECHO_T}$cf_cv_mixedcase" >&6
 test "$cf_cv_mixedcase" = yes && cat >>confdefs.h <<\EOF
 #define MIXEDCASE_FILENAMES 1
 EOF
 
-echo "$as_me:3186: checking whether ln -s works" >&5
+echo "$as_me:3229: checking whether ln -s works" >&5
 echo $ECHO_N "checking whether ln -s works... $ECHO_C" >&6
 LN_S=$as_ln_s
 if test "$LN_S" = "ln -s"; then
-  echo "$as_me:3190: result: yes" >&5
+  echo "$as_me:3233: result: yes" >&5
 echo "${ECHO_T}yes" >&6
 else
-  echo "$as_me:3193: result: no, using $LN_S" >&5
+  echo "$as_me:3236: result: no, using $LN_S" >&5
 echo "${ECHO_T}no, using $LN_S" >&6
 fi
 
 # Extract the first word of "ctags", so it can be a program name with args.
 set dummy ctags; ac_word=$2
-echo "$as_me:3199: checking for $ac_word" >&5
+echo "$as_me:3242: checking for $ac_word" >&5
 echo $ECHO_N "checking for $ac_word... $ECHO_C" >&6
 if test "${ac_cv_prog_MAKE_LOWER_TAGS+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
@@ -3211,7 +3254,7 @@
   test -z "$ac_dir" && ac_dir=.
   $as_executable_p "$ac_dir/$ac_word" || continue
 ac_cv_prog_MAKE_LOWER_TAGS="yes"
-echo "$as_me:3214: found $ac_dir/$ac_word" >&5
+echo "$as_me:3257: found $ac_dir/$ac_word" >&5
 break
 done
 
@@ -3220,17 +3263,17 @@
 fi
 MAKE_LOWER_TAGS=$ac_cv_prog_MAKE_LOWER_TAGS
 if test -n "$MAKE_LOWER_TAGS"; then
-  echo "$as_me:3223: result: $MAKE_LOWER_TAGS" >&5
+  echo "$as_me:3266: result: $MAKE_LOWER_TAGS" >&5
 echo "${ECHO_T}$MAKE_LOWER_TAGS" >&6
 else
-  echo "$as_me:3226: result: no" >&5
+  echo "$as_me:3269: result: no" >&5
 echo "${ECHO_T}no" >&6
 fi
 
 if test "$cf_cv_mixedcase" = yes ; then
 	# Extract the first word of "etags", so it can be a program name with args.
 set dummy etags; ac_word=$2
-echo "$as_me:3233: checking for $ac_word" >&5
+echo "$as_me:3276: checking for $ac_word" >&5
 echo $ECHO_N "checking for $ac_word... $ECHO_C" >&6
 if test "${ac_cv_prog_MAKE_UPPER_TAGS+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
@@ -3245,7 +3288,7 @@
   test -z "$ac_dir" && ac_dir=.
   $as_executable_p "$ac_dir/$ac_word" || continue
 ac_cv_prog_MAKE_UPPER_TAGS="yes"
-echo "$as_me:3248: found $ac_dir/$ac_word" >&5
+echo "$as_me:3291: found $ac_dir/$ac_word" >&5
 break
 done
 
@@ -3254,10 +3297,10 @@
 fi
 MAKE_UPPER_TAGS=$ac_cv_prog_MAKE_UPPER_TAGS
 if test -n "$MAKE_UPPER_TAGS"; then
-  echo "$as_me:3257: result: $MAKE_UPPER_TAGS" >&5
+  echo "$as_me:3300: result: $MAKE_UPPER_TAGS" >&5
 echo "${ECHO_T}$MAKE_UPPER_TAGS" >&6
 else
-  echo "$as_me:3260: result: no" >&5
+  echo "$as_me:3303: result: no" >&5
 echo "${ECHO_T}no" >&6
 fi
 
@@ -3281,7 +3324,7 @@
 do
   # Extract the first word of "$ac_prog", so it can be a program name with args.
 set dummy $ac_prog; ac_word=$2
-echo "$as_me:3284: checking for $ac_word" >&5
+echo "$as_me:3327: checking for $ac_word" >&5
 echo $ECHO_N "checking for $ac_word... $ECHO_C" >&6
 if test "${ac_cv_prog_LINT+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
@@ -3296,7 +3339,7 @@
   test -z "$ac_dir" && ac_dir=.
   $as_executable_p "$ac_dir/$ac_word" || continue
 ac_cv_prog_LINT="$ac_prog"
-echo "$as_me:3299: found $ac_dir/$ac_word" >&5
+echo "$as_me:3342: found $ac_dir/$ac_word" >&5
 break
 done
 
@@ -3304,10 +3347,10 @@
 fi
 LINT=$ac_cv_prog_LINT
 if test -n "$LINT"; then
-  echo "$as_me:3307: result: $LINT" >&5
+  echo "$as_me:3350: result: $LINT" >&5
 echo "${ECHO_T}$LINT" >&6
 else
-  echo "$as_me:3310: result: no" >&5
+  echo "$as_me:3353: result: no" >&5
 echo "${ECHO_T}no" >&6
 fi
 
@@ -3318,7 +3361,7 @@
 do
   # Extract the first word of "$ac_prog", so it can be a program name with args.
 set dummy $ac_prog; ac_word=$2
-echo "$as_me:3321: checking for $ac_word" >&5
+echo "$as_me:3364: checking for $ac_word" >&5
 echo $ECHO_N "checking for $ac_word... $ECHO_C" >&6
 if test "${ac_cv_prog_MAN+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
@@ -3333,7 +3376,7 @@
   test -z "$ac_dir" && ac_dir=.
   $as_executable_p "$ac_dir/$ac_word" || continue
 ac_cv_prog_MAN="$ac_prog"
-echo "$as_me:3336: found $ac_dir/$ac_word" >&5
+echo "$as_me:3379: found $ac_dir/$ac_word" >&5
 break
 done
 
@@ -3341,10 +3384,10 @@
 fi
 MAN=$ac_cv_prog_MAN
 if test -n "$MAN"; then
-  echo "$as_me:3344: result: $MAN" >&5
+  echo "$as_me:3387: result: $MAN" >&5
 echo "${ECHO_T}$MAN" >&6
 else
-  echo "$as_me:3347: result: no" >&5
+  echo "$as_me:3390: result: no" >&5
 echo "${ECHO_T}no" >&6
 fi
 
@@ -3354,7 +3397,7 @@
 if test -n "$ac_tool_prefix"; then
   # Extract the first word of "${ac_tool_prefix}ranlib", so it can be a program name with args.
 set dummy ${ac_tool_prefix}ranlib; ac_word=$2
-echo "$as_me:3357: checking for $ac_word" >&5
+echo "$as_me:3400: checking for $ac_word" >&5
 echo $ECHO_N "checking for $ac_word... $ECHO_C" >&6
 if test "${ac_cv_prog_RANLIB+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
@@ -3369,7 +3412,7 @@
   test -z "$ac_dir" && ac_dir=.
   $as_executable_p "$ac_dir/$ac_word" || continue
 ac_cv_prog_RANLIB="${ac_tool_prefix}ranlib"
-echo "$as_me:3372: found $ac_dir/$ac_word" >&5
+echo "$as_me:3415: found $ac_dir/$ac_word" >&5
 break
 done
 
@@ -3377,10 +3420,10 @@
 fi
 RANLIB=$ac_cv_prog_RANLIB
 if test -n "$RANLIB"; then
-  echo "$as_me:3380: result: $RANLIB" >&5
+  echo "$as_me:3423: result: $RANLIB" >&5
 echo "${ECHO_T}$RANLIB" >&6
 else
-  echo "$as_me:3383: result: no" >&5
+  echo "$as_me:3426: result: no" >&5
 echo "${ECHO_T}no" >&6
 fi
 
@@ -3389,7 +3432,7 @@
   ac_ct_RANLIB=$RANLIB
   # Extract the first word of "ranlib", so it can be a program name with args.
 set dummy ranlib; ac_word=$2
-echo "$as_me:3392: checking for $ac_word" >&5
+echo "$as_me:3435: checking for $ac_word" >&5
 echo $ECHO_N "checking for $ac_word... $ECHO_C" >&6
 if test "${ac_cv_prog_ac_ct_RANLIB+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
@@ -3404,7 +3447,7 @@
   test -z "$ac_dir" && ac_dir=.
   $as_executable_p "$ac_dir/$ac_word" || continue
 ac_cv_prog_ac_ct_RANLIB="ranlib"
-echo "$as_me:3407: found $ac_dir/$ac_word" >&5
+echo "$as_me:3450: found $ac_dir/$ac_word" >&5
 break
 done
 
@@ -3413,10 +3456,10 @@
 fi
 ac_ct_RANLIB=$ac_cv_prog_ac_ct_RANLIB
 if test -n "$ac_ct_RANLIB"; then
-  echo "$as_me:3416: result: $ac_ct_RANLIB" >&5
+  echo "$as_me:3459: result: $ac_ct_RANLIB" >&5
 echo "${ECHO_T}$ac_ct_RANLIB" >&6
 else
-  echo "$as_me:3419: result: no" >&5
+  echo "$as_me:3462: result: no" >&5
 echo "${ECHO_T}no" >&6
 fi
 
@@ -3428,7 +3471,7 @@
 if test -n "$ac_tool_prefix"; then
   # Extract the first word of "${ac_tool_prefix}ld", so it can be a program name with args.
 set dummy ${ac_tool_prefix}ld; ac_word=$2
-echo "$as_me:3431: checking for $ac_word" >&5
+echo "$as_me:3474: checking for $ac_word" >&5
 echo $ECHO_N "checking for $ac_word... $ECHO_C" >&6
 if test "${ac_cv_prog_LD+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
@@ -3443,7 +3486,7 @@
   test -z "$ac_dir" && ac_dir=.
   $as_executable_p "$ac_dir/$ac_word" || continue
 ac_cv_prog_LD="${ac_tool_prefix}ld"
-echo "$as_me:3446: found $ac_dir/$ac_word" >&5
+echo "$as_me:3489: found $ac_dir/$ac_word" >&5
 break
 done
 
@@ -3451,10 +3494,10 @@
 fi
 LD=$ac_cv_prog_LD
 if test -n "$LD"; then
-  echo "$as_me:3454: result: $LD" >&5
+  echo "$as_me:3497: result: $LD" >&5
 echo "${ECHO_T}$LD" >&6
 else
-  echo "$as_me:3457: result: no" >&5
+  echo "$as_me:3500: result: no" >&5
 echo "${ECHO_T}no" >&6
 fi
 
@@ -3463,7 +3506,7 @@
   ac_ct_LD=$LD
   # Extract the first word of "ld", so it can be a program name with args.
 set dummy ld; ac_word=$2
-echo "$as_me:3466: checking for $ac_word" >&5
+echo "$as_me:3509: checking for $ac_word" >&5
 echo $ECHO_N "checking for $ac_word... $ECHO_C" >&6
 if test "${ac_cv_prog_ac_ct_LD+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
@@ -3478,7 +3521,7 @@
   test -z "$ac_dir" && ac_dir=.
   $as_executable_p "$ac_dir/$ac_word" || continue
 ac_cv_prog_ac_ct_LD="ld"
-echo "$as_me:3481: found $ac_dir/$ac_word" >&5
+echo "$as_me:3524: found $ac_dir/$ac_word" >&5
 break
 done
 
@@ -3487,10 +3530,10 @@
 fi
 ac_ct_LD=$ac_cv_prog_ac_ct_LD
 if test -n "$ac_ct_LD"; then
-  echo "$as_me:3490: result: $ac_ct_LD" >&5
+  echo "$as_me:3533: result: $ac_ct_LD" >&5
 echo "${ECHO_T}$ac_ct_LD" >&6
 else
-  echo "$as_me:3493: result: no" >&5
+  echo "$as_me:3536: result: no" >&5
 echo "${ECHO_T}no" >&6
 fi
 
@@ -3502,7 +3545,7 @@
 if test -n "$ac_tool_prefix"; then
   # Extract the first word of "${ac_tool_prefix}ar", so it can be a program name with args.
 set dummy ${ac_tool_prefix}ar; ac_word=$2
-echo "$as_me:3505: checking for $ac_word" >&5
+echo "$as_me:3548: checking for $ac_word" >&5
 echo $ECHO_N "checking for $ac_word... $ECHO_C" >&6
 if test "${ac_cv_prog_AR+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
@@ -3517,7 +3560,7 @@
   test -z "$ac_dir" && ac_dir=.
   $as_executable_p "$ac_dir/$ac_word" || continue
 ac_cv_prog_AR="${ac_tool_prefix}ar"
-echo "$as_me:3520: found $ac_dir/$ac_word" >&5
+echo "$as_me:3563: found $ac_dir/$ac_word" >&5
 break
 done
 
@@ -3525,10 +3568,10 @@
 fi
 AR=$ac_cv_prog_AR
 if test -n "$AR"; then
-  echo "$as_me:3528: result: $AR" >&5
+  echo "$as_me:3571: result: $AR" >&5
 echo "${ECHO_T}$AR" >&6
 else
-  echo "$as_me:3531: result: no" >&5
+  echo "$as_me:3574: result: no" >&5
 echo "${ECHO_T}no" >&6
 fi
 
@@ -3537,7 +3580,7 @@
   ac_ct_AR=$AR
   # Extract the first word of "ar", so it can be a program name with args.
 set dummy ar; ac_word=$2
-echo "$as_me:3540: checking for $ac_word" >&5
+echo "$as_me:3583: checking for $ac_word" >&5
 echo $ECHO_N "checking for $ac_word... $ECHO_C" >&6
 if test "${ac_cv_prog_ac_ct_AR+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
@@ -3552,7 +3595,7 @@
   test -z "$ac_dir" && ac_dir=.
   $as_executable_p "$ac_dir/$ac_word" || continue
 ac_cv_prog_ac_ct_AR="ar"
-echo "$as_me:3555: found $ac_dir/$ac_word" >&5
+echo "$as_me:3598: found $ac_dir/$ac_word" >&5
 break
 done
 
@@ -3561,10 +3604,10 @@
 fi
 ac_ct_AR=$ac_cv_prog_ac_ct_AR
 if test -n "$ac_ct_AR"; then
-  echo "$as_me:3564: result: $ac_ct_AR" >&5
+  echo "$as_me:3607: result: $ac_ct_AR" >&5
 echo "${ECHO_T}$ac_ct_AR" >&6
 else
-  echo "$as_me:3567: result: no" >&5
+  echo "$as_me:3610: result: no" >&5
 echo "${ECHO_T}no" >&6
 fi
 
@@ -3577,10 +3620,10 @@
   echo $ECHO_N "(cached) $ECHO_C" >&6
 else
 
-echo "$as_me:3580: checking for archiver options (symbol AR_OPTS)" >&5
+echo "$as_me:3623: checking for archiver options (symbol AR_OPTS)" >&5
 echo $ECHO_N "checking for archiver options (symbol AR_OPTS)... $ECHO_C" >&6
 test -z "$AR_OPTS" && AR_OPTS=rv
-echo "$as_me:3583: result: $AR_OPTS" >&5
+echo "$as_me:3626: result: $AR_OPTS" >&5
 echo "${ECHO_T}$AR_OPTS" >&6
 
 cf_cv_subst_AR_OPTS=$AR_OPTS
@@ -3588,7 +3631,7 @@
 
 AR_OPTS=${cf_cv_subst_AR_OPTS}
 
-echo "$as_me:3591: checking for makeflags variable" >&5
+echo "$as_me:3634: checking for makeflags variable" >&5
 echo $ECHO_N "checking for makeflags variable... $ECHO_C" >&6
 if test "${cf_cv_makeflags+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
@@ -3621,10 +3664,10 @@
 	rm -f cf_makeflags.tmp
 
 fi
-echo "$as_me:3624: result: $cf_cv_makeflags" >&5
+echo "$as_me:3667: result: $cf_cv_makeflags" >&5
 echo "${ECHO_T}$cf_cv_makeflags" >&6
 
-echo "$as_me:3627: checking if you have specified an install-prefix" >&5
+echo "$as_me:3670: checking if you have specified an install-prefix" >&5
 echo $ECHO_N "checking if you have specified an install-prefix... $ECHO_C" >&6
 
 # Check whether --with-install-prefix or --without-install-prefix was given.
@@ -3637,7 +3680,7 @@
 		;;
 	esac
 fi;
-echo "$as_me:3640: result: $DESTDIR" >&5
+echo "$as_me:3683: result: $DESTDIR" >&5
 echo "${ECHO_T}$DESTDIR" >&6
 
 ###############################################################################
@@ -3645,13 +3688,17 @@
 # If we're cross-compiling, allow the user to override the tools and their
 # options.  The configure script is oriented toward identifying the host
 # compiler, etc., but we need a build compiler to generate parts of the source.
-: ${BUILD_CC:='$(CC)'}
-: ${BUILD_CFLAGS:='$(CFLAGS)'}
-: ${BUILD_CPPFLAGS:='$(CPPFLAGS)'}
-: ${BUILD_LDFLAGS:='$(LDFLAGS)'}
-: ${BUILD_LIBS:='$(LIBS)'}
-: ${BUILD_EXEEXT:='$x'}
+
 if test "$cross_compiling" = yes ; then
+	# defaults that we might want to override
+	: ${BUILD_CC:='$(CC)'}
+	: ${BUILD_CPP:='$(CC) -E'}
+	: ${BUILD_CFLAGS:=''}
+	: ${BUILD_CPPFLAGS:=''}
+	: ${BUILD_LDFLAGS:=''}
+	: ${BUILD_LIBS:=''}
+	: ${BUILD_EXEEXT:='$x'}
+	: ${BUILD_OBJEXT:='o'}
 
 # Check whether --with-build-cc or --without-build-cc was given.
 if test "${with_build_cc+set}" = set; then
@@ -3662,7 +3709,7 @@
 do
   # Extract the first word of "$ac_prog", so it can be a program name with args.
 set dummy $ac_prog; ac_word=$2
-echo "$as_me:3665: checking for $ac_word" >&5
+echo "$as_me:3712: checking for $ac_word" >&5
 echo $ECHO_N "checking for $ac_word... $ECHO_C" >&6
 if test "${ac_cv_prog_BUILD_CC+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
@@ -3677,7 +3724,7 @@
   test -z "$ac_dir" && ac_dir=.
   $as_executable_p "$ac_dir/$ac_word" || continue
 ac_cv_prog_BUILD_CC="$ac_prog"
-echo "$as_me:3680: found $ac_dir/$ac_word" >&5
+echo "$as_me:3727: found $ac_dir/$ac_word" >&5
 break
 done
 
@@ -3685,10 +3732,10 @@
 fi
 BUILD_CC=$ac_cv_prog_BUILD_CC
 if test -n "$BUILD_CC"; then
-  echo "$as_me:3688: result: $BUILD_CC" >&5
+  echo "$as_me:3735: result: $BUILD_CC" >&5
 echo "${ECHO_T}$BUILD_CC" >&6
 else
-  echo "$as_me:3691: result: no" >&5
+  echo "$as_me:3738: result: no" >&5
 echo "${ECHO_T}no" >&6
 fi
 
@@ -3697,6 +3744,14 @@
 
 fi;
 
+# Check whether --with-build-cpp or --without-build-cpp was given.
+if test "${with_build_cpp+set}" = set; then
+  withval="$with_build_cpp"
+  BUILD_CPP="$withval"
+else
+  BUILD_CPP='$(CC) -E'
+fi;
+
 # Check whether --with-build-cflags or --without-build-cflags was given.
 if test "${with_build_cflags+set}" = set; then
   withval="$with_build_cflags"
@@ -3720,7 +3775,18 @@
   withval="$with_build_libs"
   BUILD_LIBS="$withval"
 fi;
+	# this assumes we're on Unix.
 	BUILD_EXEEXT=
+	BUILD_OBJEXT=o
+else
+	: ${BUILD_CC:='$(CC)'}
+	: ${BUILD_CPP:='$(CPP)'}
+	: ${BUILD_CFLAGS:='$(CFLAGS)'}
+	: ${BUILD_CPPFLAGS:='$(CPPFLAGS)'}
+	: ${BUILD_LDFLAGS:='$(LDFLAGS)'}
+	: ${BUILD_LIBS:='$(LIBS)'}
+	: ${BUILD_EXEEXT:='$x'}
+	: ${BUILD_OBJEXT:='o'}
 fi
 
 ###############################################################################
@@ -3746,7 +3812,7 @@
 LIB_INSTALL=
 LIB_UNINSTALL=
 
-echo "$as_me:3749: checking if you want to build libraries with libtool" >&5
+echo "$as_me:3815: checking if you want to build libraries with libtool" >&5
 echo $ECHO_N "checking if you want to build libraries with libtool... $ECHO_C" >&6
 
 # Check whether --with-libtool or --without-libtool was given.
@@ -3756,7 +3822,7 @@
 else
   with_libtool=no
 fi;
-echo "$as_me:3759: result: $with_libtool" >&5
+echo "$as_me:3825: result: $with_libtool" >&5
 echo "${ECHO_T}$with_libtool" >&6
 if test "$with_libtool" != "no"; then
 
@@ -3781,7 +3847,7 @@
   with_libtool=`echo $with_libtool | sed -e s%NONE%$ac_default_prefix%`
   ;;
 *)
-  { { echo "$as_me:3784: error: expected a pathname, not \"$with_libtool\"" >&5
+  { { echo "$as_me:3850: error: expected a pathname, not \"$with_libtool\"" >&5
 echo "$as_me: error: expected a pathname, not \"$with_libtool\"" >&2;}
    { (exit 1); exit 1; }; }
   ;;
@@ -3791,7 +3857,7 @@
 	else
  		# Extract the first word of "libtool", so it can be a program name with args.
 set dummy libtool; ac_word=$2
-echo "$as_me:3794: checking for $ac_word" >&5
+echo "$as_me:3860: checking for $ac_word" >&5
 echo $ECHO_N "checking for $ac_word... $ECHO_C" >&6
 if test "${ac_cv_path_LIBTOOL+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
@@ -3808,7 +3874,7 @@
   test -z "$ac_dir" && ac_dir=.
   if $as_executable_p "$ac_dir/$ac_word"; then
    ac_cv_path_LIBTOOL="$ac_dir/$ac_word"
-   echo "$as_me:3811: found $ac_dir/$ac_word" >&5
+   echo "$as_me:3877: found $ac_dir/$ac_word" >&5
    break
 fi
 done
@@ -3819,16 +3885,16 @@
 LIBTOOL=$ac_cv_path_LIBTOOL
 
 if test -n "$LIBTOOL"; then
-  echo "$as_me:3822: result: $LIBTOOL" >&5
+  echo "$as_me:3888: result: $LIBTOOL" >&5
 echo "${ECHO_T}$LIBTOOL" >&6
 else
-  echo "$as_me:3825: result: no" >&5
+  echo "$as_me:3891: result: no" >&5
 echo "${ECHO_T}no" >&6
 fi
 
  	fi
  	if test -z "$LIBTOOL" ; then
- 		{ { echo "$as_me:3831: error: Cannot find libtool" >&5
+ 		{ { echo "$as_me:3897: error: Cannot find libtool" >&5
 echo "$as_me: error: Cannot find libtool" >&2;}
    { (exit 1); exit 1; }; }
  	fi
@@ -3843,17 +3909,17 @@
 	LIB_PREP=:
 
 	# Show the version of libtool
-	echo "$as_me:3846: checking version of libtool" >&5
+	echo "$as_me:3912: checking version of libtool" >&5
 echo $ECHO_N "checking version of libtool... $ECHO_C" >&6
 
 	# Save the version in a cache variable - this is not entirely a good
 	# thing, but the version string from libtool is very ugly, and for
 	# bug reports it might be useful to have the original string.
 	cf_cv_libtool_version=`$LIBTOOL --version 2>&1 | sed -e '2,$d' -e 's/([^)]*)//g' -e 's/^[^1-9]*//' -e 's/[^0-9.].*//'`
-	echo "$as_me:3853: result: $cf_cv_libtool_version" >&5
+	echo "$as_me:3919: result: $cf_cv_libtool_version" >&5
 echo "${ECHO_T}$cf_cv_libtool_version" >&6
 	if test -z "$cf_cv_libtool_version" ; then
-		{ { echo "$as_me:3856: error: This is not libtool" >&5
+		{ { echo "$as_me:3922: error: This is not libtool" >&5
 echo "$as_me: error: This is not libtool" >&2;}
    { (exit 1); exit 1; }; }
 	fi
@@ -3880,7 +3946,7 @@
 
 else
 
-echo "$as_me:3883: checking if you want to build shared libraries" >&5
+echo "$as_me:3949: checking if you want to build shared libraries" >&5
 echo $ECHO_N "checking if you want to build shared libraries... $ECHO_C" >&6
 
 # Check whether --with-shared or --without-shared was given.
@@ -3890,11 +3956,11 @@
 else
   with_shared=no
 fi;
-echo "$as_me:3893: result: $with_shared" >&5
+echo "$as_me:3959: result: $with_shared" >&5
 echo "${ECHO_T}$with_shared" >&6
 test "$with_shared" = "yes" && cf_list_models="$cf_list_models shared"
 
-echo "$as_me:3897: checking if you want to build static libraries" >&5
+echo "$as_me:3963: checking if you want to build static libraries" >&5
 echo $ECHO_N "checking if you want to build static libraries... $ECHO_C" >&6
 
 # Check whether --with-normal or --without-normal was given.
@@ -3904,11 +3970,11 @@
 else
   with_normal=yes
 fi;
-echo "$as_me:3907: result: $with_normal" >&5
+echo "$as_me:3973: result: $with_normal" >&5
 echo "${ECHO_T}$with_normal" >&6
 test "$with_normal" = "yes" && cf_list_models="$cf_list_models normal"
 
-echo "$as_me:3911: checking if you want to build debug libraries" >&5
+echo "$as_me:3977: checking if you want to build debug libraries" >&5
 echo $ECHO_N "checking if you want to build debug libraries... $ECHO_C" >&6
 
 # Check whether --with-debug or --without-debug was given.
@@ -3918,11 +3984,11 @@
 else
   with_debug=yes
 fi;
-echo "$as_me:3921: result: $with_debug" >&5
+echo "$as_me:3987: result: $with_debug" >&5
 echo "${ECHO_T}$with_debug" >&6
 test "$with_debug" = "yes" && cf_list_models="$cf_list_models debug"
 
-echo "$as_me:3925: checking if you want to build profiling libraries" >&5
+echo "$as_me:3991: checking if you want to build profiling libraries" >&5
 echo $ECHO_N "checking if you want to build profiling libraries... $ECHO_C" >&6
 
 # Check whether --with-profile or --without-profile was given.
@@ -3932,7 +3998,7 @@
 else
   with_profile=no
 fi;
-echo "$as_me:3935: result: $with_profile" >&5
+echo "$as_me:4001: result: $with_profile" >&5
 echo "${ECHO_T}$with_profile" >&6
 test "$with_profile" = "yes" && cf_list_models="$cf_list_models profile"
 
@@ -3940,19 +4006,19 @@
 
 ###############################################################################
 
-echo "$as_me:3943: checking for specified models" >&5
+echo "$as_me:4009: checking for specified models" >&5
 echo $ECHO_N "checking for specified models... $ECHO_C" >&6
 test -z "$cf_list_models" && cf_list_models=normal
 test "$with_libtool" != "no" && cf_list_models=libtool
-echo "$as_me:3947: result: $cf_list_models" >&5
+echo "$as_me:4013: result: $cf_list_models" >&5
 echo "${ECHO_T}$cf_list_models" >&6
 
 ### Use the first model as the default, and save its suffix for use in building
 ### up test-applications.
-echo "$as_me:3952: checking for default model" >&5
+echo "$as_me:4018: checking for default model" >&5
 echo $ECHO_N "checking for default model... $ECHO_C" >&6
 DFT_LWR_MODEL=`echo "$cf_list_models" | $AWK '{print $1}'`
-echo "$as_me:3955: result: $DFT_LWR_MODEL" >&5
+echo "$as_me:4021: result: $DFT_LWR_MODEL" >&5
 echo "${ECHO_T}$DFT_LWR_MODEL" >&6
 
 DFT_UPR_MODEL=`echo "$DFT_LWR_MODEL" | sed y%abcdefghijklmnopqrstuvwxyz./-%ABCDEFGHIJKLMNOPQRSTUVWXYZ___%`
@@ -3976,7 +4042,7 @@
 
 ###############################################################################
 
-echo "$as_me:3979: checking if you want to build a separate terminfo library" >&5
+echo "$as_me:4045: checking if you want to build a separate terminfo library" >&5
 echo $ECHO_N "checking if you want to build a separate terminfo library... $ECHO_C" >&6
 
 # Check whether --with-termlib or --without-termlib was given.
@@ -3986,12 +4052,12 @@
 else
   with_termlib=no
 fi;
-echo "$as_me:3989: result: $with_termlib" >&5
+echo "$as_me:4055: result: $with_termlib" >&5
 echo "${ECHO_T}$with_termlib" >&6
 
 ### Checks for special libraries, must be done up-front.
 
-echo "$as_me:3994: checking if you want to link with dbmalloc for testing" >&5
+echo "$as_me:4060: checking if you want to link with dbmalloc for testing" >&5
 echo $ECHO_N "checking if you want to link with dbmalloc for testing... $ECHO_C" >&6
 
 # Check whether --with-dbmalloc or --without-dbmalloc was given.
@@ -4001,11 +4067,49 @@
 else
   with_dbmalloc=no
 fi;
-echo "$as_me:4004: result: $with_dbmalloc" >&5
+echo "$as_me:4070: result: $with_dbmalloc" >&5
 echo "${ECHO_T}$with_dbmalloc" >&6
-if test $with_dbmalloc = yes ; then
+if test "$with_dbmalloc" = yes ; then
+	echo "$as_me:4073: checking for dbmalloc.h" >&5
+echo $ECHO_N "checking for dbmalloc.h... $ECHO_C" >&6
+if test "${ac_cv_header_dbmalloc_h+set}" = set; then
+  echo $ECHO_N "(cached) $ECHO_C" >&6
+else
+  cat >conftest.$ac_ext <<_ACEOF
+#line 4079 "configure"
+#include "confdefs.h"
+#include <dbmalloc.h>
+_ACEOF
+if { (eval echo "$as_me:4083: \"$ac_cpp conftest.$ac_ext\"") >&5
+  (eval $ac_cpp conftest.$ac_ext) 2>conftest.er1
+  ac_status=$?
+  egrep -v '^ *\+' conftest.er1 >conftest.err
+  rm -f conftest.er1
+  cat conftest.err >&5
+  echo "$as_me:4089: \$? = $ac_status" >&5
+  (exit $ac_status); } >/dev/null; then
+  if test -s conftest.err; then
+    ac_cpp_err=$ac_c_preproc_warn_flag
+  else
+    ac_cpp_err=
+  fi
+else
+  ac_cpp_err=yes
+fi
+if test -z "$ac_cpp_err"; then
+  ac_cv_header_dbmalloc_h=yes
+else
+  echo "$as_me: failed program was:" >&5
+  cat conftest.$ac_ext >&5
+  ac_cv_header_dbmalloc_h=no
+fi
+rm -f conftest.err conftest.$ac_ext
+fi
+echo "$as_me:4108: result: $ac_cv_header_dbmalloc_h" >&5
+echo "${ECHO_T}$ac_cv_header_dbmalloc_h" >&6
+if test $ac_cv_header_dbmalloc_h = yes; then
 
-echo "$as_me:4008: checking for debug_malloc in -ldbmalloc" >&5
+echo "$as_me:4112: checking for debug_malloc in -ldbmalloc" >&5
 echo $ECHO_N "checking for debug_malloc in -ldbmalloc... $ECHO_C" >&6
 if test "${ac_cv_lib_dbmalloc_debug_malloc+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
@@ -4013,7 +4117,7 @@
   ac_check_lib_save_LIBS=$LIBS
 LIBS="-ldbmalloc  $LIBS"
 cat >conftest.$ac_ext <<_ACEOF
-#line 4016 "configure"
+#line 4120 "configure"
 #include "confdefs.h"
 
 /* Override any gcc2 internal prototype to avoid an error.  */
@@ -4032,16 +4136,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext conftest$ac_exeext
-if { (eval echo "$as_me:4035: \"$ac_link\"") >&5
+if { (eval echo "$as_me:4139: \"$ac_link\"") >&5
   (eval $ac_link) 2>&5
   ac_status=$?
-  echo "$as_me:4038: \$? = $ac_status" >&5
+  echo "$as_me:4142: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest$ac_exeext'
-  { (eval echo "$as_me:4041: \"$ac_try\"") >&5
+  { (eval echo "$as_me:4145: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:4044: \$? = $ac_status" >&5
+  echo "$as_me:4148: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   ac_cv_lib_dbmalloc_debug_malloc=yes
 else
@@ -4052,7 +4156,7 @@
 rm -f conftest.$ac_objext conftest$ac_exeext conftest.$ac_ext
 LIBS=$ac_check_lib_save_LIBS
 fi
-echo "$as_me:4055: result: $ac_cv_lib_dbmalloc_debug_malloc" >&5
+echo "$as_me:4159: result: $ac_cv_lib_dbmalloc_debug_malloc" >&5
 echo "${ECHO_T}$ac_cv_lib_dbmalloc_debug_malloc" >&6
 if test $ac_cv_lib_dbmalloc_debug_malloc = yes; then
   cat >>confdefs.h <<EOF
@@ -4065,7 +4169,9 @@
 
 fi
 
-echo "$as_me:4068: checking if you want to link with dmalloc for testing" >&5
+fi
+
+echo "$as_me:4174: checking if you want to link with dmalloc for testing" >&5
 echo $ECHO_N "checking if you want to link with dmalloc for testing... $ECHO_C" >&6
 
 # Check whether --with-dmalloc or --without-dmalloc was given.
@@ -4075,11 +4181,49 @@
 else
   with_dmalloc=no
 fi;
-echo "$as_me:4078: result: $with_dmalloc" >&5
+echo "$as_me:4184: result: $with_dmalloc" >&5
 echo "${ECHO_T}$with_dmalloc" >&6
-if test $with_dmalloc = yes ; then
+if test "$with_dmalloc" = yes ; then
+	echo "$as_me:4187: checking for dmalloc.h" >&5
+echo $ECHO_N "checking for dmalloc.h... $ECHO_C" >&6
+if test "${ac_cv_header_dmalloc_h+set}" = set; then
+  echo $ECHO_N "(cached) $ECHO_C" >&6
+else
+  cat >conftest.$ac_ext <<_ACEOF
+#line 4193 "configure"
+#include "confdefs.h"
+#include <dmalloc.h>
+_ACEOF
+if { (eval echo "$as_me:4197: \"$ac_cpp conftest.$ac_ext\"") >&5
+  (eval $ac_cpp conftest.$ac_ext) 2>conftest.er1
+  ac_status=$?
+  egrep -v '^ *\+' conftest.er1 >conftest.err
+  rm -f conftest.er1
+  cat conftest.err >&5
+  echo "$as_me:4203: \$? = $ac_status" >&5
+  (exit $ac_status); } >/dev/null; then
+  if test -s conftest.err; then
+    ac_cpp_err=$ac_c_preproc_warn_flag
+  else
+    ac_cpp_err=
+  fi
+else
+  ac_cpp_err=yes
+fi
+if test -z "$ac_cpp_err"; then
+  ac_cv_header_dmalloc_h=yes
+else
+  echo "$as_me: failed program was:" >&5
+  cat conftest.$ac_ext >&5
+  ac_cv_header_dmalloc_h=no
+fi
+rm -f conftest.err conftest.$ac_ext
+fi
+echo "$as_me:4222: result: $ac_cv_header_dmalloc_h" >&5
+echo "${ECHO_T}$ac_cv_header_dmalloc_h" >&6
+if test $ac_cv_header_dmalloc_h = yes; then
 
-echo "$as_me:4082: checking for dmalloc_debug in -ldmalloc" >&5
+echo "$as_me:4226: checking for dmalloc_debug in -ldmalloc" >&5
 echo $ECHO_N "checking for dmalloc_debug in -ldmalloc... $ECHO_C" >&6
 if test "${ac_cv_lib_dmalloc_dmalloc_debug+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
@@ -4087,7 +4231,7 @@
   ac_check_lib_save_LIBS=$LIBS
 LIBS="-ldmalloc  $LIBS"
 cat >conftest.$ac_ext <<_ACEOF
-#line 4090 "configure"
+#line 4234 "configure"
 #include "confdefs.h"
 
 /* Override any gcc2 internal prototype to avoid an error.  */
@@ -4106,16 +4250,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext conftest$ac_exeext
-if { (eval echo "$as_me:4109: \"$ac_link\"") >&5
+if { (eval echo "$as_me:4253: \"$ac_link\"") >&5
   (eval $ac_link) 2>&5
   ac_status=$?
-  echo "$as_me:4112: \$? = $ac_status" >&5
+  echo "$as_me:4256: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest$ac_exeext'
-  { (eval echo "$as_me:4115: \"$ac_try\"") >&5
+  { (eval echo "$as_me:4259: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:4118: \$? = $ac_status" >&5
+  echo "$as_me:4262: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   ac_cv_lib_dmalloc_dmalloc_debug=yes
 else
@@ -4126,7 +4270,7 @@
 rm -f conftest.$ac_objext conftest$ac_exeext conftest.$ac_ext
 LIBS=$ac_check_lib_save_LIBS
 fi
-echo "$as_me:4129: result: $ac_cv_lib_dmalloc_dmalloc_debug" >&5
+echo "$as_me:4273: result: $ac_cv_lib_dmalloc_dmalloc_debug" >&5
 echo "${ECHO_T}$ac_cv_lib_dmalloc_dmalloc_debug" >&6
 if test $ac_cv_lib_dmalloc_dmalloc_debug = yes; then
   cat >>confdefs.h <<EOF
@@ -4139,8 +4283,10 @@
 
 fi
 
+fi
+
 SHLIB_LIST=""
-echo "$as_me:4143: checking if you want to link with the gpm mouse library" >&5
+echo "$as_me:4289: checking if you want to link with the gpm mouse library" >&5
 echo $ECHO_N "checking if you want to link with the gpm mouse library... $ECHO_C" >&6
 
 # Check whether --with-gpm or --without-gpm was given.
@@ -4150,10 +4296,10 @@
 else
   with_gpm=no
 fi;
-echo "$as_me:4153: result: $with_gpm" >&5
+echo "$as_me:4299: result: $with_gpm" >&5
 echo "${ECHO_T}$with_gpm" >&6
 if test "$with_gpm" = yes ; then
-	echo "$as_me:4156: checking for Gpm_Open in -lgpm" >&5
+	echo "$as_me:4302: checking for Gpm_Open in -lgpm" >&5
 echo $ECHO_N "checking for Gpm_Open in -lgpm... $ECHO_C" >&6
 if test "${ac_cv_lib_gpm_Gpm_Open+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
@@ -4161,7 +4307,7 @@
   ac_check_lib_save_LIBS=$LIBS
 LIBS="-lgpm  $LIBS"
 cat >conftest.$ac_ext <<_ACEOF
-#line 4164 "configure"
+#line 4310 "configure"
 #include "confdefs.h"
 
 /* Override any gcc2 internal prototype to avoid an error.  */
@@ -4180,16 +4326,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext conftest$ac_exeext
-if { (eval echo "$as_me:4183: \"$ac_link\"") >&5
+if { (eval echo "$as_me:4329: \"$ac_link\"") >&5
   (eval $ac_link) 2>&5
   ac_status=$?
-  echo "$as_me:4186: \$? = $ac_status" >&5
+  echo "$as_me:4332: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest$ac_exeext'
-  { (eval echo "$as_me:4189: \"$ac_try\"") >&5
+  { (eval echo "$as_me:4335: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:4192: \$? = $ac_status" >&5
+  echo "$as_me:4338: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   ac_cv_lib_gpm_Gpm_Open=yes
 else
@@ -4200,7 +4346,7 @@
 rm -f conftest.$ac_objext conftest$ac_exeext conftest.$ac_ext
 LIBS=$ac_check_lib_save_LIBS
 fi
-echo "$as_me:4203: result: $ac_cv_lib_gpm_Gpm_Open" >&5
+echo "$as_me:4349: result: $ac_cv_lib_gpm_Gpm_Open" >&5
 echo "${ECHO_T}$ac_cv_lib_gpm_Gpm_Open" >&6
 if test $ac_cv_lib_gpm_Gpm_Open = yes; then
 
@@ -4213,23 +4359,23 @@
 for ac_header in gpm.h
 do
 as_ac_Header=`echo "ac_cv_header_$ac_header" | $as_tr_sh`
-echo "$as_me:4216: checking for $ac_header" >&5
+echo "$as_me:4362: checking for $ac_header" >&5
 echo $ECHO_N "checking for $ac_header... $ECHO_C" >&6
 if eval "test \"\${$as_ac_Header+set}\" = set"; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
 else
   cat >conftest.$ac_ext <<_ACEOF
-#line 4222 "configure"
+#line 4368 "configure"
 #include "confdefs.h"
 #include <$ac_header>
 _ACEOF
-if { (eval echo "$as_me:4226: \"$ac_cpp conftest.$ac_ext\"") >&5
+if { (eval echo "$as_me:4372: \"$ac_cpp conftest.$ac_ext\"") >&5
   (eval $ac_cpp conftest.$ac_ext) 2>conftest.er1
   ac_status=$?
   egrep -v '^ *\+' conftest.er1 >conftest.err
   rm -f conftest.er1
   cat conftest.err >&5
-  echo "$as_me:4232: \$? = $ac_status" >&5
+  echo "$as_me:4378: \$? = $ac_status" >&5
   (exit $ac_status); } >/dev/null; then
   if test -s conftest.err; then
     ac_cpp_err=$ac_c_preproc_warn_flag
@@ -4248,7 +4394,7 @@
 fi
 rm -f conftest.err conftest.$ac_ext
 fi
-echo "$as_me:4251: result: `eval echo '${'$as_ac_Header'}'`" >&5
+echo "$as_me:4397: result: `eval echo '${'$as_ac_Header'}'`" >&5
 echo "${ECHO_T}`eval echo '${'$as_ac_Header'}'`" >&6
 if test `eval echo '${'$as_ac_Header'}'` = yes; then
   cat >>confdefs.h <<EOF
@@ -4259,7 +4405,7 @@
 done
 
 else
-  { echo "$as_me:4262: WARNING: Cannot link with gpm library - read the FAQ" >&5
+  { echo "$as_me:4408: WARNING: Cannot link with gpm library - read the FAQ" >&5
 echo "$as_me: WARNING: Cannot link with gpm library - read the FAQ" >&2;}
 fi
 
@@ -4267,7 +4413,7 @@
 
 # not everyone has "test -c"
 if test -c /dev/sysmouse 2>/dev/null ; then
-echo "$as_me:4270: checking if you want to use sysmouse" >&5
+echo "$as_me:4416: checking if you want to use sysmouse" >&5
 echo $ECHO_N "checking if you want to use sysmouse... $ECHO_C" >&6
 
 # Check whether --with-sysmouse or --without-sysmouse was given.
@@ -4279,7 +4425,7 @@
 fi;
 	if test "$cf_with_sysmouse" != no ; then
 	cat >conftest.$ac_ext <<_ACEOF
-#line 4282 "configure"
+#line 4428 "configure"
 #include "confdefs.h"
 
 #include <osreldate.h>
@@ -4302,16 +4448,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext
-if { (eval echo "$as_me:4305: \"$ac_compile\"") >&5
+if { (eval echo "$as_me:4451: \"$ac_compile\"") >&5
   (eval $ac_compile) 2>&5
   ac_status=$?
-  echo "$as_me:4308: \$? = $ac_status" >&5
+  echo "$as_me:4454: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest.$ac_objext'
-  { (eval echo "$as_me:4311: \"$ac_try\"") >&5
+  { (eval echo "$as_me:4457: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:4314: \$? = $ac_status" >&5
+  echo "$as_me:4460: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   cf_with_sysmouse=yes
 else
@@ -4321,7 +4467,7 @@
 fi
 rm -f conftest.$ac_objext conftest.$ac_ext
 	fi
-echo "$as_me:4324: result: $cf_with_sysmouse" >&5
+echo "$as_me:4470: result: $cf_with_sysmouse" >&5
 echo "${ECHO_T}$cf_with_sysmouse" >&6
 test "$cf_with_sysmouse" = yes && cat >>confdefs.h <<\EOF
 #define USE_SYSMOUSE 1
@@ -4339,7 +4485,7 @@
 	test -n "$GXX" && test "${ac_cv_prog_cxx_g}" != yes && CXX_G_OPT=''
 fi
 
-echo "$as_me:4342: checking for default loader flags" >&5
+echo "$as_me:4488: checking for default loader flags" >&5
 echo $ECHO_N "checking for default loader flags... $ECHO_C" >&6
 case $DFT_LWR_MODEL in
 libtool) LD_MODEL=''   ;;
@@ -4348,10 +4494,10 @@
 profile) LD_MODEL='-pg';;
 shared)  LD_MODEL=''   ;;
 esac
-echo "$as_me:4351: result: $LD_MODEL" >&5
+echo "$as_me:4497: result: $LD_MODEL" >&5
 echo "${ECHO_T}$LD_MODEL" >&6
 
-echo "$as_me:4354: checking if rpath option should be used" >&5
+echo "$as_me:4500: checking if rpath option should be used" >&5
 echo $ECHO_N "checking if rpath option should be used... $ECHO_C" >&6
 
 # Check whether --enable-rpath or --disable-rpath was given.
@@ -4361,7 +4507,7 @@
 else
   cf_cv_ld_rpath=no
 fi;
-echo "$as_me:4364: result: $cf_cv_ld_rpath" >&5
+echo "$as_me:4510: result: $cf_cv_ld_rpath" >&5
 echo "${ECHO_T}$cf_cv_ld_rpath" >&6
 
 	LOCAL_LDFLAGS=
@@ -4371,7 +4517,7 @@
 
 	cf_cv_do_symlinks=no
 
-	echo "$as_me:4374: checking if release/abi version should be used for shared libs" >&5
+	echo "$as_me:4520: checking if release/abi version should be used for shared libs" >&5
 echo $ECHO_N "checking if release/abi version should be used for shared libs... $ECHO_C" >&6
 
 # Check whether --with-shlib-version or --without-shlib-version was given.
@@ -4386,7 +4532,7 @@
 		cf_cv_shlib_version=$withval
 		;;
 	*)
-		{ { echo "$as_me:4389: error: option value must be one of: rel, abi, auto or no" >&5
+		{ { echo "$as_me:4535: error: option value must be one of: rel, abi, auto or no" >&5
 echo "$as_me: error: option value must be one of: rel, abi, auto or no" >&2;}
    { (exit 1); exit 1; }; }
 		;;
@@ -4395,7 +4541,7 @@
 else
   cf_cv_shlib_version=auto
 fi;
-	echo "$as_me:4398: result: $cf_cv_shlib_version" >&5
+	echo "$as_me:4544: result: $cf_cv_shlib_version" >&5
 echo "${ECHO_T}$cf_cv_shlib_version" >&6
 
 	cf_cv_rm_so_locs=no
@@ -4404,14 +4550,14 @@
 	CC_SHARED_OPTS=
 	if test "$GCC" = yes
 	then
-		echo "$as_me:4407: checking which $CC option to use" >&5
+		echo "$as_me:4553: checking which $CC option to use" >&5
 echo $ECHO_N "checking which $CC option to use... $ECHO_C" >&6
 		cf_save_CFLAGS="$CFLAGS"
 		for CC_SHARED_OPTS in -fPIC -fpic ''
 		do
 			CFLAGS="$cf_save_CFLAGS $CC_SHARED_OPTS"
 			cat >conftest.$ac_ext <<_ACEOF
-#line 4414 "configure"
+#line 4560 "configure"
 #include "confdefs.h"
 #include <stdio.h>
 int
@@ -4423,16 +4569,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext
-if { (eval echo "$as_me:4426: \"$ac_compile\"") >&5
+if { (eval echo "$as_me:4572: \"$ac_compile\"") >&5
   (eval $ac_compile) 2>&5
   ac_status=$?
-  echo "$as_me:4429: \$? = $ac_status" >&5
+  echo "$as_me:4575: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest.$ac_objext'
-  { (eval echo "$as_me:4432: \"$ac_try\"") >&5
+  { (eval echo "$as_me:4578: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:4435: \$? = $ac_status" >&5
+  echo "$as_me:4581: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   break
 else
@@ -4441,7 +4587,7 @@
 fi
 rm -f conftest.$ac_objext conftest.$ac_ext
 		done
-		echo "$as_me:4444: result: $CC_SHARED_OPTS" >&5
+		echo "$as_me:4590: result: $CC_SHARED_OPTS" >&5
 echo "${ECHO_T}$CC_SHARED_OPTS" >&6
 		CFLAGS="$cf_save_CFLAGS"
 	fi
@@ -4625,7 +4771,7 @@
 			test "$cf_cv_do_symlinks" = no && cf_cv_do_symlinks=yes
 			;;
 		*)
-			{ echo "$as_me:4628: WARNING: ignored --with-shlib-version" >&5
+			{ echo "$as_me:4774: WARNING: ignored --with-shlib-version" >&5
 echo "$as_me: WARNING: ignored --with-shlib-version" >&2;}
 			;;
 		esac
@@ -4633,12 +4779,12 @@
 	esac
 
 	if test -n "$cf_ld_rpath_opt" ; then
-		echo "$as_me:4636: checking if we need a space after rpath option" >&5
+		echo "$as_me:4782: checking if we need a space after rpath option" >&5
 echo $ECHO_N "checking if we need a space after rpath option... $ECHO_C" >&6
 		cf_save_LIBS="$LIBS"
 		LIBS="$LIBS ${cf_ld_rpath_opt}$libdir"
 		cat >conftest.$ac_ext <<_ACEOF
-#line 4641 "configure"
+#line 4787 "configure"
 #include "confdefs.h"
 
 int
@@ -4650,16 +4796,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext conftest$ac_exeext
-if { (eval echo "$as_me:4653: \"$ac_link\"") >&5
+if { (eval echo "$as_me:4799: \"$ac_link\"") >&5
   (eval $ac_link) 2>&5
   ac_status=$?
-  echo "$as_me:4656: \$? = $ac_status" >&5
+  echo "$as_me:4802: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest$ac_exeext'
-  { (eval echo "$as_me:4659: \"$ac_try\"") >&5
+  { (eval echo "$as_me:4805: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:4662: \$? = $ac_status" >&5
+  echo "$as_me:4808: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   cf_rpath_space=no
 else
@@ -4669,7 +4815,7 @@
 fi
 rm -f conftest.$ac_objext conftest$ac_exeext conftest.$ac_ext
 		LIBS="$cf_save_LIBS"
-		echo "$as_me:4672: result: $cf_rpath_space" >&5
+		echo "$as_me:4818: result: $cf_rpath_space" >&5
 echo "${ECHO_T}$cf_rpath_space" >&6
 		test "$cf_rpath_space" = yes && cf_ld_rpath_opt="$cf_ld_rpath_opt "
 		MK_SHARED_LIB="$MK_SHARED_LIB $cf_ld_rpath_opt\$(libdir)"
@@ -4678,7 +4824,7 @@
 if test "$CC_SHARED_OPTS" = "unknown"; then
 	for model in $cf_list_models; do
 		if test "$model" = "shared"; then
-			{ { echo "$as_me:4681: error: Shared libraries are not supported in this version" >&5
+			{ { echo "$as_me:4827: error: Shared libraries are not supported in this version" >&5
 echo "$as_me: error: Shared libraries are not supported in this version" >&2;}
    { (exit 1); exit 1; }; }
 		fi
@@ -4688,7 +4834,7 @@
 ###############################################################################
 
 ###	use option --disable-overwrite to leave out the link to -lcurses
-echo "$as_me:4691: checking if you wish to install ncurses overwriting curses" >&5
+echo "$as_me:4837: checking if you wish to install ncurses overwriting curses" >&5
 echo $ECHO_N "checking if you wish to install ncurses overwriting curses... $ECHO_C" >&6
 
 # Check whether --enable-overwrite or --disable-overwrite was given.
@@ -4698,10 +4844,10 @@
 else
   if test "$prefix" = "/usr" ; then with_overwrite=yes; else with_overwrite=no; fi
 fi;
-echo "$as_me:4701: result: $with_overwrite" >&5
+echo "$as_me:4847: result: $with_overwrite" >&5
 echo "${ECHO_T}$with_overwrite" >&6
 
-echo "$as_me:4704: checking if external terminfo-database is used" >&5
+echo "$as_me:4850: checking if external terminfo-database is used" >&5
 echo $ECHO_N "checking if external terminfo-database is used... $ECHO_C" >&6
 
 # Check whether --enable-database or --disable-database was given.
@@ -4711,7 +4857,7 @@
 else
   use_database=yes
 fi;
-echo "$as_me:4714: result: $use_database" >&5
+echo "$as_me:4860: result: $use_database" >&5
 echo "${ECHO_T}$use_database" >&6
 
 case $host_os in #(vi
@@ -4733,7 +4879,7 @@
 #define USE_DATABASE 1
 EOF
 
-	echo "$as_me:4736: checking which terminfo source-file will be installed" >&5
+	echo "$as_me:4882: checking which terminfo source-file will be installed" >&5
 echo $ECHO_N "checking which terminfo source-file will be installed... $ECHO_C" >&6
 
 # Check whether --enable-database or --disable-database was given.
@@ -4741,11 +4887,11 @@
   enableval="$enable_database"
   TERMINFO_SRC=$withval
 fi;
-	echo "$as_me:4744: result: $TERMINFO_SRC" >&5
+	echo "$as_me:4890: result: $TERMINFO_SRC" >&5
 echo "${ECHO_T}$TERMINFO_SRC" >&6
 fi
 
-echo "$as_me:4748: checking for list of fallback descriptions" >&5
+echo "$as_me:4894: checking for list of fallback descriptions" >&5
 echo $ECHO_N "checking for list of fallback descriptions... $ECHO_C" >&6
 
 # Check whether --with-fallbacks or --without-fallbacks was given.
@@ -4755,7 +4901,7 @@
 else
   with_fallback=
 fi;
-echo "$as_me:4758: result: $with_fallback" >&5
+echo "$as_me:4904: result: $with_fallback" >&5
 echo "${ECHO_T}$with_fallback" >&6
 FALLBACK_LIST=`echo "$with_fallback" | sed -e 's/,/ /g'`
 
@@ -4765,7 +4911,7 @@
 	MAKE_TERMINFO="#"
 else
 
-echo "$as_me:4768: checking for list of terminfo directories" >&5
+echo "$as_me:4914: checking for list of terminfo directories" >&5
 echo $ECHO_N "checking for list of terminfo directories... $ECHO_C" >&6
 
 # Check whether --with-terminfo-dirs or --without-terminfo-dirs was given.
@@ -4799,7 +4945,7 @@
   cf_src_path=`echo $cf_src_path | sed -e s%NONE%$ac_default_prefix%`
   ;;
 *)
-  { { echo "$as_me:4802: error: expected a pathname, not \"$cf_src_path\"" >&5
+  { { echo "$as_me:4948: error: expected a pathname, not \"$cf_src_path\"" >&5
 echo "$as_me: error: expected a pathname, not \"$cf_src_path\"" >&2;}
    { (exit 1); exit 1; }; }
   ;;
@@ -4812,13 +4958,13 @@
 
 eval 'TERMINFO_DIRS="$cf_dst_path"'
 
-echo "$as_me:4815: result: $TERMINFO_DIRS" >&5
+echo "$as_me:4961: result: $TERMINFO_DIRS" >&5
 echo "${ECHO_T}$TERMINFO_DIRS" >&6
 test -n "$TERMINFO_DIRS" && cat >>confdefs.h <<EOF
 #define TERMINFO_DIRS "$TERMINFO_DIRS"
 EOF
 
-echo "$as_me:4821: checking for default terminfo directory" >&5
+echo "$as_me:4967: checking for default terminfo directory" >&5
 echo $ECHO_N "checking for default terminfo directory... $ECHO_C" >&6
 
 # Check whether --with-default-terminfo-dir or --without-default-terminfo-dir was given.
@@ -4847,7 +4993,7 @@
   withval=`echo $withval | sed -e s%NONE%$ac_default_prefix%`
   ;;
 *)
-  { { echo "$as_me:4850: error: expected a pathname, not \"$withval\"" >&5
+  { { echo "$as_me:4996: error: expected a pathname, not \"$withval\"" >&5
 echo "$as_me: error: expected a pathname, not \"$withval\"" >&2;}
    { (exit 1); exit 1; }; }
   ;;
@@ -4855,7 +5001,7 @@
 
 eval TERMINFO="$withval"
 
-echo "$as_me:4858: result: $TERMINFO" >&5
+echo "$as_me:5004: result: $TERMINFO" >&5
 echo "${ECHO_T}$TERMINFO" >&6
 cat >>confdefs.h <<EOF
 #define TERMINFO "$TERMINFO"
@@ -4865,7 +5011,7 @@
 
 ###	use option --disable-big-core to make tic run on small machines
 ###	We need 4Mb, check if we can allocate 50% more than that.
-echo "$as_me:4868: checking if big-core option selected" >&5
+echo "$as_me:5014: checking if big-core option selected" >&5
 echo $ECHO_N "checking if big-core option selected... $ECHO_C" >&6
 
 # Check whether --enable-big-core or --disable-big-core was given.
@@ -4877,7 +5023,7 @@
   with_big_core=no
 else
   cat >conftest.$ac_ext <<_ACEOF
-#line 4880 "configure"
+#line 5026 "configure"
 #include "confdefs.h"
 
 #include <stdlib.h>
@@ -4891,15 +5037,15 @@
 }
 _ACEOF
 rm -f conftest$ac_exeext
-if { (eval echo "$as_me:4894: \"$ac_link\"") >&5
+if { (eval echo "$as_me:5040: \"$ac_link\"") >&5
   (eval $ac_link) 2>&5
   ac_status=$?
-  echo "$as_me:4897: \$? = $ac_status" >&5
+  echo "$as_me:5043: \$? = $ac_status" >&5
   (exit $ac_status); } && { ac_try='./conftest$ac_exeext'
-  { (eval echo "$as_me:4899: \"$ac_try\"") >&5
+  { (eval echo "$as_me:5045: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:4902: \$? = $ac_status" >&5
+  echo "$as_me:5048: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   with_big_core=yes
 else
@@ -4911,14 +5057,14 @@
 rm -f core core.* *.core conftest$ac_exeext conftest.$ac_objext conftest.$ac_ext
 fi
 fi;
-echo "$as_me:4914: result: $with_big_core" >&5
+echo "$as_me:5060: result: $with_big_core" >&5
 echo "${ECHO_T}$with_big_core" >&6
 test "$with_big_core" = "yes" && cat >>confdefs.h <<\EOF
 #define HAVE_BIG_CORE 1
 EOF
 
 ###	use option --enable-termcap to compile in the termcap fallback support
-echo "$as_me:4921: checking if you want termcap-fallback support" >&5
+echo "$as_me:5067: checking if you want termcap-fallback support" >&5
 echo $ECHO_N "checking if you want termcap-fallback support... $ECHO_C" >&6
 
 # Check whether --enable-termcap or --disable-termcap was given.
@@ -4928,13 +5074,13 @@
 else
   with_termcap=no
 fi;
-echo "$as_me:4931: result: $with_termcap" >&5
+echo "$as_me:5077: result: $with_termcap" >&5
 echo "${ECHO_T}$with_termcap" >&6
 
 if test "$with_termcap" != "yes" ; then
 	if test "$use_database" = no ; then
 		if test -z "$with_fallback" ; then
-			{ { echo "$as_me:4937: error: You have disabled the database w/o specifying fallbacks" >&5
+			{ { echo "$as_me:5083: error: You have disabled the database w/o specifying fallbacks" >&5
 echo "$as_me: error: You have disabled the database w/o specifying fallbacks" >&2;}
    { (exit 1); exit 1; }; }
 		fi
@@ -4949,7 +5095,7 @@
 #define USE_TERMCAP 1
 EOF
 
-echo "$as_me:4952: checking for list of termcap files" >&5
+echo "$as_me:5098: checking for list of termcap files" >&5
 echo $ECHO_N "checking for list of termcap files... $ECHO_C" >&6
 
 # Check whether --with-termpath or --without-termpath was given.
@@ -4983,7 +5129,7 @@
   cf_src_path=`echo $cf_src_path | sed -e s%NONE%$ac_default_prefix%`
   ;;
 *)
-  { { echo "$as_me:4986: error: expected a pathname, not \"$cf_src_path\"" >&5
+  { { echo "$as_me:5132: error: expected a pathname, not \"$cf_src_path\"" >&5
 echo "$as_me: error: expected a pathname, not \"$cf_src_path\"" >&2;}
    { (exit 1); exit 1; }; }
   ;;
@@ -4996,14 +5142,14 @@
 
 eval 'TERMPATH="$cf_dst_path"'
 
-echo "$as_me:4999: result: $TERMPATH" >&5
+echo "$as_me:5145: result: $TERMPATH" >&5
 echo "${ECHO_T}$TERMPATH" >&6
 test -n "$TERMPATH" && cat >>confdefs.h <<EOF
 #define TERMPATH "$TERMPATH"
 EOF
 
 ###	use option --enable-getcap to use a hacked getcap for reading termcaps
-echo "$as_me:5006: checking if fast termcap-loader is needed" >&5
+echo "$as_me:5152: checking if fast termcap-loader is needed" >&5
 echo $ECHO_N "checking if fast termcap-loader is needed... $ECHO_C" >&6
 
 # Check whether --enable-getcap or --disable-getcap was given.
@@ -5013,13 +5159,13 @@
 else
   with_getcap=no
 fi;
-echo "$as_me:5016: result: $with_getcap" >&5
+echo "$as_me:5162: result: $with_getcap" >&5
 echo "${ECHO_T}$with_getcap" >&6
 test "$with_getcap" = "yes" && cat >>confdefs.h <<\EOF
 #define USE_GETCAP 1
 EOF
 
-echo "$as_me:5022: checking if translated termcaps will be cached in ~/.terminfo" >&5
+echo "$as_me:5168: checking if translated termcaps will be cached in ~/.terminfo" >&5
 echo $ECHO_N "checking if translated termcaps will be cached in ~/.terminfo... $ECHO_C" >&6
 
 # Check whether --enable-getcap-cache or --disable-getcap-cache was given.
@@ -5029,7 +5175,7 @@
 else
   with_getcap_cache=no
 fi;
-echo "$as_me:5032: result: $with_getcap_cache" >&5
+echo "$as_me:5178: result: $with_getcap_cache" >&5
 echo "${ECHO_T}$with_getcap_cache" >&6
 test "$with_getcap_cache" = "yes" && cat >>confdefs.h <<\EOF
 #define USE_GETCAP_CACHE 1
@@ -5038,7 +5184,7 @@
 fi
 
 ###   Use option --disable-home-terminfo to completely remove ~/.terminfo
-echo "$as_me:5041: checking if ~/.terminfo is wanted" >&5
+echo "$as_me:5187: checking if ~/.terminfo is wanted" >&5
 echo $ECHO_N "checking if ~/.terminfo is wanted... $ECHO_C" >&6
 
 # Check whether --enable-home-terminfo or --disable-home-terminfo was given.
@@ -5060,13 +5206,13 @@
 	unlink
 do
 as_ac_var=`echo "ac_cv_func_$ac_func" | $as_tr_sh`
-echo "$as_me:5063: checking for $ac_func" >&5
+echo "$as_me:5209: checking for $ac_func" >&5
 echo $ECHO_N "checking for $ac_func... $ECHO_C" >&6
 if eval "test \"\${$as_ac_var+set}\" = set"; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
 else
   cat >conftest.$ac_ext <<_ACEOF
-#line 5069 "configure"
+#line 5215 "configure"
 #include "confdefs.h"
 /* System header to define __stub macros and hopefully few prototypes,
     which can conflict with char $ac_func (); below.  */
@@ -5097,16 +5243,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext conftest$ac_exeext
-if { (eval echo "$as_me:5100: \"$ac_link\"") >&5
+if { (eval echo "$as_me:5246: \"$ac_link\"") >&5
   (eval $ac_link) 2>&5
   ac_status=$?
-  echo "$as_me:5103: \$? = $ac_status" >&5
+  echo "$as_me:5249: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest$ac_exeext'
-  { (eval echo "$as_me:5106: \"$ac_try\"") >&5
+  { (eval echo "$as_me:5252: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:5109: \$? = $ac_status" >&5
+  echo "$as_me:5255: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   eval "$as_ac_var=yes"
 else
@@ -5116,7 +5262,7 @@
 fi
 rm -f conftest.$ac_objext conftest$ac_exeext conftest.$ac_ext
 fi
-echo "$as_me:5119: result: `eval echo '${'$as_ac_var'}'`" >&5
+echo "$as_me:5265: result: `eval echo '${'$as_ac_var'}'`" >&5
 echo "${ECHO_T}`eval echo '${'$as_ac_var'}'`" >&6
 if test `eval echo '${'$as_ac_var'}'` = yes; then
   cat >>confdefs.h <<EOF
@@ -5133,13 +5279,13 @@
 		symlink
 do
 as_ac_var=`echo "ac_cv_func_$ac_func" | $as_tr_sh`
-echo "$as_me:5136: checking for $ac_func" >&5
+echo "$as_me:5282: checking for $ac_func" >&5
 echo $ECHO_N "checking for $ac_func... $ECHO_C" >&6
 if eval "test \"\${$as_ac_var+set}\" = set"; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
 else
   cat >conftest.$ac_ext <<_ACEOF
-#line 5142 "configure"
+#line 5288 "configure"
 #include "confdefs.h"
 /* System header to define __stub macros and hopefully few prototypes,
     which can conflict with char $ac_func (); below.  */
@@ -5170,16 +5316,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext conftest$ac_exeext
-if { (eval echo "$as_me:5173: \"$ac_link\"") >&5
+if { (eval echo "$as_me:5319: \"$ac_link\"") >&5
   (eval $ac_link) 2>&5
   ac_status=$?
-  echo "$as_me:5176: \$? = $ac_status" >&5
+  echo "$as_me:5322: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest$ac_exeext'
-  { (eval echo "$as_me:5179: \"$ac_try\"") >&5
+  { (eval echo "$as_me:5325: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:5182: \$? = $ac_status" >&5
+  echo "$as_me:5328: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   eval "$as_ac_var=yes"
 else
@@ -5189,7 +5335,7 @@
 fi
 rm -f conftest.$ac_objext conftest$ac_exeext conftest.$ac_ext
 fi
-echo "$as_me:5192: result: `eval echo '${'$as_ac_var'}'`" >&5
+echo "$as_me:5338: result: `eval echo '${'$as_ac_var'}'`" >&5
 echo "${ECHO_T}`eval echo '${'$as_ac_var'}'`" >&6
 if test `eval echo '${'$as_ac_var'}'` = yes; then
   cat >>confdefs.h <<EOF
@@ -5200,7 +5346,7 @@
 done
 
 else
-	echo "$as_me:5203: checking if link/symlink functions work" >&5
+	echo "$as_me:5349: checking if link/symlink functions work" >&5
 echo $ECHO_N "checking if link/symlink functions work... $ECHO_C" >&6
 if test "${cf_cv_link_funcs+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
@@ -5213,7 +5359,7 @@
 			eval 'ac_cv_func_'$cf_func'=error'
 else
   cat >conftest.$ac_ext <<_ACEOF
-#line 5216 "configure"
+#line 5362 "configure"
 #include "confdefs.h"
 
 #include <sys/types.h>
@@ -5243,15 +5389,15 @@
 
 _ACEOF
 rm -f conftest$ac_exeext
-if { (eval echo "$as_me:5246: \"$ac_link\"") >&5
+if { (eval echo "$as_me:5392: \"$ac_link\"") >&5
   (eval $ac_link) 2>&5
   ac_status=$?
-  echo "$as_me:5249: \$? = $ac_status" >&5
+  echo "$as_me:5395: \$? = $ac_status" >&5
   (exit $ac_status); } && { ac_try='./conftest$ac_exeext'
-  { (eval echo "$as_me:5251: \"$ac_try\"") >&5
+  { (eval echo "$as_me:5397: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:5254: \$? = $ac_status" >&5
+  echo "$as_me:5400: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
 
 			cf_cv_link_funcs="$cf_cv_link_funcs $cf_func"
@@ -5269,7 +5415,7 @@
 		test -z "$cf_cv_link_funcs" && cf_cv_link_funcs=no
 
 fi
-echo "$as_me:5272: result: $cf_cv_link_funcs" >&5
+echo "$as_me:5418: result: $cf_cv_link_funcs" >&5
 echo "${ECHO_T}$cf_cv_link_funcs" >&6
 	test "$ac_cv_func_link"    = yes && cat >>confdefs.h <<\EOF
 #define HAVE_LINK 1
@@ -5285,27 +5431,27 @@
 with_symlinks=no
 
 if test "$ac_cv_func_link" != yes ; then
-    echo "$as_me:5288: checking if tic should use symbolic links" >&5
+    echo "$as_me:5434: checking if tic should use symbolic links" >&5
 echo $ECHO_N "checking if tic should use symbolic links... $ECHO_C" >&6
     if test "$ac_cv_func_symlink" = yes ; then
     	with_symlinks=yes
     else
     	with_symlinks=no
     fi
-    echo "$as_me:5295: result: $with_symlinks" >&5
+    echo "$as_me:5441: result: $with_symlinks" >&5
 echo "${ECHO_T}$with_symlinks" >&6
 elif test "$ac_cv_func_symlink" != yes ; then
-    echo "$as_me:5298: checking if tic should use hard links" >&5
+    echo "$as_me:5444: checking if tic should use hard links" >&5
 echo $ECHO_N "checking if tic should use hard links... $ECHO_C" >&6
     if test "$ac_cv_func_link" = yes ; then
     	with_links=yes
     else
     	with_links=no
     fi
-    echo "$as_me:5305: result: $with_links" >&5
+    echo "$as_me:5451: result: $with_links" >&5
 echo "${ECHO_T}$with_links" >&6
 else
-    echo "$as_me:5308: checking if tic should use symbolic links" >&5
+    echo "$as_me:5454: checking if tic should use symbolic links" >&5
 echo $ECHO_N "checking if tic should use symbolic links... $ECHO_C" >&6
 
 # Check whether --enable-symlinks or --disable-symlinks was given.
@@ -5315,7 +5461,7 @@
 else
   with_symlinks=no
 fi;
-    echo "$as_me:5318: result: $with_symlinks" >&5
+    echo "$as_me:5464: result: $with_symlinks" >&5
 echo "${ECHO_T}$with_symlinks" >&6
 fi
 
@@ -5328,7 +5474,7 @@
 EOF
 
 ###   use option --enable-broken-linker to force on use of broken-linker support
-echo "$as_me:5331: checking if you want broken-linker support code" >&5
+echo "$as_me:5477: checking if you want broken-linker support code" >&5
 echo $ECHO_N "checking if you want broken-linker support code... $ECHO_C" >&6
 
 # Check whether --enable-broken_linker or --disable-broken_linker was given.
@@ -5338,7 +5484,7 @@
 else
   with_broken_linker=${BROKEN_LINKER-no}
 fi;
-echo "$as_me:5341: result: $with_broken_linker" >&5
+echo "$as_me:5487: result: $with_broken_linker" >&5
 echo "${ECHO_T}$with_broken_linker" >&6
 
 BROKEN_LINKER=0
@@ -5363,7 +5509,7 @@
 fi
 
 ###   use option --with-bool to override bool's type
-echo "$as_me:5366: checking for type of bool" >&5
+echo "$as_me:5512: checking for type of bool" >&5
 echo $ECHO_N "checking for type of bool... $ECHO_C" >&6
 
 # Check whether --with-bool or --without-bool was given.
@@ -5373,11 +5519,11 @@
 else
   NCURSES_BOOL=auto
 fi;
-echo "$as_me:5376: result: $NCURSES_BOOL" >&5
+echo "$as_me:5522: result: $NCURSES_BOOL" >&5
 echo "${ECHO_T}$NCURSES_BOOL" >&6
 
 ###   use option --with-ospeed to override ospeed's type
-echo "$as_me:5380: checking for type of ospeed" >&5
+echo "$as_me:5526: checking for type of ospeed" >&5
 echo $ECHO_N "checking for type of ospeed... $ECHO_C" >&6
 
 # Check whether --with-ospeed or --without-ospeed was given.
@@ -5387,11 +5533,11 @@
 else
   NCURSES_OSPEED=short
 fi;
-echo "$as_me:5390: result: $NCURSES_OSPEED" >&5
+echo "$as_me:5536: result: $NCURSES_OSPEED" >&5
 echo "${ECHO_T}$NCURSES_OSPEED" >&6
 
 ###   use option --enable-bsdpad to have tputs process BSD-style prefix padding
-echo "$as_me:5394: checking if tputs should process BSD-style prefix padding" >&5
+echo "$as_me:5540: checking if tputs should process BSD-style prefix padding" >&5
 echo $ECHO_N "checking if tputs should process BSD-style prefix padding... $ECHO_C" >&6
 
 # Check whether --enable-bsdpad or --disable-bsdpad was given.
@@ -5401,14 +5547,14 @@
 else
   with_bsdpad=no
 fi;
-echo "$as_me:5404: result: $with_bsdpad" >&5
+echo "$as_me:5550: result: $with_bsdpad" >&5
 echo "${ECHO_T}$with_bsdpad" >&6
 test "$with_bsdpad" = yes && cat >>confdefs.h <<\EOF
 #define BSD_TPUTS 1
 EOF
 
 ### Enable compiling-in rcs id's
-echo "$as_me:5411: checking if RCS identifiers should be compiled-in" >&5
+echo "$as_me:5557: checking if RCS identifiers should be compiled-in" >&5
 echo $ECHO_N "checking if RCS identifiers should be compiled-in... $ECHO_C" >&6
 
 # Check whether --with-rcs-ids or --without-rcs-ids was given.
@@ -5418,7 +5564,7 @@
 else
   with_rcs_ids=no
 fi;
-echo "$as_me:5421: result: $with_rcs_ids" >&5
+echo "$as_me:5567: result: $with_rcs_ids" >&5
 echo "${ECHO_T}$with_rcs_ids" >&6
 test "$with_rcs_ids" = yes && cat >>confdefs.h <<\EOF
 #define USE_RCS_IDS 1
@@ -5426,7 +5572,7 @@
 
 ###############################################################################
 
-echo "$as_me:5429: checking format of man-pages" >&5
+echo "$as_me:5575: checking format of man-pages" >&5
 echo $ECHO_N "checking format of man-pages... $ECHO_C" >&6
 
 # Check whether --with-manpage-format or --without-manpage-format was given.
@@ -5515,14 +5661,14 @@
   ;;
 esac
 
-echo "$as_me:5518: result: $MANPAGE_FORMAT" >&5
+echo "$as_me:5664: result: $MANPAGE_FORMAT" >&5
 echo "${ECHO_T}$MANPAGE_FORMAT" >&6
 if test -n "$cf_unknown" ; then
-  { echo "$as_me:5521: WARNING: Unexpected manpage-format $cf_unknown" >&5
+  { echo "$as_me:5667: WARNING: Unexpected manpage-format $cf_unknown" >&5
 echo "$as_me: WARNING: Unexpected manpage-format $cf_unknown" >&2;}
 fi
 
-echo "$as_me:5525: checking for manpage renaming" >&5
+echo "$as_me:5671: checking for manpage renaming" >&5
 echo $ECHO_N "checking for manpage renaming... $ECHO_C" >&6
 
 # Check whether --with-manpage-renames or --without-manpage-renames was given.
@@ -5550,7 +5696,7 @@
   if test -f $srcdir/man/$MANPAGE_RENAMES ; then
     MANPAGE_RENAMES=`cd $srcdir/man && pwd`/$MANPAGE_RENAMES
   elif test ! -f $MANPAGE_RENAMES ; then
-    { { echo "$as_me:5553: error: not a filename: $MANPAGE_RENAMES" >&5
+    { { echo "$as_me:5699: error: not a filename: $MANPAGE_RENAMES" >&5
 echo "$as_me: error: not a filename: $MANPAGE_RENAMES" >&2;}
    { (exit 1); exit 1; }; }
   fi
@@ -5564,10 +5710,10 @@
   fi
 fi
 
-echo "$as_me:5567: result: $MANPAGE_RENAMES" >&5
+echo "$as_me:5713: result: $MANPAGE_RENAMES" >&5
 echo "${ECHO_T}$MANPAGE_RENAMES" >&6
 
-echo "$as_me:5570: checking if manpage aliases will be installed" >&5
+echo "$as_me:5716: checking if manpage aliases will be installed" >&5
 echo $ECHO_N "checking if manpage aliases will be installed... $ECHO_C" >&6
 
 # Check whether --with-manpage-aliases or --without-manpage-aliases was given.
@@ -5578,7 +5724,7 @@
   MANPAGE_ALIASES=yes
 fi;
 
-echo "$as_me:5581: result: $MANPAGE_ALIASES" >&5
+echo "$as_me:5727: result: $MANPAGE_ALIASES" >&5
 echo "${ECHO_T}$MANPAGE_ALIASES" >&6
 
 if test "$LN_S" = "ln -s"; then
@@ -5589,7 +5735,7 @@
 
 MANPAGE_SYMLINKS=no
 if test "$MANPAGE_ALIASES" = yes ; then
-echo "$as_me:5592: checking if manpage symlinks should be used" >&5
+echo "$as_me:5738: checking if manpage symlinks should be used" >&5
 echo $ECHO_N "checking if manpage symlinks should be used... $ECHO_C" >&6
 
 # Check whether --with-manpage-symlinks or --without-manpage-symlinks was given.
@@ -5602,17 +5748,17 @@
 
 if test "$$cf_use_symlinks" = no; then
 if test "$MANPAGE_SYMLINKS" = yes ; then
-	{ echo "$as_me:5605: WARNING: cannot make symlinks" >&5
+	{ echo "$as_me:5751: WARNING: cannot make symlinks" >&5
 echo "$as_me: WARNING: cannot make symlinks" >&2;}
 	MANPAGE_SYMLINKS=no
 fi
 fi
 
-echo "$as_me:5611: result: $MANPAGE_SYMLINKS" >&5
+echo "$as_me:5757: result: $MANPAGE_SYMLINKS" >&5
 echo "${ECHO_T}$MANPAGE_SYMLINKS" >&6
 fi
 
-echo "$as_me:5615: checking for manpage tbl" >&5
+echo "$as_me:5761: checking for manpage tbl" >&5
 echo $ECHO_N "checking for manpage tbl... $ECHO_C" >&6
 
 # Check whether --with-manpage-tbl or --without-manpage-tbl was given.
@@ -5623,7 +5769,7 @@
   MANPAGE_TBL=no
 fi;
 
-echo "$as_me:5626: result: $MANPAGE_TBL" >&5
+echo "$as_me:5772: result: $MANPAGE_TBL" >&5
 echo "${ECHO_T}$MANPAGE_TBL" >&6
 
   if test "$prefix" = "NONE" ; then
@@ -5911,7 +6057,7 @@
 ###############################################################################
 
 ### Note that some functions (such as const) are normally disabled anyway.
-echo "$as_me:5914: checking if you want to build with function extensions" >&5
+echo "$as_me:6060: checking if you want to build with function extensions" >&5
 echo $ECHO_N "checking if you want to build with function extensions... $ECHO_C" >&6
 
 # Check whether --enable-ext-funcs or --disable-ext-funcs was given.
@@ -5921,7 +6067,7 @@
 else
   with_ext_funcs=yes
 fi;
-echo "$as_me:5924: result: $with_ext_funcs" >&5
+echo "$as_me:6070: result: $with_ext_funcs" >&5
 echo "${ECHO_T}$with_ext_funcs" >&6
 if test "$with_ext_funcs" = yes ; then
 	NCURSES_EXT_FUNCS=1
@@ -5958,7 +6104,7 @@
 fi
 
 ###   use option --enable-const to turn on use of const beyond that in XSI.
-echo "$as_me:5961: checking for extended use of const keyword" >&5
+echo "$as_me:6107: checking for extended use of const keyword" >&5
 echo $ECHO_N "checking for extended use of const keyword... $ECHO_C" >&6
 
 # Check whether --enable-const or --disable-const was given.
@@ -5968,14 +6114,14 @@
 else
   with_ext_const=no
 fi;
-echo "$as_me:5971: result: $with_ext_const" >&5
+echo "$as_me:6117: result: $with_ext_const" >&5
 echo "${ECHO_T}$with_ext_const" >&6
 NCURSES_CONST='/*nothing*/'
 if test "$with_ext_const" = yes ; then
 	NCURSES_CONST=const
 fi
 
-echo "$as_me:5978: checking if you want \$NCURSES_NO_PADDING code" >&5
+echo "$as_me:6124: checking if you want \$NCURSES_NO_PADDING code" >&5
 echo $ECHO_N "checking if you want \$NCURSES_NO_PADDING code... $ECHO_C" >&6
 
 # Check whether --enable-no-padding or --disable-no-padding was given.
@@ -5985,14 +6131,14 @@
 else
   with_no_padding=$with_ext_funcs
 fi;
-echo "$as_me:5988: result: $with_no_padding" >&5
+echo "$as_me:6134: result: $with_no_padding" >&5
 echo "${ECHO_T}$with_no_padding" >&6
 test "$with_no_padding" = yes && cat >>confdefs.h <<\EOF
 #define NCURSES_NO_PADDING 1
 EOF
 
 ###   use option --enable-sigwinch to turn on use of SIGWINCH logic
-echo "$as_me:5995: checking if you want SIGWINCH handler" >&5
+echo "$as_me:6141: checking if you want SIGWINCH handler" >&5
 echo $ECHO_N "checking if you want SIGWINCH handler... $ECHO_C" >&6
 
 # Check whether --enable-sigwinch or --disable-sigwinch was given.
@@ -6002,14 +6148,14 @@
 else
   with_sigwinch=$with_ext_funcs
 fi;
-echo "$as_me:6005: result: $with_sigwinch" >&5
+echo "$as_me:6151: result: $with_sigwinch" >&5
 echo "${ECHO_T}$with_sigwinch" >&6
 test "$with_sigwinch" = yes && cat >>confdefs.h <<\EOF
 #define USE_SIGWINCH 1
 EOF
 
 ###   use option --enable-tcap-names to allow user to define new capabilities
-echo "$as_me:6012: checking if you want user-definable terminal capabilities like termcap" >&5
+echo "$as_me:6158: checking if you want user-definable terminal capabilities like termcap" >&5
 echo $ECHO_N "checking if you want user-definable terminal capabilities like termcap... $ECHO_C" >&6
 
 # Check whether --enable-tcap-names or --disable-tcap-names was given.
@@ -6019,7 +6165,7 @@
 else
   with_tcap_names=$with_ext_funcs
 fi;
-echo "$as_me:6022: result: $with_tcap_names" >&5
+echo "$as_me:6168: result: $with_tcap_names" >&5
 echo "${ECHO_T}$with_tcap_names" >&6
 NCURSES_XNAMES=0
 test "$with_tcap_names" = yes && NCURSES_XNAMES=1
@@ -6027,7 +6173,7 @@
 ###############################################################################
 # These options are relatively safe to experiment with.
 
-echo "$as_me:6030: checking if you want all development code" >&5
+echo "$as_me:6176: checking if you want all development code" >&5
 echo $ECHO_N "checking if you want all development code... $ECHO_C" >&6
 
 # Check whether --with-develop or --without-develop was given.
@@ -6037,11 +6183,11 @@
 else
   with_develop=no
 fi;
-echo "$as_me:6040: result: $with_develop" >&5
+echo "$as_me:6186: result: $with_develop" >&5
 echo "${ECHO_T}$with_develop" >&6
 
 ###   use option --enable-hard-tabs to turn on use of hard-tabs optimize
-echo "$as_me:6044: checking if you want hard-tabs code" >&5
+echo "$as_me:6190: checking if you want hard-tabs code" >&5
 echo $ECHO_N "checking if you want hard-tabs code... $ECHO_C" >&6
 
 # Check whether --enable-hard-tabs or --disable-hard-tabs was given.
@@ -6051,13 +6197,13 @@
 else
   with_hardtabs=$with_develop
 fi;
-echo "$as_me:6054: result: $with_hardtabs" >&5
+echo "$as_me:6200: result: $with_hardtabs" >&5
 echo "${ECHO_T}$with_hardtabs" >&6
 test "$with_hardtabs" = yes && cat >>confdefs.h <<\EOF
 #define USE_HARD_TABS 1
 EOF
 
-echo "$as_me:6060: checking if you want to use restrict environment when running as root" >&5
+echo "$as_me:6206: checking if you want to use restrict environment when running as root" >&5
 echo $ECHO_N "checking if you want to use restrict environment when running as root... $ECHO_C" >&6
 
 # Check whether --enable-root-environ or --disable-root-environ was given.
@@ -6067,14 +6213,14 @@
 else
   with_root_environ=yes
 fi;
-echo "$as_me:6070: result: $with_root_environ" >&5
+echo "$as_me:6216: result: $with_root_environ" >&5
 echo "${ECHO_T}$with_root_environ" >&6
 test "$with_root_environ" = yes && cat >>confdefs.h <<\EOF
 #define USE_ROOT_ENVIRON 1
 EOF
 
 ###   use option --enable-xmc-glitch to turn on use of magic-cookie optimize
-echo "$as_me:6077: checking if you want limited support for xmc" >&5
+echo "$as_me:6223: checking if you want limited support for xmc" >&5
 echo $ECHO_N "checking if you want limited support for xmc... $ECHO_C" >&6
 
 # Check whether --enable-xmc-glitch or --disable-xmc-glitch was given.
@@ -6084,7 +6230,7 @@
 else
   with_xmc_glitch=$with_develop
 fi;
-echo "$as_me:6087: result: $with_xmc_glitch" >&5
+echo "$as_me:6233: result: $with_xmc_glitch" >&5
 echo "${ECHO_T}$with_xmc_glitch" >&6
 test "$with_xmc_glitch" = yes && cat >>confdefs.h <<\EOF
 #define USE_XMC_SUPPORT 1
@@ -6093,7 +6239,7 @@
 ###############################################################################
 # These are just experimental, probably should not be in a package:
 
-echo "$as_me:6096: checking if you do not want to assume colors are white-on-black" >&5
+echo "$as_me:6242: checking if you do not want to assume colors are white-on-black" >&5
 echo $ECHO_N "checking if you do not want to assume colors are white-on-black... $ECHO_C" >&6
 
 # Check whether --enable-assumed-color or --disable-assumed-color was given.
@@ -6103,14 +6249,14 @@
 else
   with_assumed_color=yes
 fi;
-echo "$as_me:6106: result: $with_assumed_color" >&5
+echo "$as_me:6252: result: $with_assumed_color" >&5
 echo "${ECHO_T}$with_assumed_color" >&6
 test "$with_assumed_color" = yes && cat >>confdefs.h <<\EOF
 #define USE_ASSUMED_COLOR 1
 EOF
 
 ###   use option --enable-hashmap to turn on use of hashmap scrolling logic
-echo "$as_me:6113: checking if you want hashmap scrolling-optimization code" >&5
+echo "$as_me:6259: checking if you want hashmap scrolling-optimization code" >&5
 echo $ECHO_N "checking if you want hashmap scrolling-optimization code... $ECHO_C" >&6
 
 # Check whether --enable-hashmap or --disable-hashmap was given.
@@ -6120,14 +6266,14 @@
 else
   with_hashmap=yes
 fi;
-echo "$as_me:6123: result: $with_hashmap" >&5
+echo "$as_me:6269: result: $with_hashmap" >&5
 echo "${ECHO_T}$with_hashmap" >&6
 test "$with_hashmap" = yes && cat >>confdefs.h <<\EOF
 #define USE_HASHMAP 1
 EOF
 
 ###   use option --enable-colorfgbg to turn on use of $COLORFGBG environment
-echo "$as_me:6130: checking if you want colorfgbg code" >&5
+echo "$as_me:6276: checking if you want colorfgbg code" >&5
 echo $ECHO_N "checking if you want colorfgbg code... $ECHO_C" >&6
 
 # Check whether --enable-colorfgbg or --disable-colorfgbg was given.
@@ -6137,13 +6283,13 @@
 else
   with_colorfgbg=no
 fi;
-echo "$as_me:6140: result: $with_colorfgbg" >&5
+echo "$as_me:6286: result: $with_colorfgbg" >&5
 echo "${ECHO_T}$with_colorfgbg" >&6
 test "$with_colorfgbg" = yes && cat >>confdefs.h <<\EOF
 #define USE_COLORFGBG 1
 EOF
 
-echo "$as_me:6146: checking if you want experimental safe-sprintf code" >&5
+echo "$as_me:6292: checking if you want experimental safe-sprintf code" >&5
 echo $ECHO_N "checking if you want experimental safe-sprintf code... $ECHO_C" >&6
 
 # Check whether --enable-safe-sprintf or --disable-safe-sprintf was given.
@@ -6153,7 +6299,7 @@
 else
   with_safe_sprintf=no
 fi;
-echo "$as_me:6156: result: $with_safe_sprintf" >&5
+echo "$as_me:6302: result: $with_safe_sprintf" >&5
 echo "${ECHO_T}$with_safe_sprintf" >&6
 test "$with_safe_sprintf" = yes && cat >>confdefs.h <<\EOF
 #define USE_SAFE_SPRINTF 1
@@ -6162,7 +6308,7 @@
 ###   use option --disable-scroll-hints to turn off use of scroll-hints scrolling logic
 # when hashmap is used scroll hints are useless
 if test "$with_hashmap" = no ; then
-echo "$as_me:6165: checking if you want to experiment without scrolling-hints code" >&5
+echo "$as_me:6311: checking if you want to experiment without scrolling-hints code" >&5
 echo $ECHO_N "checking if you want to experiment without scrolling-hints code... $ECHO_C" >&6
 
 # Check whether --enable-scroll-hints or --disable-scroll-hints was given.
@@ -6172,7 +6318,7 @@
 else
   with_scroll_hints=yes
 fi;
-echo "$as_me:6175: result: $with_scroll_hints" >&5
+echo "$as_me:6321: result: $with_scroll_hints" >&5
 echo "${ECHO_T}$with_scroll_hints" >&6
 test "$with_scroll_hints" = yes && cat >>confdefs.h <<\EOF
 #define USE_SCROLL_HINTS 1
@@ -6203,14 +6349,14 @@
 	;;
 linux*) #(vi
 
-echo "$as_me:6206: checking if we must define _GNU_SOURCE" >&5
+echo "$as_me:6352: checking if we must define _GNU_SOURCE" >&5
 echo $ECHO_N "checking if we must define _GNU_SOURCE... $ECHO_C" >&6
 if test "${cf_cv_gnu_source+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
 else
 
 cat >conftest.$ac_ext <<_ACEOF
-#line 6213 "configure"
+#line 6359 "configure"
 #include "confdefs.h"
 #include <sys/types.h>
 int
@@ -6225,16 +6371,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext
-if { (eval echo "$as_me:6228: \"$ac_compile\"") >&5
+if { (eval echo "$as_me:6374: \"$ac_compile\"") >&5
   (eval $ac_compile) 2>&5
   ac_status=$?
-  echo "$as_me:6231: \$? = $ac_status" >&5
+  echo "$as_me:6377: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest.$ac_objext'
-  { (eval echo "$as_me:6234: \"$ac_try\"") >&5
+  { (eval echo "$as_me:6380: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:6237: \$? = $ac_status" >&5
+  echo "$as_me:6383: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   cf_cv_gnu_source=no
 else
@@ -6243,7 +6389,7 @@
 cf_save="$CPPFLAGS"
 	 CPPFLAGS="$CPPFLAGS -D_GNU_SOURCE"
 	 cat >conftest.$ac_ext <<_ACEOF
-#line 6246 "configure"
+#line 6392 "configure"
 #include "confdefs.h"
 #include <sys/types.h>
 int
@@ -6258,16 +6404,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext
-if { (eval echo "$as_me:6261: \"$ac_compile\"") >&5
+if { (eval echo "$as_me:6407: \"$ac_compile\"") >&5
   (eval $ac_compile) 2>&5
   ac_status=$?
-  echo "$as_me:6264: \$? = $ac_status" >&5
+  echo "$as_me:6410: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest.$ac_objext'
-  { (eval echo "$as_me:6267: \"$ac_try\"") >&5
+  { (eval echo "$as_me:6413: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:6270: \$? = $ac_status" >&5
+  echo "$as_me:6416: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   cf_cv_gnu_source=no
 else
@@ -6282,7 +6428,7 @@
 rm -f conftest.$ac_objext conftest.$ac_ext
 
 fi
-echo "$as_me:6285: result: $cf_cv_gnu_source" >&5
+echo "$as_me:6431: result: $cf_cv_gnu_source" >&5
 echo "${ECHO_T}$cf_cv_gnu_source" >&6
 test "$cf_cv_gnu_source" = yes && CPPFLAGS="$CPPFLAGS -D_GNU_SOURCE"
 
@@ -6306,14 +6452,14 @@
 	CPPFLAGS="$CPPFLAGS -D__EXTENSIONS__"
 	;;
 *)
-	echo "$as_me:6309: checking if we should define _XOPEN_SOURCE" >&5
+	echo "$as_me:6455: checking if we should define _XOPEN_SOURCE" >&5
 echo $ECHO_N "checking if we should define _XOPEN_SOURCE... $ECHO_C" >&6
 if test "${cf_cv_xopen_source+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
 else
 
 	cat >conftest.$ac_ext <<_ACEOF
-#line 6316 "configure"
+#line 6462 "configure"
 #include "confdefs.h"
 #include <sys/types.h>
 int
@@ -6328,16 +6474,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext
-if { (eval echo "$as_me:6331: \"$ac_compile\"") >&5
+if { (eval echo "$as_me:6477: \"$ac_compile\"") >&5
   (eval $ac_compile) 2>&5
   ac_status=$?
-  echo "$as_me:6334: \$? = $ac_status" >&5
+  echo "$as_me:6480: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest.$ac_objext'
-  { (eval echo "$as_me:6337: \"$ac_try\"") >&5
+  { (eval echo "$as_me:6483: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:6340: \$? = $ac_status" >&5
+  echo "$as_me:6486: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   cf_cv_xopen_source=no
 else
@@ -6346,7 +6492,7 @@
 cf_save="$CPPFLAGS"
 	 CPPFLAGS="$CPPFLAGS -D_XOPEN_SOURCE=500"
 	 cat >conftest.$ac_ext <<_ACEOF
-#line 6349 "configure"
+#line 6495 "configure"
 #include "confdefs.h"
 #include <sys/types.h>
 int
@@ -6361,16 +6507,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext
-if { (eval echo "$as_me:6364: \"$ac_compile\"") >&5
+if { (eval echo "$as_me:6510: \"$ac_compile\"") >&5
   (eval $ac_compile) 2>&5
   ac_status=$?
-  echo "$as_me:6367: \$? = $ac_status" >&5
+  echo "$as_me:6513: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest.$ac_objext'
-  { (eval echo "$as_me:6370: \"$ac_try\"") >&5
+  { (eval echo "$as_me:6516: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:6373: \$? = $ac_status" >&5
+  echo "$as_me:6519: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   cf_cv_xopen_source=no
 else
@@ -6385,19 +6531,19 @@
 rm -f conftest.$ac_objext conftest.$ac_ext
 
 fi
-echo "$as_me:6388: result: $cf_cv_xopen_source" >&5
+echo "$as_me:6534: result: $cf_cv_xopen_source" >&5
 echo "${ECHO_T}$cf_cv_xopen_source" >&6
 test "$cf_cv_xopen_source" = yes && CPPFLAGS="$CPPFLAGS -D_XOPEN_SOURCE=500"
 
 	# FreeBSD 5.x headers demand this...
-	echo "$as_me:6393: checking if we should define _POSIX_C_SOURCE" >&5
+	echo "$as_me:6539: checking if we should define _POSIX_C_SOURCE" >&5
 echo $ECHO_N "checking if we should define _POSIX_C_SOURCE... $ECHO_C" >&6
 if test "${cf_cv_xopen_source+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
 else
 
 	cat >conftest.$ac_ext <<_ACEOF
-#line 6400 "configure"
+#line 6546 "configure"
 #include "confdefs.h"
 #include <sys/types.h>
 int
@@ -6412,16 +6558,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext
-if { (eval echo "$as_me:6415: \"$ac_compile\"") >&5
+if { (eval echo "$as_me:6561: \"$ac_compile\"") >&5
   (eval $ac_compile) 2>&5
   ac_status=$?
-  echo "$as_me:6418: \$? = $ac_status" >&5
+  echo "$as_me:6564: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest.$ac_objext'
-  { (eval echo "$as_me:6421: \"$ac_try\"") >&5
+  { (eval echo "$as_me:6567: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:6424: \$? = $ac_status" >&5
+  echo "$as_me:6570: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   cf_cv_xopen_source=no
 else
@@ -6430,7 +6576,7 @@
 cf_save="$CPPFLAGS"
 	 CPPFLAGS="$CPPFLAGS -D_POSIX_C_SOURCE"
 	 cat >conftest.$ac_ext <<_ACEOF
-#line 6433 "configure"
+#line 6579 "configure"
 #include "confdefs.h"
 #include <sys/types.h>
 int
@@ -6445,16 +6591,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext
-if { (eval echo "$as_me:6448: \"$ac_compile\"") >&5
+if { (eval echo "$as_me:6594: \"$ac_compile\"") >&5
   (eval $ac_compile) 2>&5
   ac_status=$?
-  echo "$as_me:6451: \$? = $ac_status" >&5
+  echo "$as_me:6597: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest.$ac_objext'
-  { (eval echo "$as_me:6454: \"$ac_try\"") >&5
+  { (eval echo "$as_me:6600: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:6457: \$? = $ac_status" >&5
+  echo "$as_me:6603: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   cf_cv_xopen_source=no
 else
@@ -6469,17 +6615,67 @@
 rm -f conftest.$ac_objext conftest.$ac_ext
 
 fi
-echo "$as_me:6472: result: $cf_cv_xopen_source" >&5
+echo "$as_me:6618: result: $cf_cv_xopen_source" >&5
 echo "${ECHO_T}$cf_cv_xopen_source" >&6
 test "$cf_cv_xopen_source" = yes && CPPFLAGS="$CPPFLAGS -D_POSIX_C_SOURCE"
 	;;
 esac
 
+# Checks for CODESET support.
+
+  echo "$as_me:6626: checking for nl_langinfo and CODESET" >&5
+echo $ECHO_N "checking for nl_langinfo and CODESET... $ECHO_C" >&6
+if test "${am_cv_langinfo_codeset+set}" = set; then
+  echo $ECHO_N "(cached) $ECHO_C" >&6
+else
+  cat >conftest.$ac_ext <<_ACEOF
+#line 6632 "configure"
+#include "confdefs.h"
+#include <langinfo.h>
+int
+main ()
+{
+char* cs = nl_langinfo(CODESET);
+  ;
+  return 0;
+}
+_ACEOF
+rm -f conftest.$ac_objext conftest$ac_exeext
+if { (eval echo "$as_me:6644: \"$ac_link\"") >&5
+  (eval $ac_link) 2>&5
+  ac_status=$?
+  echo "$as_me:6647: \$? = $ac_status" >&5
+  (exit $ac_status); } &&
+         { ac_try='test -s conftest$ac_exeext'
+  { (eval echo "$as_me:6650: \"$ac_try\"") >&5
+  (eval $ac_try) 2>&5
+  ac_status=$?
+  echo "$as_me:6653: \$? = $ac_status" >&5
+  (exit $ac_status); }; }; then
+  am_cv_langinfo_codeset=yes
+else
+  echo "$as_me: failed program was:" >&5
+cat conftest.$ac_ext >&5
+am_cv_langinfo_codeset=no
+fi
+rm -f conftest.$ac_objext conftest$ac_exeext conftest.$ac_ext
+
+fi
+echo "$as_me:6664: result: $am_cv_langinfo_codeset" >&5
+echo "${ECHO_T}$am_cv_langinfo_codeset" >&6
+  if test $am_cv_langinfo_codeset = yes; then
+
+cat >>confdefs.h <<\EOF
+#define HAVE_LANGINFO_CODESET 1
+EOF
+
+  fi
+
 # use these variables to work around a defect in gcc's fixincludes.
 NCURSES_OK_WCHAR_T=
 NCURSES_OK_WINT_T=
 
-echo "$as_me:6482: checking if you want experimental wide-character code" >&5
+echo "$as_me:6678: checking if you want experimental wide-character code" >&5
 echo $ECHO_N "checking if you want experimental wide-character code... $ECHO_C" >&6
 
 # Check whether --enable-widec or --disable-widec was given.
@@ -6489,7 +6685,7 @@
 else
   with_widec=no
 fi;
-echo "$as_me:6492: result: $with_widec" >&5
+echo "$as_me:6688: result: $with_widec" >&5
 echo "${ECHO_T}$with_widec" >&6
 if test "$with_widec" = yes ; then
 	LIB_SUFFIX="w${LIB_SUFFIX}"
@@ -6497,10 +6693,10 @@
 #define USE_WIDEC_SUPPORT 1
 EOF
 
-echo "$as_me:6500: checking if we must define _XOPEN_SOURCE" >&5
+echo "$as_me:6696: checking if we must define _XOPEN_SOURCE" >&5
 echo $ECHO_N "checking if we must define _XOPEN_SOURCE... $ECHO_C" >&6
 cat >conftest.$ac_ext <<_ACEOF
-#line 6503 "configure"
+#line 6699 "configure"
 #include "confdefs.h"
 #include <sys/types.h>
 
@@ -6516,16 +6712,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext
-if { (eval echo "$as_me:6519: \"$ac_compile\"") >&5
+if { (eval echo "$as_me:6715: \"$ac_compile\"") >&5
   (eval $ac_compile) 2>&5
   ac_status=$?
-  echo "$as_me:6522: \$? = $ac_status" >&5
+  echo "$as_me:6718: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest.$ac_objext'
-  { (eval echo "$as_me:6525: \"$ac_try\"") >&5
+  { (eval echo "$as_me:6721: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:6528: \$? = $ac_status" >&5
+  echo "$as_me:6724: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   cf_result=no
 else
@@ -6534,16 +6730,16 @@
 cf_result=yes
 fi
 rm -f conftest.$ac_objext conftest.$ac_ext
-echo "$as_me:6537: result: $cf_result" >&5
+echo "$as_me:6733: result: $cf_result" >&5
 echo "${ECHO_T}$cf_result" >&6
 
 if test "$cf_result" = yes ; then
 	CPPFLAGS="$CPPFLAGS -D_XOPEN_SOURCE=500"
 elif test "x500" != "x" ; then
-	echo "$as_me:6543: checking checking for compatible value versus 500" >&5
+	echo "$as_me:6739: checking checking for compatible value versus 500" >&5
 echo $ECHO_N "checking checking for compatible value versus 500... $ECHO_C" >&6
 	cat >conftest.$ac_ext <<_ACEOF
-#line 6546 "configure"
+#line 6742 "configure"
 #include "confdefs.h"
 #include <sys/types.h>
 
@@ -6559,16 +6755,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext
-if { (eval echo "$as_me:6562: \"$ac_compile\"") >&5
+if { (eval echo "$as_me:6758: \"$ac_compile\"") >&5
   (eval $ac_compile) 2>&5
   ac_status=$?
-  echo "$as_me:6565: \$? = $ac_status" >&5
+  echo "$as_me:6761: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest.$ac_objext'
-  { (eval echo "$as_me:6568: \"$ac_try\"") >&5
+  { (eval echo "$as_me:6764: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:6571: \$? = $ac_status" >&5
+  echo "$as_me:6767: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   cf_result=yes
 else
@@ -6577,7 +6773,7 @@
 cf_result=no
 fi
 rm -f conftest.$ac_objext conftest.$ac_ext
-	echo "$as_me:6580: result: $cf_result" >&5
+	echo "$as_me:6776: result: $cf_result" >&5
 echo "${ECHO_T}$cf_result" >&6
 	if test "$cf_result" = no ; then
 		# perhaps we can override it - try...
@@ -6585,10 +6781,10 @@
 	fi
 fi
 
-echo "$as_me:6588: checking if we must define _XOPEN_SOURCE_EXTENDED" >&5
+echo "$as_me:6784: checking if we must define _XOPEN_SOURCE_EXTENDED" >&5
 echo $ECHO_N "checking if we must define _XOPEN_SOURCE_EXTENDED... $ECHO_C" >&6
 cat >conftest.$ac_ext <<_ACEOF
-#line 6591 "configure"
+#line 6787 "configure"
 #include "confdefs.h"
 #include <sys/types.h>
 
@@ -6604,16 +6800,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext
-if { (eval echo "$as_me:6607: \"$ac_compile\"") >&5
+if { (eval echo "$as_me:6803: \"$ac_compile\"") >&5
   (eval $ac_compile) 2>&5
   ac_status=$?
-  echo "$as_me:6610: \$? = $ac_status" >&5
+  echo "$as_me:6806: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest.$ac_objext'
-  { (eval echo "$as_me:6613: \"$ac_try\"") >&5
+  { (eval echo "$as_me:6809: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:6616: \$? = $ac_status" >&5
+  echo "$as_me:6812: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   cf_result=no
 else
@@ -6622,16 +6818,16 @@
 cf_result=yes
 fi
 rm -f conftest.$ac_objext conftest.$ac_ext
-echo "$as_me:6625: result: $cf_result" >&5
+echo "$as_me:6821: result: $cf_result" >&5
 echo "${ECHO_T}$cf_result" >&6
 
 if test "$cf_result" = yes ; then
 	CPPFLAGS="$CPPFLAGS -D_XOPEN_SOURCE_EXTENDED"
 elif test "x" != "x" ; then
-	echo "$as_me:6631: checking checking for compatible value versus " >&5
+	echo "$as_me:6827: checking checking for compatible value versus " >&5
 echo $ECHO_N "checking checking for compatible value versus ... $ECHO_C" >&6
 	cat >conftest.$ac_ext <<_ACEOF
-#line 6634 "configure"
+#line 6830 "configure"
 #include "confdefs.h"
 #include <sys/types.h>
 
@@ -6647,16 +6843,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext
-if { (eval echo "$as_me:6650: \"$ac_compile\"") >&5
+if { (eval echo "$as_me:6846: \"$ac_compile\"") >&5
   (eval $ac_compile) 2>&5
   ac_status=$?
-  echo "$as_me:6653: \$? = $ac_status" >&5
+  echo "$as_me:6849: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest.$ac_objext'
-  { (eval echo "$as_me:6656: \"$ac_try\"") >&5
+  { (eval echo "$as_me:6852: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:6659: \$? = $ac_status" >&5
+  echo "$as_me:6855: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   cf_result=yes
 else
@@ -6665,7 +6861,7 @@
 cf_result=no
 fi
 rm -f conftest.$ac_objext conftest.$ac_ext
-	echo "$as_me:6668: result: $cf_result" >&5
+	echo "$as_me:6864: result: $cf_result" >&5
 echo "${ECHO_T}$cf_result" >&6
 	if test "$cf_result" = no ; then
 		# perhaps we can override it - try...
@@ -6679,13 +6875,13 @@
 for ac_func in putwc btowc wctob mbtowc wctomb mblen mbrlen mbrtowc
 do
 as_ac_var=`echo "ac_cv_func_$ac_func" | $as_tr_sh`
-echo "$as_me:6682: checking for $ac_func" >&5
+echo "$as_me:6878: checking for $ac_func" >&5
 echo $ECHO_N "checking for $ac_func... $ECHO_C" >&6
 if eval "test \"\${$as_ac_var+set}\" = set"; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
 else
   cat >conftest.$ac_ext <<_ACEOF
-#line 6688 "configure"
+#line 6884 "configure"
 #include "confdefs.h"
 /* System header to define __stub macros and hopefully few prototypes,
     which can conflict with char $ac_func (); below.  */
@@ -6716,16 +6912,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext conftest$ac_exeext
-if { (eval echo "$as_me:6719: \"$ac_link\"") >&5
+if { (eval echo "$as_me:6915: \"$ac_link\"") >&5
   (eval $ac_link) 2>&5
   ac_status=$?
-  echo "$as_me:6722: \$? = $ac_status" >&5
+  echo "$as_me:6918: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest$ac_exeext'
-  { (eval echo "$as_me:6725: \"$ac_try\"") >&5
+  { (eval echo "$as_me:6921: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:6728: \$? = $ac_status" >&5
+  echo "$as_me:6924: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   eval "$as_ac_var=yes"
 else
@@ -6735,7 +6931,7 @@
 fi
 rm -f conftest.$ac_objext conftest$ac_exeext conftest.$ac_ext
 fi
-echo "$as_me:6738: result: `eval echo '${'$as_ac_var'}'`" >&5
+echo "$as_me:6934: result: `eval echo '${'$as_ac_var'}'`" >&5
 echo "${ECHO_T}`eval echo '${'$as_ac_var'}'`" >&6
 if test `eval echo '${'$as_ac_var'}'` = yes; then
   cat >>confdefs.h <<EOF
@@ -6747,7 +6943,7 @@
 
 	if test "$ac_cv_func_putwc" != yes ; then
 
-echo "$as_me:6750: checking for putwc in libutf8" >&5
+echo "$as_me:6946: checking for putwc in libutf8" >&5
 echo $ECHO_N "checking for putwc in libutf8... $ECHO_C" >&6
 if test "${cf_cv_libutf8+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
@@ -6756,7 +6952,7 @@
 	cf_save_LIBS="$LIBS"
 	LIBS="-lutf8 $LIBS"
 cat >conftest.$ac_ext <<_ACEOF
-#line 6759 "configure"
+#line 6955 "configure"
 #include "confdefs.h"
 
 #include <libutf8.h>
@@ -6769,16 +6965,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext conftest$ac_exeext
-if { (eval echo "$as_me:6772: \"$ac_link\"") >&5
+if { (eval echo "$as_me:6968: \"$ac_link\"") >&5
   (eval $ac_link) 2>&5
   ac_status=$?
-  echo "$as_me:6775: \$? = $ac_status" >&5
+  echo "$as_me:6971: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest$ac_exeext'
-  { (eval echo "$as_me:6778: \"$ac_try\"") >&5
+  { (eval echo "$as_me:6974: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:6781: \$? = $ac_status" >&5
+  echo "$as_me:6977: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   cf_cv_libutf8=yes
 else
@@ -6790,7 +6986,7 @@
 	LIBS="$cf_save_LIBS"
 
 fi
-echo "$as_me:6793: result: $cf_cv_libutf8" >&5
+echo "$as_me:6989: result: $cf_cv_libutf8" >&5
 echo "${ECHO_T}$cf_cv_libutf8" >&6
 
 if test "$cf_cv_libutf8" = yes ; then
@@ -6807,14 +7003,14 @@
 	fi
 
 # This is needed on Tru64 5.0 to declare mbstate_t
-echo "$as_me:6810: checking if we must include wchar.h to declare mbstate_t" >&5
+echo "$as_me:7006: checking if we must include wchar.h to declare mbstate_t" >&5
 echo $ECHO_N "checking if we must include wchar.h to declare mbstate_t... $ECHO_C" >&6
 if test "${cf_cv_mbstate_t+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
 else
 
 cat >conftest.$ac_ext <<_ACEOF
-#line 6817 "configure"
+#line 7013 "configure"
 #include "confdefs.h"
 
 #include <stdlib.h>
@@ -6832,23 +7028,23 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext
-if { (eval echo "$as_me:6835: \"$ac_compile\"") >&5
+if { (eval echo "$as_me:7031: \"$ac_compile\"") >&5
   (eval $ac_compile) 2>&5
   ac_status=$?
-  echo "$as_me:6838: \$? = $ac_status" >&5
+  echo "$as_me:7034: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest.$ac_objext'
-  { (eval echo "$as_me:6841: \"$ac_try\"") >&5
+  { (eval echo "$as_me:7037: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:6844: \$? = $ac_status" >&5
+  echo "$as_me:7040: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   cf_cv_mbstate_t=no
 else
   echo "$as_me: failed program was:" >&5
 cat conftest.$ac_ext >&5
 cat >conftest.$ac_ext <<_ACEOF
-#line 6851 "configure"
+#line 7047 "configure"
 #include "confdefs.h"
 
 #include <stdlib.h>
@@ -6867,16 +7063,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext
-if { (eval echo "$as_me:6870: \"$ac_compile\"") >&5
+if { (eval echo "$as_me:7066: \"$ac_compile\"") >&5
   (eval $ac_compile) 2>&5
   ac_status=$?
-  echo "$as_me:6873: \$? = $ac_status" >&5
+  echo "$as_me:7069: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest.$ac_objext'
-  { (eval echo "$as_me:6876: \"$ac_try\"") >&5
+  { (eval echo "$as_me:7072: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:6879: \$? = $ac_status" >&5
+  echo "$as_me:7075: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   cf_cv_mbstate_t=yes
 else
@@ -6888,7 +7084,7 @@
 fi
 rm -f conftest.$ac_objext conftest.$ac_ext
 fi
-echo "$as_me:6891: result: $cf_cv_mbstate_t" >&5
+echo "$as_me:7087: result: $cf_cv_mbstate_t" >&5
 echo "${ECHO_T}$cf_cv_mbstate_t" >&6
 
 if test "$cf_cv_mbstate_t" = yes ; then
@@ -6905,14 +7101,14 @@
 fi
 
 # This is needed on Tru64 5.0 to declare wchar_t
-echo "$as_me:6908: checking if we must include wchar.h to declare wchar_t" >&5
+echo "$as_me:7104: checking if we must include wchar.h to declare wchar_t" >&5
 echo $ECHO_N "checking if we must include wchar.h to declare wchar_t... $ECHO_C" >&6
 if test "${cf_cv_wchar_t+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
 else
 
 cat >conftest.$ac_ext <<_ACEOF
-#line 6915 "configure"
+#line 7111 "configure"
 #include "confdefs.h"
 
 #include <stdlib.h>
@@ -6930,23 +7126,23 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext
-if { (eval echo "$as_me:6933: \"$ac_compile\"") >&5
+if { (eval echo "$as_me:7129: \"$ac_compile\"") >&5
   (eval $ac_compile) 2>&5
   ac_status=$?
-  echo "$as_me:6936: \$? = $ac_status" >&5
+  echo "$as_me:7132: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest.$ac_objext'
-  { (eval echo "$as_me:6939: \"$ac_try\"") >&5
+  { (eval echo "$as_me:7135: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:6942: \$? = $ac_status" >&5
+  echo "$as_me:7138: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   cf_cv_wchar_t=no
 else
   echo "$as_me: failed program was:" >&5
 cat conftest.$ac_ext >&5
 cat >conftest.$ac_ext <<_ACEOF
-#line 6949 "configure"
+#line 7145 "configure"
 #include "confdefs.h"
 
 #include <stdlib.h>
@@ -6965,16 +7161,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext
-if { (eval echo "$as_me:6968: \"$ac_compile\"") >&5
+if { (eval echo "$as_me:7164: \"$ac_compile\"") >&5
   (eval $ac_compile) 2>&5
   ac_status=$?
-  echo "$as_me:6971: \$? = $ac_status" >&5
+  echo "$as_me:7167: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest.$ac_objext'
-  { (eval echo "$as_me:6974: \"$ac_try\"") >&5
+  { (eval echo "$as_me:7170: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:6977: \$? = $ac_status" >&5
+  echo "$as_me:7173: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   cf_cv_wchar_t=yes
 else
@@ -6986,7 +7182,7 @@
 fi
 rm -f conftest.$ac_objext conftest.$ac_ext
 fi
-echo "$as_me:6989: result: $cf_cv_wchar_t" >&5
+echo "$as_me:7185: result: $cf_cv_wchar_t" >&5
 echo "${ECHO_T}$cf_cv_wchar_t" >&6
 
 if test "$cf_cv_wchar_t" = yes ; then
@@ -7008,14 +7204,14 @@
 fi
 
 # This is needed on Tru64 5.0 to declare wint_t
-echo "$as_me:7011: checking if we must include wchar.h to declare wint_t" >&5
+echo "$as_me:7207: checking if we must include wchar.h to declare wint_t" >&5
 echo $ECHO_N "checking if we must include wchar.h to declare wint_t... $ECHO_C" >&6
 if test "${cf_cv_wint_t+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
 else
 
 cat >conftest.$ac_ext <<_ACEOF
-#line 7018 "configure"
+#line 7214 "configure"
 #include "confdefs.h"
 
 #include <stdlib.h>
@@ -7033,23 +7229,23 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext
-if { (eval echo "$as_me:7036: \"$ac_compile\"") >&5
+if { (eval echo "$as_me:7232: \"$ac_compile\"") >&5
   (eval $ac_compile) 2>&5
   ac_status=$?
-  echo "$as_me:7039: \$? = $ac_status" >&5
+  echo "$as_me:7235: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest.$ac_objext'
-  { (eval echo "$as_me:7042: \"$ac_try\"") >&5
+  { (eval echo "$as_me:7238: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:7045: \$? = $ac_status" >&5
+  echo "$as_me:7241: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   cf_cv_wint_t=no
 else
   echo "$as_me: failed program was:" >&5
 cat conftest.$ac_ext >&5
 cat >conftest.$ac_ext <<_ACEOF
-#line 7052 "configure"
+#line 7248 "configure"
 #include "confdefs.h"
 
 #include <stdlib.h>
@@ -7068,16 +7264,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext
-if { (eval echo "$as_me:7071: \"$ac_compile\"") >&5
+if { (eval echo "$as_me:7267: \"$ac_compile\"") >&5
   (eval $ac_compile) 2>&5
   ac_status=$?
-  echo "$as_me:7074: \$? = $ac_status" >&5
+  echo "$as_me:7270: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest.$ac_objext'
-  { (eval echo "$as_me:7077: \"$ac_try\"") >&5
+  { (eval echo "$as_me:7273: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:7080: \$? = $ac_status" >&5
+  echo "$as_me:7276: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   cf_cv_wint_t=yes
 else
@@ -7089,7 +7285,7 @@
 fi
 rm -f conftest.$ac_objext conftest.$ac_ext
 fi
-echo "$as_me:7092: result: $cf_cv_wint_t" >&5
+echo "$as_me:7288: result: $cf_cv_wint_t" >&5
 echo "${ECHO_T}$cf_cv_wint_t" >&6
 
 if test "$cf_cv_wint_t" = yes ; then
@@ -7112,7 +7308,7 @@
 
 fi
 
-echo "$as_me:7115: checking for terminal capabilities file" >&5
+echo "$as_me:7311: checking for terminal capabilities file" >&5
 echo $ECHO_N "checking for terminal capabilities file... $ECHO_C" >&6
 
 # Check whether --with-caps or --without-caps was given.
@@ -7123,13 +7319,13 @@
   TERMINFO_CAPS=Caps
 fi;
 test -f ${srcdir}/include/${TERMINFO_CAPS} || TERMINFO_CAPS=Caps
-echo "$as_me:7126: result: $TERMINFO_CAPS" >&5
+echo "$as_me:7322: result: $TERMINFO_CAPS" >&5
 echo "${ECHO_T}$TERMINFO_CAPS" >&6
 
 ###############################################################################
 
 ###	use option --disable-echo to suppress full display compiling commands
-echo "$as_me:7132: checking if you want to display full commands during build" >&5
+echo "$as_me:7328: checking if you want to display full commands during build" >&5
 echo $ECHO_N "checking if you want to display full commands during build... $ECHO_C" >&6
 
 # Check whether --enable-echo or --disable-echo was given.
@@ -7145,11 +7341,11 @@
 	ECHO_LINK='@ echo linking $@ ... ;'
 	test -n "$LIBTOOL" && LIBTOOL="$LIBTOOL --silent"
 fi
-echo "$as_me:7148: result: $with_echo" >&5
+echo "$as_me:7344: result: $with_echo" >&5
 echo "${ECHO_T}$with_echo" >&6
 
 ###	use option --enable-warnings to turn on all gcc warnings
-echo "$as_me:7152: checking if you want to see compiler warnings" >&5
+echo "$as_me:7348: checking if you want to see compiler warnings" >&5
 echo $ECHO_N "checking if you want to see compiler warnings... $ECHO_C" >&6
 
 # Check whether --enable-warnings or --disable-warnings was given.
@@ -7157,7 +7353,7 @@
   enableval="$enable_warnings"
   with_warnings=$enableval
 fi;
-echo "$as_me:7160: result: $with_warnings" >&5
+echo "$as_me:7356: result: $with_warnings" >&5
 echo "${ECHO_T}$with_warnings" >&6
 
 if test -n "$with_warnings"; then
@@ -7166,10 +7362,10 @@
 if test "$GCC" = yes
 then
 	cat > conftest.$ac_ext <<EOF
-#line 7169 "configure"
+#line 7365 "configure"
 int main(int argc, char *argv[]) { return (argv[argc-1] == 0) ; }
 EOF
-	{ echo "$as_me:7172: checking for $CC warning options..." >&5
+	{ echo "$as_me:7368: checking for $CC warning options..." >&5
 echo "$as_me: checking for $CC warning options..." >&6;}
 	cf_save_CFLAGS="$CFLAGS"
 	EXTRA_CFLAGS="-W -Wall"
@@ -7189,12 +7385,12 @@
 		Wundef $cf_warn_CONST
 	do
 		CFLAGS="$cf_save_CFLAGS $EXTRA_CFLAGS -$cf_opt"
-		if { (eval echo "$as_me:7192: \"$ac_compile\"") >&5
+		if { (eval echo "$as_me:7388: \"$ac_compile\"") >&5
   (eval $ac_compile) 2>&5
   ac_status=$?
-  echo "$as_me:7195: \$? = $ac_status" >&5
+  echo "$as_me:7391: \$? = $ac_status" >&5
   (exit $ac_status); }; then
-			test -n "$verbose" && echo "$as_me:7197: result: ... -$cf_opt" >&5
+			test -n "$verbose" && echo "$as_me:7393: result: ... -$cf_opt" >&5
 echo "${ECHO_T}... -$cf_opt" >&6
 			case $cf_opt in #(vi
 			Wcast-qual) #(vi
@@ -7236,10 +7432,10 @@
 EOF
 if test "$GCC" = yes
 then
-	{ echo "$as_me:7239: checking for $CC __attribute__ directives..." >&5
+	{ echo "$as_me:7435: checking for $CC __attribute__ directives..." >&5
 echo "$as_me: checking for $CC __attribute__ directives..." >&6;}
 cat > conftest.$ac_ext <<EOF
-#line 7242 "configure"
+#line 7438 "configure"
 #include "confdefs.h"
 #include "conftest.h"
 #include "conftest.i"
@@ -7277,12 +7473,12 @@
 EOF
 			;;
 		esac
-		if { (eval echo "$as_me:7280: \"$ac_compile\"") >&5
+		if { (eval echo "$as_me:7476: \"$ac_compile\"") >&5
   (eval $ac_compile) 2>&5
   ac_status=$?
-  echo "$as_me:7283: \$? = $ac_status" >&5
+  echo "$as_me:7479: \$? = $ac_status" >&5
   (exit $ac_status); }; then
-			test -n "$verbose" && echo "$as_me:7285: result: ... $cf_attribute" >&5
+			test -n "$verbose" && echo "$as_me:7481: result: ... $cf_attribute" >&5
 echo "${ECHO_T}... $cf_attribute" >&6
 			cat conftest.h >>confdefs.h
 		fi
@@ -7294,7 +7490,7 @@
 fi
 
 ###	use option --enable-assertions to turn on generation of assertion code
-echo "$as_me:7297: checking if you want to enable runtime assertions" >&5
+echo "$as_me:7493: checking if you want to enable runtime assertions" >&5
 echo $ECHO_N "checking if you want to enable runtime assertions... $ECHO_C" >&6
 
 # Check whether --enable-assertions or --disable-assertions was given.
@@ -7304,7 +7500,7 @@
 else
   with_assertions=no
 fi;
-echo "$as_me:7307: result: $with_assertions" >&5
+echo "$as_me:7503: result: $with_assertions" >&5
 echo "${ECHO_T}$with_assertions" >&6
 if test -n "$GCC"
 then
@@ -7365,7 +7561,7 @@
 	;;
 esac
 
-echo "$as_me:7368: checking whether to add trace feature to all models" >&5
+echo "$as_me:7564: checking whether to add trace feature to all models" >&5
 echo $ECHO_N "checking whether to add trace feature to all models... $ECHO_C" >&6
 
 # Check whether --with-trace or --without-trace was given.
@@ -7375,7 +7571,7 @@
 else
   cf_with_trace=$cf_all_traces
 fi;
-echo "$as_me:7378: result: $with_trace" >&5
+echo "$as_me:7574: result: $with_trace" >&5
 echo "${ECHO_T}$with_trace" >&6
 
 if test "$cf_with_trace" = yes ; then
@@ -7418,13 +7614,13 @@
 fi
 
 ###	Checks for libraries.
-echo "$as_me:7421: checking for gettimeofday" >&5
+echo "$as_me:7617: checking for gettimeofday" >&5
 echo $ECHO_N "checking for gettimeofday... $ECHO_C" >&6
 if test "${ac_cv_func_gettimeofday+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
 else
   cat >conftest.$ac_ext <<_ACEOF
-#line 7427 "configure"
+#line 7623 "configure"
 #include "confdefs.h"
 /* System header to define __stub macros and hopefully few prototypes,
     which can conflict with char gettimeofday (); below.  */
@@ -7455,16 +7651,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext conftest$ac_exeext
-if { (eval echo "$as_me:7458: \"$ac_link\"") >&5
+if { (eval echo "$as_me:7654: \"$ac_link\"") >&5
   (eval $ac_link) 2>&5
   ac_status=$?
-  echo "$as_me:7461: \$? = $ac_status" >&5
+  echo "$as_me:7657: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest$ac_exeext'
-  { (eval echo "$as_me:7464: \"$ac_try\"") >&5
+  { (eval echo "$as_me:7660: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:7467: \$? = $ac_status" >&5
+  echo "$as_me:7663: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   ac_cv_func_gettimeofday=yes
 else
@@ -7474,7 +7670,7 @@
 fi
 rm -f conftest.$ac_objext conftest$ac_exeext conftest.$ac_ext
 fi
-echo "$as_me:7477: result: $ac_cv_func_gettimeofday" >&5
+echo "$as_me:7673: result: $ac_cv_func_gettimeofday" >&5
 echo "${ECHO_T}$ac_cv_func_gettimeofday" >&6
 if test $ac_cv_func_gettimeofday = yes; then
   cat >>confdefs.h <<\EOF
@@ -7483,7 +7679,7 @@
 
 else
 
-echo "$as_me:7486: checking for gettimeofday in -lbsd" >&5
+echo "$as_me:7682: checking for gettimeofday in -lbsd" >&5
 echo $ECHO_N "checking for gettimeofday in -lbsd... $ECHO_C" >&6
 if test "${ac_cv_lib_bsd_gettimeofday+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
@@ -7491,7 +7687,7 @@
   ac_check_lib_save_LIBS=$LIBS
 LIBS="-lbsd  $LIBS"
 cat >conftest.$ac_ext <<_ACEOF
-#line 7494 "configure"
+#line 7690 "configure"
 #include "confdefs.h"
 
 /* Override any gcc2 internal prototype to avoid an error.  */
@@ -7510,16 +7706,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext conftest$ac_exeext
-if { (eval echo "$as_me:7513: \"$ac_link\"") >&5
+if { (eval echo "$as_me:7709: \"$ac_link\"") >&5
   (eval $ac_link) 2>&5
   ac_status=$?
-  echo "$as_me:7516: \$? = $ac_status" >&5
+  echo "$as_me:7712: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest$ac_exeext'
-  { (eval echo "$as_me:7519: \"$ac_try\"") >&5
+  { (eval echo "$as_me:7715: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:7522: \$? = $ac_status" >&5
+  echo "$as_me:7718: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   ac_cv_lib_bsd_gettimeofday=yes
 else
@@ -7530,7 +7726,7 @@
 rm -f conftest.$ac_objext conftest$ac_exeext conftest.$ac_ext
 LIBS=$ac_check_lib_save_LIBS
 fi
-echo "$as_me:7533: result: $ac_cv_lib_bsd_gettimeofday" >&5
+echo "$as_me:7729: result: $ac_cv_lib_bsd_gettimeofday" >&5
 echo "${ECHO_T}$ac_cv_lib_bsd_gettimeofday" >&6
 if test $ac_cv_lib_bsd_gettimeofday = yes; then
   cat >>confdefs.h <<\EOF
@@ -7542,14 +7738,14 @@
 
 fi
 
-echo "$as_me:7545: checking if -lm needed for math functions" >&5
+echo "$as_me:7741: checking if -lm needed for math functions" >&5
 echo $ECHO_N "checking if -lm needed for math functions... $ECHO_C" >&6
 if test "${cf_cv_need_libm+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
 else
 
 	cat >conftest.$ac_ext <<_ACEOF
-#line 7552 "configure"
+#line 7748 "configure"
 #include "confdefs.h"
 
 	#include <stdio.h>
@@ -7564,16 +7760,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext conftest$ac_exeext
-if { (eval echo "$as_me:7567: \"$ac_link\"") >&5
+if { (eval echo "$as_me:7763: \"$ac_link\"") >&5
   (eval $ac_link) 2>&5
   ac_status=$?
-  echo "$as_me:7570: \$? = $ac_status" >&5
+  echo "$as_me:7766: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest$ac_exeext'
-  { (eval echo "$as_me:7573: \"$ac_try\"") >&5
+  { (eval echo "$as_me:7769: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:7576: \$? = $ac_status" >&5
+  echo "$as_me:7772: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   cf_cv_need_libm=no
 else
@@ -7583,7 +7779,7 @@
 fi
 rm -f conftest.$ac_objext conftest$ac_exeext conftest.$ac_ext
 fi
-echo "$as_me:7586: result: $cf_cv_need_libm" >&5
+echo "$as_me:7782: result: $cf_cv_need_libm" >&5
 echo "${ECHO_T}$cf_cv_need_libm" >&6
 if test "$cf_cv_need_libm" = yes
 then
@@ -7591,13 +7787,13 @@
 fi
 
 ###	Checks for header files.
-echo "$as_me:7594: checking for ANSI C header files" >&5
+echo "$as_me:7790: checking for ANSI C header files" >&5
 echo $ECHO_N "checking for ANSI C header files... $ECHO_C" >&6
 if test "${ac_cv_header_stdc+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
 else
   cat >conftest.$ac_ext <<_ACEOF
-#line 7600 "configure"
+#line 7796 "configure"
 #include "confdefs.h"
 #include <stdlib.h>
 #include <stdarg.h>
@@ -7605,13 +7801,13 @@
 #include <float.h>
 
 _ACEOF
-if { (eval echo "$as_me:7608: \"$ac_cpp conftest.$ac_ext\"") >&5
+if { (eval echo "$as_me:7804: \"$ac_cpp conftest.$ac_ext\"") >&5
   (eval $ac_cpp conftest.$ac_ext) 2>conftest.er1
   ac_status=$?
   egrep -v '^ *\+' conftest.er1 >conftest.err
   rm -f conftest.er1
   cat conftest.err >&5
-  echo "$as_me:7614: \$? = $ac_status" >&5
+  echo "$as_me:7810: \$? = $ac_status" >&5
   (exit $ac_status); } >/dev/null; then
   if test -s conftest.err; then
     ac_cpp_err=$ac_c_preproc_warn_flag
@@ -7633,7 +7829,7 @@
 if test $ac_cv_header_stdc = yes; then
   # SunOS 4.x string.h does not declare mem*, contrary to ANSI.
   cat >conftest.$ac_ext <<_ACEOF
-#line 7636 "configure"
+#line 7832 "configure"
 #include "confdefs.h"
 #include <string.h>
 
@@ -7651,7 +7847,7 @@
 if test $ac_cv_header_stdc = yes; then
   # ISC 2.0.2 stdlib.h does not declare free, contrary to ANSI.
   cat >conftest.$ac_ext <<_ACEOF
-#line 7654 "configure"
+#line 7850 "configure"
 #include "confdefs.h"
 #include <stdlib.h>
 
@@ -7672,7 +7868,7 @@
   :
 else
   cat >conftest.$ac_ext <<_ACEOF
-#line 7675 "configure"
+#line 7871 "configure"
 #include "confdefs.h"
 #include <ctype.h>
 #if ((' ' & 0x0FF) == 0x020)
@@ -7698,15 +7894,15 @@
 }
 _ACEOF
 rm -f conftest$ac_exeext
-if { (eval echo "$as_me:7701: \"$ac_link\"") >&5
+if { (eval echo "$as_me:7897: \"$ac_link\"") >&5
   (eval $ac_link) 2>&5
   ac_status=$?
-  echo "$as_me:7704: \$? = $ac_status" >&5
+  echo "$as_me:7900: \$? = $ac_status" >&5
   (exit $ac_status); } && { ac_try='./conftest$ac_exeext'
-  { (eval echo "$as_me:7706: \"$ac_try\"") >&5
+  { (eval echo "$as_me:7902: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:7709: \$? = $ac_status" >&5
+  echo "$as_me:7905: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   :
 else
@@ -7719,7 +7915,7 @@
 fi
 fi
 fi
-echo "$as_me:7722: result: $ac_cv_header_stdc" >&5
+echo "$as_me:7918: result: $ac_cv_header_stdc" >&5
 echo "${ECHO_T}$ac_cv_header_stdc" >&6
 if test $ac_cv_header_stdc = yes; then
 
@@ -7732,13 +7928,13 @@
 ac_header_dirent=no
 for ac_hdr in dirent.h sys/ndir.h sys/dir.h ndir.h; do
   as_ac_Header=`echo "ac_cv_header_dirent_$ac_hdr" | $as_tr_sh`
-echo "$as_me:7735: checking for $ac_hdr that defines DIR" >&5
+echo "$as_me:7931: checking for $ac_hdr that defines DIR" >&5
 echo $ECHO_N "checking for $ac_hdr that defines DIR... $ECHO_C" >&6
 if eval "test \"\${$as_ac_Header+set}\" = set"; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
 else
   cat >conftest.$ac_ext <<_ACEOF
-#line 7741 "configure"
+#line 7937 "configure"
 #include "confdefs.h"
 #include <sys/types.h>
 #include <$ac_hdr>
@@ -7753,16 +7949,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext
-if { (eval echo "$as_me:7756: \"$ac_compile\"") >&5
+if { (eval echo "$as_me:7952: \"$ac_compile\"") >&5
   (eval $ac_compile) 2>&5
   ac_status=$?
-  echo "$as_me:7759: \$? = $ac_status" >&5
+  echo "$as_me:7955: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest.$ac_objext'
-  { (eval echo "$as_me:7762: \"$ac_try\"") >&5
+  { (eval echo "$as_me:7958: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:7765: \$? = $ac_status" >&5
+  echo "$as_me:7961: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   eval "$as_ac_Header=yes"
 else
@@ -7772,7 +7968,7 @@
 fi
 rm -f conftest.$ac_objext conftest.$ac_ext
 fi
-echo "$as_me:7775: result: `eval echo '${'$as_ac_Header'}'`" >&5
+echo "$as_me:7971: result: `eval echo '${'$as_ac_Header'}'`" >&5
 echo "${ECHO_T}`eval echo '${'$as_ac_Header'}'`" >&6
 if test `eval echo '${'$as_ac_Header'}'` = yes; then
   cat >>confdefs.h <<EOF
@@ -7785,7 +7981,7 @@
 done
 # Two versions of opendir et al. are in -ldir and -lx on SCO Xenix.
 if test $ac_header_dirent = dirent.h; then
-  echo "$as_me:7788: checking for opendir in -ldir" >&5
+  echo "$as_me:7984: checking for opendir in -ldir" >&5
 echo $ECHO_N "checking for opendir in -ldir... $ECHO_C" >&6
 if test "${ac_cv_lib_dir_opendir+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
@@ -7793,7 +7989,7 @@
   ac_check_lib_save_LIBS=$LIBS
 LIBS="-ldir  $LIBS"
 cat >conftest.$ac_ext <<_ACEOF
-#line 7796 "configure"
+#line 7992 "configure"
 #include "confdefs.h"
 
 /* Override any gcc2 internal prototype to avoid an error.  */
@@ -7812,16 +8008,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext conftest$ac_exeext
-if { (eval echo "$as_me:7815: \"$ac_link\"") >&5
+if { (eval echo "$as_me:8011: \"$ac_link\"") >&5
   (eval $ac_link) 2>&5
   ac_status=$?
-  echo "$as_me:7818: \$? = $ac_status" >&5
+  echo "$as_me:8014: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest$ac_exeext'
-  { (eval echo "$as_me:7821: \"$ac_try\"") >&5
+  { (eval echo "$as_me:8017: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:7824: \$? = $ac_status" >&5
+  echo "$as_me:8020: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   ac_cv_lib_dir_opendir=yes
 else
@@ -7832,14 +8028,14 @@
 rm -f conftest.$ac_objext conftest$ac_exeext conftest.$ac_ext
 LIBS=$ac_check_lib_save_LIBS
 fi
-echo "$as_me:7835: result: $ac_cv_lib_dir_opendir" >&5
+echo "$as_me:8031: result: $ac_cv_lib_dir_opendir" >&5
 echo "${ECHO_T}$ac_cv_lib_dir_opendir" >&6
 if test $ac_cv_lib_dir_opendir = yes; then
   LIBS="$LIBS -ldir"
 fi
 
 else
-  echo "$as_me:7842: checking for opendir in -lx" >&5
+  echo "$as_me:8038: checking for opendir in -lx" >&5
 echo $ECHO_N "checking for opendir in -lx... $ECHO_C" >&6
 if test "${ac_cv_lib_x_opendir+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
@@ -7847,7 +8043,7 @@
   ac_check_lib_save_LIBS=$LIBS
 LIBS="-lx  $LIBS"
 cat >conftest.$ac_ext <<_ACEOF
-#line 7850 "configure"
+#line 8046 "configure"
 #include "confdefs.h"
 
 /* Override any gcc2 internal prototype to avoid an error.  */
@@ -7866,16 +8062,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext conftest$ac_exeext
-if { (eval echo "$as_me:7869: \"$ac_link\"") >&5
+if { (eval echo "$as_me:8065: \"$ac_link\"") >&5
   (eval $ac_link) 2>&5
   ac_status=$?
-  echo "$as_me:7872: \$? = $ac_status" >&5
+  echo "$as_me:8068: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest$ac_exeext'
-  { (eval echo "$as_me:7875: \"$ac_try\"") >&5
+  { (eval echo "$as_me:8071: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:7878: \$? = $ac_status" >&5
+  echo "$as_me:8074: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   ac_cv_lib_x_opendir=yes
 else
@@ -7886,7 +8082,7 @@
 rm -f conftest.$ac_objext conftest$ac_exeext conftest.$ac_ext
 LIBS=$ac_check_lib_save_LIBS
 fi
-echo "$as_me:7889: result: $ac_cv_lib_x_opendir" >&5
+echo "$as_me:8085: result: $ac_cv_lib_x_opendir" >&5
 echo "${ECHO_T}$ac_cv_lib_x_opendir" >&6
 if test $ac_cv_lib_x_opendir = yes; then
   LIBS="$LIBS -lx"
@@ -7894,13 +8090,13 @@
 
 fi
 
-echo "$as_me:7897: checking whether time.h and sys/time.h may both be included" >&5
+echo "$as_me:8093: checking whether time.h and sys/time.h may both be included" >&5
 echo $ECHO_N "checking whether time.h and sys/time.h may both be included... $ECHO_C" >&6
 if test "${ac_cv_header_time+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
 else
   cat >conftest.$ac_ext <<_ACEOF
-#line 7903 "configure"
+#line 8099 "configure"
 #include "confdefs.h"
 #include <sys/types.h>
 #include <sys/time.h>
@@ -7916,16 +8112,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext
-if { (eval echo "$as_me:7919: \"$ac_compile\"") >&5
+if { (eval echo "$as_me:8115: \"$ac_compile\"") >&5
   (eval $ac_compile) 2>&5
   ac_status=$?
-  echo "$as_me:7922: \$? = $ac_status" >&5
+  echo "$as_me:8118: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest.$ac_objext'
-  { (eval echo "$as_me:7925: \"$ac_try\"") >&5
+  { (eval echo "$as_me:8121: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:7928: \$? = $ac_status" >&5
+  echo "$as_me:8124: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   ac_cv_header_time=yes
 else
@@ -7935,7 +8131,7 @@
 fi
 rm -f conftest.$ac_objext conftest.$ac_ext
 fi
-echo "$as_me:7938: result: $ac_cv_header_time" >&5
+echo "$as_me:8134: result: $ac_cv_header_time" >&5
 echo "${ECHO_T}$ac_cv_header_time" >&6
 if test $ac_cv_header_time = yes; then
 
@@ -7945,14 +8141,14 @@
 
 fi
 
-echo "$as_me:7948: checking for regular-expression headers" >&5
+echo "$as_me:8144: checking for regular-expression headers" >&5
 echo $ECHO_N "checking for regular-expression headers... $ECHO_C" >&6
 if test "${cf_cv_regex+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
 else
 
 cat >conftest.$ac_ext <<_ACEOF
-#line 7955 "configure"
+#line 8151 "configure"
 #include "confdefs.h"
 #include <sys/types.h>
 #include <regex.h>
@@ -7970,16 +8166,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext conftest$ac_exeext
-if { (eval echo "$as_me:7973: \"$ac_link\"") >&5
+if { (eval echo "$as_me:8169: \"$ac_link\"") >&5
   (eval $ac_link) 2>&5
   ac_status=$?
-  echo "$as_me:7976: \$? = $ac_status" >&5
+  echo "$as_me:8172: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest$ac_exeext'
-  { (eval echo "$as_me:7979: \"$ac_try\"") >&5
+  { (eval echo "$as_me:8175: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:7982: \$? = $ac_status" >&5
+  echo "$as_me:8178: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   cf_cv_regex="regex.h"
 else
@@ -7987,7 +8183,7 @@
 cat conftest.$ac_ext >&5
 
 	cat >conftest.$ac_ext <<_ACEOF
-#line 7990 "configure"
+#line 8186 "configure"
 #include "confdefs.h"
 #include <regexp.h>
 int
@@ -8002,16 +8198,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext conftest$ac_exeext
-if { (eval echo "$as_me:8005: \"$ac_link\"") >&5
+if { (eval echo "$as_me:8201: \"$ac_link\"") >&5
   (eval $ac_link) 2>&5
   ac_status=$?
-  echo "$as_me:8008: \$? = $ac_status" >&5
+  echo "$as_me:8204: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest$ac_exeext'
-  { (eval echo "$as_me:8011: \"$ac_try\"") >&5
+  { (eval echo "$as_me:8207: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:8014: \$? = $ac_status" >&5
+  echo "$as_me:8210: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   cf_cv_regex="regexp.h"
 else
@@ -8021,7 +8217,7 @@
 		cf_save_LIBS="$LIBS"
 		LIBS="-lgen $LIBS"
 		cat >conftest.$ac_ext <<_ACEOF
-#line 8024 "configure"
+#line 8220 "configure"
 #include "confdefs.h"
 #include <regexpr.h>
 int
@@ -8036,16 +8232,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext conftest$ac_exeext
-if { (eval echo "$as_me:8039: \"$ac_link\"") >&5
+if { (eval echo "$as_me:8235: \"$ac_link\"") >&5
   (eval $ac_link) 2>&5
   ac_status=$?
-  echo "$as_me:8042: \$? = $ac_status" >&5
+  echo "$as_me:8238: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest$ac_exeext'
-  { (eval echo "$as_me:8045: \"$ac_try\"") >&5
+  { (eval echo "$as_me:8241: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:8048: \$? = $ac_status" >&5
+  echo "$as_me:8244: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   cf_cv_regex="regexpr.h"
 else
@@ -8061,7 +8257,7 @@
 
 fi
 
-echo "$as_me:8064: result: $cf_cv_regex" >&5
+echo "$as_me:8260: result: $cf_cv_regex" >&5
 echo "${ECHO_T}$cf_cv_regex" >&6
 case $cf_cv_regex in
 	regex.h)   cat >>confdefs.h <<\EOF
@@ -8097,23 +8293,23 @@
 wctype.h
 do
 as_ac_Header=`echo "ac_cv_header_$ac_header" | $as_tr_sh`
-echo "$as_me:8100: checking for $ac_header" >&5
+echo "$as_me:8296: checking for $ac_header" >&5
 echo $ECHO_N "checking for $ac_header... $ECHO_C" >&6
 if eval "test \"\${$as_ac_Header+set}\" = set"; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
 else
   cat >conftest.$ac_ext <<_ACEOF
-#line 8106 "configure"
+#line 8302 "configure"
 #include "confdefs.h"
 #include <$ac_header>
 _ACEOF
-if { (eval echo "$as_me:8110: \"$ac_cpp conftest.$ac_ext\"") >&5
+if { (eval echo "$as_me:8306: \"$ac_cpp conftest.$ac_ext\"") >&5
   (eval $ac_cpp conftest.$ac_ext) 2>conftest.er1
   ac_status=$?
   egrep -v '^ *\+' conftest.er1 >conftest.err
   rm -f conftest.er1
   cat conftest.err >&5
-  echo "$as_me:8116: \$? = $ac_status" >&5
+  echo "$as_me:8312: \$? = $ac_status" >&5
   (exit $ac_status); } >/dev/null; then
   if test -s conftest.err; then
     ac_cpp_err=$ac_c_preproc_warn_flag
@@ -8132,7 +8328,7 @@
 fi
 rm -f conftest.err conftest.$ac_ext
 fi
-echo "$as_me:8135: result: `eval echo '${'$as_ac_Header'}'`" >&5
+echo "$as_me:8331: result: `eval echo '${'$as_ac_Header'}'`" >&5
 echo "${ECHO_T}`eval echo '${'$as_ac_Header'}'`" >&6
 if test `eval echo '${'$as_ac_Header'}'` = yes; then
   cat >>confdefs.h <<EOF
@@ -8146,7 +8342,7 @@
 # Note: even non-Posix ISC needs <sys/bsdtypes.h> to declare fd_set
 if test "$ISC" = yes ; then
 
-echo "$as_me:8149: checking for main in -lcposix" >&5
+echo "$as_me:8345: checking for main in -lcposix" >&5
 echo $ECHO_N "checking for main in -lcposix... $ECHO_C" >&6
 if test "${ac_cv_lib_cposix_main+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
@@ -8154,7 +8350,7 @@
   ac_check_lib_save_LIBS=$LIBS
 LIBS="-lcposix  $LIBS"
 cat >conftest.$ac_ext <<_ACEOF
-#line 8157 "configure"
+#line 8353 "configure"
 #include "confdefs.h"
 
 int
@@ -8166,16 +8362,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext conftest$ac_exeext
-if { (eval echo "$as_me:8169: \"$ac_link\"") >&5
+if { (eval echo "$as_me:8365: \"$ac_link\"") >&5
   (eval $ac_link) 2>&5
   ac_status=$?
-  echo "$as_me:8172: \$? = $ac_status" >&5
+  echo "$as_me:8368: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest$ac_exeext'
-  { (eval echo "$as_me:8175: \"$ac_try\"") >&5
+  { (eval echo "$as_me:8371: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:8178: \$? = $ac_status" >&5
+  echo "$as_me:8374: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   ac_cv_lib_cposix_main=yes
 else
@@ -8186,7 +8382,7 @@
 rm -f conftest.$ac_objext conftest$ac_exeext conftest.$ac_ext
 LIBS=$ac_check_lib_save_LIBS
 fi
-echo "$as_me:8189: result: $ac_cv_lib_cposix_main" >&5
+echo "$as_me:8385: result: $ac_cv_lib_cposix_main" >&5
 echo "${ECHO_T}$ac_cv_lib_cposix_main" >&6
 if test $ac_cv_lib_cposix_main = yes; then
   cat >>confdefs.h <<EOF
@@ -8197,7 +8393,7 @@
 
 fi
 
-	echo "$as_me:8200: checking for bzero in -linet" >&5
+	echo "$as_me:8396: checking for bzero in -linet" >&5
 echo $ECHO_N "checking for bzero in -linet... $ECHO_C" >&6
 if test "${ac_cv_lib_inet_bzero+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
@@ -8205,7 +8401,7 @@
   ac_check_lib_save_LIBS=$LIBS
 LIBS="-linet  $LIBS"
 cat >conftest.$ac_ext <<_ACEOF
-#line 8208 "configure"
+#line 8404 "configure"
 #include "confdefs.h"
 
 /* Override any gcc2 internal prototype to avoid an error.  */
@@ -8224,16 +8420,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext conftest$ac_exeext
-if { (eval echo "$as_me:8227: \"$ac_link\"") >&5
+if { (eval echo "$as_me:8423: \"$ac_link\"") >&5
   (eval $ac_link) 2>&5
   ac_status=$?
-  echo "$as_me:8230: \$? = $ac_status" >&5
+  echo "$as_me:8426: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest$ac_exeext'
-  { (eval echo "$as_me:8233: \"$ac_try\"") >&5
+  { (eval echo "$as_me:8429: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:8236: \$? = $ac_status" >&5
+  echo "$as_me:8432: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   ac_cv_lib_inet_bzero=yes
 else
@@ -8244,21 +8440,21 @@
 rm -f conftest.$ac_objext conftest$ac_exeext conftest.$ac_ext
 LIBS=$ac_check_lib_save_LIBS
 fi
-echo "$as_me:8247: result: $ac_cv_lib_inet_bzero" >&5
+echo "$as_me:8443: result: $ac_cv_lib_inet_bzero" >&5
 echo "${ECHO_T}$ac_cv_lib_inet_bzero" >&6
 if test $ac_cv_lib_inet_bzero = yes; then
   LIBS="$LIBS -linet"
 fi
 fi
 
-echo "$as_me:8254: checking if sys/time.h works with sys/select.h" >&5
+echo "$as_me:8450: checking if sys/time.h works with sys/select.h" >&5
 echo $ECHO_N "checking if sys/time.h works with sys/select.h... $ECHO_C" >&6
 if test "${cf_cv_sys_time_select+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
 else
 
 cat >conftest.$ac_ext <<_ACEOF
-#line 8261 "configure"
+#line 8457 "configure"
 #include "confdefs.h"
 
 #include <sys/types.h>
@@ -8278,16 +8474,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext
-if { (eval echo "$as_me:8281: \"$ac_compile\"") >&5
+if { (eval echo "$as_me:8477: \"$ac_compile\"") >&5
   (eval $ac_compile) 2>&5
   ac_status=$?
-  echo "$as_me:8284: \$? = $ac_status" >&5
+  echo "$as_me:8480: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest.$ac_objext'
-  { (eval echo "$as_me:8287: \"$ac_try\"") >&5
+  { (eval echo "$as_me:8483: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:8290: \$? = $ac_status" >&5
+  echo "$as_me:8486: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   cf_cv_sys_time_select=yes
 else
@@ -8299,7 +8495,7 @@
 
 fi
 
-echo "$as_me:8302: result: $cf_cv_sys_time_select" >&5
+echo "$as_me:8498: result: $cf_cv_sys_time_select" >&5
 echo "${ECHO_T}$cf_cv_sys_time_select" >&6
 test "$cf_cv_sys_time_select" = yes && cat >>confdefs.h <<\EOF
 #define HAVE_SYS_TIME_SELECT 1
@@ -8312,7 +8508,7 @@
 ac_link='$CC -o conftest$ac_exeext $CFLAGS $CPPFLAGS $LDFLAGS conftest.$ac_ext $LIBS >&5'
 ac_compiler_gnu=$ac_cv_c_compiler_gnu
 
-echo "$as_me:8315: checking for $CC option to accept ANSI C" >&5
+echo "$as_me:8511: checking for $CC option to accept ANSI C" >&5
 echo $ECHO_N "checking for $CC option to accept ANSI C... $ECHO_C" >&6
 if test "${ac_cv_prog_cc_stdc+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
@@ -8320,7 +8516,7 @@
   ac_cv_prog_cc_stdc=no
 ac_save_CC=$CC
 cat >conftest.$ac_ext <<_ACEOF
-#line 8323 "configure"
+#line 8519 "configure"
 #include "confdefs.h"
 #include <stdarg.h>
 #include <stdio.h>
@@ -8369,16 +8565,16 @@
 do
   CC="$ac_save_CC $ac_arg"
   rm -f conftest.$ac_objext
-if { (eval echo "$as_me:8372: \"$ac_compile\"") >&5
+if { (eval echo "$as_me:8568: \"$ac_compile\"") >&5
   (eval $ac_compile) 2>&5
   ac_status=$?
-  echo "$as_me:8375: \$? = $ac_status" >&5
+  echo "$as_me:8571: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest.$ac_objext'
-  { (eval echo "$as_me:8378: \"$ac_try\"") >&5
+  { (eval echo "$as_me:8574: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:8381: \$? = $ac_status" >&5
+  echo "$as_me:8577: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   ac_cv_prog_cc_stdc=$ac_arg
 break
@@ -8395,21 +8591,21 @@
 
 case "x$ac_cv_prog_cc_stdc" in
   x|xno)
-    echo "$as_me:8398: result: none needed" >&5
+    echo "$as_me:8594: result: none needed" >&5
 echo "${ECHO_T}none needed" >&6 ;;
   *)
-    echo "$as_me:8401: result: $ac_cv_prog_cc_stdc" >&5
+    echo "$as_me:8597: result: $ac_cv_prog_cc_stdc" >&5
 echo "${ECHO_T}$ac_cv_prog_cc_stdc" >&6
     CC="$CC $ac_cv_prog_cc_stdc" ;;
 esac
 
-echo "$as_me:8406: checking for an ANSI C-conforming const" >&5
+echo "$as_me:8602: checking for an ANSI C-conforming const" >&5
 echo $ECHO_N "checking for an ANSI C-conforming const... $ECHO_C" >&6
 if test "${ac_cv_c_const+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
 else
   cat >conftest.$ac_ext <<_ACEOF
-#line 8412 "configure"
+#line 8608 "configure"
 #include "confdefs.h"
 
 int
@@ -8467,16 +8663,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext
-if { (eval echo "$as_me:8470: \"$ac_compile\"") >&5
+if { (eval echo "$as_me:8666: \"$ac_compile\"") >&5
   (eval $ac_compile) 2>&5
   ac_status=$?
-  echo "$as_me:8473: \$? = $ac_status" >&5
+  echo "$as_me:8669: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest.$ac_objext'
-  { (eval echo "$as_me:8476: \"$ac_try\"") >&5
+  { (eval echo "$as_me:8672: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:8479: \$? = $ac_status" >&5
+  echo "$as_me:8675: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   ac_cv_c_const=yes
 else
@@ -8486,7 +8682,7 @@
 fi
 rm -f conftest.$ac_objext conftest.$ac_ext
 fi
-echo "$as_me:8489: result: $ac_cv_c_const" >&5
+echo "$as_me:8685: result: $ac_cv_c_const" >&5
 echo "${ECHO_T}$ac_cv_c_const" >&6
 if test $ac_cv_c_const = no; then
 
@@ -8496,7 +8692,7 @@
 
 fi
 
-echo "$as_me:8499: checking for inline" >&5
+echo "$as_me:8695: checking for inline" >&5
 echo $ECHO_N "checking for inline... $ECHO_C" >&6
 if test "${ac_cv_c_inline+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
@@ -8504,7 +8700,7 @@
   ac_cv_c_inline=no
 for ac_kw in inline __inline__ __inline; do
   cat >conftest.$ac_ext <<_ACEOF
-#line 8507 "configure"
+#line 8703 "configure"
 #include "confdefs.h"
 #ifndef __cplusplus
 static $ac_kw int static_foo () {return 0; }
@@ -8513,16 +8709,16 @@
 
 _ACEOF
 rm -f conftest.$ac_objext
-if { (eval echo "$as_me:8516: \"$ac_compile\"") >&5
+if { (eval echo "$as_me:8712: \"$ac_compile\"") >&5
   (eval $ac_compile) 2>&5
   ac_status=$?
-  echo "$as_me:8519: \$? = $ac_status" >&5
+  echo "$as_me:8715: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest.$ac_objext'
-  { (eval echo "$as_me:8522: \"$ac_try\"") >&5
+  { (eval echo "$as_me:8718: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:8525: \$? = $ac_status" >&5
+  echo "$as_me:8721: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   ac_cv_c_inline=$ac_kw; break
 else
@@ -8533,7 +8729,7 @@
 done
 
 fi
-echo "$as_me:8536: result: $ac_cv_c_inline" >&5
+echo "$as_me:8732: result: $ac_cv_c_inline" >&5
 echo "${ECHO_T}$ac_cv_c_inline" >&6
 case $ac_cv_c_inline in
   inline | yes) ;;
@@ -8552,14 +8748,14 @@
 #define CC_HAS_INLINE_FUNCS 1
 EOF
 
-echo "$as_me:8555: checking if unsigned literals are legal" >&5
+echo "$as_me:8751: checking if unsigned literals are legal" >&5
 echo $ECHO_N "checking if unsigned literals are legal... $ECHO_C" >&6
 if test "${cf_cv_unsigned_literals+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
 else
 
 	cat >conftest.$ac_ext <<_ACEOF
-#line 8562 "configure"
+#line 8758 "configure"
 #include "confdefs.h"
 
 int
@@ -8571,16 +8767,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext
-if { (eval echo "$as_me:8574: \"$ac_compile\"") >&5
+if { (eval echo "$as_me:8770: \"$ac_compile\"") >&5
   (eval $ac_compile) 2>&5
   ac_status=$?
-  echo "$as_me:8577: \$? = $ac_status" >&5
+  echo "$as_me:8773: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest.$ac_objext'
-  { (eval echo "$as_me:8580: \"$ac_try\"") >&5
+  { (eval echo "$as_me:8776: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:8583: \$? = $ac_status" >&5
+  echo "$as_me:8779: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   cf_cv_unsigned_literals=yes
 else
@@ -8592,10 +8788,10 @@
 
 fi
 
-echo "$as_me:8595: result: $cf_cv_unsigned_literals" >&5
+echo "$as_me:8791: result: $cf_cv_unsigned_literals" >&5
 echo "${ECHO_T}$cf_cv_unsigned_literals" >&6
 
-echo "$as_me:8598: checking for type of chtype" >&5
+echo "$as_me:8794: checking for type of chtype" >&5
 echo $ECHO_N "checking for type of chtype... $ECHO_C" >&6
 if test "${cf_cv_typeof_chtype+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
@@ -8605,7 +8801,7 @@
   cf_cv_typeof_chtype=long
 else
   cat >conftest.$ac_ext <<_ACEOF
-#line 8608 "configure"
+#line 8804 "configure"
 #include "confdefs.h"
 
 #ifdef USE_WIDEC_SUPPORT
@@ -8652,15 +8848,15 @@
 
 _ACEOF
 rm -f conftest$ac_exeext
-if { (eval echo "$as_me:8655: \"$ac_link\"") >&5
+if { (eval echo "$as_me:8851: \"$ac_link\"") >&5
   (eval $ac_link) 2>&5
   ac_status=$?
-  echo "$as_me:8658: \$? = $ac_status" >&5
+  echo "$as_me:8854: \$? = $ac_status" >&5
   (exit $ac_status); } && { ac_try='./conftest$ac_exeext'
-  { (eval echo "$as_me:8660: \"$ac_try\"") >&5
+  { (eval echo "$as_me:8856: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:8663: \$? = $ac_status" >&5
+  echo "$as_me:8859: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   cf_cv_typeof_chtype=`cat cf_test.out`
 else
@@ -8675,7 +8871,7 @@
 
 fi
 
-echo "$as_me:8678: result: $cf_cv_typeof_chtype" >&5
+echo "$as_me:8874: result: $cf_cv_typeof_chtype" >&5
 echo "${ECHO_T}$cf_cv_typeof_chtype" >&6
 
 cat >>confdefs.h <<EOF
@@ -8688,14 +8884,14 @@
 
 ###	Checks for external-data
 
-echo "$as_me:8691: checking if external errno is declared" >&5
+echo "$as_me:8887: checking if external errno is declared" >&5
 echo $ECHO_N "checking if external errno is declared... $ECHO_C" >&6
 if test "${cf_cv_dcl_errno+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
 else
 
     cat >conftest.$ac_ext <<_ACEOF
-#line 8698 "configure"
+#line 8894 "configure"
 #include "confdefs.h"
 
 #ifdef HAVE_STDLIB_H
@@ -8713,16 +8909,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext
-if { (eval echo "$as_me:8716: \"$ac_compile\"") >&5
+if { (eval echo "$as_me:8912: \"$ac_compile\"") >&5
   (eval $ac_compile) 2>&5
   ac_status=$?
-  echo "$as_me:8719: \$? = $ac_status" >&5
+  echo "$as_me:8915: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest.$ac_objext'
-  { (eval echo "$as_me:8722: \"$ac_try\"") >&5
+  { (eval echo "$as_me:8918: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:8725: \$? = $ac_status" >&5
+  echo "$as_me:8921: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   cf_cv_dcl_errno=yes
 else
@@ -8733,7 +8929,7 @@
 rm -f conftest.$ac_objext conftest.$ac_ext
 
 fi
-echo "$as_me:8736: result: $cf_cv_dcl_errno" >&5
+echo "$as_me:8932: result: $cf_cv_dcl_errno" >&5
 echo "${ECHO_T}$cf_cv_dcl_errno" >&6
 
 if test "$cf_cv_dcl_errno" = no ; then
@@ -8748,14 +8944,14 @@
 
 # It's possible (for near-UNIX clones) that the data doesn't exist
 
-echo "$as_me:8751: checking if external errno exists" >&5
+echo "$as_me:8947: checking if external errno exists" >&5
 echo $ECHO_N "checking if external errno exists... $ECHO_C" >&6
 if test "${cf_cv_have_errno+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
 else
 
     cat >conftest.$ac_ext <<_ACEOF
-#line 8758 "configure"
+#line 8954 "configure"
 #include "confdefs.h"
 
 #undef errno
@@ -8770,16 +8966,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext conftest$ac_exeext
-if { (eval echo "$as_me:8773: \"$ac_link\"") >&5
+if { (eval echo "$as_me:8969: \"$ac_link\"") >&5
   (eval $ac_link) 2>&5
   ac_status=$?
-  echo "$as_me:8776: \$? = $ac_status" >&5
+  echo "$as_me:8972: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest$ac_exeext'
-  { (eval echo "$as_me:8779: \"$ac_try\"") >&5
+  { (eval echo "$as_me:8975: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:8782: \$? = $ac_status" >&5
+  echo "$as_me:8978: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   cf_cv_have_errno=yes
 else
@@ -8790,7 +8986,7 @@
 rm -f conftest.$ac_objext conftest$ac_exeext conftest.$ac_ext
 
 fi
-echo "$as_me:8793: result: $cf_cv_have_errno" >&5
+echo "$as_me:8989: result: $cf_cv_have_errno" >&5
 echo "${ECHO_T}$cf_cv_have_errno" >&6
 
 if test "$cf_cv_have_errno" = yes ; then
@@ -8803,7 +8999,7 @@
 
 fi
 
-echo "$as_me:8806: checking if data-only library module links" >&5
+echo "$as_me:9002: checking if data-only library module links" >&5
 echo $ECHO_N "checking if data-only library module links... $ECHO_C" >&6
 if test "${cf_cv_link_dataonly+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
@@ -8811,20 +9007,20 @@
 
 	rm -f conftest.a
 	cat >conftest.$ac_ext <<EOF
-#line 8814 "configure"
+#line 9010 "configure"
 int	testdata[3] = { 123, 456, 789 };
 EOF
-	if { (eval echo "$as_me:8817: \"$ac_compile\"") >&5
+	if { (eval echo "$as_me:9013: \"$ac_compile\"") >&5
   (eval $ac_compile) 2>&5
   ac_status=$?
-  echo "$as_me:8820: \$? = $ac_status" >&5
+  echo "$as_me:9016: \$? = $ac_status" >&5
   (exit $ac_status); } ; then
 		mv conftest.o data.o && \
 		( $AR $AR_OPTS conftest.a data.o ) 2>&5 1>/dev/null
 	fi
 	rm -f conftest.$ac_ext data.o
 	cat >conftest.$ac_ext <<EOF
-#line 8827 "configure"
+#line 9023 "configure"
 int	testfunc()
 {
 #if defined(NeXT)
@@ -8837,10 +9033,10 @@
 #endif
 }
 EOF
-	if { (eval echo "$as_me:8840: \"$ac_compile\"") >&5
+	if { (eval echo "$as_me:9036: \"$ac_compile\"") >&5
   (eval $ac_compile) 2>&5
   ac_status=$?
-  echo "$as_me:8843: \$? = $ac_status" >&5
+  echo "$as_me:9039: \$? = $ac_status" >&5
   (exit $ac_status); }; then
 		mv conftest.o func.o && \
 		( $AR $AR_OPTS conftest.a func.o ) 2>&5 1>/dev/null
@@ -8853,7 +9049,7 @@
   cf_cv_link_dataonly=unknown
 else
   cat >conftest.$ac_ext <<_ACEOF
-#line 8856 "configure"
+#line 9052 "configure"
 #include "confdefs.h"
 
 	int main()
@@ -8864,15 +9060,15 @@
 
 _ACEOF
 rm -f conftest$ac_exeext
-if { (eval echo "$as_me:8867: \"$ac_link\"") >&5
+if { (eval echo "$as_me:9063: \"$ac_link\"") >&5
   (eval $ac_link) 2>&5
   ac_status=$?
-  echo "$as_me:8870: \$? = $ac_status" >&5
+  echo "$as_me:9066: \$? = $ac_status" >&5
   (exit $ac_status); } && { ac_try='./conftest$ac_exeext'
-  { (eval echo "$as_me:8872: \"$ac_try\"") >&5
+  { (eval echo "$as_me:9068: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:8875: \$? = $ac_status" >&5
+  echo "$as_me:9071: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   cf_cv_link_dataonly=yes
 else
@@ -8887,7 +9083,7 @@
 
 fi
 
-echo "$as_me:8890: result: $cf_cv_link_dataonly" >&5
+echo "$as_me:9086: result: $cf_cv_link_dataonly" >&5
 echo "${ECHO_T}$cf_cv_link_dataonly" >&6
 
 if test "$cf_cv_link_dataonly" = no ; then
@@ -8924,13 +9120,13 @@
 
 do
 as_ac_var=`echo "ac_cv_func_$ac_func" | $as_tr_sh`
-echo "$as_me:8927: checking for $ac_func" >&5
+echo "$as_me:9123: checking for $ac_func" >&5
 echo $ECHO_N "checking for $ac_func... $ECHO_C" >&6
 if eval "test \"\${$as_ac_var+set}\" = set"; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
 else
   cat >conftest.$ac_ext <<_ACEOF
-#line 8933 "configure"
+#line 9129 "configure"
 #include "confdefs.h"
 /* System header to define __stub macros and hopefully few prototypes,
     which can conflict with char $ac_func (); below.  */
@@ -8961,16 +9157,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext conftest$ac_exeext
-if { (eval echo "$as_me:8964: \"$ac_link\"") >&5
+if { (eval echo "$as_me:9160: \"$ac_link\"") >&5
   (eval $ac_link) 2>&5
   ac_status=$?
-  echo "$as_me:8967: \$? = $ac_status" >&5
+  echo "$as_me:9163: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest$ac_exeext'
-  { (eval echo "$as_me:8970: \"$ac_try\"") >&5
+  { (eval echo "$as_me:9166: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:8973: \$? = $ac_status" >&5
+  echo "$as_me:9169: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   eval "$as_ac_var=yes"
 else
@@ -8980,7 +9176,7 @@
 fi
 rm -f conftest.$ac_objext conftest$ac_exeext conftest.$ac_ext
 fi
-echo "$as_me:8983: result: `eval echo '${'$as_ac_var'}'`" >&5
+echo "$as_me:9179: result: `eval echo '${'$as_ac_var'}'`" >&5
 echo "${ECHO_T}`eval echo '${'$as_ac_var'}'`" >&6
 if test `eval echo '${'$as_ac_var'}'` = yes; then
   cat >>confdefs.h <<EOF
@@ -8992,14 +9188,14 @@
 
 if test "$with_getcap" = "yes" ; then
 
-echo "$as_me:8995: checking for terminal-capability database functions" >&5
+echo "$as_me:9191: checking for terminal-capability database functions" >&5
 echo $ECHO_N "checking for terminal-capability database functions... $ECHO_C" >&6
 if test "${cf_cv_cgetent+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
 else
 
 cat >conftest.$ac_ext <<_ACEOF
-#line 9002 "configure"
+#line 9198 "configure"
 #include "confdefs.h"
 
 #include <stdlib.h>
@@ -9019,16 +9215,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext conftest$ac_exeext
-if { (eval echo "$as_me:9022: \"$ac_link\"") >&5
+if { (eval echo "$as_me:9218: \"$ac_link\"") >&5
   (eval $ac_link) 2>&5
   ac_status=$?
-  echo "$as_me:9025: \$? = $ac_status" >&5
+  echo "$as_me:9221: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest$ac_exeext'
-  { (eval echo "$as_me:9028: \"$ac_try\"") >&5
+  { (eval echo "$as_me:9224: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:9031: \$? = $ac_status" >&5
+  echo "$as_me:9227: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   cf_cv_cgetent=yes
 else
@@ -9040,7 +9236,7 @@
 
 fi
 
-echo "$as_me:9043: result: $cf_cv_cgetent" >&5
+echo "$as_me:9239: result: $cf_cv_cgetent" >&5
 echo "${ECHO_T}$cf_cv_cgetent" >&6
 test "$cf_cv_cgetent" = yes && cat >>confdefs.h <<\EOF
 #define HAVE_BSD_CGETENT 1
@@ -9048,14 +9244,14 @@
 
 fi
 
-echo "$as_me:9051: checking for isascii" >&5
+echo "$as_me:9247: checking for isascii" >&5
 echo $ECHO_N "checking for isascii... $ECHO_C" >&6
 if test "${cf_cv_have_isascii+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
 else
 
 	cat >conftest.$ac_ext <<_ACEOF
-#line 9058 "configure"
+#line 9254 "configure"
 #include "confdefs.h"
 #include <ctype.h>
 int
@@ -9067,16 +9263,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext conftest$ac_exeext
-if { (eval echo "$as_me:9070: \"$ac_link\"") >&5
+if { (eval echo "$as_me:9266: \"$ac_link\"") >&5
   (eval $ac_link) 2>&5
   ac_status=$?
-  echo "$as_me:9073: \$? = $ac_status" >&5
+  echo "$as_me:9269: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest$ac_exeext'
-  { (eval echo "$as_me:9076: \"$ac_try\"") >&5
+  { (eval echo "$as_me:9272: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:9079: \$? = $ac_status" >&5
+  echo "$as_me:9275: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   cf_cv_have_isascii=yes
 else
@@ -9087,17 +9283,17 @@
 rm -f conftest.$ac_objext conftest$ac_exeext conftest.$ac_ext
 
 fi
-echo "$as_me:9090: result: $cf_cv_have_isascii" >&5
+echo "$as_me:9286: result: $cf_cv_have_isascii" >&5
 echo "${ECHO_T}$cf_cv_have_isascii" >&6
 test "$cf_cv_have_isascii" = yes && cat >>confdefs.h <<\EOF
 #define HAVE_ISASCII 1
 EOF
 
 if test "$ac_cv_func_sigaction" = yes; then
-echo "$as_me:9097: checking whether sigaction needs _POSIX_SOURCE" >&5
+echo "$as_me:9293: checking whether sigaction needs _POSIX_SOURCE" >&5
 echo $ECHO_N "checking whether sigaction needs _POSIX_SOURCE... $ECHO_C" >&6
 cat >conftest.$ac_ext <<_ACEOF
-#line 9100 "configure"
+#line 9296 "configure"
 #include "confdefs.h"
 
 #include <sys/types.h>
@@ -9111,16 +9307,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext
-if { (eval echo "$as_me:9114: \"$ac_compile\"") >&5
+if { (eval echo "$as_me:9310: \"$ac_compile\"") >&5
   (eval $ac_compile) 2>&5
   ac_status=$?
-  echo "$as_me:9117: \$? = $ac_status" >&5
+  echo "$as_me:9313: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest.$ac_objext'
-  { (eval echo "$as_me:9120: \"$ac_try\"") >&5
+  { (eval echo "$as_me:9316: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:9123: \$? = $ac_status" >&5
+  echo "$as_me:9319: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   sigact_bad=no
 else
@@ -9128,7 +9324,7 @@
 cat conftest.$ac_ext >&5
 
 cat >conftest.$ac_ext <<_ACEOF
-#line 9131 "configure"
+#line 9327 "configure"
 #include "confdefs.h"
 
 #define _POSIX_SOURCE
@@ -9143,16 +9339,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext
-if { (eval echo "$as_me:9146: \"$ac_compile\"") >&5
+if { (eval echo "$as_me:9342: \"$ac_compile\"") >&5
   (eval $ac_compile) 2>&5
   ac_status=$?
-  echo "$as_me:9149: \$? = $ac_status" >&5
+  echo "$as_me:9345: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest.$ac_objext'
-  { (eval echo "$as_me:9152: \"$ac_try\"") >&5
+  { (eval echo "$as_me:9348: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:9155: \$? = $ac_status" >&5
+  echo "$as_me:9351: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   sigact_bad=yes
 	 cat >>confdefs.h <<\EOF
@@ -9167,7 +9363,7 @@
 rm -f conftest.$ac_objext conftest.$ac_ext
 fi
 rm -f conftest.$ac_objext conftest.$ac_ext
-echo "$as_me:9170: result: $sigact_bad" >&5
+echo "$as_me:9366: result: $sigact_bad" >&5
 echo "${ECHO_T}$sigact_bad" >&6
 fi
 
@@ -9178,23 +9374,23 @@
 
 do
 as_ac_Header=`echo "ac_cv_header_$ac_header" | $as_tr_sh`
-echo "$as_me:9181: checking for $ac_header" >&5
+echo "$as_me:9377: checking for $ac_header" >&5
 echo $ECHO_N "checking for $ac_header... $ECHO_C" >&6
 if eval "test \"\${$as_ac_Header+set}\" = set"; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
 else
   cat >conftest.$ac_ext <<_ACEOF
-#line 9187 "configure"
+#line 9383 "configure"
 #include "confdefs.h"
 #include <$ac_header>
 _ACEOF
-if { (eval echo "$as_me:9191: \"$ac_cpp conftest.$ac_ext\"") >&5
+if { (eval echo "$as_me:9387: \"$ac_cpp conftest.$ac_ext\"") >&5
   (eval $ac_cpp conftest.$ac_ext) 2>conftest.er1
   ac_status=$?
   egrep -v '^ *\+' conftest.er1 >conftest.err
   rm -f conftest.er1
   cat conftest.err >&5
-  echo "$as_me:9197: \$? = $ac_status" >&5
+  echo "$as_me:9393: \$? = $ac_status" >&5
   (exit $ac_status); } >/dev/null; then
   if test -s conftest.err; then
     ac_cpp_err=$ac_c_preproc_warn_flag
@@ -9213,7 +9409,7 @@
 fi
 rm -f conftest.err conftest.$ac_ext
 fi
-echo "$as_me:9216: result: `eval echo '${'$as_ac_Header'}'`" >&5
+echo "$as_me:9412: result: `eval echo '${'$as_ac_Header'}'`" >&5
 echo "${ECHO_T}`eval echo '${'$as_ac_Header'}'`" >&6
 if test `eval echo '${'$as_ac_Header'}'` = yes; then
   cat >>confdefs.h <<EOF
@@ -9228,23 +9424,23 @@
 for ac_header in sys/termio.h
 do
 as_ac_Header=`echo "ac_cv_header_$ac_header" | $as_tr_sh`
-echo "$as_me:9231: checking for $ac_header" >&5
+echo "$as_me:9427: checking for $ac_header" >&5
 echo $ECHO_N "checking for $ac_header... $ECHO_C" >&6
 if eval "test \"\${$as_ac_Header+set}\" = set"; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
 else
   cat >conftest.$ac_ext <<_ACEOF
-#line 9237 "configure"
+#line 9433 "configure"
 #include "confdefs.h"
 #include <$ac_header>
 _ACEOF
-if { (eval echo "$as_me:9241: \"$ac_cpp conftest.$ac_ext\"") >&5
+if { (eval echo "$as_me:9437: \"$ac_cpp conftest.$ac_ext\"") >&5
   (eval $ac_cpp conftest.$ac_ext) 2>conftest.er1
   ac_status=$?
   egrep -v '^ *\+' conftest.er1 >conftest.err
   rm -f conftest.er1
   cat conftest.err >&5
-  echo "$as_me:9247: \$? = $ac_status" >&5
+  echo "$as_me:9443: \$? = $ac_status" >&5
   (exit $ac_status); } >/dev/null; then
   if test -s conftest.err; then
     ac_cpp_err=$ac_c_preproc_warn_flag
@@ -9263,7 +9459,7 @@
 fi
 rm -f conftest.err conftest.$ac_ext
 fi
-echo "$as_me:9266: result: `eval echo '${'$as_ac_Header'}'`" >&5
+echo "$as_me:9462: result: `eval echo '${'$as_ac_Header'}'`" >&5
 echo "${ECHO_T}`eval echo '${'$as_ac_Header'}'`" >&6
 if test `eval echo '${'$as_ac_Header'}'` = yes; then
   cat >>confdefs.h <<EOF
@@ -9281,10 +9477,10 @@
 	*)	termios_bad=maybe ;;
 	esac
 	if test "$termios_bad" = maybe ; then
-	echo "$as_me:9284: checking whether termios.h needs _POSIX_SOURCE" >&5
+	echo "$as_me:9480: checking whether termios.h needs _POSIX_SOURCE" >&5
 echo $ECHO_N "checking whether termios.h needs _POSIX_SOURCE... $ECHO_C" >&6
 	cat >conftest.$ac_ext <<_ACEOF
-#line 9287 "configure"
+#line 9483 "configure"
 #include "confdefs.h"
 #include <termios.h>
 int
@@ -9296,16 +9492,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext
-if { (eval echo "$as_me:9299: \"$ac_compile\"") >&5
+if { (eval echo "$as_me:9495: \"$ac_compile\"") >&5
   (eval $ac_compile) 2>&5
   ac_status=$?
-  echo "$as_me:9302: \$? = $ac_status" >&5
+  echo "$as_me:9498: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest.$ac_objext'
-  { (eval echo "$as_me:9305: \"$ac_try\"") >&5
+  { (eval echo "$as_me:9501: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:9308: \$? = $ac_status" >&5
+  echo "$as_me:9504: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   termios_bad=no
 else
@@ -9313,7 +9509,7 @@
 cat conftest.$ac_ext >&5
 
 		cat >conftest.$ac_ext <<_ACEOF
-#line 9316 "configure"
+#line 9512 "configure"
 #include "confdefs.h"
 
 #define _POSIX_SOURCE
@@ -9327,16 +9523,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext
-if { (eval echo "$as_me:9330: \"$ac_compile\"") >&5
+if { (eval echo "$as_me:9526: \"$ac_compile\"") >&5
   (eval $ac_compile) 2>&5
   ac_status=$?
-  echo "$as_me:9333: \$? = $ac_status" >&5
+  echo "$as_me:9529: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest.$ac_objext'
-  { (eval echo "$as_me:9336: \"$ac_try\"") >&5
+  { (eval echo "$as_me:9532: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:9339: \$? = $ac_status" >&5
+  echo "$as_me:9535: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   termios_bad=unknown
 else
@@ -9351,19 +9547,19 @@
 
 fi
 rm -f conftest.$ac_objext conftest.$ac_ext
-	echo "$as_me:9354: result: $termios_bad" >&5
+	echo "$as_me:9550: result: $termios_bad" >&5
 echo "${ECHO_T}$termios_bad" >&6
 	fi
 fi
 
-echo "$as_me:9359: checking for tcgetattr" >&5
+echo "$as_me:9555: checking for tcgetattr" >&5
 echo $ECHO_N "checking for tcgetattr... $ECHO_C" >&6
 if test "${cf_cv_have_tcgetattr+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
 else
 
 cat >conftest.$ac_ext <<_ACEOF
-#line 9366 "configure"
+#line 9562 "configure"
 #include "confdefs.h"
 
 #include <sys/types.h>
@@ -9391,16 +9587,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext conftest$ac_exeext
-if { (eval echo "$as_me:9394: \"$ac_link\"") >&5
+if { (eval echo "$as_me:9590: \"$ac_link\"") >&5
   (eval $ac_link) 2>&5
   ac_status=$?
-  echo "$as_me:9397: \$? = $ac_status" >&5
+  echo "$as_me:9593: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest$ac_exeext'
-  { (eval echo "$as_me:9400: \"$ac_try\"") >&5
+  { (eval echo "$as_me:9596: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:9403: \$? = $ac_status" >&5
+  echo "$as_me:9599: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   cf_cv_have_tcgetattr=yes
 else
@@ -9410,20 +9606,20 @@
 fi
 rm -f conftest.$ac_objext conftest$ac_exeext conftest.$ac_ext
 fi
-echo "$as_me:9413: result: $cf_cv_have_tcgetattr" >&5
+echo "$as_me:9609: result: $cf_cv_have_tcgetattr" >&5
 echo "${ECHO_T}$cf_cv_have_tcgetattr" >&6
 test "$cf_cv_have_tcgetattr" = yes && cat >>confdefs.h <<\EOF
 #define HAVE_TCGETATTR 1
 EOF
 
-echo "$as_me:9419: checking for vsscanf function or workaround" >&5
+echo "$as_me:9615: checking for vsscanf function or workaround" >&5
 echo $ECHO_N "checking for vsscanf function or workaround... $ECHO_C" >&6
 if test "${cf_cv_func_vsscanf+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
 else
 
 cat >conftest.$ac_ext <<_ACEOF
-#line 9426 "configure"
+#line 9622 "configure"
 #include "confdefs.h"
 
 #include <stdarg.h>
@@ -9439,16 +9635,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext conftest$ac_exeext
-if { (eval echo "$as_me:9442: \"$ac_link\"") >&5
+if { (eval echo "$as_me:9638: \"$ac_link\"") >&5
   (eval $ac_link) 2>&5
   ac_status=$?
-  echo "$as_me:9445: \$? = $ac_status" >&5
+  echo "$as_me:9641: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest$ac_exeext'
-  { (eval echo "$as_me:9448: \"$ac_try\"") >&5
+  { (eval echo "$as_me:9644: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:9451: \$? = $ac_status" >&5
+  echo "$as_me:9647: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   cf_cv_func_vsscanf=vsscanf
 else
@@ -9456,7 +9652,7 @@
 cat conftest.$ac_ext >&5
 
 cat >conftest.$ac_ext <<_ACEOF
-#line 9459 "configure"
+#line 9655 "configure"
 #include "confdefs.h"
 
 #include <stdarg.h>
@@ -9478,16 +9674,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext conftest$ac_exeext
-if { (eval echo "$as_me:9481: \"$ac_link\"") >&5
+if { (eval echo "$as_me:9677: \"$ac_link\"") >&5
   (eval $ac_link) 2>&5
   ac_status=$?
-  echo "$as_me:9484: \$? = $ac_status" >&5
+  echo "$as_me:9680: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest$ac_exeext'
-  { (eval echo "$as_me:9487: \"$ac_try\"") >&5
+  { (eval echo "$as_me:9683: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:9490: \$? = $ac_status" >&5
+  echo "$as_me:9686: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   cf_cv_func_vsscanf=vfscanf
 else
@@ -9495,7 +9691,7 @@
 cat conftest.$ac_ext >&5
 
 cat >conftest.$ac_ext <<_ACEOF
-#line 9498 "configure"
+#line 9694 "configure"
 #include "confdefs.h"
 
 #include <stdarg.h>
@@ -9517,16 +9713,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext conftest$ac_exeext
-if { (eval echo "$as_me:9520: \"$ac_link\"") >&5
+if { (eval echo "$as_me:9716: \"$ac_link\"") >&5
   (eval $ac_link) 2>&5
   ac_status=$?
-  echo "$as_me:9523: \$? = $ac_status" >&5
+  echo "$as_me:9719: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest$ac_exeext'
-  { (eval echo "$as_me:9526: \"$ac_try\"") >&5
+  { (eval echo "$as_me:9722: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:9529: \$? = $ac_status" >&5
+  echo "$as_me:9725: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   cf_cv_func_vsscanf=_doscan
 else
@@ -9541,7 +9737,7 @@
 fi
 rm -f conftest.$ac_objext conftest$ac_exeext conftest.$ac_ext
 fi
-echo "$as_me:9544: result: $cf_cv_func_vsscanf" >&5
+echo "$as_me:9740: result: $cf_cv_func_vsscanf" >&5
 echo "${ECHO_T}$cf_cv_func_vsscanf" >&6
 
 case $cf_cv_func_vsscanf in #(vi
@@ -9559,7 +9755,7 @@
 ;;
 esac
 
-echo "$as_me:9562: checking for working mkstemp" >&5
+echo "$as_me:9758: checking for working mkstemp" >&5
 echo $ECHO_N "checking for working mkstemp... $ECHO_C" >&6
 if test "${cf_cv_func_mkstemp+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
@@ -9567,13 +9763,13 @@
 
 rm -f conftest*
 if test "$cross_compiling" = yes; then
-  echo "$as_me:9570: checking for mkstemp" >&5
+  echo "$as_me:9766: checking for mkstemp" >&5
 echo $ECHO_N "checking for mkstemp... $ECHO_C" >&6
 if test "${ac_cv_func_mkstemp+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
 else
   cat >conftest.$ac_ext <<_ACEOF
-#line 9576 "configure"
+#line 9772 "configure"
 #include "confdefs.h"
 /* System header to define __stub macros and hopefully few prototypes,
     which can conflict with char mkstemp (); below.  */
@@ -9604,16 +9800,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext conftest$ac_exeext
-if { (eval echo "$as_me:9607: \"$ac_link\"") >&5
+if { (eval echo "$as_me:9803: \"$ac_link\"") >&5
   (eval $ac_link) 2>&5
   ac_status=$?
-  echo "$as_me:9610: \$? = $ac_status" >&5
+  echo "$as_me:9806: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest$ac_exeext'
-  { (eval echo "$as_me:9613: \"$ac_try\"") >&5
+  { (eval echo "$as_me:9809: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:9616: \$? = $ac_status" >&5
+  echo "$as_me:9812: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   ac_cv_func_mkstemp=yes
 else
@@ -9623,12 +9819,12 @@
 fi
 rm -f conftest.$ac_objext conftest$ac_exeext conftest.$ac_ext
 fi
-echo "$as_me:9626: result: $ac_cv_func_mkstemp" >&5
+echo "$as_me:9822: result: $ac_cv_func_mkstemp" >&5
 echo "${ECHO_T}$ac_cv_func_mkstemp" >&6
 
 else
   cat >conftest.$ac_ext <<_ACEOF
-#line 9631 "configure"
+#line 9827 "configure"
 #include "confdefs.h"
 
 #include <sys/types.h>
@@ -9666,15 +9862,15 @@
 
 _ACEOF
 rm -f conftest$ac_exeext
-if { (eval echo "$as_me:9669: \"$ac_link\"") >&5
+if { (eval echo "$as_me:9865: \"$ac_link\"") >&5
   (eval $ac_link) 2>&5
   ac_status=$?
-  echo "$as_me:9672: \$? = $ac_status" >&5
+  echo "$as_me:9868: \$? = $ac_status" >&5
   (exit $ac_status); } && { ac_try='./conftest$ac_exeext'
-  { (eval echo "$as_me:9674: \"$ac_try\"") >&5
+  { (eval echo "$as_me:9870: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:9677: \$? = $ac_status" >&5
+  echo "$as_me:9873: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   cf_cv_func_mkstemp=yes
 
@@ -9689,7 +9885,7 @@
 fi
 
 fi
-echo "$as_me:9692: result: $cf_cv_func_mkstemp" >&5
+echo "$as_me:9888: result: $cf_cv_func_mkstemp" >&5
 echo "${ECHO_T}$cf_cv_func_mkstemp" >&6
 if test "$cf_cv_func_mkstemp" = yes ; then
 	cat >>confdefs.h <<\EOF
@@ -9706,21 +9902,21 @@
 fi
 
 if test "$cross_compiling" = yes ; then
-	{ echo "$as_me:9709: WARNING: cross compiling: assume setvbuf params not reversed" >&5
+	{ echo "$as_me:9905: WARNING: cross compiling: assume setvbuf params not reversed" >&5
 echo "$as_me: WARNING: cross compiling: assume setvbuf params not reversed" >&2;}
 else
-	echo "$as_me:9712: checking whether setvbuf arguments are reversed" >&5
+	echo "$as_me:9908: checking whether setvbuf arguments are reversed" >&5
 echo $ECHO_N "checking whether setvbuf arguments are reversed... $ECHO_C" >&6
 if test "${ac_cv_func_setvbuf_reversed+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
 else
   if test "$cross_compiling" = yes; then
-  { { echo "$as_me:9718: error: cannot run test program while cross compiling" >&5
+  { { echo "$as_me:9914: error: cannot run test program while cross compiling" >&5
 echo "$as_me: error: cannot run test program while cross compiling" >&2;}
    { (exit 1); exit 1; }; }
 else
   cat >conftest.$ac_ext <<_ACEOF
-#line 9723 "configure"
+#line 9919 "configure"
 #include "confdefs.h"
 #include <stdio.h>
 /* If setvbuf has the reversed format, exit 0. */
@@ -9737,15 +9933,15 @@
 }
 _ACEOF
 rm -f conftest$ac_exeext
-if { (eval echo "$as_me:9740: \"$ac_link\"") >&5
+if { (eval echo "$as_me:9936: \"$ac_link\"") >&5
   (eval $ac_link) 2>&5
   ac_status=$?
-  echo "$as_me:9743: \$? = $ac_status" >&5
+  echo "$as_me:9939: \$? = $ac_status" >&5
   (exit $ac_status); } && { ac_try='./conftest$ac_exeext'
-  { (eval echo "$as_me:9745: \"$ac_try\"") >&5
+  { (eval echo "$as_me:9941: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:9748: \$? = $ac_status" >&5
+  echo "$as_me:9944: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   ac_cv_func_setvbuf_reversed=yes
 else
@@ -9758,7 +9954,7 @@
 fi
 rm -f core core.* *.core
 fi
-echo "$as_me:9761: result: $ac_cv_func_setvbuf_reversed" >&5
+echo "$as_me:9957: result: $ac_cv_func_setvbuf_reversed" >&5
 echo "${ECHO_T}$ac_cv_func_setvbuf_reversed" >&6
 if test $ac_cv_func_setvbuf_reversed = yes; then
 
@@ -9769,13 +9965,13 @@
 fi
 
 fi
-echo "$as_me:9772: checking return type of signal handlers" >&5
+echo "$as_me:9968: checking return type of signal handlers" >&5
 echo $ECHO_N "checking return type of signal handlers... $ECHO_C" >&6
 if test "${ac_cv_type_signal+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
 else
   cat >conftest.$ac_ext <<_ACEOF
-#line 9778 "configure"
+#line 9974 "configure"
 #include "confdefs.h"
 #include <sys/types.h>
 #include <signal.h>
@@ -9797,16 +9993,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext
-if { (eval echo "$as_me:9800: \"$ac_compile\"") >&5
+if { (eval echo "$as_me:9996: \"$ac_compile\"") >&5
   (eval $ac_compile) 2>&5
   ac_status=$?
-  echo "$as_me:9803: \$? = $ac_status" >&5
+  echo "$as_me:9999: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest.$ac_objext'
-  { (eval echo "$as_me:9806: \"$ac_try\"") >&5
+  { (eval echo "$as_me:10002: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:9809: \$? = $ac_status" >&5
+  echo "$as_me:10005: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   ac_cv_type_signal=void
 else
@@ -9816,21 +10012,21 @@
 fi
 rm -f conftest.$ac_objext conftest.$ac_ext
 fi
-echo "$as_me:9819: result: $ac_cv_type_signal" >&5
+echo "$as_me:10015: result: $ac_cv_type_signal" >&5
 echo "${ECHO_T}$ac_cv_type_signal" >&6
 
 cat >>confdefs.h <<EOF
 #define RETSIGTYPE $ac_cv_type_signal
 EOF
 
-echo "$as_me:9826: checking for type sigaction_t" >&5
+echo "$as_me:10022: checking for type sigaction_t" >&5
 echo $ECHO_N "checking for type sigaction_t... $ECHO_C" >&6
 if test "${cf_cv_type_sigaction+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
 else
 
 	cat >conftest.$ac_ext <<_ACEOF
-#line 9833 "configure"
+#line 10029 "configure"
 #include "confdefs.h"
 
 #include <signal.h>
@@ -9843,16 +10039,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext
-if { (eval echo "$as_me:9846: \"$ac_compile\"") >&5
+if { (eval echo "$as_me:10042: \"$ac_compile\"") >&5
   (eval $ac_compile) 2>&5
   ac_status=$?
-  echo "$as_me:9849: \$? = $ac_status" >&5
+  echo "$as_me:10045: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest.$ac_objext'
-  { (eval echo "$as_me:9852: \"$ac_try\"") >&5
+  { (eval echo "$as_me:10048: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:9855: \$? = $ac_status" >&5
+  echo "$as_me:10051: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   cf_cv_type_sigaction=yes
 else
@@ -9863,13 +10059,13 @@
 rm -f conftest.$ac_objext conftest.$ac_ext
 fi
 
-echo "$as_me:9866: result: $cf_cv_type_sigaction" >&5
+echo "$as_me:10062: result: $cf_cv_type_sigaction" >&5
 echo "${ECHO_T}$cf_cv_type_sigaction" >&6
 test "$cf_cv_type_sigaction" = yes && cat >>confdefs.h <<\EOF
 #define HAVE_TYPE_SIGACTION 1
 EOF
 
-echo "$as_me:9872: checking declaration of size-change" >&5
+echo "$as_me:10068: checking declaration of size-change" >&5
 echo $ECHO_N "checking declaration of size-change... $ECHO_C" >&6
 if test "${cf_cv_sizechange+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
@@ -9884,7 +10080,7 @@
     CPPFLAGS="$cf_save_CPPFLAGS"
     test -n "$cf_opts" && CPPFLAGS="$CPPFLAGS -D$cf_opts"
     cat >conftest.$ac_ext <<_ACEOF
-#line 9887 "configure"
+#line 10083 "configure"
 #include "confdefs.h"
 #include <sys/types.h>
 #ifdef HAVE_TERMIOS_H
@@ -9928,16 +10124,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext
-if { (eval echo "$as_me:9931: \"$ac_compile\"") >&5
+if { (eval echo "$as_me:10127: \"$ac_compile\"") >&5
   (eval $ac_compile) 2>&5
   ac_status=$?
-  echo "$as_me:9934: \$? = $ac_status" >&5
+  echo "$as_me:10130: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest.$ac_objext'
-  { (eval echo "$as_me:9937: \"$ac_try\"") >&5
+  { (eval echo "$as_me:10133: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:9940: \$? = $ac_status" >&5
+  echo "$as_me:10136: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   cf_cv_sizechange=yes
 else
@@ -9956,7 +10152,7 @@
 done
 
 fi
-echo "$as_me:9959: result: $cf_cv_sizechange" >&5
+echo "$as_me:10155: result: $cf_cv_sizechange" >&5
 echo "${ECHO_T}$cf_cv_sizechange" >&6
 if test "$cf_cv_sizechange" != no ; then
 	cat >>confdefs.h <<\EOF
@@ -9973,13 +10169,13 @@
 	esac
 fi
 
-echo "$as_me:9976: checking for memmove" >&5
+echo "$as_me:10172: checking for memmove" >&5
 echo $ECHO_N "checking for memmove... $ECHO_C" >&6
 if test "${ac_cv_func_memmove+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
 else
   cat >conftest.$ac_ext <<_ACEOF
-#line 9982 "configure"
+#line 10178 "configure"
 #include "confdefs.h"
 /* System header to define __stub macros and hopefully few prototypes,
     which can conflict with char memmove (); below.  */
@@ -10010,16 +10206,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext conftest$ac_exeext
-if { (eval echo "$as_me:10013: \"$ac_link\"") >&5
+if { (eval echo "$as_me:10209: \"$ac_link\"") >&5
   (eval $ac_link) 2>&5
   ac_status=$?
-  echo "$as_me:10016: \$? = $ac_status" >&5
+  echo "$as_me:10212: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest$ac_exeext'
-  { (eval echo "$as_me:10019: \"$ac_try\"") >&5
+  { (eval echo "$as_me:10215: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:10022: \$? = $ac_status" >&5
+  echo "$as_me:10218: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   ac_cv_func_memmove=yes
 else
@@ -10029,19 +10225,19 @@
 fi
 rm -f conftest.$ac_objext conftest$ac_exeext conftest.$ac_ext
 fi
-echo "$as_me:10032: result: $ac_cv_func_memmove" >&5
+echo "$as_me:10228: result: $ac_cv_func_memmove" >&5
 echo "${ECHO_T}$ac_cv_func_memmove" >&6
 if test $ac_cv_func_memmove = yes; then
   :
 else
 
-echo "$as_me:10038: checking for bcopy" >&5
+echo "$as_me:10234: checking for bcopy" >&5
 echo $ECHO_N "checking for bcopy... $ECHO_C" >&6
 if test "${ac_cv_func_bcopy+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
 else
   cat >conftest.$ac_ext <<_ACEOF
-#line 10044 "configure"
+#line 10240 "configure"
 #include "confdefs.h"
 /* System header to define __stub macros and hopefully few prototypes,
     which can conflict with char bcopy (); below.  */
@@ -10072,16 +10268,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext conftest$ac_exeext
-if { (eval echo "$as_me:10075: \"$ac_link\"") >&5
+if { (eval echo "$as_me:10271: \"$ac_link\"") >&5
   (eval $ac_link) 2>&5
   ac_status=$?
-  echo "$as_me:10078: \$? = $ac_status" >&5
+  echo "$as_me:10274: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest$ac_exeext'
-  { (eval echo "$as_me:10081: \"$ac_try\"") >&5
+  { (eval echo "$as_me:10277: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:10084: \$? = $ac_status" >&5
+  echo "$as_me:10280: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   ac_cv_func_bcopy=yes
 else
@@ -10091,11 +10287,11 @@
 fi
 rm -f conftest.$ac_objext conftest$ac_exeext conftest.$ac_ext
 fi
-echo "$as_me:10094: result: $ac_cv_func_bcopy" >&5
+echo "$as_me:10290: result: $ac_cv_func_bcopy" >&5
 echo "${ECHO_T}$ac_cv_func_bcopy" >&6
 if test $ac_cv_func_bcopy = yes; then
 
-	echo "$as_me:10098: checking if bcopy does overlapping moves" >&5
+	echo "$as_me:10294: checking if bcopy does overlapping moves" >&5
 echo $ECHO_N "checking if bcopy does overlapping moves... $ECHO_C" >&6
 if test "${cf_cv_good_bcopy+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
@@ -10105,7 +10301,7 @@
   cf_cv_good_bcopy=unknown
 else
   cat >conftest.$ac_ext <<_ACEOF
-#line 10108 "configure"
+#line 10304 "configure"
 #include "confdefs.h"
 
 int main() {
@@ -10119,15 +10315,15 @@
 
 _ACEOF
 rm -f conftest$ac_exeext
-if { (eval echo "$as_me:10122: \"$ac_link\"") >&5
+if { (eval echo "$as_me:10318: \"$ac_link\"") >&5
   (eval $ac_link) 2>&5
   ac_status=$?
-  echo "$as_me:10125: \$? = $ac_status" >&5
+  echo "$as_me:10321: \$? = $ac_status" >&5
   (exit $ac_status); } && { ac_try='./conftest$ac_exeext'
-  { (eval echo "$as_me:10127: \"$ac_try\"") >&5
+  { (eval echo "$as_me:10323: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:10130: \$? = $ac_status" >&5
+  echo "$as_me:10326: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   cf_cv_good_bcopy=yes
 else
@@ -10140,7 +10336,7 @@
 fi
 
 fi
-echo "$as_me:10143: result: $cf_cv_good_bcopy" >&5
+echo "$as_me:10339: result: $cf_cv_good_bcopy" >&5
 echo "${ECHO_T}$cf_cv_good_bcopy" >&6
 
 else
@@ -10161,7 +10357,7 @@
 
 fi
 
-echo "$as_me:10164: checking if poll really works" >&5
+echo "$as_me:10360: checking if poll really works" >&5
 echo $ECHO_N "checking if poll really works... $ECHO_C" >&6
 if test "${cf_cv_working_poll+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
@@ -10171,7 +10367,7 @@
   cf_cv_working_poll=unknown
 else
   cat >conftest.$ac_ext <<_ACEOF
-#line 10174 "configure"
+#line 10370 "configure"
 #include "confdefs.h"
 
 #include <stdio.h>
@@ -10192,15 +10388,15 @@
 }
 _ACEOF
 rm -f conftest$ac_exeext
-if { (eval echo "$as_me:10195: \"$ac_link\"") >&5
+if { (eval echo "$as_me:10391: \"$ac_link\"") >&5
   (eval $ac_link) 2>&5
   ac_status=$?
-  echo "$as_me:10198: \$? = $ac_status" >&5
+  echo "$as_me:10394: \$? = $ac_status" >&5
   (exit $ac_status); } && { ac_try='./conftest$ac_exeext'
-  { (eval echo "$as_me:10200: \"$ac_try\"") >&5
+  { (eval echo "$as_me:10396: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:10203: \$? = $ac_status" >&5
+  echo "$as_me:10399: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   cf_cv_working_poll=yes
 else
@@ -10212,7 +10408,7 @@
 rm -f core core.* *.core conftest$ac_exeext conftest.$ac_objext conftest.$ac_ext
 fi
 fi
-echo "$as_me:10215: result: $cf_cv_working_poll" >&5
+echo "$as_me:10411: result: $cf_cv_working_poll" >&5
 echo "${ECHO_T}$cf_cv_working_poll" >&6
 test "$cf_cv_working_poll" = "yes" && cat >>confdefs.h <<\EOF
 #define HAVE_WORKING_POLL 1
@@ -10225,7 +10421,7 @@
 
 # Just in case, check if the C compiler has a bool type.
 
-echo "$as_me:10228: checking if we should include stdbool.h" >&5
+echo "$as_me:10424: checking if we should include stdbool.h" >&5
 echo $ECHO_N "checking if we should include stdbool.h... $ECHO_C" >&6
 
 if test "${cf_cv_header_stdbool_h+set}" = set; then
@@ -10233,7 +10429,7 @@
 else
 
 	cat >conftest.$ac_ext <<_ACEOF
-#line 10236 "configure"
+#line 10432 "configure"
 #include "confdefs.h"
 
 int
@@ -10245,23 +10441,23 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext
-if { (eval echo "$as_me:10248: \"$ac_compile\"") >&5
+if { (eval echo "$as_me:10444: \"$ac_compile\"") >&5
   (eval $ac_compile) 2>&5
   ac_status=$?
-  echo "$as_me:10251: \$? = $ac_status" >&5
+  echo "$as_me:10447: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest.$ac_objext'
-  { (eval echo "$as_me:10254: \"$ac_try\"") >&5
+  { (eval echo "$as_me:10450: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:10257: \$? = $ac_status" >&5
+  echo "$as_me:10453: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   cf_cv_header_stdbool_h=0
 else
   echo "$as_me: failed program was:" >&5
 cat conftest.$ac_ext >&5
 cat >conftest.$ac_ext <<_ACEOF
-#line 10264 "configure"
+#line 10460 "configure"
 #include "confdefs.h"
 
 #ifndef __BEOS__
@@ -10277,16 +10473,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext
-if { (eval echo "$as_me:10280: \"$ac_compile\"") >&5
+if { (eval echo "$as_me:10476: \"$ac_compile\"") >&5
   (eval $ac_compile) 2>&5
   ac_status=$?
-  echo "$as_me:10283: \$? = $ac_status" >&5
+  echo "$as_me:10479: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest.$ac_objext'
-  { (eval echo "$as_me:10286: \"$ac_try\"") >&5
+  { (eval echo "$as_me:10482: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:10289: \$? = $ac_status" >&5
+  echo "$as_me:10485: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   cf_cv_header_stdbool_h=1
 else
@@ -10300,13 +10496,13 @@
 fi
 
 if test "$cf_cv_header_stdbool_h" = 1
-then	echo "$as_me:10303: result: yes" >&5
+then	echo "$as_me:10499: result: yes" >&5
 echo "${ECHO_T}yes" >&6
-else	echo "$as_me:10305: result: no" >&5
+else	echo "$as_me:10501: result: no" >&5
 echo "${ECHO_T}no" >&6
 fi
 
-echo "$as_me:10309: checking for builtin bool type" >&5
+echo "$as_me:10505: checking for builtin bool type" >&5
 echo $ECHO_N "checking for builtin bool type... $ECHO_C" >&6
 
 if test "${cf_cv_cc_bool_type+set}" = set; then
@@ -10314,7 +10510,7 @@
 else
 
 	cat >conftest.$ac_ext <<_ACEOF
-#line 10317 "configure"
+#line 10513 "configure"
 #include "confdefs.h"
 
 #include <stdio.h>
@@ -10329,16 +10525,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext
-if { (eval echo "$as_me:10332: \"$ac_compile\"") >&5
+if { (eval echo "$as_me:10528: \"$ac_compile\"") >&5
   (eval $ac_compile) 2>&5
   ac_status=$?
-  echo "$as_me:10335: \$? = $ac_status" >&5
+  echo "$as_me:10531: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest.$ac_objext'
-  { (eval echo "$as_me:10338: \"$ac_try\"") >&5
+  { (eval echo "$as_me:10534: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:10341: \$? = $ac_status" >&5
+  echo "$as_me:10537: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   cf_cv_cc_bool_type=1
 else
@@ -10351,9 +10547,9 @@
 fi
 
 if test "$cf_cv_cc_bool_type" = 1
-then	echo "$as_me:10354: result: yes" >&5
+then	echo "$as_me:10550: result: yes" >&5
 echo "${ECHO_T}yes" >&6
-else	echo "$as_me:10356: result: no" >&5
+else	echo "$as_me:10552: result: no" >&5
 echo "${ECHO_T}no" >&6
 fi
 
@@ -10374,7 +10570,7 @@
 	cf_stdcpp_libname=stdc++
 	;;
 esac
-echo "$as_me:10377: checking for library $cf_stdcpp_libname" >&5
+echo "$as_me:10573: checking for library $cf_stdcpp_libname" >&5
 echo $ECHO_N "checking for library $cf_stdcpp_libname... $ECHO_C" >&6
 if test "${cf_cv_libstdcpp+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
@@ -10383,7 +10579,7 @@
 	cf_save="$LIBS"
 	LIBS="$LIBS -l$cf_stdcpp_libname"
 cat >conftest.$ac_ext <<_ACEOF
-#line 10386 "configure"
+#line 10582 "configure"
 #include "confdefs.h"
 
 #include <strstream.h>
@@ -10399,16 +10595,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext conftest$ac_exeext
-if { (eval echo "$as_me:10402: \"$ac_link\"") >&5
+if { (eval echo "$as_me:10598: \"$ac_link\"") >&5
   (eval $ac_link) 2>&5
   ac_status=$?
-  echo "$as_me:10405: \$? = $ac_status" >&5
+  echo "$as_me:10601: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest$ac_exeext'
-  { (eval echo "$as_me:10408: \"$ac_try\"") >&5
+  { (eval echo "$as_me:10604: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:10411: \$? = $ac_status" >&5
+  echo "$as_me:10607: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   cf_cv_libstdcpp=yes
 else
@@ -10420,11 +10616,53 @@
 	LIBS="$cf_save"
 
 fi
-echo "$as_me:10423: result: $cf_cv_libstdcpp" >&5
+echo "$as_me:10619: result: $cf_cv_libstdcpp" >&5
 echo "${ECHO_T}$cf_cv_libstdcpp" >&6
 test "$cf_cv_libstdcpp" = yes && CXXLIBS="$CXXLIBS -l$cf_stdcpp_libname"
 fi
 
+	echo "$as_me:10624: checking whether $CXX understands -c and -o together" >&5
+echo $ECHO_N "checking whether $CXX understands -c and -o together... $ECHO_C" >&6
+if test "${cf_cv_prog_CXX_c_o+set}" = set; then
+  echo $ECHO_N "(cached) $ECHO_C" >&6
+else
+
+cat > conftest.$ac_ext <<CF_EOF
+#include <stdio.h>
+int main()
+{
+	return 0;
+}
+CF_EOF
+# We do the test twice because some compilers refuse to overwrite an
+# existing .o file with -o, though they will create one.
+ac_try='$CXX -c conftest.$ac_ext -o conftest2.$ac_objext >&5'
+if { (eval echo "$as_me:10640: \"$ac_try\"") >&5
+  (eval $ac_try) 2>&5
+  ac_status=$?
+  echo "$as_me:10643: \$? = $ac_status" >&5
+  (exit $ac_status); } &&
+  test -f conftest2.$ac_objext && { (eval echo "$as_me:10645: \"$ac_try\"") >&5
+  (eval $ac_try) 2>&5
+  ac_status=$?
+  echo "$as_me:10648: \$? = $ac_status" >&5
+  (exit $ac_status); };
+then
+  eval cf_cv_prog_CXX_c_o=yes
+else
+  eval cf_cv_prog_CXX_c_o=no
+fi
+rm -f conftest*
+
+fi
+if test $cf_cv_prog_CXX_c_o = yes; then
+  echo "$as_me:10659: result: yes" >&5
+echo "${ECHO_T}yes" >&6
+else
+  echo "$as_me:10662: result: no" >&5
+echo "${ECHO_T}no" >&6
+fi
+
 	case $GXX_VERSION in
 	1*|2.0-6*)
 		cf_cxx_library=yes
@@ -10441,12 +10679,12 @@
 	;;
 esac
 if test "$GXX" = yes; then
-	echo "$as_me:10444: checking for lib$cf_gpp_libname" >&5
+	echo "$as_me:10682: checking for lib$cf_gpp_libname" >&5
 echo $ECHO_N "checking for lib$cf_gpp_libname... $ECHO_C" >&6
 	cf_save="$LIBS"
 	LIBS="$LIBS -l$cf_gpp_libname"
 	cat >conftest.$ac_ext <<_ACEOF
-#line 10449 "configure"
+#line 10687 "configure"
 #include "confdefs.h"
 
 #include <$cf_gpp_libname/builtin.h>
@@ -10460,16 +10698,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext conftest$ac_exeext
-if { (eval echo "$as_me:10463: \"$ac_link\"") >&5
+if { (eval echo "$as_me:10701: \"$ac_link\"") >&5
   (eval $ac_link) 2>&5
   ac_status=$?
-  echo "$as_me:10466: \$? = $ac_status" >&5
+  echo "$as_me:10704: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest$ac_exeext'
-  { (eval echo "$as_me:10469: \"$ac_try\"") >&5
+  { (eval echo "$as_me:10707: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:10472: \$? = $ac_status" >&5
+  echo "$as_me:10710: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   cf_cxx_library=yes
 	 CXXLIBS="$CXXLIBS -l$cf_gpp_libname"
@@ -10488,7 +10726,7 @@
   echo "$as_me: failed program was:" >&5
 cat conftest.$ac_ext >&5
 cat >conftest.$ac_ext <<_ACEOF
-#line 10491 "configure"
+#line 10729 "configure"
 #include "confdefs.h"
 
 #include <builtin.h>
@@ -10502,16 +10740,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext conftest$ac_exeext
-if { (eval echo "$as_me:10505: \"$ac_link\"") >&5
+if { (eval echo "$as_me:10743: \"$ac_link\"") >&5
   (eval $ac_link) 2>&5
   ac_status=$?
-  echo "$as_me:10508: \$? = $ac_status" >&5
+  echo "$as_me:10746: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest$ac_exeext'
-  { (eval echo "$as_me:10511: \"$ac_try\"") >&5
+  { (eval echo "$as_me:10749: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:10514: \$? = $ac_status" >&5
+  echo "$as_me:10752: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   cf_cxx_library=yes
 	 CXXLIBS="$CXXLIBS -l$cf_gpp_libname"
@@ -10528,7 +10766,7 @@
 fi
 rm -f conftest.$ac_objext conftest$ac_exeext conftest.$ac_ext
 	LIBS="$cf_save"
-	echo "$as_me:10531: result: $cf_cxx_library" >&5
+	echo "$as_me:10769: result: $cf_cxx_library" >&5
 echo "${ECHO_T}$cf_cxx_library" >&6
 fi
 
@@ -10543,7 +10781,7 @@
 ac_compile='$CXX -c $CXXFLAGS $CPPFLAGS conftest.$ac_ext >&5'
 ac_link='$CXX -o conftest$ac_exeext $CXXFLAGS $CPPFLAGS $LDFLAGS conftest.$ac_ext $LIBS >&5'
 ac_compiler_gnu=$ac_cv_cxx_compiler_gnu
-echo "$as_me:10546: checking how to run the C++ preprocessor" >&5
+echo "$as_me:10784: checking how to run the C++ preprocessor" >&5
 echo $ECHO_N "checking how to run the C++ preprocessor... $ECHO_C" >&6
 if test -z "$CXXCPP"; then
   if test "${ac_cv_prog_CXXCPP+set}" = set; then
@@ -10560,18 +10798,18 @@
   # On the NeXT, cc -E runs the code through the compiler's parser,
   # not just through cpp. "Syntax error" is here to catch this case.
   cat >conftest.$ac_ext <<_ACEOF
-#line 10563 "configure"
+#line 10801 "configure"
 #include "confdefs.h"
 #include <assert.h>
                      Syntax error
 _ACEOF
-if { (eval echo "$as_me:10568: \"$ac_cpp conftest.$ac_ext\"") >&5
+if { (eval echo "$as_me:10806: \"$ac_cpp conftest.$ac_ext\"") >&5
   (eval $ac_cpp conftest.$ac_ext) 2>conftest.er1
   ac_status=$?
   egrep -v '^ *\+' conftest.er1 >conftest.err
   rm -f conftest.er1
   cat conftest.err >&5
-  echo "$as_me:10574: \$? = $ac_status" >&5
+  echo "$as_me:10812: \$? = $ac_status" >&5
   (exit $ac_status); } >/dev/null; then
   if test -s conftest.err; then
     ac_cpp_err=$ac_cxx_preproc_warn_flag
@@ -10594,17 +10832,17 @@
   # OK, works on sane cases.  Now check whether non-existent headers
   # can be detected and how.
   cat >conftest.$ac_ext <<_ACEOF
-#line 10597 "configure"
+#line 10835 "configure"
 #include "confdefs.h"
 #include <ac_nonexistent.h>
 _ACEOF
-if { (eval echo "$as_me:10601: \"$ac_cpp conftest.$ac_ext\"") >&5
+if { (eval echo "$as_me:10839: \"$ac_cpp conftest.$ac_ext\"") >&5
   (eval $ac_cpp conftest.$ac_ext) 2>conftest.er1
   ac_status=$?
   egrep -v '^ *\+' conftest.er1 >conftest.err
   rm -f conftest.er1
   cat conftest.err >&5
-  echo "$as_me:10607: \$? = $ac_status" >&5
+  echo "$as_me:10845: \$? = $ac_status" >&5
   (exit $ac_status); } >/dev/null; then
   if test -s conftest.err; then
     ac_cpp_err=$ac_cxx_preproc_warn_flag
@@ -10641,7 +10879,7 @@
 else
   ac_cv_prog_CXXCPP=$CXXCPP
 fi
-echo "$as_me:10644: result: $CXXCPP" >&5
+echo "$as_me:10882: result: $CXXCPP" >&5
 echo "${ECHO_T}$CXXCPP" >&6
 ac_preproc_ok=false
 for ac_cxx_preproc_warn_flag in '' yes
@@ -10651,18 +10889,18 @@
   # On the NeXT, cc -E runs the code through the compiler's parser,
   # not just through cpp. "Syntax error" is here to catch this case.
   cat >conftest.$ac_ext <<_ACEOF
-#line 10654 "configure"
+#line 10892 "configure"
 #include "confdefs.h"
 #include <assert.h>
                      Syntax error
 _ACEOF
-if { (eval echo "$as_me:10659: \"$ac_cpp conftest.$ac_ext\"") >&5
+if { (eval echo "$as_me:10897: \"$ac_cpp conftest.$ac_ext\"") >&5
   (eval $ac_cpp conftest.$ac_ext) 2>conftest.er1
   ac_status=$?
   egrep -v '^ *\+' conftest.er1 >conftest.err
   rm -f conftest.er1
   cat conftest.err >&5
-  echo "$as_me:10665: \$? = $ac_status" >&5
+  echo "$as_me:10903: \$? = $ac_status" >&5
   (exit $ac_status); } >/dev/null; then
   if test -s conftest.err; then
     ac_cpp_err=$ac_cxx_preproc_warn_flag
@@ -10685,17 +10923,17 @@
   # OK, works on sane cases.  Now check whether non-existent headers
   # can be detected and how.
   cat >conftest.$ac_ext <<_ACEOF
-#line 10688 "configure"
+#line 10926 "configure"
 #include "confdefs.h"
 #include <ac_nonexistent.h>
 _ACEOF
-if { (eval echo "$as_me:10692: \"$ac_cpp conftest.$ac_ext\"") >&5
+if { (eval echo "$as_me:10930: \"$ac_cpp conftest.$ac_ext\"") >&5
   (eval $ac_cpp conftest.$ac_ext) 2>conftest.er1
   ac_status=$?
   egrep -v '^ *\+' conftest.er1 >conftest.err
   rm -f conftest.er1
   cat conftest.err >&5
-  echo "$as_me:10698: \$? = $ac_status" >&5
+  echo "$as_me:10936: \$? = $ac_status" >&5
   (exit $ac_status); } >/dev/null; then
   if test -s conftest.err; then
     ac_cpp_err=$ac_cxx_preproc_warn_flag
@@ -10723,7 +10961,7 @@
 if $ac_preproc_ok; then
   :
 else
-  { { echo "$as_me:10726: error: C++ preprocessor \"$CXXCPP\" fails sanity check" >&5
+  { { echo "$as_me:10964: error: C++ preprocessor \"$CXXCPP\" fails sanity check" >&5
 echo "$as_me: error: C++ preprocessor \"$CXXCPP\" fails sanity check" >&2;}
    { (exit 1); exit 1; }; }
 fi
@@ -10737,23 +10975,23 @@
 for ac_header in typeinfo
 do
 as_ac_Header=`echo "ac_cv_header_$ac_header" | $as_tr_sh`
-echo "$as_me:10740: checking for $ac_header" >&5
+echo "$as_me:10978: checking for $ac_header" >&5
 echo $ECHO_N "checking for $ac_header... $ECHO_C" >&6
 if eval "test \"\${$as_ac_Header+set}\" = set"; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
 else
   cat >conftest.$ac_ext <<_ACEOF
-#line 10746 "configure"
+#line 10984 "configure"
 #include "confdefs.h"
 #include <$ac_header>
 _ACEOF
-if { (eval echo "$as_me:10750: \"$ac_cpp conftest.$ac_ext\"") >&5
+if { (eval echo "$as_me:10988: \"$ac_cpp conftest.$ac_ext\"") >&5
   (eval $ac_cpp conftest.$ac_ext) 2>conftest.er1
   ac_status=$?
   egrep -v '^ *\+' conftest.er1 >conftest.err
   rm -f conftest.er1
   cat conftest.err >&5
-  echo "$as_me:10756: \$? = $ac_status" >&5
+  echo "$as_me:10994: \$? = $ac_status" >&5
   (exit $ac_status); } >/dev/null; then
   if test -s conftest.err; then
     ac_cpp_err=$ac_cxx_preproc_warn_flag
@@ -10772,7 +11010,7 @@
 fi
 rm -f conftest.err conftest.$ac_ext
 fi
-echo "$as_me:10775: result: `eval echo '${'$as_ac_Header'}'`" >&5
+echo "$as_me:11013: result: `eval echo '${'$as_ac_Header'}'`" >&5
 echo "${ECHO_T}`eval echo '${'$as_ac_Header'}'`" >&6
 if test `eval echo '${'$as_ac_Header'}'` = yes; then
   cat >>confdefs.h <<EOF
@@ -10782,7 +11020,7 @@
 fi
 done
 
-echo "$as_me:10785: checking if we should include stdbool.h" >&5
+echo "$as_me:11023: checking if we should include stdbool.h" >&5
 echo $ECHO_N "checking if we should include stdbool.h... $ECHO_C" >&6
 
 if test "${cf_cv_header_stdbool_h+set}" = set; then
@@ -10790,7 +11028,7 @@
 else
 
 	cat >conftest.$ac_ext <<_ACEOF
-#line 10793 "configure"
+#line 11031 "configure"
 #include "confdefs.h"
 
 int
@@ -10802,23 +11040,23 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext
-if { (eval echo "$as_me:10805: \"$ac_compile\"") >&5
+if { (eval echo "$as_me:11043: \"$ac_compile\"") >&5
   (eval $ac_compile) 2>&5
   ac_status=$?
-  echo "$as_me:10808: \$? = $ac_status" >&5
+  echo "$as_me:11046: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest.$ac_objext'
-  { (eval echo "$as_me:10811: \"$ac_try\"") >&5
+  { (eval echo "$as_me:11049: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:10814: \$? = $ac_status" >&5
+  echo "$as_me:11052: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   cf_cv_header_stdbool_h=0
 else
   echo "$as_me: failed program was:" >&5
 cat conftest.$ac_ext >&5
 cat >conftest.$ac_ext <<_ACEOF
-#line 10821 "configure"
+#line 11059 "configure"
 #include "confdefs.h"
 
 #ifndef __BEOS__
@@ -10834,16 +11072,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext
-if { (eval echo "$as_me:10837: \"$ac_compile\"") >&5
+if { (eval echo "$as_me:11075: \"$ac_compile\"") >&5
   (eval $ac_compile) 2>&5
   ac_status=$?
-  echo "$as_me:10840: \$? = $ac_status" >&5
+  echo "$as_me:11078: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest.$ac_objext'
-  { (eval echo "$as_me:10843: \"$ac_try\"") >&5
+  { (eval echo "$as_me:11081: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:10846: \$? = $ac_status" >&5
+  echo "$as_me:11084: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   cf_cv_header_stdbool_h=1
 else
@@ -10857,13 +11095,13 @@
 fi
 
 if test "$cf_cv_header_stdbool_h" = 1
-then	echo "$as_me:10860: result: yes" >&5
+then	echo "$as_me:11098: result: yes" >&5
 echo "${ECHO_T}yes" >&6
-else	echo "$as_me:10862: result: no" >&5
+else	echo "$as_me:11100: result: no" >&5
 echo "${ECHO_T}no" >&6
 fi
 
-echo "$as_me:10866: checking for builtin bool type" >&5
+echo "$as_me:11104: checking for builtin bool type" >&5
 echo $ECHO_N "checking for builtin bool type... $ECHO_C" >&6
 
 if test "${cf_cv_builtin_bool+set}" = set; then
@@ -10871,7 +11109,7 @@
 else
 
 	cat >conftest.$ac_ext <<_ACEOF
-#line 10874 "configure"
+#line 11112 "configure"
 #include "confdefs.h"
 
 #include <stdio.h>
@@ -10886,16 +11124,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext
-if { (eval echo "$as_me:10889: \"$ac_compile\"") >&5
+if { (eval echo "$as_me:11127: \"$ac_compile\"") >&5
   (eval $ac_compile) 2>&5
   ac_status=$?
-  echo "$as_me:10892: \$? = $ac_status" >&5
+  echo "$as_me:11130: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest.$ac_objext'
-  { (eval echo "$as_me:10895: \"$ac_try\"") >&5
+  { (eval echo "$as_me:11133: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:10898: \$? = $ac_status" >&5
+  echo "$as_me:11136: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   cf_cv_builtin_bool=1
 else
@@ -10908,13 +11146,13 @@
 fi
 
 if test "$cf_cv_builtin_bool" = 1
-then	echo "$as_me:10911: result: yes" >&5
+then	echo "$as_me:11149: result: yes" >&5
 echo "${ECHO_T}yes" >&6
-else	echo "$as_me:10913: result: no" >&5
+else	echo "$as_me:11151: result: no" >&5
 echo "${ECHO_T}no" >&6
 fi
 
-echo "$as_me:10917: checking for size of bool" >&5
+echo "$as_me:11155: checking for size of bool" >&5
 echo $ECHO_N "checking for size of bool... $ECHO_C" >&6
 if test "${cf_cv_type_of_bool+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
@@ -10925,7 +11163,7 @@
   cf_cv_type_of_bool=unknown
 else
   cat >conftest.$ac_ext <<_ACEOF
-#line 10928 "configure"
+#line 11166 "configure"
 #include "confdefs.h"
 
 #include <stdlib.h>
@@ -10967,15 +11205,15 @@
 
 _ACEOF
 rm -f conftest$ac_exeext
-if { (eval echo "$as_me:10970: \"$ac_link\"") >&5
+if { (eval echo "$as_me:11208: \"$ac_link\"") >&5
   (eval $ac_link) 2>&5
   ac_status=$?
-  echo "$as_me:10973: \$? = $ac_status" >&5
+  echo "$as_me:11211: \$? = $ac_status" >&5
   (exit $ac_status); } && { ac_try='./conftest$ac_exeext'
-  { (eval echo "$as_me:10975: \"$ac_try\"") >&5
+  { (eval echo "$as_me:11213: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:10978: \$? = $ac_status" >&5
+  echo "$as_me:11216: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   cf_cv_type_of_bool=`cat cf_test.out`
 		 if test -z "$cf_cv_type_of_bool"; then
@@ -10993,18 +11231,18 @@
 fi
 
 	rm -f cf_test.out
-echo "$as_me:10996: result: $cf_cv_type_of_bool" >&5
+echo "$as_me:11234: result: $cf_cv_type_of_bool" >&5
 echo "${ECHO_T}$cf_cv_type_of_bool" >&6
 if test "$cf_cv_type_of_bool" = unknown ; then
 	case .$NCURSES_BOOL in #(vi
 	.auto|.) NCURSES_BOOL=unsigned;;
 	esac
-	{ echo "$as_me:11002: WARNING: Assuming $NCURSES_BOOL for type of bool" >&5
+	{ echo "$as_me:11240: WARNING: Assuming $NCURSES_BOOL for type of bool" >&5
 echo "$as_me: WARNING: Assuming $NCURSES_BOOL for type of bool" >&2;}
 	cf_cv_type_of_bool=$NCURSES_BOOL
 fi
 
-echo "$as_me:11007: checking for special defines needed for etip.h" >&5
+echo "$as_me:11245: checking for special defines needed for etip.h" >&5
 echo $ECHO_N "checking for special defines needed for etip.h... $ECHO_C" >&6
 cf_save_CXXFLAGS="$CXXFLAGS"
 cf_result="none"
@@ -11016,7 +11254,7 @@
 	test -n "$cf_math" && CXXFLAGS="$CXXFLAGS -DETIP_NEEDS_${cf_math}"
 	test -n "$cf_excp" && CXXFLAGS="$CXXFLAGS -DETIP_NEEDS_${cf_excp}"
 cat >conftest.$ac_ext <<_ACEOF
-#line 11019 "configure"
+#line 11257 "configure"
 #include "confdefs.h"
 
 #include <etip.h.in>
@@ -11030,16 +11268,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext
-if { (eval echo "$as_me:11033: \"$ac_compile\"") >&5
+if { (eval echo "$as_me:11271: \"$ac_compile\"") >&5
   (eval $ac_compile) 2>&5
   ac_status=$?
-  echo "$as_me:11036: \$? = $ac_status" >&5
+  echo "$as_me:11274: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest.$ac_objext'
-  { (eval echo "$as_me:11039: \"$ac_try\"") >&5
+  { (eval echo "$as_me:11277: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:11042: \$? = $ac_status" >&5
+  echo "$as_me:11280: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
 
 	test -n "$cf_math" && cat >>confdefs.h <<EOF
@@ -11060,12 +11298,12 @@
 rm -f conftest.$ac_objext conftest.$ac_ext
 done
 done
-echo "$as_me:11063: result: $cf_result" >&5
+echo "$as_me:11301: result: $cf_result" >&5
 echo "${ECHO_T}$cf_result" >&6
 CXXFLAGS="$cf_save_CXXFLAGS"
 
 if test -n "$CXX"; then
-echo "$as_me:11068: checking if $CXX accepts parameter initialization" >&5
+echo "$as_me:11306: checking if $CXX accepts parameter initialization" >&5
 echo $ECHO_N "checking if $CXX accepts parameter initialization... $ECHO_C" >&6
 if test "${cf_cv_cpp_param_init+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
@@ -11081,7 +11319,7 @@
   cf_cv_cpp_param_init=unknown
 else
   cat >conftest.$ac_ext <<_ACEOF
-#line 11084 "configure"
+#line 11322 "configure"
 #include "confdefs.h"
 
 class TEST {
@@ -11100,15 +11338,15 @@
 
 _ACEOF
 rm -f conftest$ac_exeext
-if { (eval echo "$as_me:11103: \"$ac_link\"") >&5
+if { (eval echo "$as_me:11341: \"$ac_link\"") >&5
   (eval $ac_link) 2>&5
   ac_status=$?
-  echo "$as_me:11106: \$? = $ac_status" >&5
+  echo "$as_me:11344: \$? = $ac_status" >&5
   (exit $ac_status); } && { ac_try='./conftest$ac_exeext'
-  { (eval echo "$as_me:11108: \"$ac_try\"") >&5
+  { (eval echo "$as_me:11346: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:11111: \$? = $ac_status" >&5
+  echo "$as_me:11349: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   cf_cv_cpp_param_init=yes
 else
@@ -11126,7 +11364,7 @@
 ac_compiler_gnu=$ac_cv_cxx_compiler_gnu
 
 fi
-echo "$as_me:11129: result: $cf_cv_cpp_param_init" >&5
+echo "$as_me:11367: result: $cf_cv_cpp_param_init" >&5
 echo "${ECHO_T}$cf_cv_cpp_param_init" >&6
 fi
 test "$cf_cv_cpp_param_init" = yes && cat >>confdefs.h <<\EOF
@@ -11144,23 +11382,23 @@
 for ac_header in strstream.h
 do
 as_ac_Header=`echo "ac_cv_header_$ac_header" | $as_tr_sh`
-echo "$as_me:11147: checking for $ac_header" >&5
+echo "$as_me:11385: checking for $ac_header" >&5
 echo $ECHO_N "checking for $ac_header... $ECHO_C" >&6
 if eval "test \"\${$as_ac_Header+set}\" = set"; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
 else
   cat >conftest.$ac_ext <<_ACEOF
-#line 11153 "configure"
+#line 11391 "configure"
 #include "confdefs.h"
 #include <$ac_header>
 _ACEOF
-if { (eval echo "$as_me:11157: \"$ac_cpp conftest.$ac_ext\"") >&5
+if { (eval echo "$as_me:11395: \"$ac_cpp conftest.$ac_ext\"") >&5
   (eval $ac_cpp conftest.$ac_ext) 2>conftest.er1
   ac_status=$?
   egrep -v '^ *\+' conftest.er1 >conftest.err
   rm -f conftest.er1
   cat conftest.err >&5
-  echo "$as_me:11163: \$? = $ac_status" >&5
+  echo "$as_me:11401: \$? = $ac_status" >&5
   (exit $ac_status); } >/dev/null; then
   if test -s conftest.err; then
     ac_cpp_err=$ac_cxx_preproc_warn_flag
@@ -11179,7 +11417,7 @@
 fi
 rm -f conftest.err conftest.$ac_ext
 fi
-echo "$as_me:11182: result: `eval echo '${'$as_ac_Header'}'`" >&5
+echo "$as_me:11420: result: `eval echo '${'$as_ac_Header'}'`" >&5
 echo "${ECHO_T}`eval echo '${'$as_ac_Header'}'`" >&6
 if test `eval echo '${'$as_ac_Header'}'` = yes; then
   cat >>confdefs.h <<EOF
@@ -11189,7 +11427,7 @@
 fi
 done
 
-echo "$as_me:11192: checking if $CXX supports vscan function" >&5
+echo "$as_me:11430: checking if $CXX supports vscan function" >&5
 echo $ECHO_N "checking if $CXX supports vscan function... $ECHO_C" >&6
 if test "${cf_cv_cpp_vscan_func+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
@@ -11203,7 +11441,7 @@
 	strstream_cast)	cf_vscan_defs=USE_STRSTREAM_VSCAN_CAST ;;
 	esac
 	cat >conftest.$ac_ext <<_ACEOF
-#line 11206 "configure"
+#line 11444 "configure"
 #include "confdefs.h"
 
 #include <stdio.h>
@@ -11248,16 +11486,16 @@
 }
 _ACEOF
 rm -f conftest.$ac_objext conftest$ac_exeext
-if { (eval echo "$as_me:11251: \"$ac_link\"") >&5
+if { (eval echo "$as_me:11489: \"$ac_link\"") >&5
   (eval $ac_link) 2>&5
   ac_status=$?
-  echo "$as_me:11254: \$? = $ac_status" >&5
+  echo "$as_me:11492: \$? = $ac_status" >&5
   (exit $ac_status); } &&
          { ac_try='test -s conftest$ac_exeext'
-  { (eval echo "$as_me:11257: \"$ac_try\"") >&5
+  { (eval echo "$as_me:11495: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:11260: \$? = $ac_status" >&5
+  echo "$as_me:11498: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   cf_cv_cpp_vscan_func=$cf_vscan_func; break
 else
@@ -11270,7 +11508,7 @@
 	done
 
 fi
-echo "$as_me:11273: result: $cf_cv_cpp_vscan_func" >&5
+echo "$as_me:11511: result: $cf_cv_cpp_vscan_func" >&5
 echo "${ECHO_T}$cf_cv_cpp_vscan_func" >&6
 
 ac_ext=cc
@@ -11352,7 +11590,7 @@
 	else
 		if test "$cf_cv_header_stdbool_h" = 1 ; then
 
-echo "$as_me:11355: checking for size of bool" >&5
+echo "$as_me:11593: checking for size of bool" >&5
 echo $ECHO_N "checking for size of bool... $ECHO_C" >&6
 if test "${cf_cv_type_of_bool+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
@@ -11363,7 +11601,7 @@
   cf_cv_type_of_bool=unknown
 else
   cat >conftest.$ac_ext <<_ACEOF
-#line 11366 "configure"
+#line 11604 "configure"
 #include "confdefs.h"
 
 #include <stdlib.h>
@@ -11405,15 +11643,15 @@
 
 _ACEOF
 rm -f conftest$ac_exeext
-if { (eval echo "$as_me:11408: \"$ac_link\"") >&5
+if { (eval echo "$as_me:11646: \"$ac_link\"") >&5
   (eval $ac_link) 2>&5
   ac_status=$?
-  echo "$as_me:11411: \$? = $ac_status" >&5
+  echo "$as_me:11649: \$? = $ac_status" >&5
   (exit $ac_status); } && { ac_try='./conftest$ac_exeext'
-  { (eval echo "$as_me:11413: \"$ac_try\"") >&5
+  { (eval echo "$as_me:11651: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
-  echo "$as_me:11416: \$? = $ac_status" >&5
+  echo "$as_me:11654: \$? = $ac_status" >&5
   (exit $ac_status); }; }; then
   cf_cv_type_of_bool=`cat cf_test.out`
 		 if test -z "$cf_cv_type_of_bool"; then
@@ -11431,25 +11669,25 @@
 fi
 
 	rm -f cf_test.out
-echo "$as_me:11434: result: $cf_cv_type_of_bool" >&5
+echo "$as_me:11672: result: $cf_cv_type_of_bool" >&5
 echo "${ECHO_T}$cf_cv_type_of_bool" >&6
 if test "$cf_cv_type_of_bool" = unknown ; then
 	case .$NCURSES_BOOL in #(vi
 	.auto|.) NCURSES_BOOL=unsigned;;
 	esac
-	{ echo "$as_me:11440: WARNING: Assuming $NCURSES_BOOL for type of bool" >&5
+	{ echo "$as_me:11678: WARNING: Assuming $NCURSES_BOOL for type of bool" >&5
 echo "$as_me: WARNING: Assuming $NCURSES_BOOL for type of bool" >&2;}
 	cf_cv_type_of_bool=$NCURSES_BOOL
 fi
 
 		else
-			echo "$as_me:11446: checking for fallback type of bool" >&5
+			echo "$as_me:11684: checking for fallback type of bool" >&5
 echo $ECHO_N "checking for fallback type of bool... $ECHO_C" >&6
 			case "$host_cpu" in #(vi
 			i?86)	cf_cv_type_of_bool=char	;; #(vi
 			*)	cf_cv_type_of_bool=int	;;
 			esac
-			echo "$as_me:11452: result: $cf_cv_type_of_bool" >&5
+			echo "$as_me:11690: result: $cf_cv_type_of_bool" >&5
 echo "${ECHO_T}$cf_cv_type_of_bool" >&6
 		fi
 	fi
@@ -11478,7 +11716,7 @@
 cf_ada_make=gnatmake
 # Extract the first word of "$cf_ada_make", so it can be a program name with args.
 set dummy $cf_ada_make; ac_word=$2
-echo "$as_me:11481: checking for $ac_word" >&5
+echo "$as_me:11719: checking for $ac_word" >&5
 echo $ECHO_N "checking for $ac_word... $ECHO_C" >&6
 if test "${ac_cv_prog_gnat_exists+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
@@ -11493,7 +11731,7 @@
   test -z "$ac_dir" && ac_dir=.
   $as_executable_p "$ac_dir/$ac_word" || continue
 ac_cv_prog_gnat_exists="yes"
-echo "$as_me:11496: found $ac_dir/$ac_word" >&5
+echo "$as_me:11734: found $ac_dir/$ac_word" >&5
 break
 done
 
@@ -11502,10 +11740,10 @@
 fi
 gnat_exists=$ac_cv_prog_gnat_exists
 if test -n "$gnat_exists"; then
-  echo "$as_me:11505: result: $gnat_exists" >&5
+  echo "$as_me:11743: result: $gnat_exists" >&5
 echo "${ECHO_T}$gnat_exists" >&6
 else
-  echo "$as_me:11508: result: no" >&5
+  echo "$as_me:11746: result: no" >&5
 echo "${ECHO_T}no" >&6
 fi
 
@@ -11513,11 +11751,11 @@
    cf_ada_make=
 else
 
-echo "$as_me:11516: checking for gnat version" >&5
+echo "$as_me:11754: checking for gnat version" >&5
 echo $ECHO_N "checking for gnat version... $ECHO_C" >&6
 cf_gnat_version=`${cf_ada_make-gnatmake} -v 2>&1 | grep '[0-9].[0-9][0-9]*' |\
   sed -e '2,$d' -e 's/[^0-9 \.]//g' -e 's/^[ ]*//' -e 's/ .*//'`
-echo "$as_me:11520: result: $cf_gnat_version" >&5
+echo "$as_me:11758: result: $cf_gnat_version" >&5
 echo "${ECHO_T}$cf_gnat_version" >&6
 
 case $cf_gnat_version in
@@ -11540,7 +11778,7 @@
 
    # Extract the first word of "m4", so it can be a program name with args.
 set dummy m4; ac_word=$2
-echo "$as_me:11543: checking for $ac_word" >&5
+echo "$as_me:11781: checking for $ac_word" >&5
 echo $ECHO_N "checking for $ac_word... $ECHO_C" >&6
 if test "${ac_cv_prog_M4_exists+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
@@ -11555,7 +11793,7 @@
   test -z "$ac_dir" && ac_dir=.
   $as_executable_p "$ac_dir/$ac_word" || continue
 ac_cv_prog_M4_exists="yes"
-echo "$as_me:11558: found $ac_dir/$ac_word" >&5
+echo "$as_me:11796: found $ac_dir/$ac_word" >&5
 break
 done
 
@@ -11564,10 +11802,10 @@
 fi
 M4_exists=$ac_cv_prog_M4_exists
 if test -n "$M4_exists"; then
-  echo "$as_me:11567: result: $M4_exists" >&5
+  echo "$as_me:11805: result: $M4_exists" >&5
 echo "${ECHO_T}$M4_exists" >&6
 else
-  echo "$as_me:11570: result: no" >&5
+  echo "$as_me:11808: result: no" >&5
 echo "${ECHO_T}no" >&6
 fi
 
@@ -11576,7 +11814,7 @@
       echo Ada95 binding required program m4 not found. Ada95 binding disabled.
    fi
    if test "$cf_cv_prog_gnat_correct" = yes; then
-      echo "$as_me:11579: checking if GNAT works" >&5
+      echo "$as_me:11817: checking if GNAT works" >&5
 echo $ECHO_N "checking if GNAT works... $ECHO_C" >&6
 
 rm -f conftest*
@@ -11604,7 +11842,7 @@
 fi
 rm -f conftest*
 
-      echo "$as_me:11607: result: $cf_cv_prog_gnat_correct" >&5
+      echo "$as_me:11845: result: $cf_cv_prog_gnat_correct" >&5
 echo "${ECHO_T}$cf_cv_prog_gnat_correct" >&6
    fi
 fi
@@ -11647,7 +11885,7 @@
   withval=`echo $withval | sed -e s%NONE%$ac_default_prefix%`
   ;;
 *)
-  { { echo "$as_me:11650: error: expected a pathname, not \"$withval\"" >&5
+  { { echo "$as_me:11888: error: expected a pathname, not \"$withval\"" >&5
 echo "$as_me: error: expected a pathname, not \"$withval\"" >&2;}
    { (exit 1); exit 1; }; }
   ;;
@@ -11681,7 +11919,7 @@
   withval=`echo $withval | sed -e s%NONE%$ac_default_prefix%`
   ;;
 *)
-  { { echo "$as_me:11684: error: expected a pathname, not \"$withval\"" >&5
+  { { echo "$as_me:11922: error: expected a pathname, not \"$withval\"" >&5
 echo "$as_me: error: expected a pathname, not \"$withval\"" >&2;}
    { (exit 1); exit 1; }; }
   ;;
@@ -11694,9 +11932,9 @@
 
 ### Construct the library-subsets, if any, from this set of keywords:
 ### none, base, ext_funcs, ext_tinfo, termlib, widechar (see CF_LIB_RULES).
-echo "$as_me:11697: checking for library subsets" >&5
+echo "$as_me:11935: checking for library subsets" >&5
 echo $ECHO_N "checking for library subsets... $ECHO_C" >&6
-if test "$with_termlib" = yes ; then
+if test "$with_termlib" != no ; then
 	LIB_SUBSETS="termlib"
 	test "$with_ext_funcs" = yes && LIB_SUBSETS="${LIB_SUBSETS}+ext_tinfo"
 	LIB_SUBSETS="${LIB_SUBSETS} "
@@ -11707,7 +11945,7 @@
 LIB_SUBSETS="${LIB_SUBSETS}base"
 test "$with_widec"     = yes && LIB_SUBSETS="${LIB_SUBSETS}+widechar"
 test "$with_ext_funcs" = yes && LIB_SUBSETS="${LIB_SUBSETS}+ext_funcs"
-echo "$as_me:11710: result: $LIB_SUBSETS" >&5
+echo "$as_me:11948: result: $LIB_SUBSETS" >&5
 echo "${ECHO_T}$LIB_SUBSETS" >&6
 
 ### Construct the list of include-directories to be generated
@@ -11745,7 +11983,7 @@
 fi
 
 ### Build up pieces for makefile rules
-echo "$as_me:11748: checking default library suffix" >&5
+echo "$as_me:11986: checking default library suffix" >&5
 echo $ECHO_N "checking default library suffix... $ECHO_C" >&6
 
 	case $DFT_LWR_MODEL in
@@ -11756,10 +11994,10 @@
 	shared)  DFT_ARG_SUFFIX=''   ;;
 	esac
 	test -n "$LIB_SUFFIX" && DFT_ARG_SUFFIX="${LIB_SUFFIX}${DFT_ARG_SUFFIX}"
-echo "$as_me:11759: result: $DFT_ARG_SUFFIX" >&5
+echo "$as_me:11997: result: $DFT_ARG_SUFFIX" >&5
 echo "${ECHO_T}$DFT_ARG_SUFFIX" >&6
 
-echo "$as_me:11762: checking default library-dependency suffix" >&5
+echo "$as_me:12000: checking default library-dependency suffix" >&5
 echo $ECHO_N "checking default library-dependency suffix... $ECHO_C" >&6
 
 	case $DFT_LWR_MODEL in
@@ -11788,10 +12026,10 @@
 		;;
 	esac
 fi
-echo "$as_me:11791: result: $DFT_DEP_SUFFIX" >&5
+echo "$as_me:12029: result: $DFT_DEP_SUFFIX" >&5
 echo "${ECHO_T}$DFT_DEP_SUFFIX" >&6
 
-echo "$as_me:11794: checking default object directory" >&5
+echo "$as_me:12032: checking default object directory" >&5
 echo $ECHO_N "checking default object directory... $ECHO_C" >&6
 
 	case $DFT_LWR_MODEL in
@@ -11807,12 +12045,12 @@
 			DFT_OBJ_SUBDIR='obj_s' ;;
 		esac
 	esac
-echo "$as_me:11810: result: $DFT_OBJ_SUBDIR" >&5
+echo "$as_me:12048: result: $DFT_OBJ_SUBDIR" >&5
 echo "${ECHO_T}$DFT_OBJ_SUBDIR" >&6
 
 # libtool thinks it can make c++ shared libraries (perhaps only g++)
 if test "$cf_with_cxx" = yes ; then
-echo "$as_me:11815: checking c++ library-dependency suffix" >&5
+echo "$as_me:12053: checking c++ library-dependency suffix" >&5
 echo $ECHO_N "checking c++ library-dependency suffix... $ECHO_C" >&6
 if test "$with_libtool" != "no"; then
 	CXX_LIB_SUFFIX=$DFT_DEP_SUFFIX
@@ -11838,22 +12076,43 @@
 	esac
 	test -n "$LIB_SUFFIX" && CXX_LIB_SUFFIX="${LIB_SUFFIX}${CXX_LIB_SUFFIX}"
 fi
-echo "$as_me:11841: result: $CXX_LIB_SUFFIX" >&5
+echo "$as_me:12079: result: $CXX_LIB_SUFFIX" >&5
 echo "${ECHO_T}$CXX_LIB_SUFFIX" >&6
 
 fi
 
+### Set up low-level terminfo dependencies for makefiles.
 TINFO_LIST="$SHLIB_LIST"
-if test "$with_libtool" = no ; then
-	test "$with_termlib" = yes && SHLIB_LIST="$SHLIB_LIST -ltinfo${LIB_SUFFIX}"
+if test "$with_termlib" != no ; then
+
+	if test "$with_termlib" != yes ; then
+		TINFO_NAME=$with_termlib
+		TINFO_ARG_SUFFIX="${with_termlib}`echo ${DFT_ARG_SUFFIX}|sed -e "s/^${LIB_SUFFIX}//"`"
+		TINFO_DEP_SUFFIX="${with_termlib}`echo ${DFT_DEP_SUFFIX}|sed -e "s/^${LIB_SUFFIX}//"`"
+		TINFO_LIB_SUFFIX="${with_termlib}"
+	else
+		TINFO_ARG_SUFFIX="${TINFO_NAME}${DFT_ARG_SUFFIX}"
+		TINFO_DEP_SUFFIX="${TINFO_NAME}${DFT_DEP_SUFFIX}"
+		TINFO_LIB_SUFFIX="${TINFO_NAME}${LIB_SUFFIX}"
+	fi
+
+	TEST_DEPS="${LIB_DIR}/${LIB_PREFIX}${TINFO_DEP_SUFFIX}"
+	if test "$DFT_LWR_MODEL" = "libtool"; then
+		TEST_ARGS="${TEST_DEPS}"
+	else
+		TEST_ARGS="-l${TINFO_ARG_SUFFIX}"
+		SHLIB_LIST="$SHLIB_LIST -l${TINFO_LIB_SUFFIX}"
+	fi
 fi
 
-echo "$as_me:11851: checking where we will install curses.h" >&5
+PROG_ARGS="$TEST_ARGS"
+
+echo "$as_me:12110: checking where we will install curses.h" >&5
 echo $ECHO_N "checking where we will install curses.h... $ECHO_C" >&6
 test "$with_overwrite" = no && \
 test "x$includedir" = 'x${prefix}/include' && \
 	includedir='$(prefix)/include/ncurses'${LIB_SUFFIX}
-echo "$as_me:11856: result: $includedir" >&5
+echo "$as_me:12115: result: $includedir" >&5
 echo "${ECHO_T}$includedir" >&6
 
 ### Resolve a conflict between normal and wide-curses by forcing applications
@@ -11861,24 +12120,11 @@
 if test "$with_overwrite" != no ; then
 if test "$NCURSES_LIBUTF8" = 1 ; then
 	NCURSES_LIBUTF8='defined(HAVE_LIBUTF8_H)'
-	{ echo "$as_me:11864: WARNING: Wide-character applications must define HAVE_LIBUTF8_H to include curses.h" >&5
+	{ echo "$as_me:12123: WARNING: Wide-character applications must define HAVE_LIBUTF8_H to include curses.h" >&5
 echo "$as_me: WARNING: Wide-character applications must define HAVE_LIBUTF8_H to include curses.h" >&2;}
 fi
 fi
 
-### Set up low-level terminfo dependencies for makefiles.  Note that we
-### could override this.
-if test "$with_termlib" = yes ; then
-	TEST_DEPS="${LIB_DIR}/${LIB_PREFIX}${TINFO_NAME}${DFT_DEP_SUFFIX}"
-	if test "$DFT_LWR_MODEL" = "libtool"; then
-		TEST_ARGS="${TEST_DEPS}"
-	else
-		TEST_ARGS="-l${TINFO_NAME}${DFT_ARG_SUFFIX}"
-	fi
-fi
-PROG_DEPS="$TEST_DEPS"
-PROG_ARGS="$TEST_ARGS"
-
 ### predefined stuff for the test programs
 cat >>confdefs.h <<\EOF
 #define HAVE_SLK_COLOR 1
@@ -11887,7 +12133,7 @@
 ### Construct the list of subdirectories for which we'll customize makefiles
 ### with the appropriate compile-rules.
 
-echo "$as_me:11890: checking for src modules" >&5
+echo "$as_me:12136: checking for src modules" >&5
 echo $ECHO_N "checking for src modules... $ECHO_C" >&6
 
 # dependencies and linker-arguments for test-programs
@@ -11899,7 +12145,7 @@
 fi
 
 # dependencies and linker-arguments for utility-programs
-test "$with_termlib" != yes && PROG_ARGS="$TEST_ARGS"
+test "$with_termlib" = no && PROG_ARGS="$TEST_ARGS"
 
 cf_cv_src_modules=
 for cf_dir in $modules_to_build
@@ -11947,7 +12193,7 @@
 		fi
 	fi
 done
-echo "$as_me:11950: result: $cf_cv_src_modules" >&5
+echo "$as_me:12196: result: $cf_cv_src_modules" >&5
 echo "${ECHO_T}$cf_cv_src_modules" >&6
 TEST_ARGS="-L${LIB_DIR} $TEST_ARGS"
 
@@ -12134,7 +12380,7 @@
 : ${CONFIG_STATUS=./config.status}
 ac_clean_files_save=$ac_clean_files
 ac_clean_files="$ac_clean_files $CONFIG_STATUS"
-{ echo "$as_me:12137: creating $CONFIG_STATUS" >&5
+{ echo "$as_me:12383: creating $CONFIG_STATUS" >&5
 echo "$as_me: creating $CONFIG_STATUS" >&6;}
 cat >$CONFIG_STATUS <<_ACEOF
 #! $SHELL
@@ -12310,7 +12556,7 @@
     echo "$ac_cs_version"; exit 0 ;;
   --he | --h)
     # Conflict between --help and --header
-    { { echo "$as_me:12313: error: ambiguous option: $1
+    { { echo "$as_me:12559: error: ambiguous option: $1
 Try \`$0 --help' for more information." >&5
 echo "$as_me: error: ambiguous option: $1
 Try \`$0 --help' for more information." >&2;}
@@ -12329,7 +12575,7 @@
     ac_need_defaults=false;;
 
   # This is an error.
-  -*) { { echo "$as_me:12332: error: unrecognized option: $1
+  -*) { { echo "$as_me:12578: error: unrecognized option: $1
 Try \`$0 --help' for more information." >&5
 echo "$as_me: error: unrecognized option: $1
 Try \`$0 --help' for more information." >&2;}
@@ -12369,6 +12615,7 @@
 
 AWK="$AWK"
 CF_LIST_MODELS="$cf_list_models"
+DFT_ARG_SUFFIX="$DFT_ARG_SUFFIX"
 DFT_LWR_MODEL="$DFT_LWR_MODEL"
 LDCONFIG="$LDCONFIG"
 LIB_NAME="$LIB_NAME"
@@ -12379,12 +12626,16 @@
 NCURSES_OSPEED="$NCURSES_OSPEED"
 SRC_SUBDIRS="$SRC_SUBDIRS"
 TERMINFO="$TERMINFO"
+TINFO_ARG_SUFFIX="$TINFO_ARG_SUFFIX"
+TINFO_LIB_SUFFIX="$TINFO_LIB_SUFFIX"
 TINFO_NAME="$TINFO_NAME"
 WITH_CURSES_H="$with_curses_h"
 WITH_ECHO="$with_echo"
 WITH_OVERWRITE="$with_overwrite"
 cf_cv_abi_version="$cf_cv_abi_version"
 cf_cv_do_symlinks="$cf_cv_do_symlinks"
+cf_cv_prog_CC_c_o=$cf_cv_prog_CC_c_o
+cf_cv_prog_CXX_c_o=$cf_cv_prog_CXX_c_o
 cf_cv_rel_version="$cf_cv_rel_version"
 cf_cv_rm_so_locs="$cf_cv_rm_so_locs"
 cf_cv_shlib_version="$cf_cv_shlib_version"
@@ -12409,7 +12660,7 @@
   "Makefile" ) CONFIG_FILES="$CONFIG_FILES Makefile" ;;
   "default" ) CONFIG_COMMANDS="$CONFIG_COMMANDS default" ;;
   "include/ncurses_cfg.h" ) CONFIG_HEADERS="$CONFIG_HEADERS include/ncurses_cfg.h:include/ncurses_cfg.hin" ;;
-  *) { { echo "$as_me:12412: error: invalid argument: $ac_config_target" >&5
+  *) { { echo "$as_me:12663: error: invalid argument: $ac_config_target" >&5
 echo "$as_me: error: invalid argument: $ac_config_target" >&2;}
    { (exit 1); exit 1; }; };;
   esac
@@ -12545,11 +12796,13 @@
 s,@cf_cv_makeflags@,$cf_cv_makeflags,;t t
 s,@DESTDIR@,$DESTDIR,;t t
 s,@BUILD_CC@,$BUILD_CC,;t t
+s,@BUILD_CPP@,$BUILD_CPP,;t t
 s,@BUILD_CFLAGS@,$BUILD_CFLAGS,;t t
 s,@BUILD_CPPFLAGS@,$BUILD_CPPFLAGS,;t t
 s,@BUILD_LDFLAGS@,$BUILD_LDFLAGS,;t t
 s,@BUILD_LIBS@,$BUILD_LIBS,;t t
 s,@BUILD_EXEEXT@,$BUILD_EXEEXT,;t t
+s,@BUILD_OBJEXT@,$BUILD_OBJEXT,;t t
 s,@cf_list_models@,$cf_list_models,;t t
 s,@LIBTOOL@,$LIBTOOL,;t t
 s,@LIBTOOL_CXX@,$LIBTOOL_CXX,;t t
@@ -12630,12 +12883,15 @@
 s,@DFT_DEP_SUFFIX@,$DFT_DEP_SUFFIX,;t t
 s,@DFT_OBJ_SUBDIR@,$DFT_OBJ_SUBDIR,;t t
 s,@CXX_LIB_SUFFIX@,$CXX_LIB_SUFFIX,;t t
+s,@TINFO_ARG_SUFFIX@,$TINFO_ARG_SUFFIX,;t t
+s,@TINFO_DEP_SUFFIX@,$TINFO_DEP_SUFFIX,;t t
+s,@TINFO_LIB_SUFFIX@,$TINFO_LIB_SUFFIX,;t t
+s,@PROG_ARGS@,$PROG_ARGS,;t t
 s,@EXTRA_LIBS@,$EXTRA_LIBS,;t t
 s,@TINFO_LIST@,$TINFO_LIST,;t t
 s,@SHLIB_LIST@,$SHLIB_LIST,;t t
 s,@TEST_DEPS@,$TEST_DEPS,;t t
 s,@TEST_ARGS@,$TEST_ARGS,;t t
-s,@PROG_ARGS@,$PROG_ARGS,;t t
 s,@ADA_SUBDIRS@,$ADA_SUBDIRS,;t t
 s,@DIRS_TO_MAKE@,$DIRS_TO_MAKE,;t t
 CEOF
@@ -12752,7 +13008,7 @@
   esac
 
   if test x"$ac_file" != x-; then
-    { echo "$as_me:12755: creating $ac_file" >&5
+    { echo "$as_me:13011: creating $ac_file" >&5
 echo "$as_me: creating $ac_file" >&6;}
     rm -f "$ac_file"
   fi
@@ -12770,7 +13026,7 @@
       -) echo $tmp/stdin ;;
       [\\/$]*)
          # Absolute (can't be DOS-style, as IFS=:)
-         test -f "$f" || { { echo "$as_me:12773: error: cannot find input file: $f" >&5
+         test -f "$f" || { { echo "$as_me:13029: error: cannot find input file: $f" >&5
 echo "$as_me: error: cannot find input file: $f" >&2;}
    { (exit 1); exit 1; }; }
          echo $f;;
@@ -12783,7 +13039,7 @@
            echo $srcdir/$f
          else
            # /dev/null tree
-           { { echo "$as_me:12786: error: cannot find input file: $f" >&5
+           { { echo "$as_me:13042: error: cannot find input file: $f" >&5
 echo "$as_me: error: cannot find input file: $f" >&2;}
    { (exit 1); exit 1; }; }
          fi;;
@@ -12849,7 +13105,7 @@
   * )   ac_file_in=$ac_file.in ;;
   esac
 
-  test x"$ac_file" != x- && { echo "$as_me:12852: creating $ac_file" >&5
+  test x"$ac_file" != x- && { echo "$as_me:13108: creating $ac_file" >&5
 echo "$as_me: creating $ac_file" >&6;}
 
   # First look for the input files in the build tree, otherwise in the
@@ -12860,7 +13116,7 @@
       -) echo $tmp/stdin ;;
       [\\/$]*)
          # Absolute (can't be DOS-style, as IFS=:)
-         test -f "$f" || { { echo "$as_me:12863: error: cannot find input file: $f" >&5
+         test -f "$f" || { { echo "$as_me:13119: error: cannot find input file: $f" >&5
 echo "$as_me: error: cannot find input file: $f" >&2;}
    { (exit 1); exit 1; }; }
          echo $f;;
@@ -12873,7 +13129,7 @@
            echo $srcdir/$f
          else
            # /dev/null tree
-           { { echo "$as_me:12876: error: cannot find input file: $f" >&5
+           { { echo "$as_me:13132: error: cannot find input file: $f" >&5
 echo "$as_me: error: cannot find input file: $f" >&2;}
    { (exit 1); exit 1; }; }
          fi;;
@@ -12931,7 +13187,7 @@
   rm -f $tmp/in
   if test x"$ac_file" != x-; then
     if cmp -s $ac_file $tmp/config.h 2>/dev/null; then
-      { echo "$as_me:12934: $ac_file is unchanged" >&5
+      { echo "$as_me:13190: $ac_file is unchanged" >&5
 echo "$as_me: $ac_file is unchanged" >&6;}
     else
       ac_dir=`$as_expr X"$ac_file" : 'X\(.*[^/]\)//*[^/][^/]*/*$' \| \
@@ -13055,7 +13311,7 @@
 			cf_subsets="$LIB_SUBSETS"
 			cf_termlib=`echo "$cf_subsets" |sed -e 's/ .*$//'`
 			if test "$cf_termlib" != "$cf_subsets" ; then
-				cf_item=`echo $LIBS_TO_MAKE |sed -e s%$LIB_NAME%$TINFO_NAME%g`
+				cf_item=`echo $LIBS_TO_MAKE |sed -e s%${LIB_NAME}${LIB_SUFFIX}%${TINFO_LIB_SUFFIX}%g`
 				LIBS_TO_MAKE="$cf_item $LIBS_TO_MAKE"
 			fi
 		else
@@ -13115,6 +13371,22 @@
 		esac
 	esac
 
+			# Test for case where we build libinfo with a different name.
+			cf_libname=$cf_dir
+			if test $cf_dir = ncurses ; then
+				case $cf_subset in
+				*base*)
+					;;
+				termlib*)
+					cf_libname=$TINFO_LIB_SUFFIX
+					if test -n "${DFT_ARG_SUFFIX}" ; then
+						# undo $LIB_SUFFIX add-on in CF_LIB_SUFFIX
+						cf_suffix=`echo $cf_suffix |sed -e "s%^${LIB_SUFFIX}%%"`
+					fi
+				;;
+				esac
+			fi
+
 			# These dependencies really are for development, not
 			# builds, but they are useful in porting, too.
 			cf_depend="../include/ncurses_cfg.h"
@@ -13131,7 +13403,7 @@
 			fi
 
 			$AWK -f $srcdir/mk-1st.awk \
-				name=$cf_dir \
+				name=$cf_libname \
 				traces=$LIB_TRACING \
 				MODEL=$CF_ITEM \
 				model=$cf_subdir \
@@ -13160,6 +13432,8 @@
 				subset=$cf_subset \
 				srcdir=$srcdir \
 				echo=$WITH_ECHO \
+				crenames=$cf_cv_prog_CC_c_o \
+				cxxrenames=$cf_cv_prog_CXX_c_o \
 				$srcdir/$cf_dir/modules >>$cf_dir/Makefile
 			cf_subdirs="$cf_subdirs $cf_subdir"
 			done
Index: configure.in
Prereq:  1.312 
--- ncurses-5.4-20040208/configure.in	2004-01-24 14:29:13.000000000 -0500
+++ ncurses-5.4-20040424/configure.in	2004-02-28 16:11:33.000000000 -0500
@@ -28,14 +28,14 @@
 dnl
 dnl Author: Thomas E. Dickey 1995-on
 dnl
-dnl $Id: configure.in,v 1.312 2004/01/24 19:29:13 tom Exp $
+dnl $Id: configure.in,v 1.316 2004/02/28 21:11:33 tom Exp $
 dnl Process this file with autoconf to produce a configure script.
 dnl
 dnl See http://invisible-island.net/autoconf/ for additional information.
 dnl
 dnl ---------------------------------------------------------------------------
 AC_PREREQ(2.13.20020210)
-AC_REVISION($Revision: 1.312 $)
+AC_REVISION($Revision: 1.316 $)
 AC_INIT(ncurses/base/lib_initscr.c)
 AC_CONFIG_HEADER(include/ncurses_cfg.h:include/ncurses_cfg.hin)
 
@@ -62,6 +62,7 @@
 
 AC_PROG_CPP
 AC_PROG_GCC_TRADITIONAL
+CF_PROG_CC_C_O(CC)
 AC_ISC_POSIX
 CF_ANSI_CC_REQD
 CF_PROG_EXT
@@ -180,37 +181,7 @@
 # If we're cross-compiling, allow the user to override the tools and their
 # options.  The configure script is oriented toward identifying the host
 # compiler, etc., but we need a build compiler to generate parts of the source.
-: ${BUILD_CC:='$(CC)'}
-: ${BUILD_CFLAGS:='$(CFLAGS)'}
-: ${BUILD_CPPFLAGS:='$(CPPFLAGS)'}
-: ${BUILD_LDFLAGS:='$(LDFLAGS)'}
-: ${BUILD_LIBS:='$(LIBS)'}
-: ${BUILD_EXEEXT:='$x'}
-if test "$cross_compiling" = yes ; then
-	AC_ARG_WITH(build-cc,
-		[  --with-build-cc=XXX     the build C compiler ($BUILD_CC)],
-		[BUILD_CC="$withval"],
-		[AC_CHECK_PROGS(BUILD_CC, $CC gcc cc)])
-	AC_ARG_WITH(build-cflags,
-		[  --with-build-cflags=XXX the build C compiler-flags],
-		[BUILD_CFLAGS="$withval"])
-	AC_ARG_WITH(build-cppflags,
-		[  --with-build-cppflags=XXX the build C preprocessor-flags],
-		[BUILD_CPPFLAGS="$withval"])
-	AC_ARG_WITH(build-ldflags,
-		[  --with-build-ldflags=XXX the build linker-flags],
-		[BUILD_LDFLAGS="$withval"])
-	AC_ARG_WITH(build-libs,
-		[  --with-build-libs=XXX   the build libraries],
-		[BUILD_LIBS="$withval"])
-	BUILD_EXEEXT=
-fi
-AC_SUBST(BUILD_CC)
-AC_SUBST(BUILD_CFLAGS)
-AC_SUBST(BUILD_CPPFLAGS)
-AC_SUBST(BUILD_LDFLAGS)
-AC_SUBST(BUILD_LIBS)
-AC_SUBST(BUILD_EXEEXT)
+CF_BUILD_CC
 
 ###############################################################################
 CF_HELP_MESSAGE(Options to Specify the Libraries Built/Used:)
@@ -779,6 +750,9 @@
 # Check to define _XOPEN_SOURCE "automatically"
 CF_XOPEN_SOURCE
 
+# Checks for CODESET support.
+AM_LANGINFO_CODESET
+
 # use these variables to work around a defect in gcc's fixincludes.
 NCURSES_OK_WCHAR_T=
 NCURSES_OK_WINT_T=
@@ -1042,6 +1016,7 @@
 if test -n "$CXX" ; then
 	AC_LANG_CPLUSPLUS
 	CF_STDCPP_LIBRARY
+	CF_PROG_CC_C_O(CXX)
 
 	case $GXX_VERSION in
 	1*|2.[0-6]*)
@@ -1202,7 +1177,7 @@
 ### Construct the library-subsets, if any, from this set of keywords:
 ### none, base, ext_funcs, ext_tinfo, termlib, widechar (see CF_LIB_RULES).
 AC_MSG_CHECKING(for library subsets)
-if test "$with_termlib" = yes ; then
+if test "$with_termlib" != no ; then
 	LIB_SUBSETS="termlib"
 	test "$with_ext_funcs" = yes && LIB_SUBSETS="${LIB_SUBSETS}+ext_tinfo"
 	LIB_SUBSETS="${LIB_SUBSETS} "
@@ -1254,10 +1229,35 @@
 AC_SUBST(CXX_LIB_SUFFIX)
 fi
 
+### Set up low-level terminfo dependencies for makefiles.
 TINFO_LIST="$SHLIB_LIST"
-if test "$with_libtool" = no ; then
-	test "$with_termlib" = yes && SHLIB_LIST="$SHLIB_LIST -ltinfo${LIB_SUFFIX}"
+if test "$with_termlib" != no ; then
+
+	if test "$with_termlib" != yes ; then
+		TINFO_NAME=$with_termlib
+		TINFO_ARG_SUFFIX="${with_termlib}`echo ${DFT_ARG_SUFFIX}|sed -e "s/^${LIB_SUFFIX}//"`"
+		TINFO_DEP_SUFFIX="${with_termlib}`echo ${DFT_DEP_SUFFIX}|sed -e "s/^${LIB_SUFFIX}//"`"
+		TINFO_LIB_SUFFIX="${with_termlib}"
+	else
+		TINFO_ARG_SUFFIX="${TINFO_NAME}${DFT_ARG_SUFFIX}"
+		TINFO_DEP_SUFFIX="${TINFO_NAME}${DFT_DEP_SUFFIX}"
+		TINFO_LIB_SUFFIX="${TINFO_NAME}${LIB_SUFFIX}"
+	fi
+
+	TEST_DEPS="${LIB_DIR}/${LIB_PREFIX}${TINFO_DEP_SUFFIX}"
+	if test "$DFT_LWR_MODEL" = "libtool"; then
+		TEST_ARGS="${TEST_DEPS}"
+	else
+		TEST_ARGS="-l${TINFO_ARG_SUFFIX}"
+		SHLIB_LIST="$SHLIB_LIST -l${TINFO_LIB_SUFFIX}"
+	fi
 fi
+AC_SUBST(TINFO_ARG_SUFFIX)
+AC_SUBST(TINFO_DEP_SUFFIX)
+AC_SUBST(TINFO_LIB_SUFFIX)
+
+PROG_ARGS="$TEST_ARGS"
+AC_SUBST(PROG_ARGS)
 
 AC_MSG_CHECKING(where we will install curses.h)
 test "$with_overwrite" = no && \
@@ -1278,19 +1278,6 @@
 AC_SUBST(TINFO_LIST)
 AC_SUBST(SHLIB_LIST)
 
-### Set up low-level terminfo dependencies for makefiles.  Note that we
-### could override this.
-if test "$with_termlib" = yes ; then
-	TEST_DEPS="${LIB_DIR}/${LIB_PREFIX}${TINFO_NAME}${DFT_DEP_SUFFIX}"
-	if test "$DFT_LWR_MODEL" = "libtool"; then
-		TEST_ARGS="${TEST_DEPS}"
-	else
-		TEST_ARGS="-l${TINFO_NAME}${DFT_ARG_SUFFIX}"
-	fi
-fi
-PROG_DEPS="$TEST_DEPS"
-PROG_ARGS="$TEST_ARGS"
-
 ### predefined stuff for the test programs
 AC_DEFINE(HAVE_SLK_COLOR)
 
@@ -1323,6 +1310,7 @@
 
 AWK="$AWK"
 CF_LIST_MODELS="$cf_list_models"
+DFT_ARG_SUFFIX="$DFT_ARG_SUFFIX"
 DFT_LWR_MODEL="$DFT_LWR_MODEL"
 LDCONFIG="$LDCONFIG"
 LIB_NAME="$LIB_NAME"
@@ -1333,12 +1321,16 @@
 NCURSES_OSPEED="$NCURSES_OSPEED"
 SRC_SUBDIRS="$SRC_SUBDIRS"
 TERMINFO="$TERMINFO"
+TINFO_ARG_SUFFIX="$TINFO_ARG_SUFFIX"
+TINFO_LIB_SUFFIX="$TINFO_LIB_SUFFIX"
 TINFO_NAME="$TINFO_NAME"
 WITH_CURSES_H="$with_curses_h"
 WITH_ECHO="$with_echo"
 WITH_OVERWRITE="$with_overwrite"
 cf_cv_abi_version="$cf_cv_abi_version"
 cf_cv_do_symlinks="$cf_cv_do_symlinks"
+cf_cv_prog_CC_c_o=$cf_cv_prog_CC_c_o
+cf_cv_prog_CXX_c_o=$cf_cv_prog_CXX_c_o
 cf_cv_rel_version="$cf_cv_rel_version"
 cf_cv_rm_so_locs="$cf_cv_rm_so_locs"
 cf_cv_shlib_version="$cf_cv_shlib_version"
Index: dist.mk
Prereq:  1.402 
--- ncurses-5.4-20040208/dist.mk	2004-02-08 15:56:43.000000000 -0500
+++ ncurses-5.4-20040424/dist.mk	2004-04-24 14:24:50.000000000 -0400
@@ -1,4 +1,4 @@
-# $Id: dist.mk,v 1.402 2004/02/08 20:56:43 tom Exp $
+# $Id: dist.mk,v 1.414 2004/04/24 18:24:50 tom Exp $
 # Makefile for creating ncurses distributions.
 #
 # This only needs to be used directly as a makefile by developers, but
@@ -10,7 +10,7 @@
 # These define the major/minor/patch versions of ncurses.
 NCURSES_MAJOR = 5
 NCURSES_MINOR = 4
-NCURSES_PATCH = 20040208
+NCURSES_PATCH = 20040424
 
 # We don't append the patch to the version, since this only applies to releases
 VERSION = $(NCURSES_MAJOR).$(NCURSES_MINOR)
Index: form/fld_pad.c
Prereq:  1.7 
--- ncurses-5.4-20040208/form/fld_pad.c	2003-10-25 11:17:08.000000000 -0400
+++ ncurses-5.4-20040424/form/fld_pad.c	2004-04-03 18:03:13.000000000 -0500
@@ -1,5 +1,5 @@
 /****************************************************************************
- * Copyright (c) 1998-2002,2003 Free Software Foundation, Inc.              *
+ * Copyright (c) 1998-2003,2004 Free Software Foundation, Inc.              *
  *                                                                          *
  * Permission is hereby granted, free of charge, to any person obtaining a  *
  * copy of this software and associated documentation files (the            *
@@ -32,7 +32,7 @@
 
 #include "form.priv.h"
 
-MODULE_ID("$Id: fld_pad.c,v 1.7 2003/10/25 15:17:08 tom Exp $")
+MODULE_ID("$Id: fld_pad.c,v 1.8 2004/04/03 23:03:13 tom Exp $")
 
 /*---------------------------------------------------------------------------
 |   Facility      :  libnform  
@@ -46,17 +46,17 @@
 |                    E_SYSTEM_ERROR - system error
 +--------------------------------------------------------------------------*/
 NCURSES_EXPORT(int)
-set_field_pad (FIELD  * field, int ch)
+set_field_pad(FIELD *field, int ch)
 {
   int res = E_BAD_ARGUMENT;
 
-  Normalize_Field( field );
-  if (isprint((unsigned char)ch))
+  Normalize_Field(field);
+  if (isprint(UChar(ch)))
     {
       if (field->pad != ch)
 	{
 	  field->pad = ch;
-	  res = _nc_Synchronize_Attributes( field );
+	  res = _nc_Synchronize_Attributes(field);
 	}
       else
 	res = E_OK;
@@ -73,9 +73,9 @@
 |   Return Values :  The pad character.
 +--------------------------------------------------------------------------*/
 NCURSES_EXPORT(int)
-field_pad (const FIELD * field)
+field_pad(const FIELD *field)
 {
-  return Normalize_Field( field )->pad;
+  return Normalize_Field(field)->pad;
 }
 
 /* fld_pad.c ends here */
Index: form/form.priv.h
Prereq:  0.11 
--- ncurses-5.4-20040208/form/form.priv.h	2003-11-08 15:38:51.000000000 -0500
+++ ncurses-5.4-20040424/form/form.priv.h	2004-03-06 20:45:39.000000000 -0500
@@ -1,5 +1,5 @@
 /****************************************************************************
- * Copyright (c) 1998-2002,2003 Free Software Foundation, Inc.              *
+ * Copyright (c) 1998-2003,2004 Free Software Foundation, Inc.              *
  *                                                                          *
  * Permission is hereby granted, free of charge, to any person obtaining a  *
  * copy of this software and associated documentation files (the            *
@@ -30,11 +30,24 @@
  *   Author:  Juergen Pfeifer, 1995,1997                                    *
  ****************************************************************************/
 
-/* $Id: form.priv.h,v 0.11 2003/11/08 20:38:51 tom Exp $ */
+/* $Id: form.priv.h,v 0.13 2004/03/07 01:45:39 tom Exp $ */
+
+#ifndef FORM_PRIV_H
+#define FORM_PRIV_H 1
 
 #include "mf_common.h"
 #include "form.h"
 
+#if USE_WIDEC_SUPPORT
+#include <wchar.h>
+#include <wctype.h>
+
+#ifndef MB_LEN_MAX
+#define MB_LEN_MAX 8 /* should be >= MB_CUR_MAX, but that may be a function */
+#endif
+
+#endif
+
 /* form  status values */
 #define _OVLMODE         (0x04) /* Form is in overlay mode                */
 #define _WINDOW_MODIFIED (0x10) /* Current field window has been modified */
@@ -86,6 +99,8 @@
   struct typearg *right;
 } TypeArgument;
 
+#define UChar(c)	((unsigned char)(c))
+
 /* This is a dummy request code (normally invalid) to be used internally
    with the form_driver() routine to position to the first active field
    on the form
@@ -128,3 +143,9 @@
 extern NCURSES_EXPORT(bool) _nc_Internal_Validation (FORM*);
 extern NCURSES_EXPORT(int) _nc_Set_Current_Field (FORM*,FIELD*);
 extern NCURSES_EXPORT(int) _nc_Position_Form_Cursor (FORM*);
+
+#if USE_WIDEC_SUPPORT
+extern NCURSES_EXPORT(wchar_t *) _nc_Widen_String(char *, int *);
+#endif
+
+#endif /* FORM_PRIV_H */
Index: form/frm_driver.c
Prereq:  1.45 
--- ncurses-5.4-20040208/form/frm_driver.c	2003-12-06 12:22:42.000000000 -0500
+++ ncurses-5.4-20040424/form/frm_driver.c	2004-04-03 18:03:29.000000000 -0500
@@ -1,5 +1,5 @@
 /****************************************************************************
- * Copyright (c) 1998-2002,2003 Free Software Foundation, Inc.              *
+ * Copyright (c) 1998-2003,2004 Free Software Foundation, Inc.              *
  *                                                                          *
  * Permission is hereby granted, free of charge, to any person obtaining a  *
  * copy of this software and associated documentation files (the            *
@@ -32,11 +32,11 @@
 
 #include "form.priv.h"
 
-MODULE_ID("$Id: frm_driver.c,v 1.45 2003/12/06 17:22:42 tom Exp $")
+MODULE_ID("$Id: frm_driver.c,v 1.47 2004/04/03 23:03:29 tom Exp $")
 
 /*----------------------------------------------------------------------------
   This is the core module of the form library. It contains the majority
-  of the driver routines as well as the form_driver function. 
+  of the driver routines as well as the form_driver function.
 
   Essentially this module is nearly the whole library. This is because
   all the functions in this module depends on some others in the module,
@@ -53,7 +53,7 @@
         The current field of the form is left and some new field is
         entered.
    c)   Intra-Field Navigation     ( all functions prefixed by IFN_ )
-        The current position in the current field is changed. 
+        The current position in the current field is changed.
    d)   Vertical Scrolling         ( all functions prefixed by VSC_ )
         Essentially this is a specialization of Intra-Field navigation.
         It has to check for a multi-line field.
@@ -87,7 +87,7 @@
 of the original SVr4 implementation, although in some areas it is quite
 clear that this isn't the most appropriate way. As far as possible this
 sources will allow you to build a forms lib that behaves quite similar
-to SVr4, but now and in the future we will give you better options. 
+to SVr4, but now and in the future we will give you better options.
 Perhaps at some time we will make this configurable at runtime.
 */
 
@@ -106,7 +106,7 @@
 static int FN_Previous_Field (FORM * form);
 static int FE_New_Line(FORM *);
 static int FE_Delete_Previous(FORM *);
-
+
 /*----------------------------------------------------------------------------
   Macro Definitions.
 
@@ -193,11 +193,11 @@
 
 #define Minimum(a,b) (((a)<=(b)) ? (a) : (b))
 #define Maximum(a,b) (((a)>=(b)) ? (a) : (b))
-
+
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static char *Get_Start_Of_Data(char * buf, int blen)
-|   
+|
 |   Description   :  Return pointer to first non-blank position in buffer.
 |                    If buffer is empty return pointer to buffer itself.
 |
@@ -209,36 +209,36 @@
   char *end = &buf[blen];
 
   assert(buf && blen>=0);
-  while( (p < end) && is_blank(*p) ) 
+  while( (p < end) && is_blank(*p) )
     p++;
   return( (p==end) ? buf : p );
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static char *After_End_Of_Data(char * buf, int blen)
-|   
+|
 |   Description   :  Return pointer after last non-blank position in buffer.
 |                    If buffer is empty, return pointer to buffer itself.
 |
-|   Return Values :  Pointer to position after last non-blank position in 
+|   Return Values :  Pointer to position after last non-blank position in
 |                    buffer.
 +--------------------------------------------------------------------------*/
 INLINE static char *After_End_Of_Data(char * buf,int blen)
 {
   char *p   = &buf[blen];
-  
+
   assert(buf && blen>=0);
-  while( (p>buf) && is_blank(p[-1]) ) 
+  while( (p>buf) && is_blank(p[-1]) )
     p--;
   return( p );
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static char *Get_First_Whitespace_Character(
 |                                     char * buf, int   blen)
-|   
+|
 |   Description   :  Position to the first whitespace character.
 |
 |   Return Values :  Pointer to first whitespace character in buffer.
@@ -247,47 +247,47 @@
 {
   char *p   = buf;
   char *end = &p[blen];
-  
+
   assert(buf && blen>=0);
-  while( (p < end) && !is_blank(*p)) 
+  while( (p < end) && !is_blank(*p))
     p++;
   return( (p==end) ? buf : p );
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static char *After_Last_Whitespace_Character(
 |                                     char * buf, int blen)
-|   
+|
 |   Description   :  Get the position after the last whitespace character.
 |
-|   Return Values :  Pointer to position after last whitespace character in 
+|   Return Values :  Pointer to position after last whitespace character in
 |                    buffer.
 +--------------------------------------------------------------------------*/
 INLINE static char *After_Last_Whitespace_Character(char * buf, int blen)
 {
   char *p   = &buf[blen];
-  
+
   assert(buf && blen>=0);
-  while( (p>buf) && !is_blank(p[-1]) ) 
+  while( (p>buf) && !is_blank(p[-1]) )
     p--;
   return( p );
 }
 
 /* Set this to 1 to use the div_t version. This is a good idea if your
    compiler has an intrinsic div() support. Unfortunately GNU-C has it
-   not yet. 
+   not yet.
    N.B.: This only works if form->curcol follows immediately form->currow
-         and both are of type int. 
+         and both are of type int.
 */
 #define USE_DIV_T (0)
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static void Adjust_Cursor_Position(
 |                                       FORM * form, const char * pos)
-|   
-|   Description   :  Set current row and column of the form to values 
+|
+|   Description   :  Set current row and column of the form to values
 |                    corresponding to the buffer position.
 |
 |   Return Values :  -
@@ -305,17 +305,17 @@
 #else
   form->currow = idx / field->dcols;
   form->curcol = idx - field->cols * form->currow;
-#endif  
+#endif
   if ( field->drows < form->currow )
     form->currow = 0;
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static void Buffer_To_Window(
 |                                      const FIELD  * field,
 |                                      WINDOW * win)
-|   
+|
 |   Description   :  Copy the buffer to the window. If it is a multi-line
 |                    field, the buffer is split to the lines of the
 |                    window without any editing.
@@ -334,8 +334,8 @@
   width  = getmaxx(win);
   height = getmaxy(win);
 
-  for(row=0, pBuffer=field->buf; 
-      row < height; 
+  for(row=0, pBuffer=field->buf;
+      row < height;
       row++, pBuffer += width )
     {
       if ((len = (int)( After_End_Of_Data( pBuffer, width ) - pBuffer )) > 0)
@@ -343,15 +343,15 @@
 	  wmove( win, row, 0 );
 	  waddnstr( win, pBuffer, len );
 	}
-    }	
+    }
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static void Window_To_Buffer(
 |                                          WINDOW * win,
 |                                          FIELD  * field)
-|   
+|
 |   Description   :  Copy the content of the window into the buffer.
 |                    The multiple lines of a window are simply
 |                    concatenated into the buffer. Pad characters in
@@ -365,7 +365,7 @@
   int len = 0;
   char *p;
   int row, height;
-  
+
   assert(win && field && field->buf );
 
   pad = field->pad;
@@ -385,16 +385,16 @@
       int i;
       for(i=0; i<len; i++, p++)
 	{
-	  if (*p==pad) 
+	  if (*p==pad)
 	    *p = C_BLANK;
 	}
     }
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static void Synchronize_Buffer(FORM * form)
-|   
+|
 |   Description   :  If there was a change, copy the content of the
 |                    window into the buffer, so the buffer is synchronized
 |                    with the windows content. We have to indicate that the
@@ -414,9 +414,9 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static bool Field_Grown( FIELD *field, int amount)
-|   
+|
 |   Description   :  This function is called for growable dynamic fields
 |                    only. It has to increase the buffers and to allocate
 |                    a new window for this field.
@@ -446,10 +446,10 @@
       bool need_visual_update = ((form != (FORM *)0)      &&
 				 (form->status & _POSTED) &&
 				 (form->current==field));
-      
+
       if (need_visual_update)
 	Synchronize_Buffer(form);
-      
+
       if (single_line_field)
 	{
 	  growth = field->cols * amount;
@@ -487,7 +487,7 @@
 	  int i;
 	  char *old_bp;
 	  char *new_bp;
-	  
+
 	  field->buf = newbuf;
 	  for(i=0;i<=field->nbuf;i++)
 	    {
@@ -501,16 +501,16 @@
 	    }
 
 	  if (need_visual_update)
-	    { 	      
+	    {
 	      WINDOW *new_window = newpad(field->drows,field->dcols);
 	      if (!new_window)
 		{ /* restore old state */
 		  field->dcols = old_dcols;
 		  field->drows = old_drows;
 		  field->buf   = oldbuf;
-		  if (( single_line_field              && 
+		  if (( single_line_field              &&
 			(field->dcols!=field->maxgrow)) ||
-		      (!single_line_field              && 
+		      (!single_line_field              &&
 		       (field->drows!=field->maxgrow)))
 		    field->status |= _MAY_GROW;
 		  free( newbuf );
@@ -542,17 +542,17 @@
 		}
 	    }
 	  result = TRUE;
-	}	
+	}
     }
   return(result);
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  int _nc_Position_Form_Cursor(FORM * form)
-|   
+|
 |   Description   :  Position the cursor in the window for the current
-|                    field to be in sync. with the currow and curcol 
+|                    field to be in sync. with the currow and curcol
 |                    values.
 |
 |   Return Values :  E_OK              - success
@@ -565,11 +565,11 @@
 {
   FIELD  *field;
   WINDOW *formwin;
-  
+
   if (!form)
     return(E_BAD_ARGUMENT);
 
-  if (!form->w || !form->current) 
+  if (!form->w || !form->current)
     return(E_SYSTEM_ERROR);
 
   field    = form->current;
@@ -585,15 +585,15 @@
 	    field->fcol + form->curcol - form->begincol);
       wcursyncup(formwin);
     }
-  else 
+  else
     wcursyncup(form->w);
   return(E_OK);
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  int _nc_Refresh_Current_Field(FORM * form)
-|   
+|
 |   Description   :  Propagate the changes in the fields window to the
 |                    window of the form.
 |
@@ -610,7 +610,7 @@
   if (!form)
     RETURN(E_BAD_ARGUMENT);
 
-  if (!form->w || !form->current) 
+  if (!form->w || !form->current)
     RETURN(E_SYSTEM_ERROR);
 
   field    = form->current;
@@ -664,20 +664,20 @@
 		      first_unmodified_row = first_modified_row + field->rows;
 		      field->status &= ~_NEWTOP;
 		    }
-		  else 
+		  else
 		    { /* we try to optimize : finding the range of touched
                          lines */
 		      first_modified_row = form->toprow;
 		      while(first_modified_row < row_after_bottom)
 			{
-			  if (is_linetouched(form->w,first_modified_row)) 
+			  if (is_linetouched(form->w,first_modified_row))
 			    break;
 			  first_modified_row++;
 			}
 		      first_unmodified_row = first_modified_row;
 		      while(first_unmodified_row < row_after_bottom)
 			{
-			  if (!is_linetouched(form->w,first_unmodified_row)) 
+			  if (!is_linetouched(form->w,first_unmodified_row))
 			    break;
 			  first_unmodified_row++;
 			}
@@ -703,7 +703,7 @@
 	}
       else
 	{ /* if the field-window is simply a derived window, i.e. contains
-	     no invisible parts, the whole thing is trivial 
+	     no invisible parts, the whole thing is trivial
 	  */
 	  wsyncup(form->w);
 	}
@@ -711,14 +711,14 @@
   untouchwin(form->w);
   return _nc_Position_Form_Cursor(form);
 }
-	
+
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static void Perform_Justification(
 |                                        FIELD  * field,
 |                                        WINDOW * win)
-|   
-|   Description   :  Output field with requested justification 
+|
+|   Description   :  Output field with requested justification
 |
 |   Return Values :  -
 +--------------------------------------------------------------------------*/
@@ -755,11 +755,11 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static void Undo_Justification(
 |                                     FIELD  * field,
 |                                     WINDOW * win)
-|   
+|
 |   Description   :  Display field without any justification, i.e.
 |                    left justified
 |
@@ -782,21 +782,21 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static bool Check_Char(
 |                                           FIELDTYPE * typ,
 |                                           int ch,
 |                                           TypeArgument *argp)
-|   
+|
 |   Description   :  Perform a single character check for character ch
-|                    according to the fieldtype instance.  
+|                    according to the fieldtype instance.
 |
 |   Return Values :  TRUE             - Character is valid
 |                    FALSE            - Character is invalid
 +--------------------------------------------------------------------------*/
 static bool Check_Char(FIELDTYPE * typ, int ch, TypeArgument *argp)
 {
-  if (typ) 
+  if (typ)
     {
       if (typ->status & _LINKED_TYPE)
 	{
@@ -804,22 +804,22 @@
 	  return(
 	    Check_Char(typ->left ,ch,argp->left ) ||
 	    Check_Char(typ->right,ch,argp->right) );
-	} 
-      else 
+	}
+      else
 	{
 	  if (typ->ccheck)
 	    return typ->ccheck(ch,(void *)argp);
 	}
     }
-  return (isprint((unsigned char)ch) ? TRUE : FALSE);
+  return (!iscntrl(UChar(ch)) ? TRUE : FALSE);
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int Display_Or_Erase_Field(
 |                                           FIELD * field,
 |                                           bool bEraseFlag)
-|   
+|
 |   Description   :  Create a subwindow for the field and display the
 |                    buffer contents (apply justification if required)
 |                    or simply erase the field.
@@ -839,7 +839,7 @@
   win  = derwin(fwin,
 		field->rows,field->cols,field->frow,field->fcol);
 
-  if (!win) 
+  if (!win)
     return E_SYSTEM_ERROR;
   else
     {
@@ -871,14 +871,14 @@
 #define Erase_Field(field)   Display_Or_Erase_Field(field,TRUE)
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int Synchronize_Field(FIELD * field)
-|   
+|
 |   Description   :  Synchronize the windows content with the value in
 |                    the buffer.
 |
 |   Return Values :  E_OK                - success
-|                    E_BAD_ARGUMENT      - invalid field pointer 
+|                    E_BAD_ARGUMENT      - invalid field pointer
 |                    E_SYSTEM_ERROR      - some severe basic error
 +--------------------------------------------------------------------------*/
 static int Synchronize_Field(FIELD * field)
@@ -893,15 +893,15 @@
       && Field_Really_Appears(field))
     {
       if (field == form->current)
-	{ 
+	{
 	  form->currow  = form->curcol = form->toprow = form->begincol = 0;
 	  werase(form->w);
-      
+
 	  if ( (field->opts & O_PUBLIC) && Justification_Allowed(field) )
 	    Undo_Justification( field, form->w );
 	  else
 	    Buffer_To_Window( field, form->w );
-	  
+
 	  field->status |= _NEWTOP;
 	  res = _nc_Refresh_Current_Field( form );
 	}
@@ -913,15 +913,15 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int Synchronize_Linked_Fields(FIELD * field)
-|   
+|
 |   Description   :  Propagate the Synchronize_Field function to all linked
 |                    fields. The first error that occurs in the sequence
 |                    of updates is the return value.
 |
 |   Return Values :  E_OK                - success
-|                    E_BAD_ARGUMENT      - invalid field pointer 
+|                    E_BAD_ARGUMENT      - invalid field pointer
 |                    E_SYSTEM_ERROR      - some severe basic error
 +--------------------------------------------------------------------------*/
 static int Synchronize_Linked_Fields(FIELD * field)
@@ -936,7 +936,7 @@
   if (!field->link)
     return(E_SYSTEM_ERROR);
 
-  for(linked_field = field->link; 
+  for(linked_field = field->link;
       linked_field!= field;
       linked_field = linked_field->link )
     {
@@ -948,12 +948,12 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  int _nc_Synchronize_Attributes(FIELD * field)
-|   
+|
 |   Description   :  If a fields visual attributes have changed, this
 |                    routine is called to propagate those changes to the
-|                    screen.  
+|                    screen.
 |
 |   Return Values :  E_OK             - success
 |                    E_BAD_ARGUMENT   - invalid field pointer
@@ -971,7 +971,7 @@
 
   if (((form=field->form) != (FORM *)0)
       && Field_Really_Appears(field))
-    {    
+    {
       if (form->current==field)
 	{
 	  Synchronize_Buffer(form);
@@ -981,12 +981,12 @@
 	    {
 	      if (Justification_Allowed(field))
 		Undo_Justification(field,form->w);
-	      else 
+	      else
 		Buffer_To_Window(field,form->w);
 	    }
-	  else 
+	  else
 	    {
-	      formwin = Get_Form_Window(form); 
+	      formwin = Get_Form_Window(form);
 	      copywin(form->w,formwin,
 		      0,0,
 		      field->frow,field->fcol,
@@ -997,7 +997,7 @@
 	      _nc_Refresh_Current_Field(form);
 	    }
 	}
-      else 
+      else
 	{
 	  res = Display_Field(field);
 	}
@@ -1006,16 +1006,16 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  int _nc_Synchronize_Options(FIELD * field,
 |                                                Field_Options newopts)
-|   
+|
 |   Description   :  If a fields options have changed, this routine is
 |                    called to propagate these changes to the screen and
 |                    to really change the behavior of the field.
 |
 |   Return Values :  E_OK                - success
-|                    E_BAD_ARGUMENT      - invalid field pointer 
+|                    E_BAD_ARGUMENT      - invalid field pointer
 |                    E_SYSTEM_ERROR      - some severe basic error
 +--------------------------------------------------------------------------*/
 NCURSES_EXPORT(int)
@@ -1096,8 +1096,8 @@
 		  Field_Really_Appears(field))
 		{
 		  res2 = Display_Field(field);
-		}	 
-	    }     
+		}
+	    }
 	}
       if (res2 != E_OK)
 	res = res2;
@@ -1107,14 +1107,14 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  int _nc_Set_Current_Field(FORM  * form,
 |                                              FIELD * newfield)
-|   
+|
 |   Description   :  Make the newfield the new current field.
 |
 |   Return Values :  E_OK                - success
-|                    E_BAD_ARGUMENT      - invalid form or field pointer 
+|                    E_BAD_ARGUMENT      - invalid form or field pointer
 |                    E_SYSTEM_ERROR      - some severe basic error
 +--------------------------------------------------------------------------*/
 NCURSES_EXPORT(int)
@@ -1134,11 +1134,11 @@
     return(E_NOT_CONNECTED);
 
   field = form->current;
- 
-  if ((field!=newfield) || 
+
+  if ((field!=newfield) ||
       !(form->status & _POSTED))
     {
-      if ((form->w) && 
+      if ((form->w) &&
 	  (field->opts & O_VISIBLE) &&
 	  (field->form->curpage == field->page))
 	{
@@ -1149,10 +1149,10 @@
 		{
 		  if (form->toprow==0)
 		    field->status &= ~_NEWTOP;
-		  else 
+		  else
 		    field->status |= _NEWTOP;
-		} 
-	      else 
+		}
+	      else
 		{
 		  if (Justification_Allowed(field))
 		    {
@@ -1166,16 +1166,16 @@
 	  delwin(form->w);
 	  form->w = (WINDOW *)0;
 	}
-      
+
       field = newfield;
 
       if (Has_Invisible_Parts(field))
 	new_window = newpad(field->drows,field->dcols);
-      else 
+      else
 	new_window = derwin(Get_Form_Window(form),
 			    field->rows,field->cols,field->frow,field->fcol);
 
-      if (!new_window) 
+      if (!new_window)
 	return(E_SYSTEM_ERROR);
 
       form->current = field;
@@ -1191,8 +1191,8 @@
 	{
 	  werase(form->w);
 	  Buffer_To_Window(field,form->w);
-	} 
-      else 
+	}
+      else
 	{
 	  if (Justification_Allowed(field))
 	    {
@@ -1208,15 +1208,15 @@
   form->currow = form->curcol = form->toprow = form->begincol = 0;
   return(E_OK);
 }
-
+
 /*----------------------------------------------------------------------------
   Intra-Field Navigation routines
   --------------------------------------------------------------------------*/
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int IFN_Next_Character(FORM * form)
-|   
+|
 |   Description   :  Move to the next character in the field. In a multi-line
 |                    field this wraps at the end of the line.
 |
@@ -1226,7 +1226,7 @@
 static int IFN_Next_Character(FORM * form)
 {
   FIELD *field = form->current;
-  
+
   if ((++(form->curcol))==field->dcols)
     {
       if ((++(form->currow))==field->drows)
@@ -1251,11 +1251,11 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int IFN_Previous_Character(FORM * form)
-|   
-|   Description   :  Move to the previous character in the field. In a 
-|                    multi-line field this wraps and the beginning of the 
+|
+|   Description   :  Move to the previous character in the field. In a
+|                    multi-line field this wraps and the beginning of the
 |                    line.
 |
 |   Return Values :  E_OK                - success
@@ -1277,9 +1277,9 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int IFN_Next_Line(FORM * form)
-|   
+|
 |   Description   :  Move to the beginning of the next line in the field
 |
 |   Return Values :  E_OK                - success
@@ -1303,9 +1303,9 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int IFN_Previous_Line(FORM * form)
-|   
+|
 |   Description   :  Move to the beginning of the previous line in the field
 |
 |   Return Values :  E_OK                - success
@@ -1323,9 +1323,9 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int IFN_Next_Word(FORM * form)
-|   
+|
 |   Description   :  Move to the beginning of the next word in the field.
 |
 |   Return Values :  E_OK             - success
@@ -1351,7 +1351,7 @@
   t = Get_Start_Of_Data(s,Buffer_Length(field) -
 			(int)(s - field->buf));
 #if !FRIENDLY_PREV_NEXT_WORD
-  if (s==t) 
+  if (s==t)
     return(E_REQUEST_DENIED);
   else
 #endif
@@ -1362,9 +1362,9 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int IFN_Previous_Word(FORM * form)
-|   
+|
 |   Description   :  Move to the beginning of the previous word in the field.
 |
 |   Return Values :  E_OK             - success
@@ -1388,14 +1388,14 @@
      the previous word! */
   if (s==bp)
     again = TRUE;
-  
+
   /* And next call now goes backward to look for the last whitespace
      before that, pointing right after this, so it points to the begin
-     of the previous word. 
+     of the previous word.
   */
   t = After_Last_Whitespace_Character(field->buf,(int)(s - field->buf));
 #if !FRIENDLY_PREV_NEXT_WORD
-  if (s==t) 
+  if (s==t)
     return(E_REQUEST_DENIED);
 #endif
   if (again)
@@ -1403,7 +1403,7 @@
       s = After_End_Of_Data(field->buf,(int)(t - field->buf));
       t = After_Last_Whitespace_Character(field->buf,(int)(s - field->buf));
 #if !FRIENDLY_PREV_NEXT_WORD
-      if (s==t) 
+      if (s==t)
 	return(E_REQUEST_DENIED);
 #endif
     }
@@ -1412,13 +1412,13 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int IFN_Beginning_Of_Field(FORM * form)
-|   
+|
 |   Description   :  Place the cursor at the first non-pad character in
-|                    the field. 
+|                    the field.
 |
-|   Return Values :  E_OK             - success            
+|   Return Values :  E_OK             - success
 +--------------------------------------------------------------------------*/
 static int IFN_Beginning_Of_Field(FORM * form)
 {
@@ -1431,12 +1431,12 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int IFN_End_Of_Field(FORM * form)
-|   
+|
 |   Description   :  Place the cursor after the last non-pad character in
 |                    the field. If the field occupies the last position in
-|                    the buffer, the cursor is positioned on the last 
+|                    the buffer, the cursor is positioned on the last
 |                    character.
 |
 |   Return Values :  E_OK              - success
@@ -1455,9 +1455,9 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int IFN_Beginning_Of_Line(FORM * form)
-|   
+|
 |   Description   :  Place the cursor on the first non-pad character in
 |                    the current line of the field.
 |
@@ -1475,11 +1475,11 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int IFN_End_Of_Line(FORM * form)
-|   
+|
 |   Description   :  Place the cursor after the last non-pad character in the
-|                    current line of the field. If the field occupies the 
+|                    current line of the field. If the field occupies the
 |                    last column in the line, the cursor is positioned on the
 |                    last character of the line.
 |
@@ -1492,7 +1492,7 @@
   char *bp;
 
   Synchronize_Buffer(form);
-  bp  = Address_Of_Current_Row_In_Buffer(form); 
+  bp  = Address_Of_Current_Row_In_Buffer(form);
   pos = After_End_Of_Data(bp,field->dcols);
   if (pos == (bp + field->dcols))
     pos--;
@@ -1501,11 +1501,11 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int IFN_Left_Character(FORM * form)
-|   
+|
 |   Description   :  Move one character to the left in the current line.
-|                    This doesn't cycle.  
+|                    This doesn't cycle.
 |
 |   Return Values :  E_OK             - success
 |                    E_REQUEST_DENIED - already in first column
@@ -1521,9 +1521,9 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int IFN_Right_Character(FORM * form)
-|   
+|
 |   Description   :  Move one character to the right in the current line.
 |                    This doesn't cycle.
 |
@@ -1546,9 +1546,9 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int IFN_Up_Character(FORM * form)
-|   
+|
 |   Description   :  Move one line up. This doesn't cycle through the lines
 |                    of the field.
 |
@@ -1566,9 +1566,9 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int IFN_Down_Character(FORM * form)
-|   
+|
 |   Description   :  Move one line down. This doesn't cycle through the
 |                    lines of the field.
 |
@@ -1591,21 +1591,21 @@
   return(E_OK);
 }
 /*----------------------------------------------------------------------------
-  END of Intra-Field Navigation routines 
+  END of Intra-Field Navigation routines
   --------------------------------------------------------------------------*/
-
+
 /*----------------------------------------------------------------------------
   Vertical scrolling helper routines
   --------------------------------------------------------------------------*/
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int VSC_Generic(FORM *form, int lines)
 |
 |   Description   :  Scroll multi-line field forward (lines>0) or
 |                    backward (lines<0) this many lines.
 |
-|   Return Values :  E_OK              - success 
+|   Return Values :  E_OK              - success
 |                    E_REQUEST_DENIED  - can't scroll
 +--------------------------------------------------------------------------*/
 static int VSC_Generic(FORM *form, int lines)
@@ -1630,7 +1630,7 @@
     {
       if (rows_to_go > form->toprow)
 	rows_to_go = form->toprow;
-      
+
       if (rows_to_go > 0)
 	{
 	  form->currow -= rows_to_go;
@@ -1643,18 +1643,18 @@
 /*----------------------------------------------------------------------------
   End of Vertical scrolling helper routines
   --------------------------------------------------------------------------*/
-
+
 /*----------------------------------------------------------------------------
   Vertical scrolling routines
   --------------------------------------------------------------------------*/
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int Vertical_Scrolling(
 |                                           int (* const fct) (FORM *),
 |                                           FORM * form)
-|   
-|   Description   :  Performs the generic vertical scrolling routines. 
+|
+|   Description   :  Performs the generic vertical scrolling routines.
 |                    This has to check for a multi-line field and to set
 |                    the _NEWTOP flag if scrolling really occurred.
 |
@@ -1674,9 +1674,9 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int VSC_Scroll_Line_Forward(FORM * form)
-|   
+|
 |   Description   :  Scroll multi-line field forward a line
 |
 |   Return Values :  E_OK                - success
@@ -1688,9 +1688,9 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int VSC_Scroll_Line_Backward(FORM * form)
-|   
+|
 |   Description   :  Scroll multi-line field backward a line
 |
 |   Return Values :  E_OK                - success
@@ -1702,9 +1702,9 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int VSC_Scroll_Page_Forward(FORM * form)
-|   
+|
 |   Description   :  Scroll a multi-line field forward a page
 |
 |   Return Values :  E_OK              - success
@@ -1716,9 +1716,9 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int VSC_Scroll_Half_Page_Forward(FORM * form)
-|   
+|
 |   Description   :  Scroll a multi-line field forward half a page
 |
 |   Return Values :  E_OK              - success
@@ -1730,9 +1730,9 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int VSC_Scroll_Page_Backward(FORM * form)
-|   
+|
 |   Description   :  Scroll a multi-line field backward a page
 |
 |   Return Values :  E_OK              - success
@@ -1744,9 +1744,9 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int VSC_Scroll_Half_Page_Backward(FORM * form)
-|   
+|
 |   Description   :  Scroll a multi-line field backward half a page
 |
 |   Return Values :  E_OK              - success
@@ -1759,19 +1759,19 @@
 /*----------------------------------------------------------------------------
   End of Vertical scrolling routines
   --------------------------------------------------------------------------*/
-
+
 /*----------------------------------------------------------------------------
   Horizontal scrolling helper routines
   --------------------------------------------------------------------------*/
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int HSC_Generic(FORM *form, int columns)
 |
 |   Description   :  Scroll single-line field forward (columns>0) or
 |                    backward (columns<0) this many columns.
 |
-|   Return Values :  E_OK              - success 
+|   Return Values :  E_OK              - success
 |                    E_REQUEST_DENIED  - can't scroll
 +--------------------------------------------------------------------------*/
 static int HSC_Generic(FORM *form, int columns)
@@ -1784,7 +1784,7 @@
     {
       if ((cols_to_go + form->begincol) > (field->dcols - field->cols))
 	cols_to_go = field->dcols - field->cols - form->begincol;
-      
+
       if (cols_to_go > 0)
 	{
 	  form->curcol   += cols_to_go;
@@ -1809,18 +1809,18 @@
 /*----------------------------------------------------------------------------
   End of Horizontal scrolling helper routines
   --------------------------------------------------------------------------*/
-
+
 /*----------------------------------------------------------------------------
   Horizontal scrolling routines
   --------------------------------------------------------------------------*/
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int Horizontal_Scrolling(
 |                                          int (* const fct) (FORM *),
 |                                          FORM * form)
-|   
-|   Description   :  Performs the generic horizontal scrolling routines. 
+|
+|   Description   :  Performs the generic horizontal scrolling routines.
 |                    This has to check for a single-line field.
 |
 |   Return Values :  Propagated error code from low-level driver calls
@@ -1834,9 +1834,9 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int HSC_Scroll_Char_Forward(FORM * form)
-|   
+|
 |   Description   :  Scroll single-line field forward a character
 |
 |   Return Values :  E_OK                - success
@@ -1848,9 +1848,9 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int HSC_Scroll_Char_Backward(FORM * form)
-|   
+|
 |   Description   :  Scroll single-line field backward a character
 |
 |   Return Values :  E_OK                - success
@@ -1862,9 +1862,9 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int HSC_Horizontal_Line_Forward(FORM* form)
-|   
+|
 |   Description   :  Scroll single-line field forward a line
 |
 |   Return Values :  E_OK                - success
@@ -1876,9 +1876,9 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int HSC_Horizontal_Half_Line_Forward(FORM* form)
-|   
+|
 |   Description   :  Scroll single-line field forward half a line
 |
 |   Return Values :  E_OK               - success
@@ -1890,9 +1890,9 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int HSC_Horizontal_Line_Backward(FORM* form)
-|   
+|
 |   Description   :  Scroll single-line field backward a line
 |
 |   Return Values :  E_OK                - success
@@ -1904,9 +1904,9 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int HSC_Horizontal_Half_Line_Backward(FORM* form)
-|   
+|
 |   Description   :  Scroll single-line field backward half a line
 |
 |   Return Values :  E_OK                - success
@@ -1920,15 +1920,15 @@
 /*----------------------------------------------------------------------------
   End of Horizontal scrolling routines
   --------------------------------------------------------------------------*/
-
+
 /*----------------------------------------------------------------------------
   Helper routines for Field Editing
   --------------------------------------------------------------------------*/
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static bool Is_There_Room_For_A_Line(FORM * form)
-|   
+|
 |   Description   :  Check whether or not there is enough room in the
 |                    buffer to enter a whole line.
 |
@@ -1939,7 +1939,7 @@
 {
   FIELD *field = form->current;
   char *begin_of_last_line, *s;
-  
+
   Synchronize_Buffer(form);
   begin_of_last_line = Address_Of_Row_In_Buffer(field,(field->drows-1));
   s  = After_End_Of_Data(begin_of_last_line,field->dcols);
@@ -1947,9 +1947,9 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static bool Is_There_Room_For_A_Char_In_Line(FORM * form)
-|   
+|
 |   Description   :  Checks whether or not there is room for a new character
 |                    in the current line.
 |
@@ -1971,27 +1971,27 @@
   !Is_There_Room_For_A_Char_In_Line(f)
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int Insert_String(
 |                                             FORM * form,
 |                                             int row,
 |                                             char *txt,
 |                                             int  len )
-|   
+|
 |   Description   :  Insert the 'len' characters beginning at pointer 'txt'
 |                    into the 'row' of the 'form'. The insertion occurs
 |                    on the beginning of the row, all other characters are
-|                    moved to the right. After the text a pad character will 
+|                    moved to the right. After the text a pad character will
 |                    be inserted to separate the text from the rest. If
 |                    necessary the insertion moves characters on the next
 |                    line to make place for the requested insertion string.
 |
-|   Return Values :  E_OK              - success 
+|   Return Values :  E_OK              - success
 |                    E_REQUEST_DENIED  -
 |                    E_SYSTEM_ERROR    - system error
 +--------------------------------------------------------------------------*/
 static int Insert_String(FORM *form, int row, char *txt, int len)
-{ 
+{
   FIELD  *field    = form->current;
   char *bp         = Address_Of_Row_In_Buffer(field,row);
   int datalen      = (int)(After_End_Of_Data(bp,field->dcols) - bp);
@@ -2017,11 +2017,11 @@
 	  if (!Field_Grown(field,1))
 	    return(E_SYSTEM_ERROR);
 	  /* !!!Side-Effect : might be changed due to growth!!! */
-	  bp = Address_Of_Row_In_Buffer(field,row); 
+	  bp = Address_Of_Row_In_Buffer(field,row);
 	}
 
-      if (row < (field->drows - 1)) 
-	{ 
+      if (row < (field->drows - 1))
+	{
 	  split = After_Last_Whitespace_Character(bp,
 		    (int)(Get_Start_Of_Data(bp + field->dcols - requiredlen ,
 					    requiredlen) - bp));
@@ -2030,7 +2030,7 @@
 	  datalen = (int)(split-bp); /* + freelen has to stay on this line   */
 	  freelen = field->dcols - (datalen + freelen); /* for the next line */
 
-	  if ((result=Insert_String(form,row+1,split,freelen))==E_OK) 
+	  if ((result=Insert_String(form,row+1,split,freelen))==E_OK)
 	    {
 	      wmove(form->w,row,datalen);
 	      wclrtoeol(form->w);
@@ -2046,10 +2046,10 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int Wrapping_Not_Necessary_Or_Wrapping_Ok(
 |                                             FORM * form)
-|   
+|
 |   Description   :  If a character has been entered into a field, it may
 |                    be that wrapping has to occur. This routine checks
 |                    whether or not wrapping is required and if so, performs
@@ -2117,17 +2117,17 @@
     result = E_OK; /* wrapping was not necessary */
   return(result);
 }
-
+
 /*----------------------------------------------------------------------------
   Field Editing routines
   --------------------------------------------------------------------------*/
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int Field_Editing(
 |                                    int (* const fct) (FORM *),
 |                                    FORM * form)
-|   
+|
 |   Description   :  Generic routine for field editing requests. The driver
 |                    routines are only called for editable fields, the
 |                    _WINDOW_MODIFIED flag is set if editing occurred.
@@ -2140,13 +2140,13 @@
 {
   int res = E_REQUEST_DENIED;
 
-  /* We have to deal here with the specific case of the overloaded 
+  /* We have to deal here with the specific case of the overloaded
      behavior of New_Line and Delete_Previous requests.
      They may end up in navigational requests if we are on the first
      character in a field. But navigation is also allowed on non-
      editable fields.
-  */ 
-  if ((fct==FE_Delete_Previous)            && 
+  */
+  if ((fct==FE_Delete_Previous)            &&
       (form->opts & O_BS_OVERLOAD)         &&
       First_Position_In_Current_Field(form) )
     {
@@ -2180,11 +2180,11 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int FE_New_Line(FORM * form)
-|   
+|
 |   Description   :  Perform a new line request. This is rather complex
-|                    compared to other routines in this code due to the 
+|                    compared to other routines in this code due to the
 |                    rather difficult to understand description in the
 |                    manuals.
 |
@@ -2197,10 +2197,10 @@
   FIELD  *field = form->current;
   char *bp, *t;
   bool Last_Row = ((field->drows - 1)==form->currow);
-  
-  if (form->status & _OVLMODE) 
+
+  if (form->status & _OVLMODE)
     {
-      if (Last_Row && 
+      if (Last_Row &&
 	  (!(Growable(field) && !Single_Line_Field(field))))
 	{
 	  if (!(form->opts & O_NL_OVERLOAD))
@@ -2214,7 +2214,7 @@
 	  form->status |= _WINDOW_MODIFIED;
 	  return Inter_Field_Navigation(FN_Next_Field,form);
 	}
-      else 
+      else
 	{
 	  if (Last_Row && !Field_Grown(field,1))
 	    { /* N.B.: due to the logic in the 'if', LastRow==TRUE
@@ -2230,7 +2230,7 @@
 	  return(E_OK);
 	}
     }
-  else 
+  else
     { /* Insert Mode */
       if (Last_Row &&
 	  !(Growable(field) && !Single_Line_Field(field)))
@@ -2239,15 +2239,15 @@
 	    return(E_REQUEST_DENIED);
 	  return Inter_Field_Navigation(FN_Next_Field,form);
 	}
-      else 
+      else
 	{
 	  bool May_Do_It = !Last_Row && Is_There_Room_For_A_Line(form);
-	  
+
 	  if (!(May_Do_It || Growable(field)))
 	    return(E_REQUEST_DENIED);
 	  if (!May_Do_It && !Field_Grown(field,1))
 	    return(E_SYSTEM_ERROR);
-	  
+
 	  bp= Address_Of_Current_Position_In_Buffer(form);
 	  t = After_End_Of_Data(bp,field->dcols - form->curcol);
 	  wmove(form->w,form->currow,form->curcol);
@@ -2264,9 +2264,9 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int FE_Insert_Character(FORM * form)
-|   
+|
 |   Description   :  Insert blank character at the cursor position
 |
 |   Return Values :  E_OK
@@ -2297,9 +2297,9 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int FE_Insert_Line(FORM * form)
-|   
+|
 |   Description   :  Insert a blank line at the cursor position
 |
 |   Return Values :  E_OK               - success
@@ -2312,7 +2312,7 @@
 
   if (Check_Char(field->type,(int)C_BLANK,(TypeArgument *)(field->arg)))
     {
-      bool Maybe_Done = (form->currow!=(field->drows-1)) && 
+      bool Maybe_Done = (form->currow!=(field->drows-1)) &&
 	                Is_There_Room_For_A_Line(form);
 
       if (!Single_Line_Field(field) &&
@@ -2332,9 +2332,9 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int FE_Delete_Character(FORM * form)
-|   
+|
 |   Description   :  Delete character at the cursor position
 |
 |   Return Values :  E_OK    - success
@@ -2347,9 +2347,9 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int FE_Delete_Previous(FORM * form)
-|   
+|
 |   Description   :  Delete character before cursor. Again this is a rather
 |                    difficult piece compared to others due to the overloading
 |                    semantics of backspace.
@@ -2362,33 +2362,33 @@
 static int FE_Delete_Previous(FORM * form)
 {
   FIELD  *field = form->current;
-  
+
   if (First_Position_In_Current_Field(form))
     return E_REQUEST_DENIED;
 
   if ( (--(form->curcol))<0 )
     {
       char *this_line, *prev_line, *prev_end, *this_end;
-      
+
       form->curcol++;
-      if (form->status & _OVLMODE) 
+      if (form->status & _OVLMODE)
 	return E_REQUEST_DENIED;
-      
+
       prev_line = Address_Of_Row_In_Buffer(field,(form->currow-1));
       this_line = Address_Of_Row_In_Buffer(field,(form->currow));
       Synchronize_Buffer(form);
       prev_end = After_End_Of_Data(prev_line,field->dcols);
       this_end = After_End_Of_Data(this_line,field->dcols);
-      if ((int)(this_end-this_line) > 
-	  (field->cols-(int)(prev_end-prev_line))) 
+      if ((int)(this_end-this_line) >
+	  (field->cols-(int)(prev_end-prev_line)))
 	return E_REQUEST_DENIED;
       wmove(form->w,form->currow,form->curcol);
       wdeleteln(form->w);
       Adjust_Cursor_Position(form,prev_end);
       wmove(form->w,form->currow,form->curcol);
       waddnstr(form->w,this_line,(int)(this_end-this_line));
-    } 
-  else 
+    }
+  else
     {
       wmove(form->w,form->currow,form->curcol);
       wdelch(form->w);
@@ -2397,9 +2397,9 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int FE_Delete_Line(FORM * form)
-|   
+|
 |   Description   :  Delete line at cursor position.
 |
 |   Return Values :  E_OK  - success
@@ -2412,9 +2412,9 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int FE_Delete_Word(FORM * form)
-|   
+|
 |   Description   :  Delete word at cursor position
 |
 |   Return Values :  E_OK               - success
@@ -2427,19 +2427,19 @@
   char   *ep = bp + field->dcols;
   char   *cp = bp + form->curcol;
   char *s;
-  
+
   Synchronize_Buffer(form);
-  if (is_blank(*cp)) 
+  if (is_blank(*cp))
     return E_REQUEST_DENIED; /* not in word */
 
   /* move cursor to begin of word and erase to end of screen-line */
   Adjust_Cursor_Position(form,
-			 After_Last_Whitespace_Character(bp,form->curcol)); 
+			 After_Last_Whitespace_Character(bp,form->curcol));
   wmove(form->w,form->currow,form->curcol);
   wclrtoeol(form->w);
 
   /* skip over word in buffer */
-  s = Get_First_Whitespace_Character(cp,(int)(ep-cp)); 
+  s = Get_First_Whitespace_Character(cp,(int)(ep-cp));
   /* to begin of next word    */
   s = Get_Start_Of_Data(s,(int)(ep - s));
   if ( (s!=cp) && !is_blank(*s))
@@ -2451,9 +2451,9 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int FE_Clear_To_End_Of_Line(FORM * form)
-|   
+|
 |   Description   :  Clear to end of current line.
 |
 |   Return Values :  E_OK   - success
@@ -2466,9 +2466,9 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int FE_Clear_To_End_Of_Field(FORM * form)
-|   
+|
 |   Description   :  Clear to end of field.
 |
 |   Return Values :  E_OK   - success
@@ -2481,9 +2481,9 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int FE_Clear_Field(FORM * form)
-|   
+|
 |   Description   :  Clear entire field.
 |
 |   Return Values :  E_OK   - success
@@ -2495,17 +2495,17 @@
   return E_OK;
 }
 /*----------------------------------------------------------------------------
-  END of Field Editing routines 
+  END of Field Editing routines
   --------------------------------------------------------------------------*/
-
+
 /*----------------------------------------------------------------------------
   Edit Mode routines
   --------------------------------------------------------------------------*/
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int EM_Overlay_Mode(FORM * form)
-|   
+|
 |   Description   :  Switch to overlay mode.
 |
 |   Return Values :  E_OK   - success
@@ -2517,9 +2517,9 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int EM_Insert_Mode(FORM * form)
-|   
+|
 |   Description   :  Switch to insert mode
 |
 |   Return Values :  E_OK   - success
@@ -2531,20 +2531,20 @@
 }
 
 /*----------------------------------------------------------------------------
-  END of Edit Mode routines 
+  END of Edit Mode routines
   --------------------------------------------------------------------------*/
-
+
 /*----------------------------------------------------------------------------
   Helper routines for Choice Requests
   --------------------------------------------------------------------------*/
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static bool Next_Choice(
 |                                            FIELDTYPE * typ,
 |                                            FIELD * field,
 |                                            TypeArgument *argp)
-|   
+|
 |   Description   :  Get the next field choice. For linked types this is
 |                    done recursively.
 |
@@ -2553,7 +2553,7 @@
 +--------------------------------------------------------------------------*/
 static bool Next_Choice(FIELDTYPE * typ, FIELD *field, TypeArgument *argp)
 {
-  if (!typ || !(typ->status & _HAS_CHOICE)) 
+  if (!typ || !(typ->status & _HAS_CHOICE))
     return FALSE;
 
   if (typ->status & _LINKED_TYPE)
@@ -2562,7 +2562,7 @@
       return(
 	     Next_Choice(typ->left ,field,argp->left) ||
 	     Next_Choice(typ->right,field,argp->right) );
-    } 
+    }
   else
     {
       assert(typ->next);
@@ -2571,12 +2571,12 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static bool Previous_Choice(
 |                                                FIELDTYPE * typ,
 |                                                FIELD * field,
 |                                                TypeArgument *argp)
-|   
+|
 |   Description   :  Get the previous field choice. For linked types this
 |                    is done recursively.
 |
@@ -2585,7 +2585,7 @@
 +--------------------------------------------------------------------------*/
 static bool Previous_Choice(FIELDTYPE *typ, FIELD *field, TypeArgument *argp)
 {
-  if (!typ || !(typ->status & _HAS_CHOICE)) 
+  if (!typ || !(typ->status & _HAS_CHOICE))
     return FALSE;
 
   if (typ->status & _LINKED_TYPE)
@@ -2594,8 +2594,8 @@
       return(
 	     Previous_Choice(typ->left ,field,argp->left) ||
 	     Previous_Choice(typ->right,field,argp->right));
-    } 
-  else 
+    }
+  else
     {
       assert(typ->prev);
       return typ->prev(field,(void *)argp);
@@ -2604,15 +2604,15 @@
 /*----------------------------------------------------------------------------
   End of Helper routines for Choice Requests
   --------------------------------------------------------------------------*/
-
+
 /*----------------------------------------------------------------------------
   Routines for Choice Requests
   --------------------------------------------------------------------------*/
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int CR_Next_Choice(FORM * form)
-|   
+|
 |   Description   :  Get the next field choice.
 |
 |   Return Values :  E_OK              - success
@@ -2622,14 +2622,14 @@
 {
   FIELD *field = form->current;
   Synchronize_Buffer(form);
-  return ((Next_Choice(field->type,field,(TypeArgument *)(field->arg))) ? 
+  return ((Next_Choice(field->type,field,(TypeArgument *)(field->arg))) ?
 	  E_OK : E_REQUEST_DENIED);
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int CR_Previous_Choice(FORM * form)
-|   
+|
 |   Description   :  Get the previous field choice.
 |
 |   Return Values :  E_OK              - success
@@ -2639,24 +2639,24 @@
 {
   FIELD *field = form->current;
   Synchronize_Buffer(form);
-  return ((Previous_Choice(field->type,field,(TypeArgument *)(field->arg))) ? 
+  return ((Previous_Choice(field->type,field,(TypeArgument *)(field->arg))) ?
 	  E_OK : E_REQUEST_DENIED);
 }
 /*----------------------------------------------------------------------------
   End of Routines for Choice Requests
   --------------------------------------------------------------------------*/
-
+
 /*----------------------------------------------------------------------------
   Helper routines for Field Validations.
   --------------------------------------------------------------------------*/
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static bool Check_Field(
 |                                            FIELDTYPE * typ,
 |                                            FIELD * field,
 |                                            TypeArgument * argp)
-|   
+|
 |   Description   :  Check the field according to its fieldtype and its
 |                    actual arguments. For linked fieldtypes this is done
 |                    recursively.
@@ -2674,18 +2674,18 @@
 	  assert(bp);
 	  while(is_blank(*bp))
 	    { bp++; }
-	  if (*bp == '\0') 
+	  if (*bp == '\0')
 	    return TRUE;
 	}
 
       if (typ->status & _LINKED_TYPE)
 	{
 	  assert(argp);
-	  return( 
+	  return(
 		 Check_Field(typ->left ,field,argp->left ) ||
 		 Check_Field(typ->right,field,argp->right) );
 	}
-      else 
+      else
 	{
 	  if (typ->fcheck)
 	    return typ->fcheck(field,(void *)argp);
@@ -2695,10 +2695,10 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  bool _nc_Internal_Validation(FORM * form )
-|   
-|   Description   :  Validate the current field of the form.  
+|
+|   Description   :  Validate the current field of the form.
 |
 |   Return Values :  TRUE  - field is valid
 |                    FALSE - field is invalid
@@ -2708,8 +2708,8 @@
 {
   FIELD *field;
 
-  field = form->current; 
-  
+  field = form->current;
+
   Synchronize_Buffer(form);
   if ((form->status & _FCHECK_REQUIRED) ||
       (!(field->opts & O_PASSOK)))
@@ -2725,15 +2725,15 @@
 /*----------------------------------------------------------------------------
   End of Helper routines for Field Validations.
   --------------------------------------------------------------------------*/
-
+
 /*----------------------------------------------------------------------------
   Routines for Field Validation.
   --------------------------------------------------------------------------*/
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int FV_Validation(FORM * form)
-|   
+|
 |   Description   :  Validate the current field of the form.
 |
 |   Return Values :  E_OK             - field valid
@@ -2749,16 +2749,16 @@
 /*----------------------------------------------------------------------------
   End of routines for Field Validation.
   --------------------------------------------------------------------------*/
-
+
 /*----------------------------------------------------------------------------
   Helper routines for Inter-Field Navigation
   --------------------------------------------------------------------------*/
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static FIELD *Next_Field_On_Page(FIELD * field)
-|   
-|   Description   :  Get the next field after the given field on the current 
+|
+|   Description   :  Get the next field after the given field on the current
 |                    page. The order of fields is the one defined by the
 |                    fields array. Only visible and active fields are
 |                    counted.
@@ -2774,18 +2774,18 @@
 
   do
     {
-      field_on_page = 
+      field_on_page =
 	(field_on_page==last_on_page) ? first_on_page : field_on_page + 1;
       if (Field_Is_Selectable(*field_on_page))
 	break;
-    } while(field!=(*field_on_page));  
+    } while(field!=(*field_on_page));
   return(*field_on_page);
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  FIELD* _nc_First_Active_Field(FORM * form)
-|   
+|
 |   Description   :  Get the first active field on the current page,
 |                    if there are such. If there are none, get the first
 |                    visible field on the page. If there are also none,
@@ -2800,7 +2800,7 @@
   FIELD *proposed = Next_Field_On_Page(*last_on_page);
 
   if (proposed == *last_on_page)
-    { /* there might be the special situation, where there is no 
+    { /* there might be the special situation, where there is no
 	 active and visible field on the current page. We then select
 	 the first visible field on this readonly page
       */
@@ -2815,12 +2815,12 @@
 	      if (((*field)->opts & O_VISIBLE))
 		break;
 	    } while(proposed!=(*field));
-	  
+
 	  proposed = *field;
 
 	  if ((proposed == *last_on_page) && !(proposed->opts&O_VISIBLE))
 	    { /* This means, there is also no visible field on the page.
-		 So we propose the first one and hope the very best... 
+		 So we propose the first one and hope the very best...
 		 Some very clever user has designed a readonly and invisible
 		 page on this form.
 	       */
@@ -2832,11 +2832,11 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static FIELD *Previous_Field_On_Page(FIELD * field)
-|   
-|   Description   :  Get the previous field before the given field on the 
-|                    current page. The order of fields is the one defined by 
+|
+|   Description   :  Get the previous field before the given field on the
+|                    current page. The order of fields is the one defined by
 |                    the fields array. Only visible and active fields are
 |                    counted.
 |
@@ -2848,23 +2848,23 @@
   FIELD **field_on_page = &form->field[field->index];
   FIELD **first_on_page = &form->field[form->page[form->curpage].pmin];
   FIELD **last_on_page  = &form->field[form->page[form->curpage].pmax];
-  
+
   do
     {
-      field_on_page = 
+      field_on_page =
 	(field_on_page==first_on_page) ? last_on_page : field_on_page - 1;
       if (Field_Is_Selectable(*field_on_page))
 	break;
     } while(field!=(*field_on_page));
-  
+
   return (*field_on_page);
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static FIELD *Sorted_Next_Field(FIELD * field)
-|   
-|   Description   :  Get the next field after the given field on the current 
+|
+|   Description   :  Get the next field after the given field on the current
 |                    page. The order of fields is the one defined by the
 |                    (row,column) geometry, rows are major.
 |
@@ -2880,16 +2880,16 @@
       if (Field_Is_Selectable(field_on_page))
 	break;
     } while(field_on_page!=field);
-  
+
   return (field_on_page);
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static FIELD *Sorted_Previous_Field(FIELD * field)
-|   
-|   Description   :  Get the previous field before the given field on the 
-|                    current page. The order of fields is the one defined 
+|
+|   Description   :  Get the previous field before the given field on the
+|                    current page. The order of fields is the one defined
 |                    by the (row,column) geometry, rows are major.
 |
 |   Return Values :  Pointer to the previous field.
@@ -2904,14 +2904,14 @@
       if (Field_Is_Selectable(field_on_page))
 	break;
     } while(field_on_page!=field);
-  
+
   return (field_on_page);
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static FIELD *Left_Neighbor_Field(FIELD * field)
-|   
+|
 |   Description   :  Get the left neighbor of the field on the same line
 |                    and the same page. Cycles through the line.
 |
@@ -2930,14 +2930,14 @@
     {
       field_on_page = Sorted_Previous_Field(field_on_page);
     } while(field_on_page->frow != field->frow);
-  
+
   return (field_on_page);
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static FIELD *Right_Neighbor_Field(FIELD * field)
-|   
+|
 |   Description   :  Get the right neighbor of the field on the same line
 |                    and the same page.
 |
@@ -2952,14 +2952,14 @@
     {
       field_on_page = Sorted_Next_Field(field_on_page);
     } while(field_on_page->frow != field->frow);
-  
+
   return (field_on_page);
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static FIELD *Upper_Neighbor_Field(FIELD * field)
-|   
+|
 |   Description   :  Because of the row-major nature of sorting the fields,
 |                    it is more difficult to define whats the upper neighbor
 |                    field really means. We define that it must be on a
@@ -2983,30 +2983,30 @@
     {
       field_on_page = Sorted_Previous_Field(field_on_page);
     } while(field_on_page->frow==frow && field_on_page->fcol!=fcol);
-  
+
   if (field_on_page->frow!=frow)
     { /* We really found a 'previous' line. We are positioned at the
          rightmost field on this line */
-      frow = field_on_page->frow; 
+      frow = field_on_page->frow;
 
-      /* We walk to the left as long as we are really right of the 
+      /* We walk to the left as long as we are really right of the
 	 field. */
       while(field_on_page->frow==frow && field_on_page->fcol>fcol)
 	field_on_page = Sorted_Previous_Field(field_on_page);
 
-      /* If we wrapped, just go to the right which is the first field on 
+      /* If we wrapped, just go to the right which is the first field on
 	 the row */
       if (field_on_page->frow!=frow)
 	field_on_page = Sorted_Next_Field(field_on_page);
     }
-  
+
   return (field_on_page);
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static FIELD *Down_Neighbor_Field(FIELD * field)
-|   
+|
 |   Description   :  Because of the row-major nature of sorting the fields,
 |                    its more difficult to define whats the down neighbor
 |                    field really means. We define that it must be on a
@@ -3036,30 +3036,30 @@
          field on this line */
       frow = field_on_page->frow;
 
-      /* We walk to the right as long as we are really left of the 
+      /* We walk to the right as long as we are really left of the
 	 field. */
       while(field_on_page->frow==frow && field_on_page->fcol<fcol)
 	field_on_page = Sorted_Next_Field(field_on_page);
 
-      /* If we wrapped, just go to the left which is the last field on 
+      /* If we wrapped, just go to the left which is the last field on
 	 the row */
       if (field_on_page->frow!=frow)
 	field_on_page = Sorted_Previous_Field(field_on_page);
     }
-  
+
   return(field_on_page);
 }
-
+
 /*----------------------------------------------------------------------------
   Inter-Field Navigation routines
   --------------------------------------------------------------------------*/
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int Inter_Field_Navigation(
 |                                           int (* const fct) (FORM *),
 |                                           FORM * form)
-|   
+|
 |   Description   :  Generic behavior for changing the current field, the
 |                    field is left and a new field is entered. So the field
 |                    must be validated and the field init/term hooks must
@@ -3073,7 +3073,7 @@
 {
   int res;
 
-  if (!_nc_Internal_Validation(form)) 
+  if (!_nc_Internal_Validation(form))
     res = E_INVALID_FIELD;
   else
     {
@@ -3085,9 +3085,9 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int FN_Next_Field(FORM * form)
-|   
+|
 |   Description   :  Move to the next field on the current page of the form
 |
 |   Return Values :  E_OK                 - success
@@ -3100,10 +3100,10 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int FN_Previous_Field(FORM * form)
-|   
-|   Description   :  Move to the previous field on the current page of the 
+|
+|   Description   :  Move to the previous field on the current page of the
 |                    form
 |
 |   Return Values :  E_OK                 - success
@@ -3116,9 +3116,9 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int FN_First_Field(FORM * form)
-|   
+|
 |   Description   :  Move to the first field on the current page of the form
 |
 |   Return Values :  E_OK                 - success
@@ -3131,9 +3131,9 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int FN_Last_Field(FORM * form)
-|   
+|
 |   Description   :  Move to the last field on the current page of the form
 |
 |   Return Values :  E_OK                 - success
@@ -3141,15 +3141,15 @@
 +--------------------------------------------------------------------------*/
 static int FN_Last_Field(FORM * form)
 {
-  return 
+  return
     _nc_Set_Current_Field(form,
        Previous_Field_On_Page(form->field[form->page[form->curpage].pmin]));
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int FN_Sorted_Next_Field(FORM * form)
-|   
+|
 |   Description   :  Move to the sorted next field on the current page
 |                    of the form.
 |
@@ -3163,9 +3163,9 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int FN_Sorted_Previous_Field(FORM * form)
-|   
+|
 |   Description   :  Move to the sorted previous field on the current page
 |                    of the form.
 |
@@ -3179,9 +3179,9 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int FN_Sorted_First_Field(FORM * form)
-|   
+|
 |   Description   :  Move to the sorted first field on the current page
 |                    of the form.
 |
@@ -3195,9 +3195,9 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int FN_Sorted_Last_Field(FORM * form)
-|   
+|
 |   Description   :  Move to the sorted last field on the current page
 |                    of the form.
 |
@@ -3211,9 +3211,9 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int FN_Left_Field(FORM * form)
-|   
+|
 |   Description   :  Get the field on the left of the current field on the
 |                    same line and the same page. Cycles through the line.
 |
@@ -3227,9 +3227,9 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int FN_Right_Field(FORM * form)
-|   
+|
 |   Description   :  Get the field on the right of the current field on the
 |                    same line and the same page. Cycles through the line.
 |
@@ -3243,13 +3243,13 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int FN_Up_Field(FORM * form)
-|   
+|
 |   Description   :  Get the upper neighbor of the current field. This
 |                    cycles through the page. See the comments of the
 |                    Upper_Neighbor_Field function to understand how
-|                    'upper' is defined. 
+|                    'upper' is defined.
 |
 |   Return Values :  E_OK            - success
 |                    != E_OK         - error from subordinate call
@@ -3261,13 +3261,13 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int FN_Down_Field(FORM * form)
-|   
+|
 |   Description   :  Get the down neighbor of the current field. This
 |                    cycles through the page. See the comments of the
 |                    Down_Neighbor_Field function to understand how
-|                    'down' is defined. 
+|                    'down' is defined.
 |
 |   Return Values :  E_OK            - success
 |                    != E_OK         - error from subordinate call
@@ -3278,19 +3278,19 @@
 			       Down_Neighbor_Field(form->current));
 }
 /*----------------------------------------------------------------------------
-  END of Field Navigation routines 
+  END of Field Navigation routines
   --------------------------------------------------------------------------*/
-
+
 /*----------------------------------------------------------------------------
   Helper routines for Page Navigation
   --------------------------------------------------------------------------*/
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  int _nc_Set_Form_Page(FORM * form,
 |                                          int page,
 |                                          FIELD * field)
-|   
+|
 |   Description   :  Make the given page number the current page and make
 |                    the given field the current field on the page. If
 |                    for the field NULL is given, make the first field on
@@ -3316,7 +3316,7 @@
       do
 	{
 	  if (field_on_page->opts & O_VISIBLE)
-	    if ((res=Display_Field(field_on_page))!=E_OK) 
+	    if ((res=Display_Field(field_on_page))!=E_OK)
 	      return(res);
 	  field_on_page = field_on_page->snext;
 	} while(field_on_page != last_field);
@@ -3326,7 +3326,7 @@
       else
 	/* N.B.: we don't encapsulate this by Inter_Field_Navigation(),
 	   because this is already executed in a page navigation
-	   context that contains field navigation 
+	   context that contains field navigation
 	 */
 	res = FN_First_Field(form);
     }
@@ -3334,12 +3334,12 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int Next_Page_Number(const FORM * form)
-|   
+|
 |   Description   :  Calculate the page number following the current page
 |                    number. This cycles if the highest page number is
-|                    reached.  
+|                    reached.
 |
 |   Return Values :  The next page number
 +--------------------------------------------------------------------------*/
@@ -3349,12 +3349,12 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int Previous_Page_Number(const FORM * form)
-|   
+|
 |   Description   :  Calculate the page number before the current page
 |                    number. This cycles if the first page number is
-|                    reached.  
+|                    reached.
 |
 |   Return Values :  The previous page number
 +--------------------------------------------------------------------------*/
@@ -3362,17 +3362,17 @@
 {
   return (form->curpage!=0 ? form->curpage - 1 : form->maxpage - 1);
 }
-
+
 /*----------------------------------------------------------------------------
-  Page Navigation routines 
+  Page Navigation routines
   --------------------------------------------------------------------------*/
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int Page_Navigation(
 |                                               int (* const fct) (FORM *),
 |                                               FORM * form)
-|   
+|
 |   Description   :  Generic behavior for changing a page. This means
 |                    that the field is left and a new field is entered.
 |                    So the field must be validated and the field init/term
@@ -3387,7 +3387,7 @@
 {
   int res;
 
-  if (!_nc_Internal_Validation(form)) 
+  if (!_nc_Internal_Validation(form))
     res = E_INVALID_FIELD;
   else
     {
@@ -3401,23 +3401,23 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int PN_Next_Page(FORM * form)
-|   
+|
 |   Description   :  Move to the next page of the form
 |
 |   Return Values :  E_OK                - success
 |                    != E_OK             - error from subordinate call
 +--------------------------------------------------------------------------*/
 static int PN_Next_Page(FORM * form)
-{ 
+{
   return _nc_Set_Form_Page(form,Next_Page_Number(form),(FIELD *)0);
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int PN_Previous_Page(FORM * form)
-|   
+|
 |   Description   :  Move to the previous page of the form
 |
 |   Return Values :  E_OK              - success
@@ -3429,9 +3429,9 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int PN_First_Page(FORM * form)
-|   
+|
 |   Description   :  Move to the first page of the form
 |
 |   Return Values :  E_OK              - success
@@ -3443,9 +3443,9 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int PN_Last_Page(FORM * form)
-|   
+|
 |   Description   :  Move to the last page of the form
 |
 |   Return Values :  E_OK              - success
@@ -3456,17 +3456,17 @@
   return _nc_Set_Form_Page(form,form->maxpage-1,(FIELD *)0);
 }
 /*----------------------------------------------------------------------------
-  END of Field Navigation routines 
+  END of Field Navigation routines
   --------------------------------------------------------------------------*/
-
+
 /*----------------------------------------------------------------------------
   Helper routines for the core form driver.
   --------------------------------------------------------------------------*/
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static int Data_Entry(FORM * form,int c)
-|   
+|
 |   Description   :  Enter character c into at the current position of the
 |                    current field of the form.
 |
@@ -3479,23 +3479,23 @@
   FIELD  *field = form->current;
   int result = E_REQUEST_DENIED;
 
-  if ( (field->opts & O_EDIT) 
+  if ( (field->opts & O_EDIT)
 #if FIX_FORM_INACTIVE_BUG
-       && (field->opts & O_ACTIVE) 
+       && (field->opts & O_ACTIVE)
 #endif
        )
     {
       if ( (field->opts & O_BLANK) &&
 	   First_Position_In_Current_Field(form) &&
-	   !(form->status & _FCHECK_REQUIRED) && 
+	   !(form->status & _FCHECK_REQUIRED) &&
 	   !(form->status & _WINDOW_MODIFIED) )
 	werase(form->w);
 
       if (form->status & _OVLMODE)
 	{
 	  waddch(form->w,(chtype)c);
-	} 
-      else /* no _OVLMODE */ 
+	}
+      else /* no _OVLMODE */
 	{
 	  bool There_Is_Room = Is_There_Room_For_A_Char_In_Line(form);
 
@@ -3530,12 +3530,12 @@
     }
   return result;
 }
-
+
 /* Structure to describe the binding of a request code to a function.
    The member keycode codes the request value as well as the generic
    routine to use for the request. The code for the generic routine
    is coded in the upper 16 Bits while the request code is coded in
-   the lower 16 bits. 
+   the lower 16 bits.
 
    In terms of C++ you might think of a request as a class with a
    virtual method "perform". The different types of request are
@@ -3562,13 +3562,13 @@
 #define ID_Shft  (16)
 
 /* This array holds all the Binding Infos */
-static const Binding_Info bindings[MAX_FORM_COMMAND - MIN_FORM_COMMAND + 1] = 
+static const Binding_Info bindings[MAX_FORM_COMMAND - MIN_FORM_COMMAND + 1] =
 {
   { REQ_NEXT_PAGE    |ID_PN  ,PN_Next_Page},
   { REQ_PREV_PAGE    |ID_PN  ,PN_Previous_Page},
   { REQ_FIRST_PAGE   |ID_PN  ,PN_First_Page},
   { REQ_LAST_PAGE    |ID_PN  ,PN_Last_Page},
-  
+
   { REQ_NEXT_FIELD   |ID_FN  ,FN_Next_Field},
   { REQ_PREV_FIELD   |ID_FN  ,FN_Previous_Field},
   { REQ_FIRST_FIELD  |ID_FN  ,FN_First_Field},
@@ -3581,7 +3581,7 @@
   { REQ_RIGHT_FIELD  |ID_FN  ,FN_Right_Field},
   { REQ_UP_FIELD     |ID_FN  ,FN_Up_Field},
   { REQ_DOWN_FIELD   |ID_FN  ,FN_Down_Field},
-  
+
   { REQ_NEXT_CHAR    |ID_IFN ,IFN_Next_Character},
   { REQ_PREV_CHAR    |ID_IFN ,IFN_Previous_Character},
   { REQ_NEXT_LINE    |ID_IFN ,IFN_Next_Line},
@@ -3596,7 +3596,7 @@
   { REQ_RIGHT_CHAR   |ID_IFN ,IFN_Right_Character},
   { REQ_UP_CHAR      |ID_IFN ,IFN_Up_Character},
   { REQ_DOWN_CHAR    |ID_IFN ,IFN_Down_Character},
-  
+
   { REQ_NEW_LINE     |ID_FE  ,FE_New_Line},
   { REQ_INS_CHAR     |ID_FE  ,FE_Insert_Character},
   { REQ_INS_LINE     |ID_FE  ,FE_Insert_Line},
@@ -3607,24 +3607,24 @@
   { REQ_CLR_EOL      |ID_FE  ,FE_Clear_To_End_Of_Line},
   { REQ_CLR_EOF      |ID_FE  ,FE_Clear_To_End_Of_Field},
   { REQ_CLR_FIELD    |ID_FE  ,FE_Clear_Field},
-  
+
   { REQ_OVL_MODE     |ID_EM  ,EM_Overlay_Mode},
   { REQ_INS_MODE     |ID_EM  ,EM_Insert_Mode},
-  
+
   { REQ_SCR_FLINE    |ID_VSC ,VSC_Scroll_Line_Forward},
   { REQ_SCR_BLINE    |ID_VSC ,VSC_Scroll_Line_Backward},
   { REQ_SCR_FPAGE    |ID_VSC ,VSC_Scroll_Page_Forward},
   { REQ_SCR_BPAGE    |ID_VSC ,VSC_Scroll_Page_Backward},
   { REQ_SCR_FHPAGE   |ID_VSC ,VSC_Scroll_Half_Page_Forward},
   { REQ_SCR_BHPAGE   |ID_VSC ,VSC_Scroll_Half_Page_Backward},
-  
+
   { REQ_SCR_FCHAR    |ID_HSC ,HSC_Scroll_Char_Forward},
   { REQ_SCR_BCHAR    |ID_HSC ,HSC_Scroll_Char_Backward},
   { REQ_SCR_HFLINE   |ID_HSC ,HSC_Horizontal_Line_Forward},
   { REQ_SCR_HBLINE   |ID_HSC ,HSC_Horizontal_Line_Backward},
   { REQ_SCR_HFHALF   |ID_HSC ,HSC_Horizontal_Half_Line_Forward},
   { REQ_SCR_HBHALF   |ID_HSC ,HSC_Horizontal_Half_Line_Backward},
-  
+
   { REQ_VALIDATION   |ID_FV  ,FV_Validation},
 
   { REQ_NEXT_CHOICE  |ID_CH  ,CR_Next_Choice},
@@ -3632,9 +3632,9 @@
 };
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  int form_driver(FORM * form,int  c)
-|   
+|
 |   Description   :  This is the workhorse of the forms system. It checks
 |                    to determine whether the character c is a request or
 |                    data. If it is a request, the form driver executes
@@ -3666,34 +3666,34 @@
 
   if (!(form->field))
     RETURN(E_NOT_CONNECTED);
-  
+
   assert(form->page);
-  
+
   if (c==FIRST_ACTIVE_MAGIC)
     {
       form->current = _nc_First_Active_Field(form);
       return E_OK;
     }
-  
-  assert(form->current && 
-	 form->current->buf && 
+
+  assert(form->current &&
+	 form->current->buf &&
 	 (form->current->form == form)
 	);
-  
+
   if ( form->status & _IN_DRIVER )
     RETURN(E_BAD_STATE);
 
-  if ( !( form->status & _POSTED ) ) 
+  if ( !( form->status & _POSTED ) )
     RETURN(E_NOT_POSTED);
-  
+
   if ((c>=MIN_FORM_COMMAND && c<=MAX_FORM_COMMAND) &&
       ((bindings[c-MIN_FORM_COMMAND].keycode & Key_Mask) == c))
     BI = &(bindings[c-MIN_FORM_COMMAND]);
-  
+
   if (BI)
     {
       typedef int (*Generic_Method)(int (* const)(FORM *),FORM *);
-      static const Generic_Method Generic_Methods[] = 
+      static const Generic_Method Generic_Methods[] =
 	{
 	  Page_Navigation,         /* overloaded to call field&form hooks */
 	  Inter_Field_Navigation,  /* overloaded to call field hooks      */
@@ -3707,7 +3707,7 @@
 	};
       size_t nMethods = (sizeof(Generic_Methods)/sizeof(Generic_Methods[0]));
       size_t method   = ((BI->keycode & ID_Mask) >> ID_Shft) & 0xffff;
-      
+
       if ( (method >= nMethods) || !(BI->cmd) )
 	res = E_SYSTEM_ERROR;
       else
@@ -3718,46 +3718,56 @@
 	  else
 	    res = (BI->cmd)(form);
 	}
-    } 
-  else 
+    }
+  else if (!(c & (~(int)MAX_REGULAR_CHARACTER)))
     {
-      if (!(c & (~(int)MAX_REGULAR_CHARACTER)) &&
-	  isprint((unsigned char)c) &&                      
+      /*
+       * If we're using 8-bit characters, iscntrl+isprint cover the whole set.
+       * But with multibyte characters, there is a third possibility, i.e.,
+       * parts of characters that build up into printable characters which are
+       * not considered printable.
+       *
+       * FIXME: the wide-character branch should also use Check_Char().
+       */
+#if USE_WIDEC_SUPPORT
+      if (!iscntrl(UChar(c)))
+#else
+      if (isprint(UChar(c)) &&
 	  Check_Char(form->current->type,c,
 		     (TypeArgument *)(form->current->arg)))
+#endif
 	res = Data_Entry(form,c);
     }
   _nc_Refresh_Current_Field(form);
   RETURN(res);
 }
-
+
 /*----------------------------------------------------------------------------
   Field-Buffer manipulation routines.
-  The effects of setting a buffer is tightly coupled to the core of the form
+  The effects of setting a buffer are tightly coupled to the core of the form
   driver logic. This is especially true in the case of growable fields.
-  So I don't separate this into an own module. 
+  So I don't separate this into a separate module.
   --------------------------------------------------------------------------*/
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  int set_field_buffer(FIELD *field,
 |                                         int buffer, char *value)
-|   
+|
 |   Description   :  Set the given buffer of the field to the given value.
 |                    Buffer 0 stores the displayed content of the field.
 |                    For dynamic fields this may grow the fieldbuffers if
 |                    the length of the value exceeds the current buffer
 |                    length. For buffer 0 only printable values are allowed.
 |                    For static fields, the value needs not to be zero ter-
-|                    minated. It is copied up to the length of the buffer.   
+|                    minated. It is copied up to the length of the buffer.
 |
 |   Return Values :  E_OK            - success
 |                    E_BAD_ARGUMENT  - invalid argument
 |                    E_SYSTEM_ERROR  - system error
 +--------------------------------------------------------------------------*/
 NCURSES_EXPORT(int)
-set_field_buffer
-(FIELD * field, int buffer, const char * value)
+set_field_buffer (FIELD * field, int buffer, const char * value)
 {
   char *s, *p;
   int res = E_OK;
@@ -3775,7 +3785,7 @@
 
       for(v=value; *v && (i<len); v++,i++)
 	{
-	  if (!isprint((unsigned char)*v))
+	  if (iscntrl(UChar(*v)))
 	    RETURN(E_BAD_ARGUMENT);
 	}
     }
@@ -3797,15 +3807,15 @@
 	  if (buffer==0)
 	    {
 	      unsigned int i;
-	  
+
 	      for(i=len; i<vlen; i++)
-		if (!isprint((unsigned char)value[i]))
+		if (iscntrl(UChar(value[i])))
 		  RETURN(E_BAD_ARGUMENT);
 	    }
 	  len = vlen;
 	}
     }
-  
+
   p   = Address_Of_Nth_Buffer(field,buffer);
 
 #if HAVE_MEMCCPY
@@ -3818,11 +3828,11 @@
       p[s-value] = *s++;
       s = p + (s-value);
     }
-  else 
+  else
     s=(char *)0;
 #endif
 
-  if (s) 
+  if (s)
     { /* this means, value was null terminated and not greater than the
 	 buffer. We have to pad with blanks. Please note that due to memccpy
 	 logic s points after the terminating null. */
@@ -3835,7 +3845,7 @@
   if (buffer==0)
     {
       int syncres;
-      if (((syncres=Synchronize_Field( field ))!=E_OK) && 
+      if (((syncres=Synchronize_Field( field ))!=E_OK) &&
 	  (res==E_OK))
 	res = syncres;
       if (((syncres=Synchronize_Linked_Fields(field ))!=E_OK) &&
@@ -3843,12 +3853,12 @@
 	res = syncres;
     }
   RETURN(res);
-}		
+}
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  char *field_buffer(const FIELD *field,int buffer)
-|   
+|
 |   Description   :  Return the address of the buffer for the field.
 |
 |   Return Values :  Pointer to buffer or NULL if arguments were invalid.
@@ -3862,4 +3872,95 @@
     return (char *)0;
 }
 
+#if USE_WIDEC_SUPPORT
+
+/* FIXME: see lib_get_wch.c */
+#if HAVE_MBTOWC && HAVE_MBLEN
+#define reset_mbytes(state) mblen(NULL, 0), mbtowc(NULL, NULL, 0)
+#define count_mbytes(buffer,length,state) mblen(buffer,length)
+#define trans_mbytes(wch,buffer,length,state) \
+	(int) mbtowc(&wch, buffer, length)
+#elif HAVE_MBRTOWC && HAVE_MBRLEN
+#define reset_mbytes(state) memset(&state, 0, sizeof(state))
+#define count_mbytes(buffer,length,state) mbrlen(buffer,length,&state)
+#define trans_mbytes(wch,buffer,length,state) \
+	(int) mbrtowc(&wch, buffer, length, &state)
+#else
+make an error
+#endif
+
+/*---------------------------------------------------------------------------
+| Convert a multibyte string to a wide-character string.  The result must be
+| freed by the caller.
++--------------------------------------------------------------------------*/
+NCURSES_EXPORT(wchar_t *)
+_nc_Widen_String(char *source, int *lengthp)
+{
+  wchar_t *result = 0;
+  wchar_t wch;
+  mbstate_t state;
+  size_t given = strlen(source);
+  size_t try;
+  int pass;
+  int status;
+
+  for (pass = 0; pass < 2; ++pass)
+    {
+      int need = 0;
+      size_t passed = 0;
+
+      while (passed < given)
+	{
+	  bool found = FALSE;
+
+	  for (try = 1, status = 0; try < (given - passed); ++try)
+	    {
+	      int save = source[passed + try];
+
+	      source[passed + try] = 0;
+	      reset_mbytes(state);
+	      status = trans_mbytes(wch, source + passed, try, state);
+	      source[passed + try] = save;
+
+	      if (status > 0)
+		{
+		  found = TRUE;
+		  break;
+		}
+	    }
+	  if (found)
+	    {
+	      if (pass)
+		{
+		  result[need] = wch;
+		}
+	      passed += status;
+	      ++need;
+	    }
+	  else
+	    {
+	      if (pass)
+		{
+		  result[need] = source[passed];
+		}
+	      ++need;
+	      ++passed;
+	    }
+	}
+
+      if (!pass)
+	{
+	  if (!need)
+	    break;
+	  result = calloc(need, sizeof(*result));
+	  *lengthp = need;
+	  if (result == 0)
+	    break;
+	}
+    }
+
+  return result;
+}
+#endif
+
 /* frm_driver.c ends here */
Index: form/fty_alnum.c
Prereq:  1.12 
--- ncurses-5.4-20040208/form/fty_alnum.c	2003-10-25 10:54:48.000000000 -0400
+++ ncurses-5.4-20040424/form/fty_alnum.c	2004-04-03 18:00:47.000000000 -0500
@@ -13,16 +13,16 @@
 
 #include "form.priv.h"
 
-MODULE_ID("$Id: fty_alnum.c,v 1.12 2003/10/25 14:54:48 tom Exp $")
+MODULE_ID("$Id: fty_alnum.c,v 1.13 2004/04/03 23:00:47 tom Exp $")
 
 typedef struct {
   int width;
 } alnumARG;
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static void *Make_AlphaNumeric_Type(va_list *ap)
-|   
+|
 |   Description   :  Allocate structure for alphanumeric type argument.
 |
 |   Return Values :  Pointer to argument structure or NULL on error
@@ -38,10 +38,10 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static void *Copy_AlphaNumericType(const void *argp)
-|   
-|   Description   :  Copy structure for alphanumeric type argument.  
+|
+|   Description   :  Copy structure for alphanumeric type argument.
 |
 |   Return Values :  Pointer to argument structure or NULL on error.
 +--------------------------------------------------------------------------*/
@@ -57,25 +57,25 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static void Free_AlphaNumeric_Type(void *argp)
-|   
+|
 |   Description   :  Free structure for alphanumeric type argument.
 |
 |   Return Values :  -
 +--------------------------------------------------------------------------*/
 static void Free_AlphaNumeric_Type(void * argp)
 {
-  if (argp) 
+  if (argp)
     free(argp);
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static bool Check_AlphaNumeric_Field(
 |                                      FIELD *field,
 |                                      const void *argp)
-|   
+|
 |   Description   :  Validate buffer content to be a valid alphanumeric value
 |
 |   Return Values :  TRUE  - field is valid
@@ -88,26 +88,26 @@
   int  l = -1;
   unsigned char *s;
 
-  while(*bp && *bp==' ') 
+  while(*bp && *bp==' ')
     bp++;
   if (*bp)
     {
       s = bp;
-      while(*bp && isalnum(*bp)) 
+      while(*bp && isalnum(UChar(*bp)))
 	bp++;
       l = (int)(bp-s);
-      while(*bp && *bp==' ') 
+      while(*bp && *bp==' ')
 	bp++;
     }
   return ((*bp || (l < width)) ? FALSE : TRUE);
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static bool Check_AlphaNumeric_Character(
-|                                      int c, 
+|                                      int c,
 |                                      const void *argp )
-|   
+|
 |   Description   :  Check a character for the alphanumeric type.
 |
 |   Return Values :  TRUE  - character is valid
@@ -115,7 +115,7 @@
 +--------------------------------------------------------------------------*/
 static bool Check_AlphaNumeric_Character(int c, const void * argp GCC_UNUSED)
 {
-  return (isalnum(c) ? TRUE : FALSE);
+  return (isalnum(UChar(c)) ? TRUE : FALSE);
 }
 
 static FIELDTYPE typeALNUM = {
Index: form/fty_alpha.c
Prereq:  1.12 
--- ncurses-5.4-20040208/form/fty_alpha.c	2003-10-25 10:54:48.000000000 -0400
+++ ncurses-5.4-20040424/form/fty_alpha.c	2004-04-03 18:00:47.000000000 -0500
@@ -13,43 +13,48 @@
 
 #include "form.priv.h"
 
-MODULE_ID("$Id: fty_alpha.c,v 1.12 2003/10/25 14:54:48 tom Exp $")
+MODULE_ID("$Id: fty_alpha.c,v 1.14 2004/04/03 23:00:47 tom Exp $")
 
-typedef struct {
-  int width;
-} alphaARG;
+typedef struct
+  {
+    int width;
+  }
+alphaARG;
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static void *Make_Alpha_Type(va_list *ap)
-|   
+|
 |   Description   :  Allocate structure for alpha type argument.
 |
 |   Return Values :  Pointer to argument structure or NULL on error
 +--------------------------------------------------------------------------*/
-static void *Make_Alpha_Type(va_list * ap)
+static void *
+Make_Alpha_Type(va_list *ap)
 {
-  alphaARG *argp = (alphaARG *)malloc(sizeof(alphaARG));
+  alphaARG *argp = (alphaARG *) malloc(sizeof(alphaARG));
+
   if (argp)
     {
-      argp->width = va_arg(*ap,int);
+      argp->width = va_arg(*ap, int);
     }
   return ((void *)argp);
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static void *Copy_Alpha_Type(const void * argp)
-|   
-|   Description   :  Copy structure for alpha type argument.  
+|
+|   Description   :  Copy structure for alpha type argument.
 |
 |   Return Values :  Pointer to argument structure or NULL on error.
 +--------------------------------------------------------------------------*/
-static void *Copy_Alpha_Type(const void * argp)
+static void *
+Copy_Alpha_Type(const void *argp)
 {
   const alphaARG *ap = (const alphaARG *)argp;
-  alphaARG *result = (alphaARG *)malloc(sizeof(alphaARG));
-  
+  alphaARG *result = (alphaARG *) malloc(sizeof(alphaARG));
+
   if (result)
     {
       *result = *ap;
@@ -58,70 +63,113 @@
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
 |   Function      :  static void Free_Alpha_Type( void * argp )
-|   
+|
 |   Description   :  Free structure for alpha type argument.
 |
 |   Return Values :  -
 +--------------------------------------------------------------------------*/
-static void Free_Alpha_Type(void * argp)
+static void
+Free_Alpha_Type(void *argp)
 {
-  if (argp) 
+  if (argp)
     free(argp);
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnform  
+|   Facility      :  libnform
+|   Function      :  static bool Check_Alpha_Character(
+|                                      int c,
+|                                      const void * argp)
+|
+|   Description   :  Check a character for the alpha type.
+|
+|   Return Values :  TRUE  - character is valid
+|                    FALSE - character is invalid
++--------------------------------------------------------------------------*/
+static bool
+Check_Alpha_Character(int c, const void *argp GCC_UNUSED)
+{
+#if USE_WIDEC_SUPPORT
+  if (iswalpha(c))
+    return TRUE;
+#endif
+  return (isalpha(UChar(c)) ? TRUE : FALSE);
+}
+
+/*---------------------------------------------------------------------------
+|   Facility      :  libnform
 |   Function      :  static bool Check_Alpha_Field(
 |                                      FIELD * field,
 |                                      const void * argp)
-|   
+|
 |   Description   :  Validate buffer content to be a valid alpha value
 |
 |   Return Values :  TRUE  - field is valid
 |                    FALSE - field is invalid
 +--------------------------------------------------------------------------*/
-static bool Check_Alpha_Field(FIELD * field, const void * argp)
+static bool
+Check_Alpha_Field(FIELD *field, const void *argp)
 {
   int width = ((const alphaARG *)argp)->width;
-  unsigned char *bp  = (unsigned char *)field_buffer(field,0);
-  int  l = -1;
-  unsigned char *s;
+  unsigned char *bp = (unsigned char *)field_buffer(field, 0);
+  bool result = (width < 0);
 
-  while(*bp && *bp==' ') 
+  while (*bp && *bp == ' ')
     bp++;
   if (*bp)
     {
-      s = bp;
-      while(*bp && isalpha(*bp)) 
+#if USE_WIDEC_SUPPORT
+      bool blank = FALSE;
+      int len;
+      int n;
+      wchar_t *list = _nc_Widen_String(bp, &len);
+
+      if (list != 0)
+	{
+	  for (n = 0; n < len; ++n)
+	    {
+	      if (blank)
+		{
+		  if (list[n] != ' ')
+		    {
+		      result = FALSE;
+		      break;
+		    }
+		}
+	      else if (list[n] == ' ')
+		{
+		  blank = TRUE;
+		  result = (n + 1 >= width);
+		}
+	      else if (!Check_Alpha_Character(list[n], NULL))
+		{
+		  result = FALSE;
+		  break;
+		}
+	    }
+	  free(list);
+	}
+#else
+      unsigned char *s = bp;
+      int l = -1;
+
+      while (*bp && isalpha(UChar(*bp)))
 	bp++;
-      l = (int)(bp-s);
-      while(*bp && *bp==' ') 
+      l = (int)(bp - s);
+      while (*bp && *bp == ' ')
 	bp++;
+      result = ((*bp || (l < width)) ? FALSE : TRUE);
+#endif
     }
-  return ((*bp || (l < width)) ? FALSE : TRUE);
+  return (result);
 }
 
-/*---------------------------------------------------------------------------
-|   Facility      :  libnform  
-|   Function      :  static bool Check_Alpha_Character(
-|                                      int c,
-|                                      const void * argp)
-|   
-|   Description   :  Check a character for the alpha type.
-|
-|   Return Values :  TRUE  - character is valid
-|                    FALSE - character is invalid
-+--------------------------------------------------------------------------*/
-static bool Check_Alpha_Character(int c, const void * argp GCC_UNUSED)
+static FIELDTYPE typeALPHA =
 {
-  return (isalpha(c) ? TRUE : FALSE);
-}
-
-static FIELDTYPE typeALPHA = {
   _HAS_ARGS | _RESIDENT,
-  1,                           /* this is mutable, so we can't be const */
+  1,				/* this is mutable, so we can't be const */
   (FIELDTYPE *)0,
   (FIELDTYPE *)0,
   Make_Alpha_Type,
@@ -133,6 +181,7 @@
   NULL
 };
 
-NCURSES_EXPORT_VAR(FIELDTYPE*) TYPE_ALPHA = &typeALPHA;
+NCURSES_EXPORT_VAR(FIELDTYPE *)
+TYPE_ALPHA = &typeALPHA;
 
 /* fty_alpha.c ends here */
Index: form/fty_int.c
Prereq:  1.13 
--- ncurses-5.4-20040208/form/fty_int.c	2003-10-25 10:54:48.000000000 -0400
+++ ncurses-5.4-20040424/form/fty_int.c	2004-04-03 18:00:47.000000000 -0500
@@ -13,7 +13,7 @@
 
 #include "form.priv.h"
 
-MODULE_ID("$Id: fty_int.c,v 1.13 2003/10/25 14:54:48 tom Exp $")
+MODULE_ID("$Id: fty_int.c,v 1.14 2004/04/03 23:00:47 tom Exp $")
 
 typedef struct {
   int precision;
@@ -106,7 +106,7 @@
       if (*bp=='-') bp++;
       while (*bp)
 	{
-	  if (!isdigit(*bp)) break;
+	  if (!isdigit(UChar(*bp))) break;
 	  bp++;
 	}
       while(*bp && *bp==' ') bp++;
@@ -138,7 +138,7 @@
 +--------------------------------------------------------------------------*/
 static bool Check_Integer_Character(int c, const void * argp GCC_UNUSED)
 {
-  return ((isdigit(c) || (c=='-')) ? TRUE : FALSE);
+  return ((isdigit(UChar(c)) || (c=='-')) ? TRUE : FALSE);
 }
 
 static FIELDTYPE typeINTEGER = {
Index: form/fty_ipv4.c
Prereq:  1.4 
--- ncurses-5.4-20040208/form/fty_ipv4.c	2000-12-09 18:46:12.000000000 -0500
+++ ncurses-5.4-20040424/form/fty_ipv4.c	2004-04-03 18:00:47.000000000 -0500
@@ -13,7 +13,7 @@
 
 #include "form.priv.h"
 
-MODULE_ID("$Id: fty_ipv4.c,v 1.4 2000/12/09 23:46:12 tom Exp $")
+MODULE_ID("$Id: fty_ipv4.c,v 1.5 2004/04/03 23:00:47 tom Exp $")
 
 /*---------------------------------------------------------------------------
 |   Facility      :  libnform  
@@ -32,13 +32,13 @@
   int num = 0, len;
   unsigned int d1, d2, d3, d4;
 
-  if(isdigit((unsigned char)*bp)) /* Must start with digit */
+  if(isdigit(UChar(*bp))) /* Must start with digit */
     {
       num = sscanf(bp, "%u.%u.%u.%u%n", &d1, &d2, &d3, &d4, &len);
       if (num == 4)
         {
           bp += len;            /* Make bp point to what sscanf() left */
-          while (*bp && isspace((unsigned char)*bp))
+          while (*bp && isspace(UChar(*bp)))
             bp++;               /* Allow trailing whitespace */
         }
     }
@@ -59,7 +59,7 @@
 +--------------------------------------------------------------------------*/
 static bool Check_IPV4_Character(int c, const void * argp GCC_UNUSED)
 {
-  return ((isdigit(c) || (c=='.')) ? TRUE : FALSE);
+  return ((isdigit(UChar(c)) || (c=='.')) ? TRUE : FALSE);
 }
 
 static FIELDTYPE typeIPV4 = {
Index: form/fty_num.c
Prereq:  1.16 
--- ncurses-5.4-20040208/form/fty_num.c	2003-10-25 10:54:48.000000000 -0400
+++ ncurses-5.4-20040424/form/fty_num.c	2004-04-03 18:00:47.000000000 -0500
@@ -13,7 +13,7 @@
 
 #include "form.priv.h"
 
-MODULE_ID("$Id: fty_num.c,v 1.16 2003/10/25 14:54:48 tom Exp $")
+MODULE_ID("$Id: fty_num.c,v 1.17 2004/04/03 23:00:47 tom Exp $")
 
 #if HAVE_LOCALE_H
 #include <locale.h>
@@ -117,7 +117,7 @@
 	bp++;
       while(*bp)
 	{
-	  if (!isdigit(*bp)) break;
+	  if (!isdigit(UChar(*bp))) break;
 	  bp++;
 	}
       if (*bp==(
@@ -129,7 +129,7 @@
 	  bp++;
 	  while(*bp)
 	    {
-	      if (!isdigit(*bp)) break;
+	      if (!isdigit(UChar(*bp))) break;
 	      bp++;
 	    }
 	}
@@ -165,7 +165,7 @@
   const numericARG *argn = (const numericARG *)argp;
   struct lconv* L  = argn->L;  
 
-  return (isdigit(c)  || 
+  return (isdigit(UChar(c))  || 
 	  c == '+'    || 
 	  c == '-'    || 
 	  c == (
Index: include/curses.h.in
Prereq:  1.148 
--- ncurses-5.4-20040208/include/curses.h.in	2004-01-14 18:50:12.000000000 -0500
+++ ncurses-5.4-20040424/include/curses.h.in	2004-02-28 18:07:06.000000000 -0500
@@ -32,7 +32,7 @@
  *     and: Thomas E. Dickey 1996-on                                        *
  ****************************************************************************/
 
-/* $Id: curses.h.in,v 1.148 2004/01/14 23:50:12 tom Exp $ */
+/* $Id: curses.h.in,v 1.150 2004/02/28 23:07:06 tom Exp $ */
 
 #ifndef __NCURSES_H
 #define __NCURSES_H
@@ -58,6 +58,13 @@
 #include <ncurses_dll.h>
 
 /*
+ * User-definable tweak to disable the include of <stdbool.h>.
+ */
+#ifndef NCURSES_ENABLE_STDBOOL_H
+#define NCURSES_ENABLE_STDBOOL_H @cf_cv_header_stdbool_h@
+#endif
+
+/*
  * NCURSES_ATTR_T is used to quiet compiler warnings when building ncurses
  * configured using --disable-macros.
  */
@@ -132,7 +139,7 @@
 
 #else			/* c89, c99, etc. */
 
-#if @cf_cv_header_stdbool_h@
+#if NCURSES_ENABLE_STDBOOL_H
 #include <stdbool.h>
 /* use whatever the C compiler decides bool really is */
 #define NCURSES_BOOL bool
@@ -756,7 +763,7 @@
 extern NCURSES_EXPORT(int) winsdelln (WINDOW *,int);			/* implemented */
 extern NCURSES_EXPORT(int) winsertln (WINDOW *);			/* generated */
 extern NCURSES_EXPORT(int) winsnstr (WINDOW *, const char *,int);	/* implemented */
-extern NCURSES_EXPORT(int) winsstr (WINDOW *, const char *);		/* generated */
+extern NCURSES_EXPORT(int) winsstr (WINDOW *, const char *);		/* implemented */
 extern NCURSES_EXPORT(int) winstr (WINDOW *, char *);			/* generated */
 extern NCURSES_EXPORT(int) wmove (WINDOW *,int,int);			/* implemented */
 extern NCURSES_EXPORT(int) wnoutrefresh (WINDOW *);			/* implemented */
@@ -870,7 +877,6 @@
 
 #define winstr(w, s)		winnstr(w, s, -1)
 #define winchstr(w, s)		winchnstr(w, s, -1)
-#define winsstr(w, s)		winsnstr(w, s, -1)
 
 #define redrawwin(win)		wredrawln(win, 0, (win)->_maxy+1)
 #define waddstr(win,str)	waddnstr(win,str,-1)
Index: include/ncurses_defs
Prereq:  1.21 
--- ncurses-5.4-20040208/include/ncurses_defs	2004-01-17 20:03:24.000000000 -0500
+++ ncurses-5.4-20040424/include/ncurses_defs	2004-02-28 14:31:56.000000000 -0500
@@ -1,4 +1,4 @@
-# $Id: ncurses_defs,v 1.21 2004/01/18 01:03:24 tom Exp $
+# $Id: ncurses_defs,v 1.22 2004/02/28 19:31:56 tom Exp $
 ##############################################################################
 # Copyright (c) 2000-2003,2004 Free Software Foundation, Inc.                #
 #                                                                            #
@@ -64,6 +64,7 @@
 HAVE_HAS_KEY
 HAVE_ISASCII
 HAVE_ISSETUGID
+HAVE_LANGINFO_CODESET
 HAVE_LIBC_H
 HAVE_LIBDBMALLOC
 HAVE_LIBDMALLOC
Index: include/tic.h
Prereq:  1.46 
--- ncurses-5.4-20040208/include/tic.h	2003-12-27 14:05:32.000000000 -0500
+++ ncurses-5.4-20040424/include/tic.h	2004-04-03 15:22:58.000000000 -0500
@@ -1,5 +1,5 @@
 /****************************************************************************
- * Copyright (c) 1998-2001,2003 Free Software Foundation, Inc.              *
+ * Copyright (c) 1998-2003,2004 Free Software Foundation, Inc.              *
  *                                                                          *
  * Permission is hereby granted, free of charge, to any person obtaining a  *
  * copy of this software and associated documentation files (the            *
@@ -29,10 +29,11 @@
 /****************************************************************************
  *  Author: Zeyd M. Ben-Halim <zmbenhal@netcom.com> 1992,1995               *
  *     and: Eric S. Raymond <esr@snark.thyrsus.com>                         *
+ *     and: Thomas E. Dickey 1996 on                                        *
  ****************************************************************************/
 
 /*
- * $Id: tic.h,v 1.46 2003/12/27 19:05:32 tom Exp $
+ * $Id: tic.h,v 1.49 2004/04/03 20:22:58 tom Exp $
  *	tic.h - Global variables and structures for the terminfo
  *			compiler.
  */
@@ -108,7 +109,7 @@
 #define DEBUG_LEVEL(n)	((n) << TRACE_SHIFT)
 
 #define set_trace_level(n) \
- 	_nc_tracing &= DEBUG_LEVEL(MAX_DEBUG_LEVEL), \
+	_nc_tracing &= DEBUG_LEVEL(MAX_DEBUG_LEVEL), \
 	_nc_tracing |= DEBUG_LEVEL(n)
 
 #ifdef TRACE
@@ -216,18 +217,18 @@
 #define NOTFOUND	((struct name_table_entry *) 0)
 
 /* out-of-band values for representing absent capabilities */
-#define ABSENT_BOOLEAN		(char)(-1)	/* 255 */
+#define ABSENT_BOOLEAN		((signed char)-1)	/* 255 */
 #define ABSENT_NUMERIC		(-1)
 #define ABSENT_STRING		(char *)0
 
 /* out-of-band values for representing cancels */
-#define CANCELLED_BOOLEAN	(char)(-2)	/* 254 */
+#define CANCELLED_BOOLEAN	((signed char)-2)	/* 254 */
 #define CANCELLED_NUMERIC	(-2)
 #define CANCELLED_STRING	(char *)(-1)
 
 #define VALID_BOOLEAN(s) ((unsigned char)(s) <= 1) /* reject "-1" */
 #define VALID_NUMERIC(s) ((s) >= 0)
-#define VALID_STRING(s) ((s) != CANCELLED_STRING && (s) != ABSENT_STRING)
+#define VALID_STRING(s)  ((s) != CANCELLED_STRING && (s) != ABSENT_STRING)
 
 /* termcap entries longer than this may break old binaries */
 #define MAX_TERMCAP_LENGTH	1023
@@ -278,7 +279,7 @@
 extern NCURSES_EXPORT(char *) _nc_tic_expand (const char *, bool, int);
 
 /* comp_scan.c: decode string from readable form */
-extern NCURSES_EXPORT(char) _nc_trans_string (char *, char *);
+extern NCURSES_EXPORT(int) _nc_trans_string (char *, char *);
 
 /* captoinfo.c: capability conversion */
 extern NCURSES_EXPORT(char *) _nc_captoinfo (const char *, const char *, int const);
Index: man/curs_add_wchstr.3x
Prereq:  1.2 
--- ncurses-5.4-20040208/man/curs_add_wchstr.3x	2003-12-27 13:53:41.000000000 -0500
+++ ncurses-5.4-20040424/man/curs_add_wchstr.3x	2004-03-13 14:39:10.000000000 -0500
@@ -1,5 +1,5 @@
 .\"***************************************************************************
-.\" Copyright (c) 2002,2003 Free Software Foundation, Inc.                   *
+.\" Copyright (c) 2002-2003,2004 Free Software Foundation, Inc.              *
 .\"                                                                          *
 .\" Permission is hereby granted, free of charge, to any person obtaining a  *
 .\" copy of this software and associated documentation files (the            *
@@ -26,10 +26,9 @@
 .\" authorization.                                                           *
 .\"***************************************************************************
 .\"
-.\" $Id: curs_add_wchstr.3x,v 1.2 2003/12/27 18:53:41 tom Exp $
+.\" $Id: curs_add_wchstr.3x,v 1.3 2004/03/13 19:39:10 tom Exp $
 .TH curs_add_wchstr 3X ""
 .SH NAME
-.PP
 \fBadd_wchstr\fR,
 \fBadd_wchnstr\fR,
 \fBwadd_wchstr\fR,
Index: man/curs_bkgrnd.3x
Prereq:  1.1 
--- ncurses-5.4-20040208/man/curs_bkgrnd.3x	2002-02-23 18:23:42.000000000 -0500
+++ ncurses-5.4-20040424/man/curs_bkgrnd.3x	2004-03-13 14:39:10.000000000 -0500
@@ -1,5 +1,5 @@
 .\"***************************************************************************
-.\" Copyright (c) 2002 Free Software Foundation, Inc.                        *
+.\" Copyright (c) 2002,2004 Free Software Foundation, Inc.                   *
 .\"                                                                          *
 .\" Permission is hereby granted, free of charge, to any person obtaining a  *
 .\" copy of this software and associated documentation files (the            *
@@ -26,10 +26,9 @@
 .\" authorization.                                                           *
 .\"***************************************************************************
 .\"
-.\" $Id: curs_bkgrnd.3x,v 1.1 2002/02/23 23:23:42 tom Exp $
+.\" $Id: curs_bkgrnd.3x,v 1.2 2004/03/13 19:39:10 tom Exp $
 .TH curs_bkgrnd 3X ""
 .SH NAME
-.PP
 \fBbkgrnd\fR,
 \fBwbkgrnd\fR,
 \fBbkgrndset\fR,
Index: man/curs_border_set.3x
Prereq:  1.3 
--- ncurses-5.4-20040208/man/curs_border_set.3x	2002-04-20 12:49:13.000000000 -0400
+++ ncurses-5.4-20040424/man/curs_border_set.3x	2004-03-13 14:39:10.000000000 -0500
@@ -1,5 +1,5 @@
 .\"***************************************************************************
-.\" Copyright (c) 2002 Free Software Foundation, Inc.                        *
+.\" Copyright (c) 2002,2004 Free Software Foundation, Inc.                   *
 .\"                                                                          *
 .\" Permission is hereby granted, free of charge, to any person obtaining a  *
 .\" copy of this software and associated documentation files (the            *
@@ -26,10 +26,9 @@
 .\" authorization.                                                           *
 .\"***************************************************************************
 .\"
-.\" $Id: curs_border_set.3x,v 1.3 2002/04/20 16:49:13 tom Exp $
+.\" $Id: curs_border_set.3x,v 1.4 2004/03/13 19:39:10 tom Exp $
 .TH curs_border_set 3X ""
 .SH NAME
-.PP
 \fBborder_set\fR,
 \fBwborder_set\fR,
 \fBbox_set\fR,
Index: man/curs_insstr.3x
Prereq:  1.12 
--- ncurses-5.4-20040208/man/curs_insstr.3x	2001-11-03 14:59:03.000000000 -0500
+++ ncurses-5.4-20040424/man/curs_insstr.3x	2004-02-28 18:12:39.000000000 -0500
@@ -1,5 +1,5 @@
 .\"***************************************************************************
-.\" Copyright (c) 1998,2000,2001 Free Software Foundation, Inc.              *
+.\" Copyright (c) 1998-2001,2004 Free Software Foundation, Inc.              *
 .\"                                                                          *
 .\" Permission is hereby granted, free of charge, to any person obtaining a  *
 .\" copy of this software and associated documentation files (the            *
@@ -26,7 +26,7 @@
 .\" authorization.                                                           *
 .\"***************************************************************************
 .\"
-.\" $Id: curs_insstr.3x,v 1.12 2001/11/03 19:59:03 tom Exp $
+.\" $Id: curs_insstr.3x,v 1.13 2004/02/28 23:12:39 tom Exp $
 .TH curs_insstr 3X ""
 .SH NAME
 \fBinsstr\fR,
@@ -57,28 +57,27 @@
 \fBint mvwinsnstr(WINDOW *win, int y, int x, const char *str, int n);\fR
 .br
 .SH DESCRIPTION
-These routines insert a character string (as many characters as will fit on the
-line) before the character under the cursor.  All characters to the right of
-the cursor are shifted right, with the possibility of the rightmost characters
-on the line being lost.  The cursor position does not change (after moving to
-\fIy\fR, \fIx\fR, if specified). The four routines with \fIn\fR as the last
-argument insert a leading substring of at most \fIn\fR characters.  If
-\fIn\fR<=0, then the entire string is inserted.
+These routines insert a character string
+(as many characters as will fit on the line)
+before the character under the cursor.
+All characters to the right of the cursor are shifted right.
+The \fBwinsnstr\fP and related functions perform wrapping as is done
+for \fBaddch\fP.
+The other functions do not perform wrapping,
+with the possibility of the rightmost characters on the line being lost.
+The cursor position does not change
+(after moving to \fIy\fR, \fIx\fR, if specified).
+The functions with \fIn\fR as the last argument
+insert a leading substring of at most \fIn\fR characters.
+If \fIn\fR<=0, then the entire string is inserted.
 
-If a character in \fIstr\fR is a tab, newline, carriage return or
-backspace, the cursor is moved appropriately within the window.  A
-newline also does a \fBclrtoeol\fR before moving.  Tabs are considered
-to be at every eighth column.  If a character in \fIstr\fR is another
-control character, it is drawn in the \fB^\fR\fIX\fR notation.
-Calling \fBwinch\fR after adding a control character (and moving to
-it, if necessary) does not return the control character, but instead
-returns a character in the ^-representation of the control character.
+Special characters are handled as in \fBaddch\fP.
 .SH RETURN VALUE
 All routines that return an integer return \fBERR\fR upon failure and OK (SVr4
 specifies only "an integer value other than \fBERR\fR") upon successful
 completion, unless otherwise noted in the preceding routine descriptions.
 .SH NOTES
-Note that all but \fBwinsnstr\fR may be macros.
+Note that all but \fBwinsnstr\fR and \fBwinsstr\fR may be macros.
 .SH PORTABILITY
 These functions are described in the XSI Curses standard, Issue 4, which adds
 const qualifiers to the arguments.  The XSI Curses error conditions
@@ -86,7 +85,10 @@
 are not yet detected (this implementation does not yet support XPG4 multibyte
 characters).
 .SH SEE ALSO
-\fBcurses\fR(3X), \fBcurs_clear\fR(3X), \fBcurs_inch\fR(3X).
+\fBcurses\fR(3X),
+\fBunctrl\fR(3X),
+\fBcurs_clear\fR(3X),
+\fBcurs_inch\fR(3X).
 .\"#
 .\"# The following sets edit modes for GNU EMACS
 .\"# Local Variables:
Index: man/curs_inwstr.3x
Prereq:  1.2 
--- ncurses-5.4-20040208/man/curs_inwstr.3x	2002-04-13 16:25:35.000000000 -0400
+++ ncurses-5.4-20040424/man/curs_inwstr.3x	2004-03-13 14:39:10.000000000 -0500
@@ -1,5 +1,5 @@
 .\"***************************************************************************
-.\" Copyright (c) 2002 Free Software Foundation, Inc.                        *
+.\" Copyright (c) 2002,2004 Free Software Foundation, Inc.                   *
 .\"                                                                          *
 .\" Permission is hereby granted, free of charge, to any person obtaining a  *
 .\" copy of this software and associated documentation files (the            *
@@ -26,10 +26,9 @@
 .\" authorization.                                                           *
 .\"***************************************************************************
 .\"
-.\" $Id: curs_inwstr.3x,v 1.2 2002/04/13 20:25:35 tom Exp $
+.\" $Id: curs_inwstr.3x,v 1.3 2004/03/13 19:39:10 tom Exp $
 .TH curs_inwstr 3 ""
 .SH NAME
-.PP
 \fBinwstr\fR,
 \fBinnwstr\fR,
 \fBwinwstr\fR,
Index: man/terminfo.tail
Prereq:  1.38 
--- ncurses-5.4-20040208/man/terminfo.tail	2003-01-05 17:47:05.000000000 -0500
+++ ncurses-5.4-20040424/man/terminfo.tail	2004-03-27 17:28:17.000000000 -0500
@@ -1,4 +1,4 @@
-.\" $Id: terminfo.tail,v 1.38 2003/01/05 22:47:05 tom Exp $
+.\" $Id: terminfo.tail,v 1.39 2004/03/27 22:28:17 tom Exp $
 .\" Beginning of terminfo.tail file
 .ps +1
 .PP
@@ -801,6 +801,12 @@
 .fi
 .PP
 Remember that if you specify sgr, you must also specify sgr0.
+Also, some implementations rely on sgr being given if sgr0 is,
+Not all terminfo entries necessarily have an sgr string, however.
+Many terminfo entries are derived from termcap entries
+which have no sgr string.
+The only drawback to adding an sgr string is that termcap also
+assumes that sgr0 does not exit alternate character set mode.
 .PP
 Terminals with the ``magic cookie'' glitch
 .RB ( xmc )
@@ -1479,18 +1485,18 @@
 .SS Pitfalls of Long Entries
 .PP
 Long terminfo entries are unlikely to be a problem; to date, no entry has even
-approached terminfo's 4K string-table maximum.
+approached terminfo's 4096-byte string-table maximum.
 Unfortunately, the termcap
-translations are much more strictly limited (to 1K), thus termcap translations
+translations are much more strictly limited (to 1023 bytes), thus termcap translations
 of long terminfo entries can cause problems.
 .PP
-The man pages for 4.3BSD and older versions of tgetent() instruct the user to
-allocate a 1K buffer for the termcap entry.
+The man pages for 4.3BSD and older versions of \fBtgetent()\fP instruct the user to
+allocate a 1024-byte buffer for the termcap entry.
 The entry gets null-terminated by
 the termcap library, so that makes the maximum safe length for a termcap entry
 1k-1 (1023) bytes.
 Depending on what the application and the termcap library
-being used does, and where in the termcap file the terminal type that tgetent()
+being used does, and where in the termcap file the terminal type that \fBtgetent()\fP
 is searching for is, several bad things can happen.
 .PP
 Some termcap libraries print a warning message or exit if they find an
@@ -1511,7 +1517,7 @@
 affects more than just users of that particular terminal.
 This is the
 length of the entry as it exists in /etc/termcap, minus the
-backslash-newline pairs, which tgetent() strips out while reading it.
+backslash-newline pairs, which \fBtgetent()\fP strips out while reading it.
 Some termcap libraries strip off the final newline, too (GNU termcap does not).
 Now suppose:
 .TP 5
@@ -1527,12 +1533,12 @@
 if it's the entry it wants,
 .TP 5
 *
-and tgetent() is searching for a terminal type that either is the
+and \fBtgetent()\fP is searching for a terminal type that either is the
 long entry, appears in the termcap file after the long entry, or
-doesn't appear in the file at all (so that tgetent() has to search
+doesn't appear in the file at all (so that \fBtgetent()\fP has to search
 the whole termcap file).
 .PP
-Then tgetent() will overwrite memory, perhaps its stack, and probably core dump
+Then \fBtgetent()\fP will overwrite memory, perhaps its stack, and probably core dump
 the program.
 Programs like telnet are particularly vulnerable; modern telnets
 pass along values like the terminal type automatically.
@@ -1545,7 +1551,7 @@
 .PP
 The "after tc expansion" length will have a similar effect to the
 above, but only for people who actually set TERM to that terminal
-type, since tgetent() only does "tc" expansion once it's found the
+type, since \fBtgetent()\fP only does "tc" expansion once it's found the
 terminal type it was looking for, not while searching.
 .PP
 In summary, a termcap entry that is longer than 1023 bytes can cause,
Index: menu/m_driver.c
Prereq:  1.20 
--- ncurses-5.4-20040208/menu/m_driver.c	2003-10-25 10:54:48.000000000 -0400
+++ ncurses-5.4-20040424/menu/m_driver.c	2004-04-03 18:09:47.000000000 -0500
@@ -1,5 +1,5 @@
 /****************************************************************************
- * Copyright (c) 1998,2000 Free Software Foundation, Inc.                   *
+ * Copyright (c) 1998-2003,2004 Free Software Foundation, Inc.              *
  *                                                                          *
  * Permission is hereby granted, free of charge, to any person obtaining a  *
  * copy of this software and associated documentation files (the            *
@@ -37,7 +37,7 @@
 
 #include "menu.priv.h"
 
-MODULE_ID("$Id: m_driver.c,v 1.20 2003/10/25 14:54:48 tom Exp $")
+MODULE_ID("$Id: m_driver.c,v 1.22 2004/04/03 23:09:47 tom Exp $")
 
 /* Macros */
 
@@ -62,28 +62,31 @@
 |   Return Values :  TRUE   - if it is a substring
 |                    FALSE  - if it is not a substring
 +--------------------------------------------------------------------------*/
-static bool Is_Sub_String(
-			  bool  IgnoreCaseFlag,
-			  const char *part,
-			  const char *string
-			 )
+static bool
+Is_Sub_String(
+	       bool IgnoreCaseFlag,
+	       const char *part,
+	       const char *string
+)
 {
-  assert( part && string );
-  if ( IgnoreCaseFlag )
+  assert(part && string);
+  if (IgnoreCaseFlag)
     {
-      while(*string && *part)
+      while (*string && *part)
 	{
-	  if (toupper(*string++)!=toupper(*part)) break;
+	  if (toupper(*string++) != toupper(*part))
+	    break;
 	  part++;
 	}
     }
   else
     {
-      while( *string && *part )
-	if (*part != *string++) break;
+      while (*string && *part)
+	if (*part != *string++)
+	  break;
       part++;
     }
-  return ( (*part) ? FALSE : TRUE );
+  return ((*part) ? FALSE : TRUE);
 }
 
 /*---------------------------------------------------------------------------
@@ -113,73 +116,75 @@
 +--------------------------------------------------------------------------*/
 NCURSES_EXPORT(int)
 _nc_Match_Next_Character_In_Item_Name
-(MENU *menu, int ch, ITEM **item)
+(MENU * menu, int ch, ITEM ** item)
 {
   bool found = FALSE, passed = FALSE;
-  int  idx, last;
+  int idx, last;
 
-  assert( menu && item && *item);
+  assert(menu && item && *item);
   idx = (*item)->index;
 
-  if (ch && ch!=BS)
+  if (ch && ch != BS)
     {
       /* if we become to long, we need no further checking : there can't be
-	 a match ! */
-      if ((menu->pindex+1) > menu->namelen)
+         a match ! */
+      if ((menu->pindex + 1) > menu->namelen)
 	RETURN(E_NO_MATCH);
 
-      Add_Character_To_Pattern(menu,ch);
+      Add_Character_To_Pattern(menu, ch);
       /* we artificially position one item back, because in the do...while
-	 loop we start with the next item. This means, that with a new
-	 pattern search we always start the scan with the actual item. If
-	 we do a NEXT_PATTERN oder PREV_PATTERN search, we start with the
-	 one after or before the actual item. */
+         loop we start with the next item. This means, that with a new
+         pattern search we always start the scan with the actual item. If
+         we do a NEXT_PATTERN oder PREV_PATTERN search, we start with the
+         one after or before the actual item. */
       if (--idx < 0)
-	idx = menu->nitems-1;
+	idx = menu->nitems - 1;
     }
 
   last = idx;			/* this closes the cycle */
 
-  do{
-    if (ch==BS)
-      {			/* we have to go backward */
-	if (--idx < 0)
-	  idx = menu->nitems-1;
-      }
-    else
-      {			/* otherwise we always go forward */
-	if (++idx >= menu->nitems)
-	  idx = 0;
-      }
-    if (Is_Sub_String((menu->opt & O_IGNORECASE) != 0,
-		      menu->pattern,
-		      menu->items[idx]->name.str)
+  do
+    {
+      if (ch == BS)
+	{			/* we have to go backward */
+	  if (--idx < 0)
+	    idx = menu->nitems - 1;
+	}
+      else
+	{			/* otherwise we always go forward */
+	  if (++idx >= menu->nitems)
+	    idx = 0;
+	}
+      if (Is_Sub_String((menu->opt & O_IGNORECASE) != 0,
+			menu->pattern,
+			menu->items[idx]->name.str)
 	)
-      found = TRUE;
-    else
-      passed = TRUE;
-  } while (!found && (idx != last));
+	found = TRUE;
+      else
+	passed = TRUE;
+    }
+  while (!found && (idx != last));
 
   if (found)
     {
-      if (!((idx==(*item)->index) && passed))
+      if (!((idx == (*item)->index) && passed))
 	{
 	  *item = menu->items[idx];
 	  RETURN(E_OK);
 	}
       /* This point is reached, if we fully cycled through the item list
-	 and the only match we found is the starting item. With a NEXT_PATTERN
-	 or PREV_PATTERN scan this means, that there was no additional match.
-	 If we searched with an expanded new pattern, we should never reach
-	 this point, because if the expanded pattern matches also the actual
-	 item we will find it in the first attempt (passed==FALSE) and we
-	 will never cycle through the whole item array.
-	 */
-      assert( ch==0 || ch==BS );
+         and the only match we found is the starting item. With a NEXT_PATTERN
+         or PREV_PATTERN scan this means, that there was no additional match.
+         If we searched with an expanded new pattern, we should never reach
+         this point, because if the expanded pattern matches also the actual
+         item we will find it in the first attempt (passed==FALSE) and we
+         will never cycle through the whole item array.
+       */
+      assert(ch == 0 || ch == BS);
     }
   else
     {
-      if (ch && ch!=BS && menu->pindex>0)
+      if (ch && ch != BS && menu->pindex > 0)
 	{
 	  /* if we had no match with a new pattern, we have to restore it */
 	  Remove_Character_From_Pattern(menu);
@@ -201,7 +206,7 @@
 |                    E_NOT_POSTED    - menu is not posted
 +--------------------------------------------------------------------------*/
 NCURSES_EXPORT(int)
-menu_driver (MENU * menu, int   c)
+menu_driver(MENU * menu, int c)
 {
 #define NAVIGATE(dir) \
   if (!item->dir)\
@@ -216,324 +221,327 @@
   if (!menu)
     RETURN(E_BAD_ARGUMENT);
 
-  if ( menu->status & _IN_DRIVER )
+  if (menu->status & _IN_DRIVER)
     RETURN(E_BAD_STATE);
-  if ( !( menu->status & _POSTED ) )
+  if (!(menu->status & _POSTED))
     RETURN(E_NOT_POSTED);
 
   item = menu->curitem;
 
-    my_top_row = menu->toprow;
-    assert(item);
+  my_top_row = menu->toprow;
+  assert(item);
+
+  if ((c > KEY_MAX) && (c <= MAX_MENU_COMMAND))
+    {
+      if (!((c == REQ_BACK_PATTERN)
+	    || (c == REQ_NEXT_MATCH) || (c == REQ_PREV_MATCH)))
+	{
+	  assert(menu->pattern);
+	  Reset_Pattern(menu);
+	}
 
-    if ((c > KEY_MAX) && (c<=MAX_MENU_COMMAND))
-      {
-	if (!((c==REQ_BACK_PATTERN)
-	      || (c==REQ_NEXT_MATCH) || (c==REQ_PREV_MATCH)))
-	  {
-	    assert( menu->pattern );
-	    Reset_Pattern(menu);
-	  }
-
-	switch(c)
-	  {
-	  case REQ_LEFT_ITEM:
+      switch (c)
+	{
+	case REQ_LEFT_ITEM:
 	    /*=================*/
-	    NAVIGATE(left);
-	    break;
+	  NAVIGATE(left);
+	  break;
 
-	  case REQ_RIGHT_ITEM:
+	case REQ_RIGHT_ITEM:
 	    /*==================*/
-	    NAVIGATE(right);
-	    break;
+	  NAVIGATE(right);
+	  break;
 
-	  case REQ_UP_ITEM:
+	case REQ_UP_ITEM:
 	    /*===============*/
-	    NAVIGATE(up);
-	    break;
+	  NAVIGATE(up);
+	  break;
 
-	  case REQ_DOWN_ITEM:
+	case REQ_DOWN_ITEM:
 	    /*=================*/
-	    NAVIGATE(down);
-	    break;
+	  NAVIGATE(down);
+	  break;
 
-	  case REQ_SCR_ULINE:
+	case REQ_SCR_ULINE:
 	    /*=================*/
 	  if (my_top_row == 0 || !(item->up))
-	      result = E_REQUEST_DENIED;
-	    else
-	      {
-		--my_top_row;
-		item = item->up;
-	      }
-	    break;
+	    result = E_REQUEST_DENIED;
+	  else
+	    {
+	      --my_top_row;
+	      item = item->up;
+	    }
+	  break;
 
-	  case REQ_SCR_DLINE:
+	case REQ_SCR_DLINE:
 	    /*=================*/
 	  if ((my_top_row + menu->arows >= menu->rows) || !(item->down))
-	      {
-		/* only if the menu has less items than rows, we can deny the
-		   request. Otherwise the epilogue of this routine adjusts the
-		   top row if necessary */
-		result = E_REQUEST_DENIED;
-	      }
-	  else {
-	    my_top_row++;
+	    {
+	      /* only if the menu has less items than rows, we can deny the
+	         request. Otherwise the epilogue of this routine adjusts the
+	         top row if necessary */
+	      result = E_REQUEST_DENIED;
+	    }
+	  else
+	    {
+	      my_top_row++;
 	      item = item->down;
-	  }
-	    break;
+	    }
+	  break;
 
-	  case REQ_SCR_DPAGE:
+	case REQ_SCR_DPAGE:
 	    /*=================*/
 	  rdiff = menu->rows - (menu->arows + my_top_row);
-	    if (rdiff > menu->arows)
-	      rdiff = menu->arows;
-	  if (rdiff<=0)
-	      result = E_REQUEST_DENIED;
-	    else
-	      {
-		my_top_row += rdiff;
-	      while(rdiff-- > 0 && item!=(ITEM*)0)
-		  item = item->down;
-	      }
-	    break;
+	  if (rdiff > menu->arows)
+	    rdiff = menu->arows;
+	  if (rdiff <= 0)
+	    result = E_REQUEST_DENIED;
+	  else
+	    {
+	      my_top_row += rdiff;
+	      while (rdiff-- > 0 && item != (ITEM *) 0)
+		item = item->down;
+	    }
+	  break;
 
-	  case REQ_SCR_UPAGE:
+	case REQ_SCR_UPAGE:
 	    /*=================*/
 	  rdiff = (menu->arows < my_top_row) ? menu->arows : my_top_row;
-	  if (rdiff<=0)
-	      result = E_REQUEST_DENIED;
-	    else
-	      {
-		my_top_row -= rdiff;
-	      while(rdiff-- && item!=(ITEM*)0)
-		  item = item->up;
-	      }
-	    break;
+	  if (rdiff <= 0)
+	    result = E_REQUEST_DENIED;
+	  else
+	    {
+	      my_top_row -= rdiff;
+	      while (rdiff-- && item != (ITEM *) 0)
+		item = item->up;
+	    }
+	  break;
 
-	  case REQ_FIRST_ITEM:
+	case REQ_FIRST_ITEM:
 	    /*==================*/
-	    item = menu->items[0];
-	    break;
+	  item = menu->items[0];
+	  break;
 
-	  case REQ_LAST_ITEM:
+	case REQ_LAST_ITEM:
 	    /*=================*/
-	    item = menu->items[menu->nitems-1];
-	    break;
+	  item = menu->items[menu->nitems - 1];
+	  break;
 
-	  case REQ_NEXT_ITEM:
+	case REQ_NEXT_ITEM:
 	    /*=================*/
-	    if ((item->index+1)>=menu->nitems)
-	      {
-		if (menu->opt & O_NONCYCLIC)
-		  result = E_REQUEST_DENIED;
-		else
-		  item = menu->items[0];
-	      }
-	    else
-	      item = menu->items[item->index + 1];
-	    break;
+	  if ((item->index + 1) >= menu->nitems)
+	    {
+	      if (menu->opt & O_NONCYCLIC)
+		result = E_REQUEST_DENIED;
+	      else
+		item = menu->items[0];
+	    }
+	  else
+	    item = menu->items[item->index + 1];
+	  break;
 
-	  case REQ_PREV_ITEM:
+	case REQ_PREV_ITEM:
 	    /*=================*/
-	    if (item->index<=0)
-	      {
-		if (menu->opt & O_NONCYCLIC)
-		  result = E_REQUEST_DENIED;
-		else
-		  item = menu->items[menu->nitems-1];
-	      }
-	    else
-	      item = menu->items[item->index - 1];
-	    break;
+	  if (item->index <= 0)
+	    {
+	      if (menu->opt & O_NONCYCLIC)
+		result = E_REQUEST_DENIED;
+	      else
+		item = menu->items[menu->nitems - 1];
+	    }
+	  else
+	    item = menu->items[item->index - 1];
+	  break;
 
-	  case REQ_TOGGLE_ITEM:
+	case REQ_TOGGLE_ITEM:
 	    /*===================*/
-	    if (menu->opt & O_ONEVALUE)
-	      {
-		result = E_REQUEST_DENIED;
-	      }
-	    else
-	      {
-		if (menu->curitem->opt & O_SELECTABLE)
-		  {
-		    menu->curitem->value = !menu->curitem->value;
-		    Move_And_Post_Item(menu,menu->curitem);
-		    _nc_Show_Menu(menu);
-		  }
-		else
-		  result = E_NOT_SELECTABLE;
-	      }
-	    break;
+	  if (menu->opt & O_ONEVALUE)
+	    {
+	      result = E_REQUEST_DENIED;
+	    }
+	  else
+	    {
+	      if (menu->curitem->opt & O_SELECTABLE)
+		{
+		  menu->curitem->value = !menu->curitem->value;
+		  Move_And_Post_Item(menu, menu->curitem);
+		  _nc_Show_Menu(menu);
+		}
+	      else
+		result = E_NOT_SELECTABLE;
+	    }
+	  break;
 
-	  case REQ_CLEAR_PATTERN:
+	case REQ_CLEAR_PATTERN:
 	    /*=====================*/
-	    /* already cleared in prologue */
-	    break;
+	  /* already cleared in prologue */
+	  break;
 
-	  case REQ_BACK_PATTERN:
+	case REQ_BACK_PATTERN:
 	    /*====================*/
-	    if (menu->pindex>0)
-	      {
-		assert(menu->pattern);
-		Remove_Character_From_Pattern(menu);
-		pos_menu_cursor( menu );
-	      }
-	    else
-	      result = E_REQUEST_DENIED;
-	    break;
+	  if (menu->pindex > 0)
+	    {
+	      assert(menu->pattern);
+	      Remove_Character_From_Pattern(menu);
+	      pos_menu_cursor(menu);
+	    }
+	  else
+	    result = E_REQUEST_DENIED;
+	  break;
 
-	  case REQ_NEXT_MATCH:
+	case REQ_NEXT_MATCH:
 	    /*==================*/
-	    assert(menu->pattern);
-	    if (menu->pattern[0])
-	      result = _nc_Match_Next_Character_In_Item_Name(menu,0,&item);
-	    else
-	      {
-		if ((item->index+1)<menu->nitems)
-		  item=menu->items[item->index+1];
-		else
-		  {
-		    if (menu->opt & O_NONCYCLIC)
-		      result = E_REQUEST_DENIED;
-		    else
-		      item = menu->items[0];
-		  }
-	      }
-	    break;
+	  assert(menu->pattern);
+	  if (menu->pattern[0])
+	    result = _nc_Match_Next_Character_In_Item_Name(menu, 0, &item);
+	  else
+	    {
+	      if ((item->index + 1) < menu->nitems)
+		item = menu->items[item->index + 1];
+	      else
+		{
+		  if (menu->opt & O_NONCYCLIC)
+		    result = E_REQUEST_DENIED;
+		  else
+		    item = menu->items[0];
+		}
+	    }
+	  break;
 
-	  case REQ_PREV_MATCH:
+	case REQ_PREV_MATCH:
 	    /*==================*/
-	    assert(menu->pattern);
-	    if (menu->pattern[0])
-	      result = _nc_Match_Next_Character_In_Item_Name(menu,BS,&item);
-	    else
-	      {
-		if (item->index)
-		  item = menu->items[item->index-1];
-		else
-		  {
-		    if (menu->opt & O_NONCYCLIC)
-		      result = E_REQUEST_DENIED;
-		    else
-		      item = menu->items[menu->nitems-1];
-		  }
-	      }
-	    break;
+	  assert(menu->pattern);
+	  if (menu->pattern[0])
+	    result = _nc_Match_Next_Character_In_Item_Name(menu, BS, &item);
+	  else
+	    {
+	      if (item->index)
+		item = menu->items[item->index - 1];
+	      else
+		{
+		  if (menu->opt & O_NONCYCLIC)
+		    result = E_REQUEST_DENIED;
+		  else
+		    item = menu->items[menu->nitems - 1];
+		}
+	    }
+	  break;
 
-	  default:
+	default:
 	    /*======*/
-	    result = E_UNKNOWN_COMMAND;
-	    break;
-	  }
-      }
-    else
-      {				/* not a command */
-	if ( !(c & ~((int)MAX_REGULAR_CHARACTER)) && isprint(c) )
-	  result = _nc_Match_Next_Character_In_Item_Name( menu, c, &item );
+	  result = E_UNKNOWN_COMMAND;
+	  break;
+	}
+    }
+  else
+    {				/* not a command */
+      if (!(c & ~((int)MAX_REGULAR_CHARACTER)) && isprint(UChar(c)))
+	result = _nc_Match_Next_Character_In_Item_Name(menu, c, &item);
 #ifdef NCURSES_MOUSE_VERSION
-        else if (KEY_MOUSE == c)
-	  {
-	    MEVENT	event;
-	    WINDOW* uwin = Get_Menu_UserWin(menu);
-
-	    getmouse(&event);
-	    if ((event.bstate & (BUTTON1_CLICKED         |
-				 BUTTON1_DOUBLE_CLICKED  |
-				 BUTTON1_TRIPLE_CLICKED   ))
-	     && wenclose(uwin,event.y, event.x))
-	      { /* we react only if the click was in the userwin, that means
-		 * inside the menu display area or at the decoration window.
-		 */
-		WINDOW* sub = Get_Menu_Window(menu);
-		int ry = event.y, rx = event.x; /* screen coordinates */
+      else if (KEY_MOUSE == c)
+	{
+	  MEVENT event;
+	  WINDOW *uwin = Get_Menu_UserWin(menu);
 
-		result = E_REQUEST_DENIED;
-		if (mouse_trafo(&ry,&rx,FALSE))
-		  { /* rx, ry are now "curses" coordinates */
-		    if (ry < sub->_begy)
-		      { /* we clicked above the display region; this is
-			 * interpreted as "scroll up" request
-			 */
-			if (event.bstate & BUTTON1_CLICKED)
-			  result = menu_driver(menu,REQ_SCR_ULINE);
-			else if (event.bstate & BUTTON1_DOUBLE_CLICKED)
-			  result = menu_driver(menu,REQ_SCR_UPAGE);
-			else if (event.bstate & BUTTON1_TRIPLE_CLICKED)
-			  result = menu_driver(menu,REQ_FIRST_ITEM);
-			RETURN(result);
-		      }
-		    else if (ry >= sub->_begy + sub->_maxy)
-		      { /* we clicked below the display region; this is
-			 * interpreted as "scroll down" request
-			 */
-			if (event.bstate & BUTTON1_CLICKED)
-			  result = menu_driver(menu,REQ_SCR_DLINE);
-			else if (event.bstate & BUTTON1_DOUBLE_CLICKED)
-			  result = menu_driver(menu,REQ_SCR_DPAGE);
-			else if (event.bstate & BUTTON1_TRIPLE_CLICKED)
-			  result = menu_driver(menu,REQ_LAST_ITEM);
-			RETURN(result);
-		      }
-		    else if (wenclose(sub,event.y,event.x))
-		      { /* Inside the area we try to find the hit item */
-			int i,x,y,err;
-			ry = event.y; rx = event.x;
-			if (wmouse_trafo(sub,&ry,&rx,FALSE))
-			  {
-			    for(i=0;i<menu->nitems;i++)
-			      {
-				err = _nc_menu_cursor_pos(menu,menu->items[i],
-							  &y, &x);
-				if (E_OK==err)
-				  {
-				    if ((ry==y)       &&
-					(rx>=x)       &&
-					(rx < x + menu->itemlen))
-				      {
-					item = menu->items[i];
-					result = E_OK;
-					break;
-				      }
-				  }
-			      }
-			    if (E_OK==result)
-			      { /* We found an item, now we can handle the click.
+	  getmouse(&event);
+	  if ((event.bstate & (BUTTON1_CLICKED |
+			       BUTTON1_DOUBLE_CLICKED |
+			       BUTTON1_TRIPLE_CLICKED))
+	      && wenclose(uwin, event.y, event.x))
+	    {			/* we react only if the click was in the userwin, that means
+				 * inside the menu display area or at the decoration window.
+				 */
+	      WINDOW *sub = Get_Menu_Window(menu);
+	      int ry = event.y, rx = event.x;	/* screen coordinates */
+
+	      result = E_REQUEST_DENIED;
+	      if (mouse_trafo(&ry, &rx, FALSE))
+		{		/* rx, ry are now "curses" coordinates */
+		  if (ry < sub->_begy)
+		    {		/* we clicked above the display region; this is
+				 * interpreted as "scroll up" request
+				 */
+		      if (event.bstate & BUTTON1_CLICKED)
+			result = menu_driver(menu, REQ_SCR_ULINE);
+		      else if (event.bstate & BUTTON1_DOUBLE_CLICKED)
+			result = menu_driver(menu, REQ_SCR_UPAGE);
+		      else if (event.bstate & BUTTON1_TRIPLE_CLICKED)
+			result = menu_driver(menu, REQ_FIRST_ITEM);
+		      RETURN(result);
+		    }
+		  else if (ry >= sub->_begy + sub->_maxy)
+		    {		/* we clicked below the display region; this is
+				 * interpreted as "scroll down" request
+				 */
+		      if (event.bstate & BUTTON1_CLICKED)
+			result = menu_driver(menu, REQ_SCR_DLINE);
+		      else if (event.bstate & BUTTON1_DOUBLE_CLICKED)
+			result = menu_driver(menu, REQ_SCR_DPAGE);
+		      else if (event.bstate & BUTTON1_TRIPLE_CLICKED)
+			result = menu_driver(menu, REQ_LAST_ITEM);
+		      RETURN(result);
+		    }
+		  else if (wenclose(sub, event.y, event.x))
+		    {		/* Inside the area we try to find the hit item */
+		      int i, x, y, err;
+
+		      ry = event.y;
+		      rx = event.x;
+		      if (wmouse_trafo(sub, &ry, &rx, FALSE))
+			{
+			  for (i = 0; i < menu->nitems; i++)
+			    {
+			      err = _nc_menu_cursor_pos(menu, menu->items[i],
+							&y, &x);
+			      if (E_OK == err)
+				{
+				  if ((ry == y) &&
+				      (rx >= x) &&
+				      (rx < x + menu->itemlen))
+				    {
+				      item = menu->items[i];
+				      result = E_OK;
+				      break;
+				    }
+				}
+			    }
+			  if (E_OK == result)
+			    {	/* We found an item, now we can handle the click.
 				 * A single click just positions the menu cursor
 				 * to the clicked item. A double click toggles
 				 * the item.
 				 */
-				if (event.bstate & BUTTON1_DOUBLE_CLICKED)
-				  {
-				    _nc_New_TopRow_and_CurrentItem(menu,
-								   my_top_row,
-								   item);
-				    menu_driver(menu,REQ_TOGGLE_ITEM);
-				    result = E_UNKNOWN_COMMAND;
-				  }
-			      }
-			  }
-		      }
-		  }
-	      }
-	    else
-	        result = E_REQUEST_DENIED;
-	  }
+			      if (event.bstate & BUTTON1_DOUBLE_CLICKED)
+				{
+				  _nc_New_TopRow_and_CurrentItem(menu,
+								 my_top_row,
+								 item);
+				  menu_driver(menu, REQ_TOGGLE_ITEM);
+				  result = E_UNKNOWN_COMMAND;
+				}
+			    }
+			}
+		    }
+		}
+	    }
+	  else
+	    result = E_REQUEST_DENIED;
+	}
 #endif /* NCURSES_MOUSE_VERSION */
-	else
-	  result = E_UNKNOWN_COMMAND;
-      }
+      else
+	result = E_UNKNOWN_COMMAND;
+    }
 
-  if (E_OK==result)
+  if (E_OK == result)
     {
-    /* Adjust the top row if it turns out that the current item unfortunately
-       doesn't appear in the menu window */
-    if ( item->y < my_top_row )
-      my_top_row = item->y;
-    else if ( item->y >= (my_top_row + menu->arows) )
-      my_top_row = item->y - menu->arows + 1;
+      /* Adjust the top row if it turns out that the current item unfortunately
+         doesn't appear in the menu window */
+      if (item->y < my_top_row)
+	my_top_row = item->y;
+      else if (item->y >= (my_top_row + menu->arows))
+	my_top_row = item->y - menu->arows + 1;
 
-    _nc_New_TopRow_and_CurrentItem( menu, my_top_row, item );
+      _nc_New_TopRow_and_CurrentItem(menu, my_top_row, item);
 
     }
 
Index: menu/m_item_new.c
Prereq:  1.14 
--- ncurses-5.4-20040208/menu/m_item_new.c	2003-10-25 11:23:42.000000000 -0400
+++ ncurses-5.4-20040424/menu/m_item_new.c	2004-04-03 18:09:47.000000000 -0500
@@ -1,5 +1,5 @@
 /****************************************************************************
- * Copyright (c) 1998-2002,2003 Free Software Foundation, Inc.              *
+ * Copyright (c) 1998-2003,2004 Free Software Foundation, Inc.              *
  *                                                                          *
  * Permission is hereby granted, free of charge, to any person obtaining a  *
  * copy of this software and associated documentation files (the            *
@@ -38,7 +38,7 @@
 
 #include "menu.priv.h"
 
-MODULE_ID("$Id: m_item_new.c,v 1.14 2003/10/25 15:23:42 tom Exp $")
+MODULE_ID("$Id: m_item_new.c,v 1.16 2004/04/03 23:09:47 tom Exp $")
 
 /*---------------------------------------------------------------------------
 |   Facility      :  libnmenu  
@@ -50,12 +50,13 @@
 |   Return Values :  TRUE     - if string is printable
 |                    FALSE    - if string contains non-printable characters
 +--------------------------------------------------------------------------*/
-static bool Is_Printable_String(const char *s)
+static bool
+Is_Printable_String(const char *s)
 {
   assert(s);
-  while(*s)
+  while (*s)
     {
-      if (!isprint((unsigned char)*s))
+      if (!isprint(UChar(*s)))
 	return FALSE;
       s++;
     }
@@ -73,41 +74,41 @@
 |   Return Values :  The item pointer or NULL if creation failed.
 +--------------------------------------------------------------------------*/
 NCURSES_EXPORT(ITEM *)
-new_item (const char *name, const char *description)
+new_item(const char *name, const char *description)
 {
   ITEM *item;
-  
-  if ( !name || (*name == '\0') || !Is_Printable_String(name) )
+
+  if (!name || (*name == '\0') || !Is_Printable_String(name))
     {
-      item = (ITEM *)0;
-      SET_ERROR( E_BAD_ARGUMENT );
+      item = (ITEM *) 0;
+      SET_ERROR(E_BAD_ARGUMENT);
     }
   else
     {
-      item = (ITEM *)calloc(1,sizeof(ITEM));
+      item = (ITEM *) calloc(1, sizeof(ITEM));
       if (item)
 	{
-	  *item  = _nc_Default_Item; /* hope we have struct assignment */
-	  
-	  item->name.length	   = strlen(name);
-	  item->name.str 	   = name;
+	  *item = _nc_Default_Item;	/* hope we have struct assignment */
+
+	  item->name.length = strlen(name);
+	  item->name.str = name;
 
-	  if (description && (*description != '\0') && 
+	  if (description && (*description != '\0') &&
 	      Is_Printable_String(description))
 	    {
-	      item->description.length = strlen(description);	      
-	      item->description.str    = description;
+	      item->description.length = strlen(description);
+	      item->description.str = description;
 	    }
 	  else
 	    {
 	      item->description.length = 0;
-	      item->description.str    = (char *)0;
+	      item->description.str = (char *)0;
 	    }
 	}
       else
-	SET_ERROR( E_SYSTEM_ERROR );
-    }  
-  return(item);
+	SET_ERROR(E_SYSTEM_ERROR);
+    }
+  return (item);
 }
 
 /*---------------------------------------------------------------------------
@@ -122,17 +123,17 @@
 |                    E_CONNECTED       - item is still connected to a menu    
 +--------------------------------------------------------------------------*/
 NCURSES_EXPORT(int)
-free_item (ITEM * item)
+free_item(ITEM * item)
 {
   if (!item)
-    RETURN( E_BAD_ARGUMENT );
+    RETURN(E_BAD_ARGUMENT);
 
   if (item->imenu)
-    RETURN( E_CONNECTED );
-  
+    RETURN(E_CONNECTED);
+
   free(item);
 
-  RETURN( E_OK );
+  RETURN(E_OK);
 }
 
 /*---------------------------------------------------------------------------
@@ -153,16 +154,16 @@
 |                    E_SYSTEM_ERROR     - no memory to store mark
 +--------------------------------------------------------------------------*/
 NCURSES_EXPORT(int)
-set_menu_mark (MENU * menu, const char * mark)
+set_menu_mark(MENU * menu, const char *mark)
 {
   int l;
 
-  if ( mark && (*mark != '\0') && Is_Printable_String(mark) )
+  if (mark && (*mark != '\0') && Is_Printable_String(mark))
     l = strlen(mark);
   else
     l = 0;
 
-  if ( menu )
+  if (menu)
     {
       char *old_mark = menu->mark;
       unsigned short old_status = menu->status;
@@ -171,13 +172,13 @@
 	{
 	  /* If the menu is already posted, the geometry is fixed. Then
 	     we can only accept a mark with exactly the same length */
-	  if (menu->marklen != l) 
+	  if (menu->marklen != l)
 	    RETURN(E_BAD_ARGUMENT);
-	}	
+	}
       menu->marklen = l;
       if (l)
 	{
-	  menu->mark = (char *)malloc(l+1);
+	  menu->mark = (char *)malloc(l + 1);
 	  if (menu->mark)
 	    {
 	      strcpy(menu->mark, mark);
@@ -192,19 +193,19 @@
 	}
       else
 	menu->mark = (char *)0;
-      
+
       if ((old_status & _MARK_ALLOCATED) && old_mark)
 	free(old_mark);
 
       if (menu->status & _POSTED)
 	{
-	  _nc_Draw_Menu( menu );
-	  _nc_Show_Menu( menu );
+	  _nc_Draw_Menu(menu);
+	  _nc_Show_Menu(menu);
 	}
       else
 	{
 	  /* Recalculate the geometry */
-	  _nc_Calculate_Item_Length_and_Width( menu );			
+	  _nc_Calculate_Item_Length_and_Width(menu);
 	}
     }
   else
@@ -223,9 +224,9 @@
 |   Return Values :  The marker string pointer or NULL if no marker defined
 +--------------------------------------------------------------------------*/
 NCURSES_EXPORT(const char *)
-menu_mark (const MENU * menu)
+menu_mark(const MENU * menu)
 {
-  return Normalize_Menu( menu )->mark;
+  return Normalize_Menu(menu)->mark;
 }
 
 /* m_item_new.c */
Index: menu/m_pad.c
Prereq:  1.7 
--- ncurses-5.4-20040208/menu/m_pad.c	2003-10-25 10:54:48.000000000 -0400
+++ ncurses-5.4-20040424/menu/m_pad.c	2004-04-03 18:08:49.000000000 -0500
@@ -1,5 +1,5 @@
 /****************************************************************************
- * Copyright (c) 1998,2000 Free Software Foundation, Inc.                   *
+ * Copyright (c) 1998-2003,2004 Free Software Foundation, Inc.              *
  *                                                                          *
  * Permission is hereby granted, free of charge, to any person obtaining a  *
  * copy of this software and associated documentation files (the            *
@@ -37,7 +37,7 @@
 
 #include "menu.priv.h"
 
-MODULE_ID("$Id: m_pad.c,v 1.7 2003/10/25 14:54:48 tom Exp $")
+MODULE_ID("$Id: m_pad.c,v 1.8 2004/04/03 23:08:49 tom Exp $")
 
 /* Macro to redraw menu if it is posted and changed */
 #define Refresh_Menu(menu) \
@@ -59,18 +59,18 @@
 |                    E_BAD_ARGUMENT    - an invalid value has been passed
 +--------------------------------------------------------------------------*/
 NCURSES_EXPORT(int)
-set_menu_pad (MENU *menu, int pad)
+set_menu_pad(MENU * menu, int pad)
 {
-  bool do_refresh = (menu != (MENU*)0);
+  bool do_refresh = (menu != (MENU *) 0);
 
-  if (!isprint((unsigned char)pad))
+  if (!isprint(UChar(pad)))
     RETURN(E_BAD_ARGUMENT);
-  
-  Normalize_Menu( menu );
+
+  Normalize_Menu(menu);
   menu->pad = pad;
-  
+
   if (do_refresh)
-      Refresh_Menu( menu );
+    Refresh_Menu(menu);
 
   RETURN(E_OK);
 }
@@ -84,9 +84,9 @@
 |   Return Values :  The pad character
 +--------------------------------------------------------------------------*/
 NCURSES_EXPORT(int)
-menu_pad (const MENU * menu)
+menu_pad(const MENU * menu)
 {
-  return (Normalize_Menu( menu ) -> pad);
+  return (Normalize_Menu(menu)->pad);
 }
 
 /* m_pad.c ends here */
Index: menu/m_pattern.c
Prereq:  1.9 
--- ncurses-5.4-20040208/menu/m_pattern.c	2003-12-06 12:22:10.000000000 -0500
+++ ncurses-5.4-20040424/menu/m_pattern.c	2004-04-03 18:09:47.000000000 -0500
@@ -1,5 +1,5 @@
 /****************************************************************************
- * Copyright (c) 1998-2002,2003 Free Software Foundation, Inc.              *
+ * Copyright (c) 1998-2003,2004 Free Software Foundation, Inc.              *
  *                                                                          *
  * Permission is hereby granted, free of charge, to any person obtaining a  *
  * copy of this software and associated documentation files (the            *
@@ -37,7 +37,7 @@
 
 #include "menu.priv.h"
 
-MODULE_ID("$Id: m_pattern.c,v 1.9 2003/12/06 17:22:10 tom Exp $")
+MODULE_ID("$Id: m_pattern.c,v 1.11 2004/04/03 23:09:47 tom Exp $")
 
 /*---------------------------------------------------------------------------
 |   Facility      :  libnmenu  
@@ -51,7 +51,7 @@
 |                    PatternString - as expected
 +--------------------------------------------------------------------------*/
 NCURSES_EXPORT(char *)
-menu_pattern (const MENU * menu)
+menu_pattern(const MENU * menu)
 {
   return (char *)(menu ? (menu->pattern ? menu->pattern : "") : 0);
 }
@@ -70,49 +70,49 @@
 |                    E_NO_MATCH        - no item matches pattern
 +--------------------------------------------------------------------------*/
 NCURSES_EXPORT(int)
-set_menu_pattern (MENU *menu, const char *p)
+set_menu_pattern(MENU * menu, const char *p)
 {
   ITEM *matchitem;
-  int   matchpos;
-  
-  if (!menu || !p)	
+  int matchpos;
+
+  if (!menu || !p)
     RETURN(E_BAD_ARGUMENT);
-  
+
   if (!(menu->items))
     RETURN(E_NOT_CONNECTED);
-  
-  if ( menu->status & _IN_DRIVER )
+
+  if (menu->status & _IN_DRIVER)
     RETURN(E_BAD_STATE);
-  
+
   Reset_Pattern(menu);
-  
+
   if (!(*p))
     {
       pos_menu_cursor(menu);
       RETURN(E_OK);
     }
-  
-  if (menu->status & _LINK_NEEDED) 
+
+  if (menu->status & _LINK_NEEDED)
     _nc_Link_Items(menu);
-  
-  matchpos  = menu->toprow;
+
+  matchpos = menu->toprow;
   matchitem = menu->curitem;
   assert(matchitem);
-  
-  while(*p)
+
+  while (*p)
     {
-      if ( !isprint((unsigned char)(*p)) || 
-	  (_nc_Match_Next_Character_In_Item_Name(menu,*p,&matchitem) != E_OK) )
+      if (!isprint(UChar(*p)) ||
+	  (_nc_Match_Next_Character_In_Item_Name(menu, *p, &matchitem) != E_OK))
 	{
 	  Reset_Pattern(menu);
 	  pos_menu_cursor(menu);
 	  RETURN(E_NO_MATCH);
 	}
       p++;
-    }			
-  
+    }
+
   /* This is reached if there was a match. So we position to the new item */
-  Adjust_Current_Item(menu,matchpos,matchitem);
+  Adjust_Current_Item(menu, matchpos, matchitem);
   RETURN(E_OK);
 }
 
Index: menu/m_post.c
Prereq:  1.19 
--- ncurses-5.4-20040208/menu/m_post.c	2003-10-25 10:54:48.000000000 -0400
+++ ncurses-5.4-20040424/menu/m_post.c	2004-04-10 19:45:59.000000000 -0400
@@ -1,5 +1,5 @@
 /****************************************************************************
- * Copyright (c) 1998,2000 Free Software Foundation, Inc.                   *
+ * Copyright (c) 1998-2003,2004 Free Software Foundation, Inc.              *
  *                                                                          *
  * Permission is hereby granted, free of charge, to any person obtaining a  *
  * copy of this software and associated documentation files (the            *
@@ -37,113 +37,113 @@
 
 #include "menu.priv.h"
 
-MODULE_ID("$Id: m_post.c,v 1.19 2003/10/25 14:54:48 tom Exp $")
+MODULE_ID("$Id: m_post.c,v 1.21 2004/04/10 23:45:59 tom Exp $")
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnmenu  
-|   Function      :  void _nc_Post_Item(MENU *menu, ITEM *item)  
-|   
+|   Facility      :  libnmenu
+|   Function      :  void _nc_Post_Item(MENU *menu, ITEM *item)
+|
 |   Description   :  Draw the item in the menus window at the current
-|                    window position 
+|                    window position
 |
 |   Return Values :  -
 +--------------------------------------------------------------------------*/
 NCURSES_EXPORT(void)
-_nc_Post_Item (const MENU * menu, const ITEM * item)
+_nc_Post_Item(const MENU * menu, const ITEM * item)
 {
   int i;
   chtype ch;
   int item_x, item_y;
   int count = 0;
-  bool isfore = FALSE, isback=FALSE, isgrey = FALSE;
-  
+  bool isfore = FALSE, isback = FALSE, isgrey = FALSE;
+
   assert(menu->win);
-  
-  getyx(menu->win,item_y,item_x);
-  
+
+  getyx(menu->win, item_y, item_x);
+
   /* We need a marker iff
-     - it is a onevalued menu and it is the current item
-     - or it has a selection value
-     */
-  wattron(menu->win,menu->back);
-  if (item->value || (item==menu->curitem))
+   - it is a onevalued menu and it is the current item
+   - or it has a selection value
+   */
+  wattron(menu->win, menu->back);
+  if (item->value || (item == menu->curitem))
     {
-      if (menu->marklen) 
+      if (menu->marklen)
 	{
 	  /* In a multi selection menu we use the fore attribute
 	     for a selected marker that is not the current one.
 	     This improves visualization of the menu, because now
 	     always the 'normal' marker denotes the current
 	     item. */
-	  if (!(menu->opt & O_ONEVALUE) && item->value && item!=menu->curitem)
+	  if (!(menu->opt & O_ONEVALUE) && item->value && item != menu->curitem)
 	    {
-	      wattron(menu->win,menu->fore);
+	      wattron(menu->win, menu->fore);
 	      isfore = TRUE;
 	    }
-	  waddstr(menu->win,menu->mark);
+	  waddstr(menu->win, menu->mark);
 	  if (isfore)
 	    {
-	      wattron(menu->win,menu->fore);
+	      wattron(menu->win, menu->fore);
 	      isfore = FALSE;
 	    }
 	}
     }
-  else			/* otherwise we have to wipe out the marker area */ 
-    for(ch=' ',i=menu->marklen;i>0;i--) 
-      waddch(menu->win,ch);
-  wattroff(menu->win,menu->back);
+  else				/* otherwise we have to wipe out the marker area */
+    for (ch = ' ', i = menu->marklen; i > 0; i--)
+      waddch(menu->win, ch);
+  wattroff(menu->win, menu->back);
   count += menu->marklen;
 
   /* First we have to calculate the attribute depending on selectability
      and selection status
-     */
+   */
   if (!(item->opt & O_SELECTABLE))
     {
-      wattron(menu->win,menu->grey);
+      wattron(menu->win, menu->grey);
       isgrey = TRUE;
     }
   else
     {
-      if (item->value || item==menu->curitem)
+      if (item->value || item == menu->curitem)
 	{
-	  wattron(menu->win,menu->fore);
+	  wattron(menu->win, menu->fore);
 	  isfore = TRUE;
 	}
       else
 	{
-	  wattron(menu->win,menu->back);
+	  wattron(menu->win, menu->back);
 	  isback = TRUE;
 	}
     }
 
-  waddnstr(menu->win,item->name.str,item->name.length);
-  for(ch=' ',i=menu->namelen-item->name.length;i>0;i--)
+  waddnstr(menu->win, item->name.str, item->name.length);
+  for (ch = ' ', i = menu->namelen - item->name.length; i > 0; i--)
     {
-      waddch(menu->win,ch);
+      waddch(menu->win, ch);
     }
   count += menu->namelen;
 
   /* Show description if required and available */
-  if ( (menu->opt & O_SHOWDESC) && menu->desclen>0 )
+  if ((menu->opt & O_SHOWDESC) && menu->desclen > 0)
     {
-      int m = menu->spc_desc/2;
+      int m = menu->spc_desc / 2;
       int cy = -1, cx = -1;
 
-      for(ch=' ',i=0; i < menu->spc_desc; i++)
+      for (ch = ' ', i = 0; i < menu->spc_desc; i++)
 	{
-	  if (i==m)
+	  if (i == m)
 	    {
-	      waddch(menu->win,menu->pad);
-	      getyx(menu->win,cy,cx);
+	      waddch(menu->win, menu->pad);
+	      getyx(menu->win, cy, cx);
 	    }
 	  else
-	    waddch(menu->win,ch);
+	    waddch(menu->win, ch);
 	}
       if (item->description.length)
-	waddnstr(menu->win,item->description.str,item->description.length);
-      for(ch=' ',i=menu->desclen-item->description.length; i>0; i--)
+	waddnstr(menu->win, item->description.str, item->description.length);
+      for (ch = ' ', i = menu->desclen - item->description.length; i > 0; i--)
 	{
-	  waddch(menu->win,ch);
+	  waddch(menu->win, ch);
 	}
       count += menu->desclen + menu->spc_desc;
 
@@ -151,47 +151,49 @@
 	{
 	  int j, k, ncy, ncx;
 
-	  assert(cx>=0 && cy>=0);
-	  getyx(menu->win,ncy,ncx);
-	  if (isgrey) wattroff(menu->win,menu->grey);
-	  else if (isfore) wattroff(menu->win,menu->fore);
-	  wattron(menu->win,menu->back);
-	  for(j=1; j < menu->spc_rows;j++)
+	  assert(cx >= 0 && cy >= 0);
+	  getyx(menu->win, ncy, ncx);
+	  if (isgrey)
+	    wattroff(menu->win, menu->grey);
+	  else if (isfore)
+	    wattroff(menu->win, menu->fore);
+	  wattron(menu->win, menu->back);
+	  for (j = 1; j < menu->spc_rows; j++)
 	    {
-	      if ((item_y+j) < getmaxy(menu->win))
+	      if ((item_y + j) < getmaxy(menu->win))
 		{
-		  wmove (menu->win,item_y+j,item_x);
-		  for(k=0;k<count;k++)
-		    waddch(menu->win,' ');
+		  wmove(menu->win, item_y + j, item_x);
+		  for (k = 0; k < count; k++)
+		    waddch(menu->win, ' ');
 		}
-	      if ((cy+j) < getmaxy(menu->win))
-		mvwaddch(menu->win,cy+j,cx-1,menu->pad);
+	      if ((cy + j) < getmaxy(menu->win))
+		mvwaddch(menu->win, cy + j, cx - 1, menu->pad);
 	    }
-	  wmove(menu->win,ncy,ncx);
+	  wmove(menu->win, ncy, ncx);
 	  if (!isback)
-	    wattroff(menu->win,menu->back);
+	    wattroff(menu->win, menu->back);
 	}
     }
-  
+
   /* Remove attributes */
   if (isfore)
-    wattroff(menu->win,menu->fore);
+    wattroff(menu->win, menu->fore);
   if (isback)
-    wattroff(menu->win,menu->back);
+    wattroff(menu->win, menu->back);
   if (isgrey)
-    wattroff(menu->win,menu->grey);
-}	
+    wattroff(menu->win, menu->grey);
+}
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnmenu  
+|   Facility      :  libnmenu
 |   Function      :  void _nc_Draw_Menu(const MENU *)
-|   
+|
 |   Description   :  Display the menu in its windows
 |
 |   Return Values :  -
 +--------------------------------------------------------------------------*/
 NCURSES_EXPORT(void)
-_nc_Draw_Menu (const MENU * menu)
+_nc_Draw_Menu(const MENU * menu)
 {
   ITEM *item = menu->items[0];
   ITEM *lasthor, *lastvert;
@@ -202,75 +204,76 @@
   assert(item && menu->win);
 
   s_bkgd = getbkgd(menu->win);
-  wbkgdset(menu->win,menu->back);
+  wbkgdset(menu->win, menu->back);
   werase(menu->win);
-  wbkgdset(menu->win,s_bkgd);
+  wbkgdset(menu->win, s_bkgd);
 
-  lastvert = (menu->opt & O_NONCYCLIC) ? (ITEM *)0 : item;  
+  lastvert = (menu->opt & O_NONCYCLIC) ? (ITEM *) 0 : item;
 
   do
-    {  
-      wmove(menu->win,y,0);
+    {
+      wmove(menu->win, y, 0);
+
+      hitem = item;
+      lasthor = (menu->opt & O_NONCYCLIC) ? (ITEM *) 0 : hitem;
 
-      hitem   = item;
-      lasthor = (menu->opt & O_NONCYCLIC) ? (ITEM *)0 : hitem;
-      
       do
 	{
-	  _nc_Post_Item( menu, hitem);
+	  _nc_Post_Item(menu, hitem);
 
-	  wattron(menu->win,menu->back);
-	  if ( ((hitem = hitem->right) != lasthor) && hitem )
+	  wattron(menu->win, menu->back);
+	  if (((hitem = hitem->right) != lasthor) && hitem)
 	    {
-	      int i,j, cy, cx;
+	      int i, j, cy, cx;
 	      chtype ch = ' ';
 
-	      getyx(menu->win,cy,cx);
-	      for(j=0;j<menu->spc_rows;j++)
+	      getyx(menu->win, cy, cx);
+	      for (j = 0; j < menu->spc_rows; j++)
 		{
-		  wmove(menu->win,cy+j,cx);
-		  for(i=0; i < menu->spc_cols; i++)
+		  wmove(menu->win, cy + j, cx);
+		  for (i = 0; i < menu->spc_cols; i++)
 		    {
-		      waddch( menu->win,ch);
+		      waddch(menu->win, ch);
 		    }
 		}
-	      wmove(menu->win,cy,cx+menu->spc_cols);
+	      wmove(menu->win, cy, cx + menu->spc_cols);
 	    }
-	} while (hitem && (hitem != lasthor));
-      wattroff(menu->win,menu->back);
-      
+	}
+      while (hitem && (hitem != lasthor));
+      wattroff(menu->win, menu->back);
+
       item = item->down;
       y += menu->spc_rows;
-      
-    } while( item && (item != lastvert) );
+
+    }
+  while (item && (item != lastvert));
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnmenu  
+|   Facility      :  libnmenu
 |   Function      :  int post_menu(MENU *)
-|   
+|
 |   Description   :  Post a menu to the screen. This makes it visible.
 |
 |   Return Values :  E_OK                - success
 |                    E_BAD_ARGUMENT      - not a valid menu pointer
 |                    E_SYSTEM_ERROR      - error in lower layers
-|                    E_NO_ROOM           - Menu to large for screen
 |                    E_NOT_CONNECTED     - No items connected to menu
 |                    E_BAD_STATE         - Menu in userexit routine
 |                    E_POSTED            - Menu already posted
 +--------------------------------------------------------------------------*/
 NCURSES_EXPORT(int)
-post_menu (MENU * menu)
+post_menu(MENU * menu)
 {
   if (!menu)
     RETURN(E_BAD_ARGUMENT);
-  
-  if ( menu->status & _IN_DRIVER )
+
+  if (menu->status & _IN_DRIVER)
     RETURN(E_BAD_STATE);
 
-  if ( menu->status & _POSTED )
+  if (menu->status & _POSTED)
     RETURN(E_POSTED);
-  
+
   if (menu->items && *(menu->items))
     {
       int y;
@@ -278,54 +281,50 @@
 
       WINDOW *win = Get_Menu_Window(menu);
       int maxy = getmaxy(win);
-      int maxx = getmaxx(win);
-      
-      if (maxx < menu->width || maxy < menu->height)
-	RETURN(E_NO_ROOM);
 
-      if ( (menu->win = newpad(h,menu->width)) )
+      if ((menu->win = newpad(h, menu->width)))
 	{
 	  y = (maxy >= h) ? h : maxy;
-	  if (y>=menu->height) 
+	  if (y >= menu->height)
 	    y = menu->height;
-	  if(!(menu->sub = subpad(menu->win,y,menu->width,0,0)))
+	  if (!(menu->sub = subpad(menu->win, y, menu->width, 0, 0)))
 	    RETURN(E_SYSTEM_ERROR);
 	}
-      else 
-	RETURN(E_SYSTEM_ERROR);	
-      
-      if (menu->status & _LINK_NEEDED) 
+      else
+	RETURN(E_SYSTEM_ERROR);
+
+      if (menu->status & _LINK_NEEDED)
 	_nc_Link_Items(menu);
     }
   else
     RETURN(E_NOT_CONNECTED);
-  
+
   menu->status |= _POSTED;
 
-  if (!(menu->opt&O_ONEVALUE))
+  if (!(menu->opt & O_ONEVALUE))
     {
       ITEM **items;
-  
-      for(items=menu->items;*items;items++)
+
+      for (items = menu->items; *items; items++)
 	{
 	  (*items)->value = FALSE;
 	}
     }
-  
+
   _nc_Draw_Menu(menu);
-  
-  Call_Hook(menu,menuinit);
-  Call_Hook(menu,iteminit);
-  
+
+  Call_Hook(menu, menuinit);
+  Call_Hook(menu, iteminit);
+
   _nc_Show_Menu(menu);
-  
+
   RETURN(E_OK);
 }
 
 /*---------------------------------------------------------------------------
-|   Facility      :  libnmenu  
+|   Facility      :  libnmenu
 |   Function      :  int unpost_menu(MENU *)
-|   
+|
 |   Description   :  Detach menu from screen
 |
 |   Return Values :  E_OK              - success
@@ -334,36 +333,36 @@
 |                    E_NOT_POSTED      - menu is not posted
 +--------------------------------------------------------------------------*/
 NCURSES_EXPORT(int)
-unpost_menu (MENU * menu)
+unpost_menu(MENU * menu)
 {
   WINDOW *win;
-  
+
   if (!menu)
     RETURN(E_BAD_ARGUMENT);
-  
-  if ( menu->status & _IN_DRIVER )
+
+  if (menu->status & _IN_DRIVER)
     RETURN(E_BAD_STATE);
 
-  if ( !( menu->status & _POSTED ) )
+  if (!(menu->status & _POSTED))
     RETURN(E_NOT_POSTED);
-  
-  Call_Hook(menu,itemterm);
-  Call_Hook(menu,menuterm);	
-  
+
+  Call_Hook(menu, itemterm);
+  Call_Hook(menu, menuterm);
+
   win = Get_Menu_Window(menu);
   werase(win);
   wsyncup(win);
-  
+
   assert(menu->sub);
   delwin(menu->sub);
-  menu->sub = (WINDOW *)0;
-  
+  menu->sub = (WINDOW *) 0;
+
   assert(menu->win);
   delwin(menu->win);
-  menu->win = (WINDOW *)0;
-  
+  menu->win = (WINDOW *) 0;
+
   menu->status &= ~_POSTED;
-  
+
   RETURN(E_OK);
 }
 
Index: menu/menu.priv.h
Prereq:  1.16 
--- ncurses-5.4-20040208/menu/menu.priv.h	2003-10-25 11:24:29.000000000 -0400
+++ ncurses-5.4-20040424/menu/menu.priv.h	2004-04-03 18:08:32.000000000 -0500
@@ -1,5 +1,5 @@
 /****************************************************************************
- * Copyright (c) 1998-2002,2003 Free Software Foundation, Inc.              *
+ * Copyright (c) 1998-2003,2004 Free Software Foundation, Inc.              *
  *                                                                          *
  * Permission is hereby granted, free of charge, to any person obtaining a  *
  * copy of this software and associated documentation files (the            *
@@ -30,7 +30,7 @@
  *   Author:  Juergen Pfeifer, 1995,1997                                    *
  ****************************************************************************/
 
-/* $Id: menu.priv.h,v 1.16 2003/10/25 15:24:29 tom Exp $ */
+/* $Id: menu.priv.h,v 1.17 2004/04/03 23:08:32 tom Exp $ */
 
 /***************************************************************************
 * Module menu.priv.h                                                       *
@@ -108,6 +108,8 @@
   { (menu)->pindex = 0; \
     (menu)->pattern[0] = '\0'; }
 
+#define UChar(c)	((unsigned char)(c))
+
 /* Internal functions. */
 extern NCURSES_EXPORT(void) _nc_Draw_Menu (const MENU *);
 extern NCURSES_EXPORT(void) _nc_Show_Menu (const MENU *);
Index: misc/terminfo.src
--- ncurses-5.4-20040208/misc/terminfo.src	2004-01-17 20:37:18.000000000 -0500
+++ ncurses-5.4-20040424/misc/terminfo.src	2004-03-27 18:29:17.000000000 -0500
@@ -4,8 +4,8 @@
 # Report bugs and new terminal descriptions to
 #	bug-ncurses@gnu.org
 #
-#	$Revision: 1.227 $
-#	$Date: 2004/01/18 01:37:18 $
+#	$Revision: 1.228 $
+#	$Date: 2004/03/27 23:29:17 $
 #
 # The original header is preserved below for reference.  It is noted that there
 # is a newer version which differs in some cosmetic details; we have decided
@@ -329,7 +329,9 @@
 	kbs=^H, kcub1=\E[D, kcud1=\E[B, kcuf1=\E[C, kcuu1=\E[A, 
 	khome=\E[H, 
 ansi+sgr|ansi graphic renditions, 
-	blink=\E[5m, invis=\E[8m, rev=\E[7m, sgr0=\E[0m, 
+	blink=\E[5m, invis=\E[8m, rev=\E[7m, 
+	sgr=\E[0%?%p3%t;7%;%?%p4%t;5%;%?%p7%t;8%;m%;, 
+	sgr0=\E[0m, 
 ansi+sgrso|ansi standout only, 
 	rmso=\E[m, smso=\E[7m, 
 ansi+sgrul|ansi underline only, 
@@ -2240,11 +2242,11 @@
 	cnorm=\E[?25h, cr=^M, csr=\E[%i%p1%d;%p2%dr, 
 	cub=\E[%p1%dD, cub1=^H, cud=\E[%p1%dB, cud1=^J, 
 	cuf=\E[%p1%dC, cuf1=\E[C, cup=\E[%i%p1%d;%p2%dH, 
-	cuu=\E[%p1%dA, cuu1=\E[A, cvvis=\E[?25h, dch=\E[%p1%dP, 
-	dch1=\E[P, dl=\E[%p1%dM, dl1=\E[M, 
-	dsl=\E[2$~\r\E[1$}\E[K\E[$}, ed=\E[J, el=\E[K, 
-	flash=\E[?5h\E[?5l$<200/>, fsl=\E[$}, home=\E[H, ht=^I, 
-	hts=\EH, ich=\E[%p1%d@, il=\E[%p1%dL, il1=\E[L, ind=\ED, 
+	cuu=\E[%p1%dA, cuu1=\E[A, dch=\E[%p1%dP, dch1=\E[P, 
+	dl=\E[%p1%dM, dl1=\E[M, dsl=\E[2$~\r\E[1$}\E[K\E[$}, 
+	ed=\E[J, el=\E[K, flash=\E[?5h\E[?5l$<200/>, fsl=\E[$}, 
+	home=\E[H, ht=^I, hts=\EH, ich=\E[%p1%d@, il=\E[%p1%dL, 
+	il1=\E[L, ind=\ED, 
 	is2=\E<\E F\E>\E[?1h\E[?3l\E[?4l\E[?5l\E[?7h\E[?8h\E[1;24r\E[24;1H, 
 	kbs=^H, kcub1=\EOD, kcud1=\EOB, kcuf1=\EOC, kcuu1=\EOA, 
 	kf1=\EOP, kf2=\EOQ, kf3=\EOR, kf4=\EOS, kf6=\E[17~, 
@@ -2286,8 +2288,8 @@
 	csr=\E[%i%p1%d;%p2%dr, cub=\E[%p1%dD, cub1=^H, 
 	cud=\E[%p1%dB, cud1=^J, cuf=\E[%p1%dC, cuf1=\E[C, 
 	cup=\E[%i%p1%d;%p2%dH, cuu=\E[%p1%dA, cuu1=\E[A, 
-	cvvis=\E[?25h, dch=\E[%p1%dP, dch1=\E[P, dl=\E[%p1%dM, 
-	dl1=\E[M, dsl=\E[2$~\r\E[1$}\E[K\E[$}, ed=\E[J$<10/>, 
+	dch=\E[%p1%dP, dch1=\E[P, dl=\E[%p1%dM, dl1=\E[M, 
+	dsl=\E[2$~\r\E[1$}\E[K\E[$}, ed=\E[J$<10/>, 
 	el=\E[K$<4/>, flash=\E[?5h\E[?5l$<200/>, fsl=\E[$}, 
 	home=\E[H, ht=^I, hts=\EH, ich=\E[%p1%d@, ich1=\E[@, 
 	il=\E[%p1%dL, il1=\E[L, ind=\ED, 
@@ -3285,14 +3287,15 @@
 	rmir=\E[4l, rmkx=\E>, rmso=\E[27m, rmul=\E[24m, 
 	rs1=\E>\E[1;3;4;5;6l\E[?7h\E[m\E[r\E[2J\E[H, 
 	rs2=\E[r\E[m\E[2J\E[H\E[?7h\E[?1;3;4;6l\E[4l\E>, 
-	s0ds=\E(B, s1ds=\E(0, sc=\E7, sgr0=\E[0m\017, smacs=^N, 
-	smcup=\E7\E[?47h, smir=\E[4h, smkx=\E=, smso=\E[7m, 
-	smul=\E[4m, tbc=\E[3g, use=vt220+keypad, 
+	s0ds=\E(B, s1ds=\E(0, sc=\E7, 
+	sgr=\E[0%?%p6%t;1%;%?%p2%t;4%;%?%p1%p3%|%t;7%;%?%p4%t;5%;m%?%p9%t\016%e\017%;, 
+	sgr0=\E[0m\017, smacs=^N, smcup=\E7\E[?47h, smir=\E[4h, 
+	smkx=\E=, smso=\E[7m, smul=\E[4m, tbc=\E[3g, 
+	use=vt220+keypad, 
 rxvt|rxvt terminal emulator (X Window System), 
 	ncv@, 
-	cvvis=\E[?25h, hpa=\E[%i%p1%dG, kf0=\E[21~, 
-	sgr0=\E[m\017, vpa=\E[%i%p1%dd, use=rxvt-basic, 
-	use=ecma+color, 
+	hpa=\E[%i%p1%dG, kf0=\E[21~, sgr0=\E[m\017, 
+	vpa=\E[%i%p1%dd, use=rxvt-basic, use=ecma+color, 
 rxvt-color|rxvt terminal emulator (X Window System), 
 	use=rxvt, 
 rxvt-xpm|rxvt terminal emulator (X Window System), 
@@ -3656,10 +3659,11 @@
 	khome=\E[1~, kich1=\E[2~, kmous=\E[M, knp=\E[6~, kpp=\E[5~, 
 	nel=\EE, rc=\E8, rev=\E[7m, ri=\EM, rmacs=^O, 
 	rmcup=\E[?1049l, rmir=\E[4l, rmkx=\E[?1l\E>, rmso=\E[23m, 
-	rmul=\E[24m, rs2=\Ec, sc=\E7, sgr0=\E[m, smacs=^N, 
-	smcup=\E[?1049h, smir=\E[4h, smkx=\E[?1h\E=, smso=\E[3m, 
-	smul=\E[4m, tbc=\E[3g, E0=\E(B, S0=\E(%p1%c, 
-	use=ecma+color, 
+	rmul=\E[24m, rs2=\Ec, sc=\E7, 
+	sgr=\E[0%?%p6%t;1%;%?%p1%t;3%;%?%p2%t;4%;%?%p3%t;7%;%?%p4%t;5%;m%?%p9%t\016%e\017%;, 
+	sgr0=\E[m, smacs=^N, smcup=\E[?1049h, smir=\E[4h, 
+	smkx=\E[?1h\E=, smso=\E[3m, smul=\E[4m, tbc=\E[3g, E0=\E(B, 
+	S0=\E(%p1%c, use=ecma+color, 
 # The bce and status-line entries are from screen 3.9.13 (and require some
 # changes to .screenrc).
 screen-bce|VT 100/ANSI X3.64 virtual terminal with bce, 
@@ -8609,8 +8613,8 @@
 	csr=\E[%i%p1%d;%p2%dr, cub=\E[%p1%dD, cub1=^H, 
 	cud=\E[%p1%dB, cud1=^J, cuf=\E[%p1%dC, cuf1=\E[C, 
 	cup=\E[%i%p1%d;%p2%dH, cuu=\E[%p1%dA, cuu1=\E[A, 
-	cvvis=\E[?25h, dch=\E[%p1%dP, dch1=\E[P, dl=\E[%p1%dM, 
-	dl1=\E[M, dsl=\E[2$~\r\E[1$}\E[K\E[$}, ed=\E[J, el=\E[K, 
+	dch=\E[%p1%dP, dch1=\E[P, dl=\E[%p1%dM, dl1=\E[M, 
+	dsl=\E[2$~\r\E[1$}\E[K\E[$}, ed=\E[J, el=\E[K, 
 	flash=\E[?5h\E[?5l, fsl=\E[$}, home=\E[H, ht=^I, hts=\EH, 
 	ich=\E[%p1%d@, il=\E[%p1%dL, il1=\E[L$<3/>, ind=\ED, 
 	is2=\E>\E[?3l\E[?4l\E[?5l\E[?7h\E[?8h\E[1;24r\E[24;1H, 
@@ -8712,10 +8716,9 @@
 	bel=^G, blink=\E[5m, bold=\E[1m, cbt=\E[Z, civis=\E[?25l, 
 	clear=^L, cnorm=\E[?25h, cr=^M, csr=\E[%i%p1%d;%p2%dr, 
 	cub1=^H, cud1=^C, cuf1=^B, 
-	cup=\037%p2%{32}%+%c%p1%{32}%+%c, cuu1=^^, 
-	cvvis=\E[?25h, dch1=^W, dl=\E[%p1%dM, dl1=^Z, 
-	ech=\E[%p1%dX, ed=^F5, el=^P^P, ht=^I, il=\E[%p1%dL, il1=^K, 
-	ind=\ED, invis=\E[8m, 
+	cup=\037%p2%{32}%+%c%p1%{32}%+%c, cuu1=^^, dch1=^W, 
+	dl=\E[%p1%dM, dl1=^Z, ech=\E[%p1%dX, ed=^F5, el=^P^P, ht=^I, 
+	il=\E[%p1%dL, il1=^K, ind=\ED, invis=\E[8m, 
 	is2=\017\035\E(B\E)0\E[?7h\E[?3l\E[>8g, kbs=^H, 
 	kcub1=^B, kcud1=^N, kcuf1=^F, kcuu1=^P, khome=^A, nel=^M\ED, 
 	rc=\E8, rep=\030%p1%c%p2%c, rev=^R, ri=\EM, rmcup=, rmdc=, 
@@ -12360,11 +12363,11 @@
 	bw@, eslok, 
 	it#8, wsl#80, 
 	blink=\EG2, bold=\EG0, civis=\E.1, cnorm=\E.2, cud1=^V, 
-	cvvis=\E.2, dim=\EG@, dl1=\ER, dsl=\Ef\r, 
-	flash=\Eb$<200/>\Ed, il1=\EE, ip@, is2@, kclr=^^, kdch1=\EW, 
-	kdl1=\ER, ked=\EY, kel=\ET, kf0=^AI\r, kf10@, kich1=\EQ, 
-	kil1=\EE, mc4=\Ea, mc5=\E`, ri=\EJ, rmacs=\E%%, rmir=\Er\EO, 
-	smacs=\E$, smir=\EO\Eq, smso=\EG<, tsl=\Ef, use=f100, 
+	dim=\EG@, dl1=\ER, dsl=\Ef\r, flash=\Eb$<200/>\Ed, il1=\EE, 
+	ip@, is2@, kclr=^^, kdch1=\EW, kdl1=\ER, ked=\EY, kel=\ET, 
+	kf0=^AI\r, kf10@, kich1=\EQ, kil1=\EE, mc4=\Ea, mc5=\E`, 
+	ri=\EJ, rmacs=\E%%, rmir=\Er\EO, smacs=\E$, smir=\EO\Eq, 
+	smso=\EG<, tsl=\Ef, use=f100, 
 f110-14|Liberty Freedom 110 14inch, 
 	dch1@, use=f110, 
 f110-w|Liberty Freedom 110 - 132 cols, 
@@ -12380,8 +12383,8 @@
 	clear=^Z, cnorm=\E.1, cr=^M, 
 	csr=\Em0%p1%{32}%+%c%p2%{32}%+%c, cub1=^H, cud1=^V, 
 	cuf1=^L, cup=\E=%p1%{32}%+%c%p2%{32}%+%c, cuu1=^K, 
-	cvvis=\E.1, dch1=\EW, dim=\EG@, dl1=\ER, dsl=\Ef\r, ed=\EY, 
-	el=\ET, flash=\Eo$<200/>\En, fsl=^M, home=^^, 
+	dch1=\EW, dim=\EG@, dl1=\ER, dsl=\Ef\r, ed=\EY, el=\ET, 
+	flash=\Eo$<200/>\En, fsl=^M, home=^^, 
 	hpa=\E]%p1%{32}%+%c, hts=\E1, il1=\EE, ind=^J, kbs=^H, 
 	kclr=^^, kcub1=^H, kcud1=^V, kcuf1=^L, kcuu1=^K, kdch1=\EW, 
 	kdl1=\ER, ked=\EY, kel=\ET, kf0=^AI\r, kf1=^A@\r, kf2=^AA\r, 
@@ -14032,9 +14035,9 @@
 	cbt=\EI, civis=\E`0, clear=\014$<40>, cnorm=\E`5, 
 	cr=\r$<2>, cub1=\010$<2>, cud1=\n$<2>, cuf1=\006$<2>, 
 	cup=\EY%p1%{32}%+%c%p2%{32}%+%c$<5>, cuu1=\032$<2>, 
-	cvvis=\E`5, dch1=\EW$<2>, dim=\EGp, dl1=\El$<2>, dsl=\E`c, 
-	ed=\Ek$<2>, el=\EK$<2>, fsl=^M, home=\036$<2>, ht=^I, 
-	hts=\E1, il1=\EM$<2>, ind=\n$<2>, invis=\EG1, 
+	dch1=\EW$<2>, dim=\EGp, dl1=\El$<2>, dsl=\E`c, ed=\Ek$<2>, 
+	el=\EK$<2>, fsl=^M, home=\036$<2>, ht=^I, hts=\E1, 
+	il1=\EM$<2>, ind=\n$<2>, invis=\EG1, 
 	is2=\Ee6\E~%$<100>\E+\E`\:\Ed/\E`1\EO\Ee4\Ec@0@\Ec@1A\EcB0\EcC1\Ee7$<100>, 
 	kDC=\El, kEND=\Ek, kHOM=^A, kPRT=\E7, kRIT=^F, ka1=^A, ka3=\EJ, 
 	kbs=^H, kc1=\ET, kc3=\EJ, kcub1=^U, kcud1=^J, kcuf1=^F, 
@@ -16866,9 +16869,9 @@
 	csr=\E[%i%p1%d;%p2%dr, cub=\E[%p1%dD, cub1=\E[D, 
 	cud=\E[%p1%dB, cud1=\E[B, cuf=\E[%p1%dC, cuf1=\E[C, 
 	cup=\E[%i%p1%d;%p2%dH, cuu=\E[%p1%dA, cuu1=\E[A, 
-	cvvis=\E[?25h, dch=\E[%p1%dP, dch1=\E[P, dl=\E[%p1%dM, 
-	dl1=\E[M, dsl=\E[1$}\E[2$~\n\E[0$}, ech=\E[%p1%dX, 
-	ed=\E[J, el=\E[K, el1=\E[1K, enacs=\E(B\E)0, 
+	dch=\E[%p1%dP, dch1=\E[P, dl=\E[%p1%dM, dl1=\E[M, 
+	dsl=\E[1$}\E[2$~\n\E[0$}, ech=\E[%p1%dX, ed=\E[J, 
+	el=\E[K, el1=\E[1K, enacs=\E(B\E)0, 
 	flash=\E[?5h$<50>\E[?5l, fsl=\E[0$}, home=\E[H, ht=^I, 
 	hts=\EH, ich=\E[%p1%d@, il=\E[%p1%dL, il1=\E[L, ind=\ED, 
 	is1=\E[63;1"p\E[2h, 
@@ -16966,12 +16969,12 @@
 	clear=\233H\233J, cnorm=\233?25h, cr=^M, 
 	csr=\233%i%p1%d;%p2%dr, cub=\233%p1%dD, cud=\233%p1%dB, 
 	cuf=\233%p1%dC, cup=\233%i%p1%d;%p2%dH, cuu=\233%p1%dA, 
-	cvvis=\233?25h, dch=\233%p1%dP, dch1=\233P, 
-	dl=\233%p1%dM, dsl=\2331$}\2332$~\n\2330$}, 
-	ech=\233%p1%dX, ed=\233J, el=\233K, el1=\2331K, 
-	enacs=\E(B\E)0, flash=\233?5h$<50>\233?5l, fsl=\2330$}, 
-	home=\233H, ht=^I, hts=\EH, ich=\233%p1%d@, il=\233%p1%dL, 
-	ind=\ED, is1=\E[63;2"p\E[2h, 
+	dch=\233%p1%dP, dch1=\233P, dl=\233%p1%dM, 
+	dsl=\2331$}\2332$~\n\2330$}, ech=\233%p1%dX, ed=\233J, 
+	el=\233K, el1=\2331K, enacs=\E(B\E)0, 
+	flash=\233?5h$<50>\233?5l, fsl=\2330$}, home=\233H, 
+	ht=^I, hts=\EH, ich=\233%p1%d@, il=\233%p1%dL, ind=\ED, 
+	is1=\E[63;2"p\E[2h, 
 	is2=\E[?2h\E[?3l\E[?5l\E[?7h\E[?8h\E>\E[?1l\E G\E[?42l\E[?4l, 
 	is3=\2330$}\233?25h\2332l\233H\233J, ka1=\217w, 
 	ka3=\217y, kb2=\217u, kbs=^H, kc1=\217q, kc3=\217s, 
@@ -18214,9 +18217,9 @@
 	cbt=\E[Z, civis=\E[?25l, clear=\E[H\E[2J$<6>, 
 	cnorm=\E[?25h, cub=\E[%p1%dD, cud=\E[%p1%dB, 
 	cuf=\E[%p1%dC, cup=\E[%p1%i%p1%d;%p2%dH, cuu=\E[%p1%dA, 
-	cvvis=\E[?25h, dch=\E[%p1%dP$<250>, dch1=\E[P, 
-	dl=\E[%p1%dM, ech=\E[%p1%dX$<20>, ed=\E[J$<6>, el=\E[0K, 
-	el1=\E[1K, enacs=\E(B\E)0, ff=^L, flash=\E[?5h\E[?5l$<6>, 
+	dch=\E[%p1%dP$<250>, dch1=\E[P, dl=\E[%p1%dM, 
+	ech=\E[%p1%dX$<20>, ed=\E[J$<6>, el=\E[0K, el1=\E[1K, 
+	enacs=\E(B\E)0, ff=^L, flash=\E[?5h\E[?5l$<6>, 
 	hpa=\E[%p1%{1}%+%dG, hts=\E[0W, ich=\E[%p1%d@$<250>, 
 	il=\E[%p1%dL$<36>, ip=$<10>, is2=\E[1;24r\E[24;1H, 
 	kcmd=\E[29~, kdch1=\E[P, kent=^J, kf1=\E[17~, kf10=\E[28~, 
@@ -20477,6 +20480,12 @@
 #	* add vt100+ and vt-utf8 entries -TD
 #	* add uwin entry -TD
 #
+# 2004-03-27
+#	* add sgr strings to several common entries lacking them, e.g.,
+#	  screen, to make the entries more portable -TD
+#	* remove cvvis from rxvt entry, since it is the same as cnorm -TD
+#	* similar fixups for cvvis/cnorm various entries -TD
+#
 # The following sets edit modes for GNU EMACS.
 # Local Variables:
 # fill-prefix:"\t"
Index: mk-0th.awk
Prereq:  1.14 
--- ncurses-5.4-20040208/mk-0th.awk	2002-08-31 17:36:54.000000000 -0400
+++ ncurses-5.4-20040424/mk-0th.awk	2004-04-03 19:07:38.000000000 -0500
@@ -1,6 +1,6 @@
-# $Id: mk-0th.awk,v 1.14 2002/08/31 21:36:54 tom Exp $
+# $Id: mk-0th.awk,v 1.15 2004/04/04 00:07:38 tom Exp $
 ##############################################################################
-# Copyright (c) 1998-2001 Free Software Foundation, Inc.                     #
+# Copyright (c) 1998-2002,2004 Free Software Foundation, Inc.                #
 #                                                                            #
 # Permission is hereby granted, free of charge, to any person obtaining a    #
 # copy of this software and associated documentation files (the "Software"), #
@@ -84,7 +84,7 @@
 			printf "\trm -f llib-l%s\n", libname
 			print  ""
 			printf "llib-l%s : $(C_SRC)\n", libname
-			printf "\tcproto -a -l -DLINT $(CPPFLAGS) $(C_SRC) >$@\n"
+			printf "\tcproto -a -l -DNCURSES_ENABLE_STDBOOL_H=0 -DLINT $(CPPFLAGS) $(C_SRC) >$@\n"
 			print  ""
 			print  "lintlib :"
 			printf "\tsh $(srcdir)/../misc/makellib %s $(CPPFLAGS)", libname
Index: mk-1st.awk
Prereq:  1.62 
--- ncurses-5.4-20040208/mk-1st.awk	2004-01-10 15:48:43.000000000 -0500
+++ ncurses-5.4-20040424/mk-1st.awk	2004-01-31 18:40:12.000000000 -0500
@@ -1,4 +1,4 @@
-# $Id: mk-1st.awk,v 1.62 2004/01/10 20:48:43 tom Exp $
+# $Id: mk-1st.awk,v 1.63 2004/01/31 23:40:12 tom Exp $
 ##############################################################################
 # Copyright (c) 1998-2003,2004 Free Software Foundation, Inc.                #
 #                                                                            #
@@ -116,7 +116,6 @@
 				using = 1
 			}
 			if ( subset == "termlib" || subset == "termlib+ext_tinfo" ) {
-				name  = "tinfo"
 				OBJS  = MODEL "_T"
 			} else {
 				OBJS  = MODEL
Index: mk-2nd.awk
Prereq:  1.15 
--- ncurses-5.4-20040208/mk-2nd.awk	2003-11-01 17:42:50.000000000 -0500
+++ ncurses-5.4-20040424/mk-2nd.awk	2004-02-14 20:31:16.000000000 -0500
@@ -1,6 +1,6 @@
-# $Id: mk-2nd.awk,v 1.15 2003/11/01 22:42:50 tom Exp $
+# $Id: mk-2nd.awk,v 1.17 2004/02/15 01:31:16 tom Exp $
 ##############################################################################
-# Copyright (c) 1998-2000,2003 Free Software Foundation, Inc.                #
+# Copyright (c) 1998-2003,2004 Free Software Foundation, Inc.                #
 #                                                                            #
 # Permission is hereby granted, free of charge, to any person obtaining a    #
 # copy of this software and associated documentation files (the "Software"), #
@@ -40,6 +40,8 @@
 #	MODEL (uppercase version of "model"; toupper is not portable)
 #	echo (yes iff we will show the $(CC) lines)
 #	subset ("none", "base", "base+ext_funcs" or "termlib")
+#	crenames ("yes" or "no", flag to control whether -c & -o options are used)
+#	cxxrenames ("yes" or "no", flag to control whether -c & -o options are used)
 #
 # Fields in src/modules:
 #	$1 = module name
@@ -83,9 +85,11 @@
 				if ( $2 == "c++" ) {
 					compile="CXX"
 					suffix=".cc"
+					use_c_o=cxxrenames
 				} else {
 					compile="CC"
 					suffix=".c"
+					use_c_o=crenames
 				}
 				printf "../%s/%s$o :\t%s/%s%s", model, $1, $3, $1, suffix
 				for (n = 4; n <= NF; n++) printf " \\\n\t\t\t%s", $n
@@ -96,13 +100,22 @@
 					atsign="@"
 					printf "\t@echo 'compiling %s (%s)'\n", $1, model
 				}
+				printf "\t%s", atsign;
+				if ( use_c_o != "yes" ) {
+					printf "cd ../%s; ", model;
+				}
+				printf "$(LIBTOOL_COMPILE) $(%s) $(CFLAGS_%s) -c ", compile, MODEL
 				if ( $3 == "." || srcdir == "." ) {
 					dir = $3 "/"
 					sub("^\\$\\(srcdir\\)/","",dir);
 					sub("^\\./","",dir);
-					printf "\t%scd ../%s; $(LIBTOOL_COMPILE) $(%s) $(CFLAGS_%s) -c ../%s/%s%s%s", atsign, model, compile, MODEL, name, dir, $1, suffix
-				} else
-					printf "\t%scd ../%s; $(LIBTOOL_COMPILE) $(%s) $(CFLAGS_%s) -c %s/%s%s", atsign, model, compile, MODEL, $3, $1, suffix
+					printf "../%s/%s%s%s", name, dir, $1, suffix
+				} else {
+					printf "%s/%s%s", $3, $1, suffix
+				}
+				if ( use_c_o == "yes" ) {
+					printf " -o ../%s/%s$o", model, $1
+				}
 			} else {
 				printf "%s", $1
 				for (n = 2; n <= NF; n++) printf " %s", $n
Index: ncurses/Makefile.in
Prereq:  1.91 
--- ncurses-5.4-20040208/ncurses/Makefile.in	2003-11-01 17:48:53.000000000 -0500
+++ ncurses-5.4-20040424/ncurses/Makefile.in	2004-02-28 15:57:27.000000000 -0500
@@ -1,4 +1,4 @@
-# $Id: Makefile.in,v 1.91 2003/11/01 22:48:53 tom Exp $
+# $Id: Makefile.in,v 1.92 2004/02/28 20:57:27 tom Exp $
 ##############################################################################
 # Copyright (c) 1998-2002,2003 Free Software Foundation, Inc.                #
 #                                                                            #
@@ -93,7 +93,7 @@
 CCFLAGS		= $(CPPFLAGS) $(CFLAGS)
 
 BUILD_CC	= @BUILD_CC@
-BUILD_CCFLAGS	= -DHAVE_CONFIG_H -I../ncurses -I$(srcdir) @BUILD_CPPFLAGS@ @BUILD_CFLAGS@
+BUILD_CCFLAGS	= -DHAVE_CONFIG_H -I../ncurses -I$(srcdir) -I$(INCDIR) @BUILD_CPPFLAGS@ @BUILD_CFLAGS@
 BUILD_LDFLAGS	= @BUILD_LDFLAGS@
 BUILD_LIBS	= @BUILD_LIBS@
 
Index: ncurses/base/MKunctrl.awk
Prereq:  1.9 
--- ncurses-5.4-20040208/ncurses/base/MKunctrl.awk	2001-06-02 19:59:20.000000000 -0400
+++ ncurses-5.4-20040424/ncurses/base/MKunctrl.awk	2004-04-03 17:50:37.000000000 -0500
@@ -1,6 +1,6 @@
-# $Id: MKunctrl.awk,v 1.9 2001/06/02 23:59:20 skimo Exp $
+# $Id: MKunctrl.awk,v 1.10 2004/04/03 22:50:37 tom Exp $
 ##############################################################################
-# Copyright (c) 1998,2000,2001 Free Software Foundation, Inc.                #
+# Copyright (c) 1998,2001,2004 Free Software Foundation, Inc.                #
 #                                                                            #
 # Permission is hereby granted, free of charge, to any person obtaining a    #
 # copy of this software and associated documentation files (the "Software"), #
@@ -63,7 +63,10 @@
 			printf "%s", gap
 		}
 		print "};"
+		print "int check = ChCharOf(ch);"
 		print ""
-		print "\treturn (NCURSES_CONST char *)table[ChCharOf(ch)];"
+		print "\tif (check < 0 || check >= (int)SIZEOF(table)) return 0;"
+		print ""
+		print "\treturn (NCURSES_CONST char *)table[check];"
 		print "}"
 	}
Index: ncurses/base/lib_addch.c
Prereq:  1.80 
--- ncurses-5.4-20040208/ncurses/base/lib_addch.c	2004-02-07 13:20:46.000000000 -0500
+++ ncurses-5.4-20040424/ncurses/base/lib_addch.c	2004-04-03 15:18:43.000000000 -0500
@@ -36,7 +36,7 @@
 #include <curses.priv.h>
 #include <ctype.h>
 
-MODULE_ID("$Id: lib_addch.c,v 1.80 2004/02/07 18:20:46 tom Exp $")
+MODULE_ID("$Id: lib_addch.c,v 1.83 2004/04/03 20:18:43 tom Exp $")
 
 /*
  * Ugly microtweaking alert.  Everything from here to end of module is
@@ -137,9 +137,7 @@
      * Build up multibyte characters until we have a wide-character.
      */
     if_WIDEC({
-	if (WINDOW_EXT(win, addch_used) == 0 && Charable(ch)) {
-	    WINDOW_EXT(win, addch_used) = 0;
-	} else {
+	if (WINDOW_EXT(win, addch_used) != 0 || !Charable(ch)) {
 	    char *buffer = WINDOW_EXT(win, addch_work);
 	    int len;
 	    mbstate_t state;
@@ -150,6 +148,10 @@
 		 WINDOW_EXT(win, addch_y) != y)) {
 		/* discard the incomplete multibyte character */
 		WINDOW_EXT(win, addch_used) = 0;
+		TR(TRACE_VIRTPUT,
+		   ("Alert discarded multibyte on move (%d,%d) -> (%d,%d)",
+		    WINDOW_EXT(win, addch_y), WINDOW_EXT(win, addch_x),
+		    y, x));
 	    }
 	    WINDOW_EXT(win, addch_x) = x;
 	    WINDOW_EXT(win, addch_y) = y;
@@ -164,7 +166,7 @@
 		attr_t attrs = AttrOf(ch);
 		SetChar(ch, result, attrs);
 		WINDOW_EXT(win, addch_used) = 0;
-		if (CharOf(ch) < 256) {
+		if (is8bits(CharOf(ch))) {
 		    const char *s = unctrl(CharOf(ch));
 		    if (s[1] != 0) {
 			return waddstr(win, s);
@@ -269,12 +271,12 @@
      */
     if ((AttrOf(ch) & A_ALTCHARSET)
 	|| ((s = unctrl(t))[1] == 0 ||
-		(
+	    (
 		isprint(t)
 #if USE_WIDEC_SUPPORT
 		|| WINDOW_EXT(win, addch_used)
 #endif
-		)))
+	    )))
 	return waddch_literal(win, ch);
 
     /*
Index: ncurses/base/lib_freeall.c
Prereq:  1.26 
--- ncurses-5.4-20040208/ncurses/base/lib_freeall.c	2003-12-27 13:21:57.000000000 -0500
+++ ncurses-5.4-20040424/ncurses/base/lib_freeall.c	2004-04-24 14:39:10.000000000 -0400
@@ -1,5 +1,5 @@
 /****************************************************************************
- * Copyright (c) 1998-2002,2003 Free Software Foundation, Inc.              *
+ * Copyright (c) 1998-2003,2004 Free Software Foundation, Inc.              *
  *                                                                          *
  * Permission is hereby granted, free of charge, to any person obtaining a  *
  * copy of this software and associated documentation files (the            *
@@ -32,6 +32,7 @@
 
 #include <curses.priv.h>
 #include <term_entry.h>
+#include <tic.h>
 
 #if HAVE_NC_FREEALL
 
@@ -39,7 +40,7 @@
 extern int malloc_errfd;	/* FIXME */
 #endif
 
-MODULE_ID("$Id: lib_freeall.c,v 1.26 2003/12/27 18:21:57 tom Exp $")
+MODULE_ID("$Id: lib_freeall.c,v 1.28 2004/04/24 18:39:10 tom Exp $")
 
 /*
  * Free all ncurses data.  This is used for testing only (there's no practical
@@ -82,6 +83,8 @@
 
     del_curterm(cur_term);
     _nc_free_entries(_nc_head);
+    _nc_get_type(0);
+    _nc_first_name(0);
 
     if ((s = _nc_home_terminfo()) != 0)
 	free(s);
Index: ncurses/base/lib_insch.c
Prereq:  1.18 
--- ncurses-5.4-20040208/ncurses/base/lib_insch.c	2002-11-23 16:41:05.000000000 -0500
+++ ncurses-5.4-20040424/ncurses/base/lib_insch.c	2004-04-03 16:33:00.000000000 -0500
@@ -1,5 +1,5 @@
 /****************************************************************************
- * Copyright (c) 1998-2001,2002 Free Software Foundation, Inc.              *
+ * Copyright (c) 1998-2002,2004 Free Software Foundation, Inc.              *
  *                                                                          *
  * Permission is hereby granted, free of charge, to any person obtaining a  *
  * copy of this software and associated documentation files (the            *
@@ -43,7 +43,7 @@
 #include <curses.priv.h>
 #include <ctype.h>
 
-MODULE_ID("$Id: lib_insch.c,v 1.18 2002/11/23 21:41:05 tom Exp $")
+MODULE_ID("$Id: lib_insch.c,v 1.20 2004/04/03 21:33:00 tom Exp $")
 
 /*
  * Insert the given character, updating the current location to simplify
@@ -54,6 +54,7 @@
 {
     NCURSES_CH_T wch;
     int count;
+    NCURSES_CONST char *s;
 
     switch (ch) {
     case '\t':
@@ -67,25 +68,47 @@
 	_nc_waddch_nosync(win, wch);
 	break;
     default:
-	if (is7bits(ch) && iscntrl(ch)) {
-	    _nc_insert_ch(win, '^');
-	    _nc_insert_ch(win, '@' + (ch));
-	} else if (win->_curx <= win->_maxx) {
-	    struct ldat *line = &(win->_line[win->_cury]);
-	    NCURSES_CH_T *end = &(line->text[win->_curx]);
-	    NCURSES_CH_T *temp1 = &(line->text[win->_maxx]);
-	    NCURSES_CH_T *temp2 = temp1 - 1;
-
+	if (
+#if USE_WIDEC_SUPPORT
+	       WINDOW_EXT(win, addch_used) == 0 &&
+#endif
+	       is8bits(ChCharOf(ch)) &&
+	       isprint(ChCharOf(ch))) {
+	    if (win->_curx <= win->_maxx) {
+		struct ldat *line = &(win->_line[win->_cury]);
+		NCURSES_CH_T *end = &(line->text[win->_curx]);
+		NCURSES_CH_T *temp1 = &(line->text[win->_maxx]);
+		NCURSES_CH_T *temp2 = temp1 - 1;
+
+		SetChar2(wch, ch);
+
+		CHANGED_TO_EOL(line, win->_curx, win->_maxx);
+		while (temp1 > end)
+		    *temp1-- = *temp2--;
+
+		*temp1 = _nc_render(win, wch);
+
+		win->_curx++;
+	    }
+	} else if (is8bits(ChCharOf(ch)) && iscntrl(ChCharOf(ch))) {
+	    s = unctrl(ChCharOf(ch));
+	    while (*s != '\0') {
+		_nc_insert_ch(win, ChAttrOf(ch) | UChar(*s));
+		++s;
+	    }
+	}
+#if USE_WIDEC_SUPPORT
+	else {
+	    /*
+	     * Handle multibyte characters here
+	     */
+	    if (WINDOW_EXT(win, addch_used) == 0) {
+		_nc_insert_ch(win, ChAttrOf(ch) | ' ');
+	    }
 	    SetChar2(wch, ch);
-
-	    CHANGED_TO_EOL(line, win->_curx, win->_maxx);
-	    while (temp1 > end)
-		*temp1-- = *temp2--;
-
-	    *temp1 = _nc_render(win, wch);
-
-	    win->_curx++;
+	    _nc_waddch_nosync(win, wch);
 	}
+#endif
 	break;
     }
 }
@@ -114,15 +137,16 @@
 }
 
 NCURSES_EXPORT(int)
-winsnstr(WINDOW *win, const char *s, int n)
+winsstr(WINDOW *win, const char *s)
 {
+    int n = strlen(s);
     int code = ERR;
     NCURSES_SIZE_T oy;
     NCURSES_SIZE_T ox;
     const unsigned char *str = (const unsigned char *) s;
     const unsigned char *cp;
 
-    T((T_CALLED("winsnstr(%p,%s,%d)"), win, _nc_visbufn(s, n), n));
+    T((T_CALLED("winsstr(%p,%s,%d)"), win, _nc_visbufn(s, n), n));
 
     if (win != 0 && str != 0) {
 	oy = win->_cury;
Index: ncurses/base/lib_insnstr.c
--- /dev/null	2004-04-14 14:44:16.000000000 -0400
+++ ncurses-5.4-20040424/ncurses/base/lib_insnstr.c	2004-02-28 18:44:56.000000000 -0500
@@ -0,0 +1,68 @@
+/****************************************************************************
+ * Copyright (c) 2004 Free Software Foundation, Inc.                        *
+ *                                                                          *
+ * Permission is hereby granted, free of charge, to any person obtaining a  *
+ * copy of this software and associated documentation files (the            *
+ * "Software"), to deal in the Software without restriction, including      *
+ * without limitation the rights to use, copy, modify, merge, publish,      *
+ * distribute, distribute with modifications, sublicense, and/or sell       *
+ * copies of the Software, and to permit persons to whom the Software is    *
+ * furnished to do so, subject to the following conditions:                 *
+ *                                                                          *
+ * The above copyright notice and this permission notice shall be included  *
+ * in all copies or substantial portions of the Software.                   *
+ *                                                                          *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS  *
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF               *
+ * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.   *
+ * IN NO EVENT SHALL THE ABOVE COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,   *
+ * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR    *
+ * OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR    *
+ * THE USE OR OTHER DEALINGS IN THE SOFTWARE.                               *
+ *                                                                          *
+ * Except as contained in this notice, the name(s) of the above copyright   *
+ * holders shall not be used in advertising or otherwise to promote the     *
+ * sale, use or other dealings in this Software without prior written       *
+ * authorization.                                                           *
+ ****************************************************************************/
+
+/****************************************************************************
+ *  Author: Thomas E. Dickey                                                *
+ ****************************************************************************/
+
+/*
+**	lib_insnstr.c
+**
+**	The routine winsnstr().
+**
+*/
+
+#include <curses.priv.h>
+#include <ctype.h>
+
+MODULE_ID("$Id: lib_insnstr.c,v 1.1 2004/02/28 23:44:56 tom Exp $")
+
+NCURSES_EXPORT(int)
+winsnstr(WINDOW *win, const char *s, int n)
+{
+    int code = ERR;
+    NCURSES_SIZE_T oy;
+    NCURSES_SIZE_T ox;
+    const unsigned char *str = (const unsigned char *) s;
+    const unsigned char *cp;
+
+    T((T_CALLED("winsnstr(%p,%s,%d)"), win, _nc_visbufn(s, n), n));
+
+    if (win != 0 && str != 0) {
+	oy = win->_cury;
+	ox = win->_curx;
+	for (cp = str; *cp && (n <= 0 || (cp - str) < n); cp++) {
+	    _nc_insert_ch(win, (chtype) UChar(*cp));
+	}
+	win->_curx = ox;
+	win->_cury = oy;
+	_nc_synchook(win);
+	code = OK;
+    }
+    returnCode(code);
+}
Index: ncurses/base/lib_newwin.c
Prereq:  1.34 
--- ncurses-5.4-20040208/ncurses/base/lib_newwin.c	2002-08-17 20:12:30.000000000 -0400
+++ ncurses-5.4-20040424/ncurses/base/lib_newwin.c	2004-04-10 19:42:00.000000000 -0400
@@ -1,5 +1,5 @@
 /****************************************************************************
- * Copyright (c) 1998-2001,2002 Free Software Foundation, Inc.              *
+ * Copyright (c) 1998-2002,2004 Free Software Foundation, Inc.              *
  *                                                                          *
  * Permission is hereby granted, free of charge, to any person obtaining a  *
  * copy of this software and associated documentation files (the            *
@@ -40,7 +40,7 @@
 
 #include <curses.priv.h>
 
-MODULE_ID("$Id: lib_newwin.c,v 1.34 2002/08/18 00:12:30 tom Exp $")
+MODULE_ID("$Id: lib_newwin.c,v 1.35 2004/04/10 23:42:00 tom Exp $")
 
 static WINDOW *
 remove_window_from_screen(WINDOW *win)
@@ -120,9 +120,6 @@
     if (num_columns == 0)
 	num_columns = screen_columns - begx;
 
-    if (num_columns + begx > SP->_columns || num_lines + begy > SP->_lines_avail)
-	returnWin(0);
-
     if ((win = _nc_makenew(num_lines, num_columns, begy, begx, 0)) == 0)
 	returnWin(0);
 
Index: ncurses/base/lib_set_term.c
Prereq:  1.81 
--- ncurses-5.4-20040208/ncurses/base/lib_set_term.c	2003-11-15 18:57:01.000000000 -0500
+++ ncurses-5.4-20040424/ncurses/base/lib_set_term.c	2004-04-24 16:17:39.000000000 -0400
@@ -1,5 +1,5 @@
 /****************************************************************************
- * Copyright (c) 1998-2002,2003 Free Software Foundation, Inc.              *
+ * Copyright (c) 1998-2003,2004 Free Software Foundation, Inc.              *
  *                                                                          *
  * Permission is hereby granted, free of charge, to any person obtaining a  *
  * copy of this software and associated documentation files (the            *
@@ -29,7 +29,7 @@
 /****************************************************************************
  *  Author: Zeyd M. Ben-Halim <zmbenhal@netcom.com> 1992,1995               *
  *     and: Eric S. Raymond <esr@snark.thyrsus.com>                         *
- *     and: Thomas E. Dickey                        1996-2003               *
+ *     and: Thomas E. Dickey                        1996-on                 *
  ****************************************************************************/
 
 /*
@@ -44,7 +44,7 @@
 #include <term.h>		/* cur_term */
 #include <tic.h>
 
-MODULE_ID("$Id: lib_set_term.c,v 1.81 2003/11/15 23:57:01 tom Exp $")
+MODULE_ID("$Id: lib_set_term.c,v 1.82 2004/04/24 20:17:39 tom Exp $")
 
 NCURSES_EXPORT(SCREEN *)
 set_term(SCREEN * screenp)
@@ -392,7 +392,7 @@
     SP->_screen_acs_fix = (_nc_unicode_locale() && _nc_locale_breaks_acs());
     {
 	char *env = _nc_get_locale();
-	SP->_posix_locale = ((env == 0)
+	SP->_legacy_coding = ((env == 0)
 			     || !strcmp(env, "C")
 			     || !strcmp(env, "POSIX"));
     }
Index: ncurses/base/vsscanf.c
Prereq:  1.17 
--- ncurses-5.4-20040208/ncurses/base/vsscanf.c	2003-05-24 17:10:28.000000000 -0400
+++ ncurses-5.4-20040424/ncurses/base/vsscanf.c	2004-04-03 15:27:02.000000000 -0500
@@ -1,5 +1,5 @@
 /****************************************************************************
- * Copyright (c) 1998-2001,2002 Free Software Foundation, Inc.              *
+ * Copyright (c) 1998-2003,2004 Free Software Foundation, Inc.              *
  *                                                                          *
  * Permission is hereby granted, free of charge, to any person obtaining a  *
  * copy of this software and associated documentation files (the            *
@@ -38,7 +38,7 @@
 
 #if !HAVE_VSSCANF
 
-MODULE_ID("$Id: vsscanf.c,v 1.17 2003/05/24 21:10:28 tom Exp $")
+MODULE_ID("$Id: vsscanf.c,v 1.18 2004/04/03 20:27:02 tom Exp $")
 
 #if !(HAVE_VFSCANF || HAVE__DOSCAN)
 
@@ -271,7 +271,7 @@
 				chunk = ctest;
 			    } else if ((otest = other_ch(format[n])) != oUnknown) {
 				other = otest;
-			    } else if (isalpha(format[n])) {
+			    } else if (isalpha(UChar(format[n]))) {
 				state = sFinal;
 				chunk = cError;
 			    }
Index: ncurses/curses.priv.h
Prereq:  1.255 
--- ncurses-5.4-20040208/ncurses/curses.priv.h	2004-01-31 20:05:58.000000000 -0500
+++ ncurses-5.4-20040424/ncurses/curses.priv.h	2004-04-24 16:18:07.000000000 -0400
@@ -29,12 +29,12 @@
 /****************************************************************************
  *  Author: Zeyd M. Ben-Halim <zmbenhal@netcom.com> 1992,1995               *
  *     and: Eric S. Raymond <esr@snark.thyrsus.com>                         *
- *     and: Thomas E. Dickey 1996-2002                                      *
+ *     and: Thomas E. Dickey                        1996-on                 *
  ****************************************************************************/
 
 
 /*
- * $Id: curses.priv.h,v 1.255 2004/02/01 01:05:58 Stanislav.Ievlev Exp $
+ * $Id: curses.priv.h,v 1.258 2004/04/24 20:18:07 tom Exp $
  *
  *	curses.priv.h
  *
@@ -78,6 +78,11 @@
 # include <sys/param.h>
 #endif
 
+#include <assert.h>
+#include <stdio.h>
+
+#include <errno.h>
+
 #ifndef PATH_MAX
 # if defined(_POSIX_PATH_MAX)
 #  define PATH_MAX _POSIX_PATH_MAX
@@ -88,11 +93,6 @@
 # endif
 #endif
 
-#include <assert.h>
-#include <stdio.h>
-
-#include <errno.h>
-
 #if DECL_ERRNO
 extern int errno;
 #endif
@@ -493,7 +493,7 @@
 	 * UTF-8, but do not permit ACS at the same time (see tty_update.c).
 	 */
 #if USE_WIDEC_SUPPORT
-	bool		_posix_locale;
+	bool		_legacy_coding;
 	bool		_screen_acs_fix;
 #endif
 };
@@ -517,9 +517,17 @@
 
 #define WINDOW_EXT(win,field) (((WINDOWLIST *)(win))->field)
 
+/* usually in <limits.h> */
+#ifndef UCHAR_MAX
+#define UCHAR_MAX 255
+#endif
+
 /* The terminfo source is assumed to be 7-bit ASCII */
 #define is7bits(c)	((unsigned)(c) < 128)
 
+/* Checks for isprint() should be done on 8-bit characters (non-wide) */
+#define is8bits(c)	((unsigned)(c) <= UCHAR_MAX)
+
 #ifndef min
 #define min(a,b)	((a) > (b)  ?  (b)  :  (a))
 #endif
@@ -633,7 +641,8 @@
 #define WA_NAC		1
 #define isnac(ch)	(AttrOf(ch) & WA_NAC)
 #define if_WIDEC(code)  code
-#define Charable(ch)	((SP != 0 && SP->_posix_locale)			\
+#define Charable(ch)	((SP != 0 && SP->_legacy_coding)		\
+			 || (AttrOf(ch) & A_ALTCHARSET)			\
 			 || (!isnac(ch) &&				\
 			     (ch).chars[1] == L'\0' &&			\
                              _nc_is_charable(CharOf(ch))))
Index: ncurses/llib-lncurses
--- ncurses-5.4-20040208/ncurses/llib-lncurses	2004-01-31 11:16:48.000000000 -0500
+++ ncurses-5.4-20040424/ncurses/llib-lncurses	2004-04-03 18:55:12.000000000 -0500
@@ -48,6 +48,8 @@
 
 /* ./tty/hashmap.c */
 
+#include <term.h>
+
 #undef _nc_hash_map
 void	_nc_hash_map(void)
 		{ /* void */ }
@@ -993,12 +995,6 @@
 		WINDOW	*z)
 		{ return(*(int *)0); }
 
-#undef winsstr
-int	winsstr(
-		WINDOW	*a1,
-		const char *z)
-		{ return(*(int *)0); }
-
 #undef winstr
 int	winstr(
 		WINDOW	*a1,
@@ -1096,11 +1092,10 @@
 		chtype	c)
 		{ return(*(int *)0); }
 
-#undef winsnstr
-int	winsnstr(
+#undef winsstr
+int	winsstr(
 		WINDOW	*win,
-		const char *s,
-		int	n)
+		const char *s)
 		{ return(*(int *)0); }
 
 /* ./base/lib_insdel.c */
@@ -1111,6 +1106,15 @@
 		int	n)
 		{ return(*(int *)0); }
 
+/* ./base/lib_insnstr.c */
+
+#undef winsnstr
+int	winsnstr(
+		WINDOW	*win,
+		const char *s,
+		int	n)
+		{ return(*(int *)0); }
+
 /* ./base/lib_instr.c */
 
 #undef winnstr
@@ -2068,12 +2072,6 @@
 		const char *string)
 		{ return(*(int *)0); }
 
-/* ./base/version.c */
-
-#undef curses_version
-const char *curses_version(void)
-		{ return(*(const char **)0); }
-
 /* ./base/wresize.c */
 
 #undef wresize
@@ -2337,10 +2335,10 @@
 		{ return(*(int *)0); }
 
 #undef _nc_trans_string
-char	_nc_trans_string(
+int	_nc_trans_string(
 		char	*ptr,
 		char	*last)
-		{ return(*(char *)0); }
+		{ return(*(int *)0); }
 
 #undef _nc_push_token
 void	_nc_push_token(
@@ -2623,8 +2621,6 @@
 
 /* ./tinfo/lib_setup.c */
 
-#include <sys/ioctl.h>
-
 #undef ttytype
 char	ttytype[256];
 #undef LINES
@@ -3076,3 +3072,9 @@
 #undef _nc_tic_written
 int	_nc_tic_written(void)
 		{ return(*(int *)0); }
+
+/* ./base/version.c */
+
+#undef curses_version
+const char *curses_version(void)
+		{ return(*(const char **)0); }
Index: ncurses/llib-lncursesw
--- ncurses-5.4-20040208/ncurses/llib-lncursesw	2004-01-31 11:17:01.000000000 -0500
+++ ncurses-5.4-20040424/ncurses/llib-lncursesw	2004-04-03 19:06:15.000000000 -0500
@@ -1036,12 +1036,6 @@
 		WINDOW	*z)
 		{ return(*(int *)0); }
 
-#undef winsstr
-int	winsstr(
-		WINDOW	*a1,
-		const char *z)
-		{ return(*(int *)0); }
-
 #undef winstr
 int	winstr(
 		WINDOW	*a1,
@@ -1592,11 +1586,10 @@
 		chtype	c)
 		{ return(*(int *)0); }
 
-#undef winsnstr
-int	winsnstr(
+#undef winsstr
+int	winsstr(
 		WINDOW	*win,
-		const char *s,
-		int	n)
+		const char *s)
 		{ return(*(int *)0); }
 
 /* ./base/lib_insdel.c */
@@ -1607,6 +1600,15 @@
 		int	n)
 		{ return(*(int *)0); }
 
+/* ./base/lib_insnstr.c */
+
+#undef winsnstr
+int	winsnstr(
+		WINDOW	*win,
+		const char *s,
+		int	n)
+		{ return(*(int *)0); }
+
 /* ./base/lib_instr.c */
 
 #undef winnstr
@@ -2797,12 +2799,6 @@
 		const char *string)
 		{ return(*(int *)0); }
 
-/* ./base/version.c */
-
-#undef curses_version
-const char *curses_version(void)
-		{ return(*(const char **)0); }
-
 /* ./base/wresize.c */
 
 #undef wresize
@@ -3066,10 +3062,10 @@
 		{ return(*(int *)0); }
 
 #undef _nc_trans_string
-char	_nc_trans_string(
+int	_nc_trans_string(
 		char	*ptr,
 		char	*last)
-		{ return(*(char *)0); }
+		{ return(*(int *)0); }
 
 #undef _nc_push_token
 void	_nc_push_token(
@@ -3840,3 +3836,9 @@
 #undef _nc_tic_written
 int	_nc_tic_written(void)
 		{ return(*(int *)0); }
+
+/* ./base/version.c */
+
+#undef curses_version
+const char *curses_version(void)
+		{ return(*(const char **)0); }
Index: ncurses/modules
Prereq:  1.100 
--- ncurses-5.4-20040208/ncurses/modules	2004-01-10 14:08:23.000000000 -0500
+++ ncurses-5.4-20040424/ncurses/modules	2004-02-28 20:18:06.000000000 -0500
@@ -1,6 +1,6 @@
-# $Id: modules,v 1.100 2004/01/10 19:08:23 tom Exp $
+# $Id: modules,v 1.101 2004/02/29 01:18:06 tom Exp $
 ##############################################################################
-# Copyright (c) 1998-2002,2003 Free Software Foundation, Inc.                #
+# Copyright (c) 1998-2003,2004 Free Software Foundation, Inc.                #
 #                                                                            #
 # Permission is hereby granted, free of charge, to any person obtaining a    #
 # copy of this software and associated documentation files (the "Software"), #
@@ -61,6 +61,7 @@
 lib_initscr	lib		$(base)		$(INCDIR)/tic.h
 lib_insch	lib		$(base)
 lib_insdel	lib		$(base)
+lib_insnstr	lib		$(base)
 lib_instr	lib		$(base)
 lib_isendwin	lib		$(base)
 lib_leaveok	lib		$(base)
Index: ncurses/tinfo/alloc_entry.c
Prereq:  1.40 
--- ncurses-5.4-20040208/ncurses/tinfo/alloc_entry.c	2003-11-08 16:29:54.000000000 -0500
+++ ncurses-5.4-20040424/ncurses/tinfo/alloc_entry.c	2004-04-17 18:06:25.000000000 -0400
@@ -1,5 +1,5 @@
 /****************************************************************************
- * Copyright (c) 1998-2002,2003 Free Software Foundation, Inc.              *
+ * Copyright (c) 1998-2003,2004 Free Software Foundation, Inc.              *
  *                                                                          *
  * Permission is hereby granted, free of charge, to any person obtaining a  *
  * copy of this software and associated documentation files (the            *
@@ -29,7 +29,7 @@
 /****************************************************************************
  *  Author: Zeyd M. Ben-Halim <zmbenhal@netcom.com> 1992,1995               *
  *     and: Eric S. Raymond <esr@snark.thyrsus.com>                         *
- *     and: Thomas E. Dickey                        1996-2003               *
+ *     and: Thomas E. Dickey                        1996-on                 *
  ****************************************************************************/
 
 /*
@@ -48,7 +48,7 @@
 #include <tic.h>
 #include <term_entry.h>
 
-MODULE_ID("$Id: alloc_entry.c,v 1.40 2003/11/08 21:29:54 tom Exp $")
+MODULE_ID("$Id: alloc_entry.c,v 1.41 2004/04/17 22:06:25 tom Exp $")
 
 #define ABSENT_OFFSET    -1
 #define CANCELLED_OFFSET -2
@@ -64,6 +64,13 @@
 {
     unsigned i;
 
+#if NO_LEAKS
+    if (tp == 0) {
+	FreeAndNull(stringbuf);
+	return;
+    }
+#endif
+
     if (stringbuf == 0)
 	stringbuf = (char *) malloc(MAX_STRTAB);
 
Index: ncurses/tinfo/comp_error.c
Prereq:  1.25 
--- ncurses-5.4-20040208/ncurses/tinfo/comp_error.c	2002-09-07 16:05:07.000000000 -0400
+++ ncurses-5.4-20040424/ncurses/tinfo/comp_error.c	2004-04-17 18:20:06.000000000 -0400
@@ -29,6 +29,7 @@
 /****************************************************************************
  *  Author: Zeyd M. Ben-Halim <zmbenhal@netcom.com> 1992,1995               *
  *     and: Eric S. Raymond <esr@snark.thyrsus.com>                         *
+ *     and: Thomas E. Dickey                        1996-on                 *
  ****************************************************************************/
 
 /*
@@ -40,7 +41,7 @@
 
 #include <tic.h>
 
-MODULE_ID("$Id: comp_error.c,v 1.25 2002/09/07 20:05:07 tom Exp $")
+MODULE_ID("$Id: comp_error.c,v 1.26 2004/04/17 22:20:06 tom Exp $")
 
 NCURSES_EXPORT_VAR(bool) _nc_suppress_warnings = FALSE;
 NCURSES_EXPORT_VAR(int) _nc_curr_line = 0; /* current line # in input */
@@ -70,6 +71,12 @@
 NCURSES_EXPORT(void)
 _nc_get_type(char *name)
 {
+#if NO_LEAKS
+    if (name == 0) {
+	FreeAndNull(termtype);
+	return;
+    }
+#endif
     strcpy(name, termtype != 0 ? termtype : "");
 }
 
Index: ncurses/tinfo/comp_parse.c
Prereq:  1.57 
--- ncurses-5.4-20040208/ncurses/tinfo/comp_parse.c	2003-10-25 18:25:36.000000000 -0400
+++ ncurses-5.4-20040424/ncurses/tinfo/comp_parse.c	2004-04-17 18:17:04.000000000 -0400
@@ -1,5 +1,5 @@
 /****************************************************************************
- * Copyright (c) 1998-2002,2003 Free Software Foundation, Inc.              *
+ * Copyright (c) 1998-2003,2004 Free Software Foundation, Inc.              *
  *                                                                          *
  * Permission is hereby granted, free of charge, to any person obtaining a  *
  * copy of this software and associated documentation files (the            *
@@ -29,6 +29,7 @@
 /****************************************************************************
  *  Author: Zeyd M. Ben-Halim <zmbenhal@netcom.com> 1992,1995               *
  *     and: Eric S. Raymond <esr@snark.thyrsus.com>                         *
+ *     and: Thomas E. Dickey                        1996-on                 *
  ****************************************************************************/
 
 /*
@@ -52,7 +53,7 @@
 #include <tic.h>
 #include <term_entry.h>
 
-MODULE_ID("$Id: comp_parse.c,v 1.57 2003/10/25 22:25:36 tom Exp $")
+MODULE_ID("$Id: comp_parse.c,v 1.58 2004/04/17 22:17:04 tom Exp $")
 
 static void sanity_check(TERMTYPE *);
 NCURSES_IMPEXP void NCURSES_API(*_nc_check_termtype) (TERMTYPE *) = sanity_check;
@@ -105,13 +106,7 @@
     ENTRY *ep, *next;
 
     for (ep = headp; ep; ep = next) {
-	/*
-	 * This conditional lets us disconnect storage from the list.
-	 * To do this, copy an entry out of the list, then null out
-	 * the string-table member in the original and any use entries
-	 * it references.
-	 */
-	FreeIfNeeded(ep->tterm.str_table);
+	_nc_free_termtype(&(ep->tterm));
 
 	next = ep->next;
 
@@ -188,10 +183,14 @@
 	 * use references to disk, so as to avoid chewing up a lot of
 	 * core when the resolution code could fetch entries off disk.
 	 */
-	if (hook != NULLHOOK && (*hook) (&thisentry))
+	if (hook != NULLHOOK && (*hook) (&thisentry)) {
 	    immediate++;
-	else
+	} else {
 	    enqueue(&thisentry);
+	    FreeIfNeeded(thisentry.tterm.Booleans);
+	    FreeIfNeeded(thisentry.tterm.Numbers);
+	    FreeIfNeeded(thisentry.tterm.Strings);
+	}
     }
 
     if (_nc_tail) {
Index: ncurses/tinfo/comp_scan.c
Prereq:  1.66 
--- ncurses-5.4-20040208/ncurses/tinfo/comp_scan.c	2003-12-13 19:32:40.000000000 -0500
+++ ncurses-5.4-20040424/ncurses/tinfo/comp_scan.c	2004-04-17 18:14:55.000000000 -0400
@@ -1,5 +1,5 @@
 /****************************************************************************
- * Copyright (c) 1998-2002,2003 Free Software Foundation, Inc.              *
+ * Copyright (c) 1998-2003,2004 Free Software Foundation, Inc.              *
  *                                                                          *
  * Permission is hereby granted, free of charge, to any person obtaining a  *
  * copy of this software and associated documentation files (the            *
@@ -29,6 +29,7 @@
 /****************************************************************************
  *  Author: Zeyd M. Ben-Halim <zmbenhal@netcom.com> 1992,1995               *
  *     and: Eric S. Raymond <esr@snark.thyrsus.com>                         *
+ *     and: Thomas E. Dickey                        1996 on                 *
  ****************************************************************************/
 
 /*
@@ -50,7 +51,7 @@
 #include <term_entry.h>
 #include <tic.h>
 
-MODULE_ID("$Id: comp_scan.c,v 1.66 2003/12/14 00:32:40 tom Exp $")
+MODULE_ID("$Id: comp_scan.c,v 1.68 2004/04/17 22:14:55 tom Exp $")
 
 /*
  * Maximum length of string capability we'll accept before raising an error.
@@ -94,11 +95,182 @@
 _nc_disable_period = FALSE;	/* used by tic -a option */
 #endif
 
-static bool end_of_stream(void);
-static int last_char(void);
-static int next_char(void);
-static long stream_pos(void);
-static void push_back(char c);
+/*****************************************************************************
+ *
+ * Character-stream handling
+ *
+ *****************************************************************************/
+
+#define LEXBUFSIZ	1024
+
+static char *bufptr;		/* otherwise, the input buffer pointer */
+static char *bufstart;		/* start of buffer so we can compute offsets */
+static FILE *yyin;		/* scanner's input file descriptor */
+
+/*
+ *	_nc_reset_input()
+ *
+ *	Resets the input-reading routines.  Used on initialization,
+ *	or after a seek has been done.  Exactly one argument must be
+ *	non-null.
+ */
+
+NCURSES_EXPORT(void)
+_nc_reset_input(FILE *fp, char *buf)
+{
+    pushtype = NO_PUSHBACK;
+    if (pushname != 0)
+	pushname[0] = '\0';
+    yyin = fp;
+    bufstart = bufptr = buf;
+    _nc_curr_file_pos = 0L;
+    if (fp != 0)
+	_nc_curr_line = 0;
+    _nc_curr_col = 0;
+}
+
+/*
+ *	int last_char()
+ *
+ *	Returns the final nonblank character on the current input buffer
+ */
+static int
+last_char(void)
+{
+    size_t len = strlen(bufptr);
+    while (len--) {
+	if (!isspace(UChar(bufptr[len])))
+	    return bufptr[len];
+    }
+    return 0;
+}
+
+/*
+ *	int next_char()
+ *
+ *	Returns the next character in the input stream.  Comments and leading
+ *	white space are stripped.
+ *
+ *	The global state variable 'firstcolumn' is set TRUE if the character
+ *	returned is from the first column of the input line.
+ *
+ *	The global variable _nc_curr_line is incremented for each new line.
+ *	The global variable _nc_curr_file_pos is set to the file offset of the
+ *	beginning of each line.
+ */
+
+static int
+next_char(void)
+{
+    static char *result;
+    static size_t allocated;
+    int the_char;
+
+    if (!yyin) {
+	if (result != 0) {
+	    FreeAndNull(result);
+	    FreeAndNull(pushname);
+	    allocated = 0;
+	}
+	/*
+	 * An string with an embedded null will truncate the input.  This is
+	 * intentional (we don't read binary files here).
+	 */
+	if (bufptr == 0 || *bufptr == '\0')
+	    return (EOF);
+	if (*bufptr == '\n') {
+	    _nc_curr_line++;
+	    _nc_curr_col = 0;
+	}
+    } else if (!bufptr || !*bufptr) {
+	/*
+	 * In theory this could be recoded to do its I/O one character at a
+	 * time, saving the buffer space.  In practice, this turns out to be
+	 * quite hard to get completely right.  Try it and see.  If you
+	 * succeed, don't forget to hack push_back() correspondingly.
+	 */
+	size_t used;
+	size_t len;
+
+	do {
+	    bufstart = 0;
+	    used = 0;
+	    do {
+		if (used + (LEXBUFSIZ / 4) >= allocated) {
+		    allocated += (allocated + LEXBUFSIZ);
+		    result = typeRealloc(char, allocated, result);
+		    if (result == 0)
+			return (EOF);
+		}
+		if (used == 0)
+		    _nc_curr_file_pos = ftell(yyin);
+
+		if (fgets(result + used, allocated - used, yyin) != 0) {
+		    bufstart = result;
+		    if (used == 0) {
+			_nc_curr_line++;
+			_nc_curr_col = 0;
+		    }
+		} else {
+		    if (used != 0)
+			strcat(result, "\n");
+		}
+		if ((bufptr = bufstart) != 0) {
+		    used = strlen(bufptr);
+		    while (iswhite(*bufptr))
+			bufptr++;
+
+		    /*
+		     * Treat a trailing <cr><lf> the same as a <newline> so we
+		     * can read files on OS/2, etc.
+		     */
+		    if ((len = strlen(bufptr)) > 1) {
+			if (bufptr[len - 1] == '\n'
+			    && bufptr[len - 2] == '\r') {
+			    len--;
+			    bufptr[len - 1] = '\n';
+			    bufptr[len] = '\0';
+			}
+		    }
+		} else {
+		    return (EOF);
+		}
+	    } while (bufptr[len - 1] != '\n');	/* complete a line */
+	} while (result[0] == '#');	/* ignore comments */
+    }
+
+    first_column = (bufptr == bufstart);
+    if (first_column)
+	had_newline = FALSE;
+
+    _nc_curr_col++;
+    the_char = *bufptr++;
+    return UChar(the_char);
+}
+
+static void
+push_back(char c)
+/* push a character back onto the input stream */
+{
+    if (bufptr == bufstart)
+	_nc_syserr_abort("Can't backspace off beginning of line");
+    *--bufptr = c;
+}
+
+static long
+stream_pos(void)
+/* return our current character position in the input stream */
+{
+    return (yyin ? ftell(yyin) : (bufptr ? bufptr - bufstart : 0));
+}
+
+static bool
+end_of_stream(void)
+/* are we at end of input? */
+{
+    return ((yyin ? feof(yyin) : (bufptr && *bufptr == '\0'))
+	    ? TRUE : FALSE);
+}
 
 /* Assume we may be looking at a termcap-style continuation */
 static inline int
@@ -178,6 +350,8 @@
     }
 
     if (end_of_stream()) {
+	yyin = 0;
+	next_char();		/* frees its allocated memory */
 	if (buffer != 0) {
 	    FreeAndNull(buffer);
 	}
@@ -219,7 +393,7 @@
 	}
 
 	/* have to make some punctuation chars legal for terminfo */
-	if (!isalnum(ch)
+	if (!isalnum(UChar(ch))
 #if NCURSES_EXT_FUNCS
 	    && !(ch == '.' && _nc_disable_period)
 #endif
@@ -351,7 +525,7 @@
 		had_newline = FALSE;
 	    }
 	    while ((ch = next_char()) != EOF) {
-		if (!isalnum(ch)) {
+		if (!isalnum(UChar(ch))) {
 		    if (_nc_syntax == SYN_TERMINFO) {
 			if (ch != '_')
 			    break;
@@ -497,7 +671,7 @@
  *
  */
 
-NCURSES_EXPORT(char)
+NCURSES_EXPORT(int)
 _nc_trans_string(char *ptr, char *last)
 {
     int count = 0;
@@ -687,172 +861,3 @@
 	    return;
     }
 }
-
-/*****************************************************************************
- *
- * Character-stream handling
- *
- *****************************************************************************/
-
-#define LEXBUFSIZ	1024
-
-static char *bufptr;		/* otherwise, the input buffer pointer */
-static char *bufstart;		/* start of buffer so we can compute offsets */
-static FILE *yyin;		/* scanner's input file descriptor */
-
-/*
- *	_nc_reset_input()
- *
- *	Resets the input-reading routines.  Used on initialization,
- *	or after a seek has been done.  Exactly one argument must be
- *	non-null.
- */
-
-NCURSES_EXPORT(void)
-_nc_reset_input(FILE *fp, char *buf)
-{
-    pushtype = NO_PUSHBACK;
-    if (pushname != 0)
-	pushname[0] = '\0';
-    yyin = fp;
-    bufstart = bufptr = buf;
-    _nc_curr_file_pos = 0L;
-    if (fp != 0)
-	_nc_curr_line = 0;
-    _nc_curr_col = 0;
-}
-
-/*
- *	int last_char()
- *
- *	Returns the final nonblank character on the current input buffer
- */
-static int
-last_char(void)
-{
-    size_t len = strlen(bufptr);
-    while (len--) {
-	if (!isspace(UChar(bufptr[len])))
-	    return bufptr[len];
-    }
-    return 0;
-}
-
-/*
- *	int next_char()
- *
- *	Returns the next character in the input stream.  Comments and leading
- *	white space are stripped.
- *
- *	The global state variable 'firstcolumn' is set TRUE if the character
- *	returned is from the first column of the input line.
- *
- *	The global variable _nc_curr_line is incremented for each new line.
- *	The global variable _nc_curr_file_pos is set to the file offset of the
- *	beginning of each line.
- */
-
-static int
-next_char(void)
-{
-    if (!yyin) {
-	/*
-	 * An string with an embedded null will truncate the input.  This is
-	 * intentional (we don't read binary files here).
-	 */
-	if (*bufptr == '\0')
-	    return (EOF);
-	if (*bufptr == '\n') {
-	    _nc_curr_line++;
-	    _nc_curr_col = 0;
-	}
-    } else if (!bufptr || !*bufptr) {
-	/*
-	 * In theory this could be recoded to do its I/O one character at a
-	 * time, saving the buffer space.  In practice, this turns out to be
-	 * quite hard to get completely right.  Try it and see.  If you
-	 * succeed, don't forget to hack push_back() correspondingly.
-	 */
-	static char *result;
-	static size_t allocated;
-	size_t used;
-	size_t len;
-
-	do {
-	    bufstart = 0;
-	    used = 0;
-	    do {
-		if (used + (LEXBUFSIZ / 4) >= allocated) {
-		    allocated += (allocated + LEXBUFSIZ);
-		    result = typeRealloc(char, allocated, result);
-		    if (result == 0)
-			return (EOF);
-		}
-		if (used == 0)
-		    _nc_curr_file_pos = ftell(yyin);
-
-		if (fgets(result + used, allocated - used, yyin) != 0) {
-		    bufstart = result;
-		    if (used == 0) {
-			_nc_curr_line++;
-			_nc_curr_col = 0;
-		    }
-		} else {
-		    if (used != 0)
-			strcat(result, "\n");
-		}
-		if ((bufptr = bufstart) != 0) {
-		    used = strlen(bufptr);
-		    while (iswhite(*bufptr))
-			bufptr++;
-
-		    /*
-		     * Treat a trailing <cr><lf> the same as a <newline> so we
-		     * can read files on OS/2, etc.
-		     */
-		    if ((len = strlen(bufptr)) > 1) {
-			if (bufptr[len - 1] == '\n'
-			    && bufptr[len - 2] == '\r') {
-			    len--;
-			    bufptr[len - 1] = '\n';
-			    bufptr[len] = '\0';
-			}
-		    }
-		} else {
-		    return (EOF);
-		}
-	    } while (bufptr[len - 1] != '\n');	/* complete a line */
-	} while (result[0] == '#');	/* ignore comments */
-    }
-
-    first_column = (bufptr == bufstart);
-    if (first_column)
-	had_newline = FALSE;
-
-    _nc_curr_col++;
-    return (*bufptr++);
-}
-
-static void
-push_back(char c)
-/* push a character back onto the input stream */
-{
-    if (bufptr == bufstart)
-	_nc_syserr_abort("Can't backspace off beginning of line");
-    *--bufptr = c;
-}
-
-static long
-stream_pos(void)
-/* return our current character position in the input stream */
-{
-    return (yyin ? ftell(yyin) : (bufptr ? bufptr - bufstart : 0));
-}
-
-static bool
-end_of_stream(void)
-/* are we at end of input? */
-{
-    return ((yyin ? feof(yyin) : (bufptr && *bufptr == '\0'))
-	    ? TRUE : FALSE);
-}
Index: ncurses/tinfo/lib_setup.c
Prereq:  1.79 
--- ncurses-5.4-20040208/ncurses/tinfo/lib_setup.c	2003-12-27 13:24:26.000000000 -0500
+++ ncurses-5.4-20040424/ncurses/tinfo/lib_setup.c	2004-03-28 18:48:56.000000000 -0500
@@ -1,5 +1,5 @@
 /****************************************************************************
- * Copyright (c) 1998-2002,2003 Free Software Foundation, Inc.              *
+ * Copyright (c) 1998-2003,2004 Free Software Foundation, Inc.              *
  *                                                                          *
  * Permission is hereby granted, free of charge, to any person obtaining a  *
  * copy of this software and associated documentation files (the            *
@@ -47,9 +47,13 @@
 #define _POSIX_SOURCE
 #endif
 
+#if HAVE_LOCALE_H
+#include <locale.h>
+#endif
+
 #include <term.h>		/* lines, columns, cur_term */
 
-MODULE_ID("$Id: lib_setup.c,v 1.79 2003/12/27 18:24:26 tom Exp $")
+MODULE_ID("$Id: lib_setup.c,v 1.83 2004/03/28 23:48:56 tom Exp $")
 
 /****************************************************************************
  *
@@ -73,6 +77,10 @@
 # include <sys/ptem.h>
 #endif
 
+#ifdef HAVE_LANGINFO_CODESET
+#include <langinfo.h>
+#endif
+
 /*
  * SCO defines TIOCGSIZE and the corresponding struct.  Other systems (SunOS,
  * Solaris, IRIX) define TIOCGWINSZ and struct winsize.
@@ -318,18 +326,27 @@
 }
 
 /*
- * Check if we are running in a UTF-8 locale.
+ * Find the locale which is in effect.
  */
 NCURSES_EXPORT(char *)
 _nc_get_locale(void)
 {
     char *env;
+#if HAVE_LOCALE_H
+    /*
+     * This is preferable to using getenv() since it ensures that we are using
+     * the locale which was actually initialized by the application.
+     */
+    env = setlocale(LC_CTYPE, 0);
+#else
     if (((env = getenv("LC_ALL")) != 0 && *env != '\0')
 	|| ((env = getenv("LC_CTYPE")) != 0 && *env != '\0')
 	|| ((env = getenv("LANG")) != 0 && *env != '\0')) {
-	return env;
+	;
     }
-    return 0;
+#endif
+    T(("_nc_get_locale %s", _nc_visbuf(env)));
+    return env;
 }
 
 /*
@@ -338,12 +355,21 @@
 NCURSES_EXPORT(int)
 _nc_unicode_locale(void)
 {
+    int result = 0;
+#ifdef HAVE_LANGINFO_CODESET
+    char *env = nl_langinfo(CODESET);
+    result = !strcmp(env, "UTF-8");
+    T(("_nc_unicode_locale(%s) ->%d", env, result));
+#else
     char *env = _nc_get_locale();
     if (env != 0) {
-	if (strstr(env, ".UTF-8") != 0)
-	    return 1;
+	if (strstr(env, ".UTF-8") != 0) {
+	    result = 1;
+	    T(("_nc_unicode_locale(%s) ->%d", env, result));
+	}
     }
-    return 0;
+#endif
+    return result;
 }
 
 /*
Index: ncurses/tinfo/name_match.c
Prereq:  1.12 
--- ncurses-5.4-20040208/ncurses/tinfo/name_match.c	2002-08-31 17:48:41.000000000 -0400
+++ ncurses-5.4-20040424/ncurses/tinfo/name_match.c	2004-04-17 18:11:21.000000000 -0400
@@ -1,5 +1,5 @@
 /****************************************************************************
- * Copyright (c) 1999,2000,2001 Free Software Foundation, Inc.              *
+ * Copyright (c) 1999-2002,2004 Free Software Foundation, Inc.              *
  *                                                                          *
  * Permission is hereby granted, free of charge, to any person obtaining a  *
  * copy of this software and associated documentation files (the            *
@@ -34,7 +34,7 @@
 #include <term.h>
 #include <tic.h>
 
-MODULE_ID("$Id: name_match.c,v 1.12 2002/08/31 21:48:41 Philippe.Blain Exp $")
+MODULE_ID("$Id: name_match.c,v 1.13 2004/04/17 22:11:21 tom Exp $")
 
 /*
  *	_nc_first_name(char *names)
@@ -49,6 +49,13 @@
     static char *buf;
     register unsigned n;
 
+#if NO_LEAKS
+    if (sp == 0) {
+	FreeAndNull(buf);	/* for leak-testing */
+	return 0;
+    }
+#endif
+
     if (buf == 0)
 	buf = typeMalloc(char, MAX_NAME_SIZE + 1);
     for (n = 0; n < MAX_NAME_SIZE; n++) {
@@ -67,8 +74,7 @@
  */
 
 NCURSES_EXPORT(int)
-_nc_name_match
-(const char *const namelst, const char *const name, const char *const delim)
+_nc_name_match(const char *const namelst, const char *const name, const char *const delim)
 {
     const char *s, *d, *t;
     int code, found;
Index: ncurses/tinfo/read_termcap.c
Prereq:  1.61 
--- ncurses-5.4-20040208/ncurses/tinfo/read_termcap.c	2003-11-08 15:22:45.000000000 -0500
+++ ncurses-5.4-20040424/ncurses/tinfo/read_termcap.c	2004-04-24 14:34:13.000000000 -0400
@@ -1,5 +1,5 @@
 /****************************************************************************
- * Copyright (c) 1998-2002,2003 Free Software Foundation, Inc.              *
+ * Copyright (c) 1998-2003,2004 Free Software Foundation, Inc.              *
  *                                                                          *
  * Permission is hereby granted, free of charge, to any person obtaining a  *
  * copy of this software and associated documentation files (the            *
@@ -57,7 +57,7 @@
 #include <tic.h>
 #include <term_entry.h>
 
-MODULE_ID("$Id: read_termcap.c,v 1.61 2003/11/08 20:22:45 tom Exp $")
+MODULE_ID("$Id: read_termcap.c,v 1.64 2004/04/24 18:34:13 tom Exp $")
 
 #if !PURE_TERMINFO
 
@@ -74,10 +74,10 @@
 #define TC_SYS_ERR    -3
 #define TC_REF_LOOP   -4
 
-static char *
+static NCURSES_CONST char *
 get_termpath(void)
 {
-    char *result;
+    NCURSES_CONST char *result;
 
     if (!use_terminfo_vars() || (result = getenv("TERMPATH")) == 0)
 	result = TERMPATH;
@@ -720,7 +720,7 @@
 	    if (*s == '\0') {
 		break;
 	    } else if (*s++ == '\n') {
-		while (isspace(*s))
+		while (isspace(UChar(*s)))
 		    s++;
 	    } else {
 		found = TRUE;
@@ -734,7 +734,7 @@
 		break;
 	    }
 	    base = s;
-	} else if (isgraph(ch)) {
+	} else if (isgraph(UChar(ch))) {
 	    found = TRUE;
 	}
     }
@@ -754,7 +754,7 @@
 
     while ((ch = *src++) != '\0') {
 	if (ch == '\\' && *src == '\n') {
-	    while (isspace(*src))
+	    while (isspace(UChar(*src)))
 		src++;
 	    continue;
 	}
@@ -784,7 +784,7 @@
     char pathbuf[PBUFSIZ];	/* holds raw path of filenames */
     char *pathvec[PVECSIZ];	/* to point to names in pathbuf */
     char **pvec;		/* holds usable tail of path vector */
-    char *termpath;
+    NCURSES_CONST char *termpath;
     string_desc desc;
 
     fname = pathvec;
Index: ncurses/trace/lib_tracechr.c
Prereq:  1.10 
--- ncurses-5.4-20040208/ncurses/trace/lib_tracechr.c	2003-06-14 07:05:42.000000000 -0400
+++ ncurses-5.4-20040424/ncurses/trace/lib_tracechr.c	2004-04-03 17:45:03.000000000 -0500
@@ -1,5 +1,5 @@
 /****************************************************************************
- * Copyright (c) 1998-2002,2003 Free Software Foundation, Inc.              *
+ * Copyright (c) 1998-2003,2004 Free Software Foundation, Inc.              *
  *                                                                          *
  * Permission is hereby granted, free of charge, to any person obtaining a  *
  * copy of this software and associated documentation files (the            *
@@ -38,21 +38,21 @@
 
 #include <ctype.h>
 
-MODULE_ID("$Id: lib_tracechr.c,v 1.10 2003/06/14 11:05:42 tom Exp $")
+MODULE_ID("$Id: lib_tracechr.c,v 1.11 2004/04/03 22:45:03 tom Exp $")
 
 #ifdef TRACE
 NCURSES_EXPORT(char *)
 _tracechar(int ch)
 {
     static char result[40];
-    char *name;
+    NCURSES_CONST char *name;
 
     if (ch > KEY_MIN || ch < 0) {
 	name = keyname(ch);
 	if (name == 0 || *name == '\0')
 	    name = "NULL";
 	(void) sprintf(result, "'%.30s' = %#03o", name, ch);
-    } else if (!isprint(ch) || ch > 255) {
+    } else if (!is8bits(ch) || !isprint(UChar(ch))) {
 	/*
 	 * workaround for glibc bug:
 	 * sprintf changes the result from unctrl() to an empty string if it
Index: ncurses/tty/lib_mvcur.c
Prereq:  1.97 
--- ncurses-5.4-20040208/ncurses/tty/lib_mvcur.c	2003-12-27 11:43:59.000000000 -0500
+++ ncurses-5.4-20040424/ncurses/tty/lib_mvcur.c	2004-04-03 17:32:24.000000000 -0500
@@ -1,5 +1,5 @@
 /****************************************************************************
- * Copyright (c) 1998-2002,2003 Free Software Foundation, Inc.              *
+ * Copyright (c) 1998-2003,2004 Free Software Foundation, Inc.              *
  *                                                                          *
  * Permission is hereby granted, free of charge, to any person obtaining a  *
  * copy of this software and associated documentation files (the            *
@@ -154,7 +154,7 @@
 #include <term.h>
 #include <ctype.h>
 
-MODULE_ID("$Id: lib_mvcur.c,v 1.97 2003/12/27 16:43:59 tom Exp $")
+MODULE_ID("$Id: lib_mvcur.c,v 1.98 2004/04/03 22:32:24 tom Exp $")
 
 #define WANT_CHAR(y, x)	SP->_newscr->_line[y].text[x]	/* desired state */
 #define BAUDRATE	cur_term->_baudrate	/* bits per second */
@@ -589,9 +589,11 @@
 		    && n > 0
 		    && n < (int) check.s_size
 		    && vcost == 0
-		    && str[0] == '\0'
-		    && isdigit(CharOf(WANT_CHAR(to_y, from_x))))
-		    ovw = FALSE;
+		    && str[0] == '\0') {
+		    int wanted = CharOf(WANT_CHAR(to_y, from_x));
+		    if (is8bits(wanted) && isdigit(wanted))
+			ovw = FALSE;
+		}
 #endif
 		/*
 		 * If we have no attribute changes, overwrite is cheaper.
Index: ncurses/tty/tty_update.c
Prereq:  1.205 
--- ncurses-5.4-20040208/ncurses/tty/tty_update.c	2004-02-07 13:02:42.000000000 -0500
+++ ncurses-5.4-20040424/ncurses/tty/tty_update.c	2004-04-24 16:17:54.000000000 -0400
@@ -29,7 +29,7 @@
 /****************************************************************************
  *  Author: Zeyd M. Ben-Halim <zmbenhal@netcom.com> 1992,1995               *
  *     and: Eric S. Raymond <esr@snark.thyrsus.com>                         *
- *     and: Thomas E. Dickey 1996-2004                                      *
+ *     and: Thomas E. Dickey                        1996-on                 *
  ****************************************************************************/
 
 /*-----------------------------------------------------------------
@@ -74,7 +74,7 @@
 #include <ctype.h>
 #include <term.h>
 
-MODULE_ID("$Id: tty_update.c,v 1.205 2004/02/07 18:02:42 tom Exp $")
+MODULE_ID("$Id: tty_update.c,v 1.208 2004/04/24 20:17:54 tom Exp $")
 
 /*
  * This define controls the line-breakout optimization.  Every once in a
@@ -201,8 +201,9 @@
     if ((chlen = wcwidth(CharOf(CHDEREF(ch)))) <= 0) {
 	static NCURSES_CH_T blank = NewChar(BLANK_TEXT);
 
-	if (isprint(CharOf(CHDEREF(ch)))
-	    || (SP->_posix_locale && CharOf(CHDEREF(ch)) >= 160)) {
+	if (is8bits(CharOf(CHDEREF(ch)))
+	    && (isprint(CharOf(CHDEREF(ch)))
+		|| (SP->_legacy_coding && CharOf(CHDEREF(ch)) >= 160))) {
 	    ;
 	} else {
 	    ch = CHREF(blank);
@@ -233,7 +234,6 @@
 	    chtype temp = UChar(SP->_acs_map[CharOfD(ch)]);
 	    if (temp != 0)
 		SetChar(my_ch, temp, attr);
-	    RemAttr(my_ch, A_ALTCHARSET);
 	}
 	ch = CHREF(my_ch);
     }
Index: ncurses/widechar/lib_add_wch.c
Prereq:  1.2 
--- ncurses-5.4-20040208/ncurses/widechar/lib_add_wch.c	2004-02-07 12:53:33.000000000 -0500
+++ ncurses-5.4-20040424/ncurses/widechar/lib_add_wch.c	2004-04-03 15:19:31.000000000 -0500
@@ -35,7 +35,7 @@
 
 #include <curses.priv.h>
 
-MODULE_ID("$Id: lib_add_wch.c,v 1.2 2004/02/07 17:53:33 tom Exp $")
+MODULE_ID("$Id: lib_add_wch.c,v 1.3 2004/04/03 20:19:31 tom Exp $")
 
 NCURSES_EXPORT(int)
 wadd_wch(WINDOW *win, const cchar_t * wch)
@@ -54,7 +54,7 @@
 		break;
 	    if ((PUTC_n = wcrtomb(PUTC_buf, PUTC_ch, &PUT_st)) <= 0) {
 		code = ERR;
-		if (PUTC_ch < 256)
+		if (is8bits(PUTC_ch))
 		    code = waddch(win, UChar(PUTC_ch));
 		break;
 	    }
@@ -89,7 +89,7 @@
 		break;
 	    if ((PUTC_n = wcrtomb(PUTC_buf, PUTC_ch, &PUT_st)) <= 0) {
 		code = ERR;
-		if (PUTC_ch < 256)
+		if (is8bits(PUTC_ch))
 		    code = waddch(win, UChar(PUTC_ch));
 		break;
 	    }
Index: ncurses/widechar/lib_get_wch.c
Prereq:  1.6 
--- ncurses-5.4-20040208/ncurses/widechar/lib_get_wch.c	2004-01-17 20:18:17.000000000 -0500
+++ ncurses-5.4-20040424/ncurses/widechar/lib_get_wch.c	2004-02-21 17:22:22.000000000 -0500
@@ -39,18 +39,18 @@
 
 #include <curses.priv.h>
 
-MODULE_ID("$Id: lib_get_wch.c,v 1.6 2004/01/18 01:18:17 tom Exp $")
+MODULE_ID("$Id: lib_get_wch.c,v 1.7 2004/02/21 22:22:22 tom Exp $")
 
 #if HAVE_MBTOWC && HAVE_MBLEN
 #define reset_mbytes(state) mblen(NULL, 0), mbtowc(NULL, NULL, 0)
 #define count_mbytes(buffer,length,state) mblen(buffer,length)
 #define check_mbytes(wch,buffer,length,state) \
-	(int) mbtowc(&wch, buffer, count)
+	(int) mbtowc(&wch, buffer, length)
 #elif HAVE_MBRTOWC && HAVE_MBRLEN
 #define reset_mbytes(state) memset(&state, 0, sizeof(state))
 #define count_mbytes(buffer,length,state) mbrlen(buffer,length,&state)
 #define check_mbytes(wch,buffer,length,state) \
-	(int) mbrtowc(&wch, buffer, count, &state)
+	(int) mbrtowc(&wch, buffer, length, &state)
 #else
 make an error
 #endif
Index: progs/tic.c
Prereq:  1.109 
--- ncurses-5.4-20040208/progs/tic.c	2003-12-06 12:36:57.000000000 -0500
+++ ncurses-5.4-20040424/progs/tic.c	2004-04-17 18:20:51.000000000 -0400
@@ -1,5 +1,5 @@
 /****************************************************************************
- * Copyright (c) 1998-2002,2003 Free Software Foundation, Inc.              *
+ * Copyright (c) 1998-2003,2004 Free Software Foundation, Inc.              *
  *                                                                          *
  * Permission is hereby granted, free of charge, to any person obtaining a  *
  * copy of this software and associated documentation files (the            *
@@ -45,7 +45,7 @@
 #include <term_entry.h>
 #include <transform.h>
 
-MODULE_ID("$Id: tic.c,v 1.109 2003/12/06 17:36:57 tom Exp $")
+MODULE_ID("$Id: tic.c,v 1.111 2004/04/17 22:20:51 tom Exp $")
 
 const char *_nc_progname = "tic";
 
@@ -585,7 +585,7 @@
 	(void) fprintf(stderr,
 		       "Sorry, -e can't be used without -I or -C\n");
 	cleanup();
-	return EXIT_FAILURE;
+	ExitProgram(EXIT_FAILURE);
     }
 #endif /* HAVE_BIG_CORE */
 
@@ -597,7 +597,7 @@
 		    _nc_progname,
 		    _nc_progname,
 		    usage_string);
-	    return EXIT_FAILURE;
+	    ExitProgram(EXIT_FAILURE);
 	}
     } else {
 	if (infodump == TRUE) {
@@ -628,7 +628,7 @@
 		    _nc_progname,
 		    usage_string);
 	    cleanup();
-	    return EXIT_FAILURE;
+	    ExitProgram(EXIT_FAILURE);
 	}
     }
 
@@ -660,7 +660,7 @@
     if (check_only || (!infodump && !capdump) || forceresolve) {
 	if (!_nc_resolve_uses(TRUE) && !check_only) {
 	    cleanup();
-	    return EXIT_FAILURE;
+	    ExitProgram(EXIT_FAILURE);
 	}
     }
 
@@ -754,7 +754,7 @@
 	    fprintf(log_fp, "No entries written\n");
     }
     cleanup();
-    return (EXIT_SUCCESS);
+    ExitProgram(EXIT_SUCCESS);
 }
 
 /*
@@ -1326,6 +1326,9 @@
 	free(zero);
 	if (tparm_errs)
 	    _nc_warning("stack error in sgr string");
+    } else if (PRESENT(exit_attribute_mode)) {
+	if (_nc_syntax == SYN_TERMINFO)
+	    _nc_warning("missing sgr string");
     }
 
     /*
Index: test/README
Prereq:  1.15 
--- ncurses-5.4-20040208/test/README	2003-07-05 15:17:49.000000000 -0400
+++ ncurses-5.4-20040424/test/README	2004-03-20 14:37:19.000000000 -0500
@@ -1,4 +1,4 @@
--- $Id: README,v 1.15 2003/07/05 19:17:49 tom Exp $
+-- $Id: README,v 1.16 2004/03/20 19:37:19 tom Exp $
 -------------------------------------------------------------------------------
 
 The programs in this directory are designed to test your newest toy :-)
@@ -184,7 +184,7 @@
 ----------
 BC				-
 COLORS				test: ncurses xmas
-COLOR_PAIR			test: blue bs demo_forms filter firework gdc hanoi ins_wide inserts knight ncurses newdemo rain tclock testaddch testcurs view worm xmas
+COLOR_PAIR			test: background blue bs demo_forms filter firework gdc hanoi ins_wide inserts knight ncurses newdemo rain tclock testaddch testcurs view worm xmas
 COLOR_PAIRS			test: ncurses newdemo
 COLS				test: cardfile demo_defkey demo_forms demo_keyok edit_field firework hashtest ins_wide inserts lrtest ncurses newdemo rain tclock testcurs view worm
 ESCDELAY			lib: ncurses
@@ -215,8 +215,8 @@
 attrset				test: bs firework gdc hanoi ncurses rain tclock testaddch testcurs
 baudrate			lib: ncurses
 beep				test: blue bs cardfile demo_forms edit_field hanoi ins_wide inserts knight ncurses tclock testcurs view xmas
-bkgd				test: demo_forms ncurses tclock view
-bkgdset				test: ncurses testaddch
+bkgd				test: background demo_forms ncurses tclock view
+bkgdset				test: background ncurses testaddch
 bkgrnd				-
 bkgrndset			-
 boolcodes			progs: dump_entry
@@ -227,14 +227,14 @@
 box				test: cardfile demo_forms edit_field ins_wide inserts lrtest ncurses newdemo testcurs
 box_set				test: ncurses
 can_change_color		test: ncurses
-cbreak				test: blue bs cardfile demo_defkey demo_forms demo_keyok ditto filter firework gdc hanoi hashtest ins_wide inserts knight lrtest ncurses newdemo tclock testcurs view worm xmas
+cbreak				test: background blue bs cardfile color_set demo_defkey demo_forms demo_keyok ditto filter firework gdc hanoi hashtest ins_wide inserts knight lrtest ncurses newdemo tclock testcurs view worm xmas
 chgat				-
 clear				test: blue bs gdc ncurses testcurs xmas
 clearok				test: bs knight
 clrtobot			test: ncurses
 clrtoeol			test: blue bs hanoi hashtest ncurses view
 color_content			test: ncurses
-color_set			-
+color_set			test: color_set
 copywin				test: testcurs
 cur_term			test: dots lrtest progs: clear tic tput tset
 curs_set			test: firework gdc hanoi lrtest newdemo rain tclock testcurs worm xmas
@@ -255,7 +255,7 @@
 echo				test: bs hanoi ncurses testcurs testscanw
 echo_wchar			test: ncurses
 echochar			test: ncurses
-endwin				test: blue bs cardfile demo_defkey demo_forms demo_keyok ditto filter firework firstlast gdc hanoi hashtest ins_wide inserts knight lrtest ncurses newdemo rain tclock testaddch testcurs testscanw view worm xmas
+endwin				test: background blue bs cardfile color_set demo_defkey demo_forms demo_keyok ditto filter firework firstlast gdc hanoi hashtest ins_wide inserts knight lrtest ncurses newdemo rain tclock testaddch testcurs testscanw view worm xmas
 erase				test: cardfile filter firework firstlast hanoi lrtest ncurses tclock testcurs
 erasechar			lib: ncurses
 erasewchar			-
@@ -267,14 +267,14 @@
 getbkgd				test: ncurses
 getbkgrnd			-
 getcchar			test: view
-getch				test: blue bs ditto firework firstlast hanoi hashtest lrtest rain tclock testaddch testcurs view worm xmas
+getch				test: background blue bs color_set ditto firework firstlast hanoi hashtest lrtest rain tclock testaddch testcurs view worm xmas
 getmouse			test: bs knight ncurses
 getn_wstr			-
 getnstr				test: filter ncurses
 getstr				-
 getwin				test: ncurses
 halfdelay			test: view
-has_colors			test: bs demo_forms filter firework gdc hanoi ins_wide inserts knight ncurses newdemo rain tclock testcurs view worm xmas
+has_colors			test: background bs color_set demo_forms filter firework gdc hanoi ins_wide inserts knight ncurses newdemo rain tclock testcurs view worm xmas
 has_ic				test: lrtest
 has_il				lib: ncurses
 has_key				lib: ncurses
@@ -290,8 +290,8 @@
 inchnstr			-
 inchstr				-
 init_color			test: ncurses
-init_pair			test: blue bs demo_forms filter firework gdc hanoi ins_wide inserts knight ncurses newdemo rain tclock testaddch testcurs view worm xmas
-initscr				test: blue bs cardfile demo_defkey demo_forms demo_keyok firework firstlast gdc hanoi hashtest ins_wide inserts knight lrtest ncurses newdemo rain tclock testaddch testcurs testscanw view worm xmas
+init_pair			test: background blue bs color_set demo_forms filter firework gdc hanoi ins_wide inserts knight ncurses newdemo rain tclock testaddch testcurs view worm xmas
+initscr				test: background blue bs cardfile color_set demo_defkey demo_forms demo_keyok firework firstlast gdc hanoi hashtest ins_wide inserts knight lrtest ncurses newdemo rain tclock testaddch testcurs testscanw view worm xmas
 innstr				-
 innwstr				-
 ins_nwstr			-
@@ -416,7 +416,7 @@
 nl				test: demo_forms ncurses rain testcurs
 nocbreak			test: testcurs
 nodelay				test: firework gdc lrtest ncurses newdemo rain tclock view xmas
-noecho				test: bs cardfile demo_defkey demo_forms demo_keyok ditto firework firstlast gdc hanoi hashtest ins_wide inserts knight lrtest ncurses rain tclock testcurs view worm xmas
+noecho				test: background bs cardfile color_set demo_defkey demo_forms demo_keyok ditto firework firstlast gdc hanoi hashtest ins_wide inserts knight lrtest ncurses rain tclock testcurs view worm xmas
 nonl				test: bs demo_forms hashtest ncurses view worm xmas
 noqiflush			-
 noraw				test: demo_forms ncurses testcurs
@@ -427,11 +427,12 @@
 ospeed				progs: tset
 overlay				test: testcurs xmas
 overwrite			test: ncurses
-pair_content			lib: ncurses
+pair_content			test: background color_set
+pecho_wchar			-
 pechochar			-
 pnoutrefresh			test: edit_field ncurses
 prefresh			test: testcurs
-printw				test: blue bs demo_defkey demo_keyok filter ncurses testcurs testscanw view
+printw				test: background blue bs color_set demo_defkey demo_keyok filter ncurses testcurs testscanw view
 putp				progs: tput
 putwin				test: ncurses
 qiflush				-
@@ -478,7 +479,7 @@
 slk_wset			test: ncurses
 standend			test: blue gdc ncurses worm
 standout			test: blue ncurses
-start_color			test: blue bs demo_forms filter firework gdc hanoi ins_wide inserts knight ncurses newdemo rain tclock testaddch testcurs view worm xmas
+start_color			test: background blue bs color_set demo_forms filter firework gdc hanoi ins_wide inserts knight ncurses newdemo rain tclock testaddch testcurs view worm xmas
 stdscr				test: bs demo_forms ditto filter firework gdc hanoi hashtest ins_wide inserts knight lrtest ncurses rain tclock testcurs testscanw view xmas
 strcodes			progs: dump_entry
 strfnames			progs: dump_entry
@@ -581,7 +582,7 @@
 winsdelln			lib: form
 winsertln			test: testcurs
 winsnstr			lib: form
-winsstr				-
+winsstr				lib: ncurses
 winstr				-
 winwstr				lib: ncurses
 wmouse_trafo			lib: menu
Index: test/bs.c
Prereq:  1.39 
--- ncurses-5.4-20040208/test/bs.c	2003-12-06 13:10:13.000000000 -0500
+++ ncurses-5.4-20040424/test/bs.c	2004-04-10 20:00:53.000000000 -0400
@@ -7,7 +7,7 @@
  * v2.0 featuring strict ANSI/POSIX conformance, November 1993.
  * v2.1 with ncurses mouse support, September 1995
  *
- * $Id: bs.c,v 1.39 2003/12/06 18:10:13 tom Exp $
+ * $Id: bs.c,v 1.40 2004/04/11 00:00:53 tom Exp $
  */
 
 #include <time.h>
@@ -249,7 +249,7 @@
 
 /* VARARGS1 */
 static void
-prompt(int n, const char *f, const char *s)
+prompt(int n, NCURSES_CONST char *f, const char *s)
 /* print a message at the prompt line */
 {
     (void) move(PROMPTLINE + n, 0);
Index: test/color_set.c
Prereq:  1.2 
--- ncurses-5.4-20040208/test/color_set.c	2003-12-06 19:08:47.000000000 -0500
+++ ncurses-5.4-20040424/test/color_set.c	2004-04-10 16:10:28.000000000 -0400
@@ -1,9 +1,11 @@
 /*
- * $Id: color_set.c,v 1.2 2003/12/07 00:08:47 tom Exp $
+ * $Id: color_set.c,v 1.3 2004/04/10 20:10:28 tom Exp $
  */
 
 #include <test.priv.h>
 
+#ifdef HAVE_COLOR_SET
+
 #define SHOW(n) ((n) == ERR ? "ERR" : "OK")
 
 int
@@ -53,3 +55,11 @@
 
     ExitProgram(EXIT_SUCCESS);
 }
+#else
+int
+main(void)
+{
+    printf("This program requires the curses color_set function\n");
+    ExitProgram(EXIT_FAILURE);
+}
+#endif
Index: test/demo_forms.c
Prereq:  1.3 
--- ncurses-5.4-20040208/test/demo_forms.c	2003-05-03 18:08:20.000000000 -0400
+++ ncurses-5.4-20040424/test/demo_forms.c	2004-04-17 17:18:40.000000000 -0400
@@ -1,5 +1,5 @@
 /*
- * $Id: demo_forms.c,v 1.3 2003/05/03 22:08:20 tom Exp $
+ * $Id: demo_forms.c,v 1.4 2004/04/17 21:18:40 tom Exp $
  *
  * Demonstrate a variety of functions from the form library.
  * Thomas Dickey - 2003/4/26
@@ -283,7 +283,7 @@
     demo_forms();
 
     endwin();
-    return EXIT_SUCCESS;
+    ExitProgram(EXIT_SUCCESS);
 }
 #else
 int
Index: test/dots.c
Prereq:  1.8 
--- ncurses-5.4-20040208/test/dots.c	2002-04-06 16:33:42.000000000 -0500
+++ ncurses-5.4-20040424/test/dots.c	2004-04-10 19:58:46.000000000 -0400
@@ -1,5 +1,5 @@
 /****************************************************************************
- * Copyright (c) 1999-2001,2002 Free Software Foundation, Inc.              *
+ * Copyright (c) 1999-2002,2004 Free Software Foundation, Inc.              *
  *                                                                          *
  * Permission is hereby granted, free of charge, to any person obtaining a  *
  * copy of this software and associated documentation files (the            *
@@ -29,7 +29,7 @@
 /*
  * Author: Thomas E. Dickey <dickey@clark.net> 1999
  *
- * $Id: dots.c,v 1.8 2002/04/06 21:33:42 tom Exp $
+ * $Id: dots.c,v 1.9 2004/04/10 23:58:46 tom Exp $
  *
  * A simple demo of the terminfo interface.
  */
@@ -127,12 +127,16 @@
 		tputs(tparm2(set_a_foreground, z), 1, outc);
 	    } else {
 		tputs(tparm2(set_a_background, z), 1, outc);
+		napms(1);
 	    }
 	} else if (valid(exit_attribute_mode)
 		   && valid(enter_reverse_mode)) {
-	    if (ranf() <= 0.01)
-		outs((ranf() > 0.6) ? enter_reverse_mode :
-		     exit_attribute_mode);
+	    if (ranf() <= 0.01) {
+		outs((ranf() > 0.6)
+		     ? enter_reverse_mode
+		     : exit_attribute_mode);
+		napms(1);
+	    }
 	}
 	outc(p);
 	fflush(stdout);
Index: test/ncurses.c
Prereq:  1.202 
--- ncurses-5.4-20040208/test/ncurses.c	2004-02-07 15:24:08.000000000 -0500
+++ ncurses-5.4-20040424/test/ncurses.c	2004-04-24 17:42:54.000000000 -0400
@@ -40,7 +40,7 @@
    Author: Eric S. Raymond <esr@snark.thyrsus.com> 1993
            Thomas E. Dickey (beginning revision 1.27 in 1996).
 
-$Id: ncurses.c,v 1.202 2004/02/07 20:24:08 tom Exp $
+$Id: ncurses.c,v 1.207 2004/04/24 21:42:54 tom Exp $
 
 ***************************************************************************/
 
@@ -1101,6 +1101,8 @@
 		    *bg = 0;
 		if (*bg < 0)
 		    *bg = max_colors - 1;
+	    } else {
+		return FALSE;
 	    }
 	    break;
 	}
@@ -3057,6 +3059,10 @@
 	saywhat("d5; press any key to continue");
 	rmpanel(p5);
 	pflush();
+
+	rmpanel(p3);
+	pflush();
+
 	wait_a_while(nap_msec);
 	if (nap_msec == 1)
 	    break;
@@ -3627,6 +3633,8 @@
 static const char *animals[] =
 {
     "Lions", "Tigers", "Bears", "(Oh my!)", "Newts", "Platypi", "Lemurs",
+    "Lions, Tigers, Bears, (Oh my!), Newts, Platypi, Lemurs",
+    "Lions, Tigers, Bears, (Oh my!), Newts, Platypi, Lemurs, Lions, Tigers, Bears, (Oh my!), Newts, Platypi, Lemurs",
     (char *) 0
 };
 
@@ -3670,6 +3678,8 @@
     post_menu(m);
 
     while ((c = menu_driver(m, menu_virtualize(wGetchar(menuwin)))) != E_UNKNOWN_COMMAND) {
+	if (c == E_NOT_POSTED)
+	    break;
 	if (c == E_REQUEST_DENIED)
 	    beep();
 	continue;
@@ -3931,7 +3941,7 @@
 	strcpy(temp, field_buffer(me, 1));
 	len = (long) (char *) field_userptr(me);
 	if (c <= KEY_MAX) {
-	    if (isgraph(c)) {
+	    if (isgraph(c) && (len + 1) < (int) sizeof(temp)) {
 		temp[len++] = c;
 		temp[len] = 0;
 		set_field_buffer(me, 1, temp);
@@ -4102,12 +4112,14 @@
     int c = wGetchar(w);
     unsigned n;
     FIELD *me = current_field(f);
+    bool current = TRUE;
 
     if (c == CTRL(']')) {
-	if (mode == REQ_INS_MODE)
+	if (mode == REQ_INS_MODE) {
 	    mode = REQ_OVL_MODE;
-	else
+	} else {
 	    mode = REQ_INS_MODE;
+	}
 	c = mode;
     } else {
 	for (n = 0; n < SIZEOF(lookup); n++) {
@@ -4117,15 +4129,38 @@
 	    }
 	}
     }
+    mvprintw(0, COLS - 6, "(%s)", mode == REQ_INS_MODE ? "INS" : "OVL");
 
     /*
      * Force the field that the user is typing into to be in reverse video,
      * while the other fields are shown underlined.
      */
-    if (c <= KEY_MAX) {
+    switch (c) {
+    case REQ_BEG_FIELD:
+    case REQ_CLR_EOF:
+    case REQ_CLR_EOL:
+    case REQ_CLR_FIELD:
+    case REQ_DEL_CHAR:
+    case REQ_DEL_LINE:
+    case REQ_DEL_PREV:
+    case REQ_DEL_WORD:
+    case REQ_END_FIELD:
+    case REQ_INS_CHAR:
+    case REQ_INS_LINE:
+    case REQ_LEFT_CHAR:
+    case REQ_LEFT_FIELD:
+    case REQ_NEXT_WORD:
+    case REQ_RIGHT_CHAR:
+	current = TRUE;
+	break;
+    default:
+	current = (c < KEY_MAX);
+	break;
+    }
+    if (current) {
 	c = edit_secure(me, c);
 	set_field_back(me, A_REVERSE);
-    } else if (c <= MAX_FORM_COMMAND) {
+    } else {
 	c = edit_secure(me, c);
 	set_field_back(me, A_UNDERLINE);
     }
@@ -4232,7 +4267,7 @@
     addstr("^H   -- delete previous char   ^Y  -- delete line\n");
     addstr("^G   -- delete current word    ^C  -- clear to end of line\n");
     addstr("^K   -- clear to end of field  ^X  -- clear field\n");
-    addstr("Arrow keys move within a field as you would expect.");
+    addstr("Arrow keys move within a field as you would expect. ^] toggles overlay mode.");
 
     mvaddstr(4, 57, "Forms Entry Test");
 
@@ -4542,7 +4577,9 @@
 	,"  -e fmt   specify format for soft-keys test (e)"
 	,"  -f       rip-off footer line (can repeat)"
 	,"  -h       rip-off header line (can repeat)"
+#if USE_LIBPANEL
 	,"  -s msec  specify nominal time for panel-demo (default: 1, to hold)"
+#endif
 #ifdef TRACE
 	,"  -t mask  specify default trace-level (may toggle with ^T)"
 #endif
Index: test/test.priv.h
Prereq:  1.46 
--- ncurses-5.4-20040208/test/test.priv.h	2003-10-18 20:04:24.000000000 -0400
+++ ncurses-5.4-20040424/test/test.priv.h	2004-04-10 16:11:37.000000000 -0400
@@ -29,7 +29,7 @@
 /****************************************************************************
  *  Author: Thomas E. Dickey <dickey@clark.net> 1996                        *
  ****************************************************************************/
-/* $Id: test.priv.h,v 1.46 2003/10/19 00:04:24 tom Exp $ */
+/* $Id: test.priv.h,v 1.48 2004/04/10 20:11:37 tom Exp $ */
 
 #ifndef __TEST_PRIV_H
 #define __TEST_PRIV_H 1
@@ -136,6 +136,10 @@
 #include <term.h>
 #endif
 
+#ifdef NCURSES_VERSION
+#define HAVE_COLOR_SET 1
+#endif
+
 #if NCURSES_NOMACROS
 #include <nomacros.h>
 #endif
@@ -276,12 +280,12 @@
 #endif
 
 /* out-of-band values for representing absent capabilities */
-#define ABSENT_BOOLEAN		(-1)		/* 255 */
+#define ABSENT_BOOLEAN		((signed char)-1)	/* 255 */
 #define ABSENT_NUMERIC		(-1)
 #define ABSENT_STRING		(char *)0
 
 /* out-of-band values for representing cancels */
-#define CANCELLED_BOOLEAN	(char)(-2)	/* 254 */
+#define CANCELLED_BOOLEAN	((signed char)-2)	/* 254 */
 #define CANCELLED_NUMERIC	(-2)
 #define CANCELLED_STRING	(char *)(-1)
 
Index: test/view.c
Prereq:  1.57 
--- ncurses-5.4-20040208/test/view.c	2003-05-17 17:58:43.000000000 -0400
+++ ncurses-5.4-20040424/test/view.c	2004-04-24 17:53:06.000000000 -0400
@@ -23,13 +23,15 @@
  * scroll operation worked, and the refresh() code only had to do a
  * partial repaint.
  *
- * $Id: view.c,v 1.57 2003/05/17 21:58:43 tom Exp $
+ * $Id: view.c,v 1.59 2004/04/24 21:53:06 tom Exp $
  */
 
 #include <time.h>
 
 #include <test.priv.h>
 
+#undef CTRL			/* conflict on AIX 5.2 with <sys/ioctl.h> */
+
 #if HAVE_TERMIOS_H
 # include <termios.h>
 #else
@@ -69,8 +71,9 @@
 static bool try_color = FALSE;
 
 static char *fname;
-static NCURSES_CH_T **my_lines;
+static NCURSES_CH_T **vec_lines;
 static NCURSES_CH_T **lptr;
+static int num_lines;
 
 static void
 usage(void)
@@ -180,7 +183,6 @@
     int i;
     int my_delay = 0;
     NCURSES_CH_T **olptr;
-    int length = 0;
     int value = 0;
     bool done = FALSE;
     bool got_number = FALSE;
@@ -233,7 +235,7 @@
     if (optind + 1 != argc)
 	usage();
 
-    if ((my_lines = typeMalloc(NCURSES_CH_T *, MAXLINES + 2)) == 0)
+    if ((vec_lines = typeMalloc(NCURSES_CH_T *, MAXLINES + 2)) == 0)
 	usage();
 
     fname = argv[optind];
@@ -247,7 +249,7 @@
 #endif
 
     /* slurp the file */
-    for (lptr = &my_lines[0]; (lptr - my_lines) < MAXLINES; lptr++) {
+    for (lptr = &vec_lines[0]; (lptr - vec_lines) < MAXLINES; lptr++) {
 	char temp[BUFSIZ], *s, *d;
 	int col;
 
@@ -280,7 +282,7 @@
 	*lptr = ch_dup(temp);
     }
     (void) fclose(fp);
-    length = lptr - my_lines;
+    num_lines = lptr - vec_lines;
 
     (void) initscr();		/* initialize the curses library */
     keypad(stdscr, TRUE);	/* enable keyboard mapping */
@@ -300,7 +302,7 @@
 	}
     }
 
-    lptr = my_lines;
+    lptr = vec_lines;
     while (!done) {
 	int n, c;
 
@@ -342,7 +344,7 @@
 	case 'n':
 	    olptr = lptr;
 	    for (i = 0; i < n; i++)
-		if ((lptr - my_lines) < (length - LINES + 1))
+		if ((lptr - vec_lines) < (num_lines - LINES + 1))
 		    lptr++;
 		else
 		    break;
@@ -353,7 +355,7 @@
 	case 'p':
 	    olptr = lptr;
 	    for (i = 0; i < n; i++)
-		if (lptr > my_lines)
+		if (lptr > vec_lines)
 		    lptr--;
 		else
 		    break;
@@ -362,15 +364,15 @@
 
 	case 'h':
 	case KEY_HOME:
-	    lptr = my_lines;
+	    lptr = vec_lines;
 	    break;
 
 	case 'e':
 	case KEY_END:
-	    if (length > LINES)
-		lptr = my_lines + length - LINES + 1;
+	    if (num_lines > LINES)
+		lptr = vec_lines + num_lines - LINES + 1;
 	    else
-		lptr = my_lines;
+		lptr = vec_lines;
 	    break;
 
 	case 'r':
@@ -428,6 +430,15 @@
 finish(int sig)
 {
     endwin();
+#if NO_LEAKS
+    if (vec_lines != 0) {
+	int n;
+	for (n = 0; n < num_lines; ++n) {
+	    free(vec_lines[n]);
+	}
+	free(vec_lines);
+    }
+#endif
     ExitProgram(sig != 0 ? EXIT_FAILURE : EXIT_SUCCESS);
 }
 
@@ -491,7 +502,7 @@
     scrollok(stdscr, FALSE);	/* prevent screen from moving */
     for (i = 1; i < LINES; i++) {
 	move(i, 0);
-	printw("%3ld:", (long) (lptr + i - my_lines));
+	printw("%3ld:", (long) (lptr + i - vec_lines));
 	clrtoeol();
 	if ((s = lptr[i - 1]) != 0) {
 	    int len = ch_len(s);
